searchData={"items":[{"type":"behaviour","title":"Jido.Actions.ReqAction","doc":"","ref":"Jido.Actions.ReqAction.html"},{"type":"callback","title":"Jido.Actions.ReqAction.transform_result/1","doc":"","ref":"Jido.Actions.ReqAction.html#c:transform_result/1"},{"type":"module","title":"Jido.Actions.StateManager","doc":"Provides generic actions for managing state within an agent.\n\nThis module implements the Jido.Action behavior and offers a collection\nof actions for getting, setting, updating, and deleting values in an agent's state.","ref":"Jido.Actions.StateManager.html"},{"type":"function","title":"Jido.Actions.StateManager.category/0","doc":"","ref":"Jido.Actions.StateManager.html#category/0"},{"type":"function","title":"Jido.Actions.StateManager.description/0","doc":"","ref":"Jido.Actions.StateManager.html#description/0"},{"type":"function","title":"Jido.Actions.StateManager.name/0","doc":"","ref":"Jido.Actions.StateManager.html#name/0"},{"type":"function","title":"Jido.Actions.StateManager.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.StateManager.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.StateManager.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.StateManager.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.StateManager.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.StateManager.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.StateManager.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.StateManager.html#on_error/4"},{"type":"function","title":"Jido.Actions.StateManager.output_schema/0","doc":"","ref":"Jido.Actions.StateManager.html#output_schema/0"},{"type":"function","title":"Jido.Actions.StateManager.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.StateManager.html#run/2"},{"type":"function","title":"Jido.Actions.StateManager.schema/0","doc":"","ref":"Jido.Actions.StateManager.html#schema/0"},{"type":"function","title":"Jido.Actions.StateManager.tags/0","doc":"","ref":"Jido.Actions.StateManager.html#tags/0"},{"type":"function","title":"Jido.Actions.StateManager.to_json/0","doc":"","ref":"Jido.Actions.StateManager.html#to_json/0"},{"type":"function","title":"Jido.Actions.StateManager.to_tool/0","doc":"","ref":"Jido.Actions.StateManager.html#to_tool/0"},{"type":"function","title":"Jido.Actions.StateManager.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.StateManager.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.StateManager.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.StateManager.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.StateManager.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.vsn/0","doc":"","ref":"Jido.Actions.StateManager.html#vsn/0"},{"type":"module","title":"Jido.Actions.StateManager.Delete","doc":"Action for deleting a value from the agent's state.\n\nRemoves a value from the agent's state at the specified path.","ref":"Jido.Actions.StateManager.Delete.html"},{"type":"function","title":"Jido.Actions.StateManager.Delete.category/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#category/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.description/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#description/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.name/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#name/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.StateManager.Delete.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.StateManager.Delete.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.StateManager.Delete.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.StateManager.Delete.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.StateManager.Delete.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Delete.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.StateManager.Delete.html#on_error/4"},{"type":"function","title":"Jido.Actions.StateManager.Delete.output_schema/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#output_schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.StateManager.Delete.html#run/2"},{"type":"function","title":"Jido.Actions.StateManager.Delete.schema/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.tags/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#tags/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.to_json/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#to_json/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.to_tool/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#to_tool/0"},{"type":"function","title":"Jido.Actions.StateManager.Delete.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.StateManager.Delete.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Delete.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.StateManager.Delete.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Delete.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.StateManager.Delete.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Delete.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.StateManager.Delete.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Delete.vsn/0","doc":"","ref":"Jido.Actions.StateManager.Delete.html#vsn/0"},{"type":"module","title":"Jido.Actions.StateManager.Get","doc":"Action for retrieving a value from the agent's state.\n\nGets a value from the agent's state at the specified path.","ref":"Jido.Actions.StateManager.Get.html"},{"type":"function","title":"Jido.Actions.StateManager.Get.category/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#category/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.description/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#description/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.name/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#name/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.StateManager.Get.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.StateManager.Get.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.StateManager.Get.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.StateManager.Get.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.StateManager.Get.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Get.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.StateManager.Get.html#on_error/4"},{"type":"function","title":"Jido.Actions.StateManager.Get.output_schema/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#output_schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.StateManager.Get.html#run/2"},{"type":"function","title":"Jido.Actions.StateManager.Get.schema/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.tags/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#tags/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.to_json/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#to_json/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.to_tool/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#to_tool/0"},{"type":"function","title":"Jido.Actions.StateManager.Get.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.StateManager.Get.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Get.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.StateManager.Get.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Get.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.StateManager.Get.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Get.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.StateManager.Get.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Get.vsn/0","doc":"","ref":"Jido.Actions.StateManager.Get.html#vsn/0"},{"type":"module","title":"Jido.Actions.StateManager.Set","doc":"Action for setting a value in the agent's state.\n\nSets a value in the agent's state at the specified path.","ref":"Jido.Actions.StateManager.Set.html"},{"type":"function","title":"Jido.Actions.StateManager.Set.category/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#category/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.description/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#description/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.name/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#name/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.StateManager.Set.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.StateManager.Set.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.StateManager.Set.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.StateManager.Set.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.StateManager.Set.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Set.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.StateManager.Set.html#on_error/4"},{"type":"function","title":"Jido.Actions.StateManager.Set.output_schema/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#output_schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.StateManager.Set.html#run/2"},{"type":"function","title":"Jido.Actions.StateManager.Set.schema/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.tags/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#tags/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.to_json/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#to_json/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.to_tool/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#to_tool/0"},{"type":"function","title":"Jido.Actions.StateManager.Set.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.StateManager.Set.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Set.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.StateManager.Set.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Set.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.StateManager.Set.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Set.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.StateManager.Set.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Set.vsn/0","doc":"","ref":"Jido.Actions.StateManager.Set.html#vsn/0"},{"type":"module","title":"Jido.Actions.StateManager.Update","doc":"Action for updating a value in the agent's state.\n\nUpdates a value in the agent's state at the specified path using\na transformation function.","ref":"Jido.Actions.StateManager.Update.html"},{"type":"function","title":"Jido.Actions.StateManager.Update.category/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#category/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.description/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#description/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.name/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#name/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.StateManager.Update.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.StateManager.Update.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.StateManager.Update.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.StateManager.Update.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.StateManager.Update.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.StateManager.Update.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.StateManager.Update.html#on_error/4"},{"type":"function","title":"Jido.Actions.StateManager.Update.output_schema/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#output_schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.StateManager.Update.html#run/2"},{"type":"function","title":"Jido.Actions.StateManager.Update.schema/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#schema/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.tags/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#tags/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.to_json/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#to_json/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.to_tool/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#to_tool/0"},{"type":"function","title":"Jido.Actions.StateManager.Update.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.StateManager.Update.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Update.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.StateManager.Update.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Update.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.StateManager.Update.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.StateManager.Update.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.StateManager.Update.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.StateManager.Update.vsn/0","doc":"","ref":"Jido.Actions.StateManager.Update.html#vsn/0"},{"type":"module","title":"Jido.Actions.Tasks","doc":"Provides a set of actions for managing tasks within an agent.\n\nThis module implements the Jido.Action behavior and offers a collection\nof actions for creating, updating, toggling, and deleting tasks.","ref":"Jido.Actions.Tasks.html"},{"type":"function","title":"Jido.Actions.Tasks.category/0","doc":"","ref":"Jido.Actions.Tasks.html#category/0"},{"type":"function","title":"Jido.Actions.Tasks.description/0","doc":"","ref":"Jido.Actions.Tasks.html#description/0"},{"type":"function","title":"Jido.Actions.Tasks.name/0","doc":"","ref":"Jido.Actions.Tasks.html#name/0"},{"type":"function","title":"Jido.Actions.Tasks.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.Tasks.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.Tasks.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.Tasks.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.Tasks.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.Tasks.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.Tasks.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.Tasks.html#on_error/4"},{"type":"function","title":"Jido.Actions.Tasks.output_schema/0","doc":"","ref":"Jido.Actions.Tasks.html#output_schema/0"},{"type":"function","title":"Jido.Actions.Tasks.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.Tasks.html#run/2"},{"type":"function","title":"Jido.Actions.Tasks.schema/0","doc":"","ref":"Jido.Actions.Tasks.html#schema/0"},{"type":"function","title":"Jido.Actions.Tasks.tags/0","doc":"","ref":"Jido.Actions.Tasks.html#tags/0"},{"type":"function","title":"Jido.Actions.Tasks.to_json/0","doc":"","ref":"Jido.Actions.Tasks.html#to_json/0"},{"type":"function","title":"Jido.Actions.Tasks.to_tool/0","doc":"","ref":"Jido.Actions.Tasks.html#to_tool/0"},{"type":"function","title":"Jido.Actions.Tasks.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.Tasks.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.Tasks.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.Tasks.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.Tasks.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.vsn/0","doc":"","ref":"Jido.Actions.Tasks.html#vsn/0"},{"type":"module","title":"Jido.Actions.Tasks.CreateTask","doc":"Action for creating a new task.\n\nCreates a task with the specified title and optional deadline,\nadding it to the agent's state.","ref":"Jido.Actions.Tasks.CreateTask.html"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.category/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#category/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.description/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#description/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.name/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#name/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.Tasks.CreateTask.html#on_error/4"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.output_schema/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#output_schema/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.Tasks.CreateTask.html#run/2"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.schema/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#schema/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.tags/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#tags/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.to_json/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#to_json/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.to_tool/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#to_tool/0"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.Tasks.CreateTask.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.CreateTask.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.Tasks.CreateTask.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.Tasks.CreateTask.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.CreateTask.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.Tasks.CreateTask.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.CreateTask.vsn/0","doc":"","ref":"Jido.Actions.Tasks.CreateTask.html#vsn/0"},{"type":"module","title":"Jido.Actions.Tasks.DeleteTask","doc":"Action for deleting a task.\n\nRemoves a task from the agent's state based on the provided task ID.","ref":"Jido.Actions.Tasks.DeleteTask.html"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.category/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#category/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.description/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#description/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.name/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#name/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.Tasks.DeleteTask.html#on_error/4"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.output_schema/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#output_schema/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.Tasks.DeleteTask.html#run/2"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.schema/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#schema/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.tags/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#tags/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.to_json/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#to_json/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.to_tool/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#to_tool/0"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.Tasks.DeleteTask.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.DeleteTask.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.Tasks.DeleteTask.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.Tasks.DeleteTask.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.DeleteTask.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.Tasks.DeleteTask.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.DeleteTask.vsn/0","doc":"","ref":"Jido.Actions.Tasks.DeleteTask.html#vsn/0"},{"type":"module","title":"Jido.Actions.Tasks.Task","doc":"Defines the task data structure used by the Tasks actions.\n\nRepresents a task with properties such as id, title, completion status,\ncreation timestamp, and deadline.","ref":"Jido.Actions.Tasks.Task.html"},{"type":"function","title":"Jido.Actions.Tasks.Task.new/2","doc":"","ref":"Jido.Actions.Tasks.Task.html#new/2"},{"type":"type","title":"Jido.Actions.Tasks.Task.t/0","doc":"","ref":"Jido.Actions.Tasks.Task.html#t:t/0"},{"type":"module","title":"Jido.Actions.Tasks.ToggleTask","doc":"Action for toggling the completion status of a task.\n\nSwitches a task's completed status between true and false based on\nthe provided task ID.","ref":"Jido.Actions.Tasks.ToggleTask.html"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.category/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#category/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.description/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#description/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.name/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#name/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.Tasks.ToggleTask.html#on_error/4"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.output_schema/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#output_schema/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.Tasks.ToggleTask.html#run/2"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.schema/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#schema/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.tags/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#tags/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.to_json/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#to_json/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.to_tool/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#to_tool/0"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.Tasks.ToggleTask.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.ToggleTask.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.Tasks.ToggleTask.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.Tasks.ToggleTask.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.ToggleTask.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.Tasks.ToggleTask.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.ToggleTask.vsn/0","doc":"","ref":"Jido.Actions.Tasks.ToggleTask.html#vsn/0"},{"type":"module","title":"Jido.Actions.Tasks.UpdateTask","doc":"Action for updating an existing task.\n\nUpdates a task's properties such as title and deadline based on the\nprovided task ID.","ref":"Jido.Actions.Tasks.UpdateTask.html"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.category/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#category/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.description/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#description/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.name/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#name/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_after_run/1","doc":"Callback implementation for  Jido.Action.on_after_run/1 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_after_run/1"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_after_validate_output/1","doc":"Callback implementation for  Jido.Action.on_after_validate_output/1 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_after_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_after_validate_params/1","doc":"Callback implementation for  Jido.Action.on_after_validate_params/1 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_after_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_before_validate_output/1","doc":"Callback implementation for  Jido.Action.on_before_validate_output/1 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_before_validate_output/1"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_before_validate_params/1","doc":"Callback implementation for  Jido.Action.on_before_validate_params/1 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_before_validate_params/1"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.on_error/4","doc":"Callback implementation for  Jido.Action.on_error/4 .","ref":"Jido.Actions.Tasks.UpdateTask.html#on_error/4"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.output_schema/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#output_schema/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.Actions.Tasks.UpdateTask.html#run/2"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.schema/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#schema/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.tags/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#tags/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.to_json/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#to_json/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.to_tool/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#to_tool/0"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.validate_output/1","doc":"Validates the output result for the Action.","ref":"Jido.Actions.Tasks.UpdateTask.html#validate_output/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.UpdateTask.validate_output/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     output_schema: [\n    ...>       result: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_output(%{result: \"test\", extra: \"ignored\"})\n    {:ok, %{result: \"test\", extra: \"ignored\"}}\n\n    iex> ExampleAction.validate_output(%{extra: \"ignored\"})\n    {:error, \"Invalid output for Action: Required key :result not found\"}","ref":"Jido.Actions.Tasks.UpdateTask.html#validate_output/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.Actions.Tasks.UpdateTask.html#validate_params/1"},{"type":"function","title":"Examples - Jido.Actions.Tasks.UpdateTask.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.Actions.Tasks.UpdateTask.html#validate_params/1-examples"},{"type":"function","title":"Jido.Actions.Tasks.UpdateTask.vsn/0","doc":"","ref":"Jido.Actions.Tasks.UpdateTask.html#vsn/0"},{"type":"behaviour","title":"Jido.Actions.Workflow","doc":"A specialized Action type that executes a sequence of workflow steps.\n\nThis Workflow is intentinoally simplistic - it is not meant to replace more mature Workflow\nlibraries that exist in the Elixir ecosystem.  It is included for basic use cases relevant to\nthe Jido project.\n\nThis module extends `Jido.Action` with workflow capabilities, allowing\nyou to define a sequence of steps to be executed in order. Each step\nfollows the Elixir AST pattern of `{:atom, metadata, params}`.","ref":"Jido.Actions.Workflow.html"},{"type":"behaviour","title":"Supported Step Types - Jido.Actions.Workflow","doc":"- `{:step, metadata, [instruction]}` - Execute a single instruction\n- `{:branch, metadata, [condition_value, true_action, false_action]}` - Conditional branching\n- `{:converge, metadata, [instruction]}` - Converge branch paths\n- `{:parallel, metadata, [instructions]}` - Execute instructions in parallel","ref":"Jido.Actions.Workflow.html#module-supported-step-types"},{"type":"behaviour","title":"Usage - Jido.Actions.Workflow","doc":"```elixir\ndefmodule MyWorkflow do\n  use Jido.Actions.Workflow,\n    name: \"my_workflow\",\n    description: \"A workflow that performs multiple steps\",\n    steps: [\n      {:step, [name: \"step_1\"], [{LogAction, message: \"Step 1\"}]},\n      {:branch, [name: \"branch_1\"], [\n        true,  # This will typically be replaced at runtime with a dynamic value\n        {:step, [name: \"true_branch\"], [{LogAction, message: \"Greater than 10\"}]},\n        {:step, [name: \"false_branch\"], [{LogAction, message: \"Less than or equal to 10\"}]}\n      ]},\n      {:step, [name: \"final_step\"], [{LogAction, message: \"Completed\"}]}\n    ]\nend\n```","ref":"Jido.Actions.Workflow.html#module-usage"},{"type":"behaviour","title":"Handling Dynamic Conditions - Jido.Actions.Workflow","doc":"For branch conditions that need to be evaluated at runtime, override the `execute_step/3`\nfunction in your module to handle the specific branch condition check:\n\n```elixir\n# Override execute_step to handle a specific branch condition\ndef execute_step({:branch, [name: \"my_condition\"], [_placeholder, true_branch, false_branch]}, params, context) do\n  # Determine condition dynamically using params\n  condition_value = params.value > 10\n\n  # Choose the branch based on the condition value\n  if condition_value do\n    execute_step(true_branch, params, context)\n  else\n    execute_step(false_branch, params, context)\n  end\nend\n\n# Fall back to the default implementation for other steps\ndef execute_step(step, params, context) do\n  super(step, params, context)\nend","ref":"Jido.Actions.Workflow.html#module-handling-dynamic-conditions"},{"type":"callback","title":"Jido.Actions.Workflow.execute_step/3","doc":"","ref":"Jido.Actions.Workflow.html#c:execute_step/3"},{"type":"module","title":"Jido.Agent.Directive.StateModification","doc":"Directive to modify agent state at a given path","ref":"Jido.Agent.Directive.StateModification.html"},{"type":"type","title":"Jido.Agent.Directive.StateModification.t/0","doc":"","ref":"Jido.Agent.Directive.StateModification.html#t:t/0"},{"type":"module","title":"Jido.Agent.Server.Skills","doc":"Functions for building and managing skills in the agent server.","ref":"Jido.Agent.Server.Skills.html"},{"type":"function","title":"Jido.Agent.Server.Skills.build/2","doc":"Builds the skills for the agent server.\n\nThis function takes a list of skills from the options and adds them to the server state.\nIt also collects any routes and child_specs from the skills and adds them to the options.","ref":"Jido.Agent.Server.Skills.html#build/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.Skills.build/2","doc":"- `state` - The current server state\n- `opts` - The options for the server","ref":"Jido.Agent.Server.Skills.html#build/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.Skills.build/2","doc":"- `{:ok, state, opts}` - The updated state and options\n- `{:error, reason}` - An error occurred","ref":"Jido.Agent.Server.Skills.html#build/2-returns"},{"type":"macro","title":"Jido.Agent.Server.Skills.dbug/2","doc":"","ref":"Jido.Agent.Server.Skills.html#dbug/2"},{"type":"macro","title":"Jido.Agent.Server.Skills.error/2","doc":"","ref":"Jido.Agent.Server.Skills.html#error/2"},{"type":"module","title":"Jido.Exec","doc":"Exec provides a robust set of methods for executing Actions (`Jido.Action`).\n\nThis module offers functionality to:\n- Run actions synchronously or asynchronously\n- Manage timeouts and retries\n- Cancel running actions\n- Normalize and validate input parameters and context\n- Emit telemetry events for monitoring and debugging\n\nExecs are defined as modules (Actions) that implement specific callbacks, allowing for\na standardized way of defining and executing complex actions across a distributed system.","ref":"Jido.Exec.html"},{"type":"module","title":"Features - Jido.Exec","doc":"- Synchronous and asynchronous action execution\n- Automatic retries with exponential backoff\n- Timeout handling for long-running actions\n- Parameter and context normalization\n- Comprehensive error handling and reporting\n- Telemetry integration for monitoring and tracing\n- Cancellation of running actions","ref":"Jido.Exec.html#module-features"},{"type":"module","title":"Usage - Jido.Exec","doc":"Execs are executed using the `run/4` or `run_async/4` functions:\n\n    Jido.Exec.run(MyAction, %{param1: \"value\"}, %{context_key: \"context_value\"})\n\nSee `Jido.Action` for how to define an Action.\n\nFor asynchronous execution:\n\n    async_ref = Jido.Exec.run_async(MyAction, params, context)\n    # ... do other work ...\n    result = Jido.Exec.await(async_ref)","ref":"Jido.Exec.html#module-usage"},{"type":"module","title":"Configuration - Jido.Exec","doc":"The default timeout for action execution can be configured using the Application environment:\n\n    config :jido, default_timeout: 60_000  # 60 seconds\n\nIf not configured, the default timeout is 30 seconds (30,000 milliseconds).\n\nSpecial timeout values:\n- `timeout: 0` - Disables timeout completely, actions run without time limits\n- Any positive integer - Sets timeout in milliseconds","ref":"Jido.Exec.html#module-configuration"},{"type":"type","title":"Jido.Exec.action/0","doc":"","ref":"Jido.Exec.html#t:action/0"},{"type":"type","title":"Jido.Exec.async_ref/0","doc":"","ref":"Jido.Exec.html#t:async_ref/0"},{"type":"function","title":"Jido.Exec.await/2","doc":"Waits for the result of an asynchronous Action execution.","ref":"Jido.Exec.html#await/2"},{"type":"function","title":"Parameters - Jido.Exec.await/2","doc":"- `async_ref`: The reference returned by `run_async/4`.\n- `timeout`: Maximum time (in ms) to wait for the result (default: 30000).","ref":"Jido.Exec.html#await/2-parameters"},{"type":"function","title":"Returns - Jido.Exec.await/2","doc":"- `{:ok, result}` if the Action executes successfully.\n- `{:error, reason}` if an error occurs during execution or if the action times out.","ref":"Jido.Exec.html#await/2-returns"},{"type":"function","title":"Examples - Jido.Exec.await/2","doc":"iex> async_ref = Jido.Exec.run_async(MyAction, %{input: \"value\"})\n    iex> Jido.Exec.await(async_ref, 10_000)\n    {:ok, %{result: \"processed value\"}}\n\n    iex> async_ref = Jido.Exec.run_async(SlowAction, %{input: \"value\"})\n    iex> Jido.Exec.await(async_ref, 100)\n    {:error, %Jido.Error{type: :timeout, message: \"Async action timed out after 100ms\"}}","ref":"Jido.Exec.html#await/2-examples"},{"type":"function","title":"Jido.Exec.cancel/1","doc":"Cancels a running asynchronous Action execution.","ref":"Jido.Exec.html#cancel/1"},{"type":"function","title":"Parameters - Jido.Exec.cancel/1","doc":"- `async_ref`: The reference returned by `run_async/4`, or just the PID of the process to cancel.","ref":"Jido.Exec.html#cancel/1-parameters"},{"type":"function","title":"Returns - Jido.Exec.cancel/1","doc":"- `:ok` if the cancellation was successful.\n- `{:error, reason}` if the cancellation failed or the input was invalid.","ref":"Jido.Exec.html#cancel/1-returns"},{"type":"function","title":"Examples - Jido.Exec.cancel/1","doc":"iex> async_ref = Jido.Exec.run_async(LongRunningAction, %{input: \"value\"})\n    iex> Jido.Exec.cancel(async_ref)\n    :ok\n\n    iex> Jido.Exec.cancel(\"invalid\")\n    {:error, %Jido.Error{type: :invalid_async_ref, message: \"Invalid async ref for cancellation\"}}","ref":"Jido.Exec.html#cancel/1-examples"},{"type":"type","title":"Jido.Exec.context/0","doc":"","ref":"Jido.Exec.html#t:context/0"},{"type":"macro","title":"Jido.Exec.dbug/2","doc":"","ref":"Jido.Exec.html#dbug/2"},{"type":"macro","title":"Jido.Exec.error/2","doc":"","ref":"Jido.Exec.html#error/2"},{"type":"type","title":"Jido.Exec.params/0","doc":"","ref":"Jido.Exec.html#t:params/0"},{"type":"function","title":"Jido.Exec.run/4","doc":"Executes a Action synchronously with the given parameters and context.","ref":"Jido.Exec.html#run/4"},{"type":"function","title":"Parameters - Jido.Exec.run/4","doc":"- `action`: The module implementing the Action behavior.\n- `params`: A map of input parameters for the Action.\n- `context`: A map providing additional context for the Action execution.\n- `opts`: Options controlling the execution:\n  - `:timeout` - Maximum time (in ms) allowed for the Action to complete (default: 30000).\n  - `:max_retries` - Maximum number of retry attempts (default: 1).\n  - `:backoff` - Initial backoff time in milliseconds, doubles with each retry (default: 250).\n  - `:log_level` - Override the global Logger level for this specific action. Accepts [:error, :info, :debug, :emergency, :alert, :critical, :warning, :notice].","ref":"Jido.Exec.html#run/4-parameters"},{"type":"function","title":"Action Metadata in Context - Jido.Exec.run/4","doc":"The action's metadata (name, description, category, tags, version, etc.) is made available\nto the action's `run/2` function via the `context` parameter under the `:action_metadata` key.\nThis allows actions to access their own metadata when needed.","ref":"Jido.Exec.html#run/4-action-metadata-in-context"},{"type":"function","title":"Returns - Jido.Exec.run/4","doc":"- `{:ok, result}` if the Action executes successfully.\n- `{:error, reason}` if an error occurs during execution.","ref":"Jido.Exec.html#run/4-returns"},{"type":"function","title":"Examples - Jido.Exec.run/4","doc":"iex> Jido.Exec.run(MyAction, %{input: \"value\"}, %{user_id: 123})\n    {:ok, %{result: \"processed value\"}}\n\n    iex> Jido.Exec.run(MyAction, %{invalid: \"input\"}, %{}, timeout: 1000)\n    {:error, %Jido.Error{type: :validation_error, message: \"Invalid input\"}}\n\n    iex> Jido.Exec.run(MyAction, %{input: \"value\"}, %{}, log_level: :debug)\n    {:ok, %{result: \"processed value\"}}\n\n    # Access action metadata in the action:\n    # defmodule MyAction do\n    #   use Jido.Action,\n    #     name: \"my_action\",\n    #     description: \"Example action\",\n    #     vsn: \"1.0.0\"\n    #\n    #   def run(_params, context) do\n    #     metadata = context.action_metadata\n    #     {:ok, %{name: metadata.name, version: metadata.vsn}}\n    #   end\n    # end","ref":"Jido.Exec.html#run/4-examples"},{"type":"function","title":"Jido.Exec.run_async/4","doc":"Executes a Action asynchronously with the given parameters and context.\n\nThis function immediately returns a reference that can be used to await the result\nor cancel the action.\n\n**Note**: This approach integrates with OTP by spawning tasks under a `Task.Supervisor`.\nMake sure `{Task.Supervisor, name: Jido.TaskSupervisor}` is part of your supervision tree.","ref":"Jido.Exec.html#run_async/4"},{"type":"function","title":"Parameters - Jido.Exec.run_async/4","doc":"- `action`: The module implementing the Action behavior.\n- `params`: A map of input parameters for the Action.\n- `context`: A map providing additional context for the Action execution.\n- `opts`: Options controlling the execution (same as `run/4`).","ref":"Jido.Exec.html#run_async/4-parameters"},{"type":"function","title":"Returns - Jido.Exec.run_async/4","doc":"An `async_ref` map containing:\n- `:ref` - A unique reference for this async action.\n- `:pid` - The PID of the process executing the Action.","ref":"Jido.Exec.html#run_async/4-returns"},{"type":"function","title":"Examples - Jido.Exec.run_async/4","doc":"iex> async_ref = Jido.Exec.run_async(MyAction, %{input: \"value\"}, %{user_id: 123})\n    %{ref: #Reference<0.1234.5678>, pid: #PID<0.234.0>}\n\n    iex> result = Jido.Exec.await(async_ref)\n    {:ok, %{result: \"processed value\"}}","ref":"Jido.Exec.html#run_async/4-examples"},{"type":"type","title":"Jido.Exec.run_opts/0","doc":"","ref":"Jido.Exec.html#t:run_opts/0"},{"type":"module","title":"Jido.Exec.Chain","doc":"Provides functionality to chain multiple Jido Execs together with interruption support.\n\nThis module allows for sequential execution of actions, where the output\nof one action becomes the input for the next action in the chain.\nExecution can be interrupted between actions using an interruption check function.","ref":"Jido.Exec.Chain.html"},{"type":"module","title":"Examples - Jido.Exec.Chain","doc":"iex> interrupt_check = fn -> System.monotonic_time(:millisecond) > @deadline end\n    iex> Jido.Exec.Chain.chain([AddOne, MultiplyByTwo], %{value: 5}, interrupt_check: interrupt_check)\n    {:ok, %{value: 12}}\n\n    # When interrupted:\n    iex> Jido.Exec.Chain.chain([AddOne, MultiplyByTwo], %{value: 5}, interrupt_check: fn -> true end)\n    {:interrupted, %{value: 6}}","ref":"Jido.Exec.Chain.html#module-examples"},{"type":"function","title":"Jido.Exec.Chain.chain/3","doc":"Executes a chain of actions sequentially with optional interruption support.","ref":"Jido.Exec.Chain.html#chain/3"},{"type":"function","title":"Parameters - Jido.Exec.Chain.chain/3","doc":"- `actions`: A list of actions to be executed in order. Each action\n  can be a module (the action module) or a tuple of `{action_module, options}`.\n- `initial_params`: A map of initial parameters to be passed to the first action.\n- `opts`: Additional options for the chain execution.","ref":"Jido.Exec.Chain.html#chain/3-parameters"},{"type":"function","title":"Options - Jido.Exec.Chain.chain/3","doc":"- `:async` - When set to `true`, the chain will be executed asynchronously (default: `false`).\n- `:context` - A map of context data to be passed to each action.\n- `:interrupt_check` - A function that returns boolean, called between actions to check if chain should be interrupted.","ref":"Jido.Exec.Chain.html#chain/3-options"},{"type":"function","title":"Returns - Jido.Exec.Chain.chain/3","doc":"- `{:ok, result}` where `result` is the final output of the chain.\n- `{:error, error}` if any action in the chain fails.\n- `{:interrupted, result}` if the chain was interrupted, containing the last successful result.\n- `Task.t()` if the `:async` option is set to `true`.","ref":"Jido.Exec.Chain.html#chain/3-returns"},{"type":"type","title":"Jido.Exec.Chain.chain_action/0","doc":"","ref":"Jido.Exec.Chain.html#t:chain_action/0"},{"type":"type","title":"Jido.Exec.Chain.chain_result/0","doc":"","ref":"Jido.Exec.Chain.html#t:chain_result/0"},{"type":"type","title":"Jido.Exec.Chain.interrupt_check/0","doc":"","ref":"Jido.Exec.Chain.html#t:interrupt_check/0"},{"type":"module","title":"Jido.Exec.Closure","doc":"Provides functionality to create closures around Jido Execs (Actions).\n\nThis module allows for partial application of context and options to actions,\ncreating reusable action closures that can be executed with different parameters.","ref":"Jido.Exec.Closure.html"},{"type":"type","title":"Jido.Exec.Closure.action/0","doc":"","ref":"Jido.Exec.Closure.html#t:action/0"},{"type":"function","title":"Jido.Exec.Closure.async_closure/3","doc":"Creates an async closure around a action with pre-applied context and options.","ref":"Jido.Exec.Closure.html#async_closure/3"},{"type":"function","title":"Parameters - Jido.Exec.Closure.async_closure/3","doc":"- `action`: The action module to create an async closure for.\n- `context`: The context to be applied to the action (default: %{}).\n- `opts`: The options to be applied to the action execution (default: []).","ref":"Jido.Exec.Closure.html#async_closure/3-parameters"},{"type":"function","title":"Returns - Jido.Exec.Closure.async_closure/3","doc":"A function that takes params and returns an async reference.","ref":"Jido.Exec.Closure.html#async_closure/3-returns"},{"type":"function","title":"Examples - Jido.Exec.Closure.async_closure/3","doc":"iex> async_closure = Jido.Exec.Closure.async_closure(MyAction, %{user_id: 123}, [timeout: 10_000])\n    iex> async_ref = async_closure.(%{input: \"test\"})\n    iex> Jido.Exec.await(async_ref)\n    {:ok, %{result: \"processed test\"}}","ref":"Jido.Exec.Closure.html#async_closure/3-examples"},{"type":"type","title":"Jido.Exec.Closure.closure/0","doc":"","ref":"Jido.Exec.Closure.html#t:closure/0"},{"type":"function","title":"Jido.Exec.Closure.closure/3","doc":"Creates a closure around a action with pre-applied context and options.","ref":"Jido.Exec.Closure.html#closure/3"},{"type":"function","title":"Parameters - Jido.Exec.Closure.closure/3","doc":"- `action`: The action module to create a closure for.\n- `context`: The context to be applied to the action (default: %{}).\n- `opts`: The options to be applied to the action execution (default: []).","ref":"Jido.Exec.Closure.html#closure/3-parameters"},{"type":"function","title":"Returns - Jido.Exec.Closure.closure/3","doc":"A function that takes params and returns the result of running the action.","ref":"Jido.Exec.Closure.html#closure/3-returns"},{"type":"function","title":"Examples - Jido.Exec.Closure.closure/3","doc":"iex> closure = Jido.Exec.Closure.closure(MyAction, %{user_id: 123}, [timeout: 10_000])\n    iex> closure.(%{input: \"test\"})\n    {:ok, %{result: \"processed test\"}}","ref":"Jido.Exec.Closure.html#closure/3-examples"},{"type":"type","title":"Jido.Exec.Closure.context/0","doc":"","ref":"Jido.Exec.Closure.html#t:context/0"},{"type":"type","title":"Jido.Exec.Closure.params/0","doc":"","ref":"Jido.Exec.Closure.html#t:params/0"},{"type":"type","title":"Jido.Exec.Closure.run_opts/0","doc":"","ref":"Jido.Exec.Closure.html#t:run_opts/0"},{"type":"module","title":"Jido.Skills.Tasks","doc":"An example skill that provides task management capabilities to agents.\n\nThis skill registers task-related actions (create, update, toggle, delete)\nwith the agent and handles task-related signals.","ref":"Jido.Skills.Tasks.html"},{"type":"function","title":"Jido.Skills.Tasks.run/1","doc":"","ref":"Jido.Skills.Tasks.html#run/1"},{"type":"module","title":"Jido.Telemetry","doc":"Handles telemetry events for the Jido application.\n\nThis module provides a centralized way to handle and report telemetry events\nthroughout the application. It implements common telemetry patterns and provides\na consistent interface for event handling.","ref":"Jido.Telemetry.html"},{"type":"function","title":"Jido.Telemetry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Jido.Telemetry.html#child_spec/1"},{"type":"type","title":"Jido.Telemetry.event_name/0","doc":"Supported telemetry event names.","ref":"Jido.Telemetry.html#t:event_name/0"},{"type":"function","title":"Jido.Telemetry.handle_event/4","doc":"Handles telemetry events.","ref":"Jido.Telemetry.html#handle_event/4"},{"type":"type","title":"Jido.Telemetry.measurements/0","doc":"Telemetry measurements map.","ref":"Jido.Telemetry.html#t:measurements/0"},{"type":"type","title":"Jido.Telemetry.metadata/0","doc":"Telemetry metadata map.","ref":"Jido.Telemetry.html#t:metadata/0"},{"type":"function","title":"Jido.Telemetry.span/2","doc":"Executes a function while emitting telemetry events for its execution.","ref":"Jido.Telemetry.html#span/2"},{"type":"function","title":"Jido.Telemetry.start_link/1","doc":"Starts the telemetry handler.","ref":"Jido.Telemetry.html#start_link/1"},{"type":"behaviour","title":"Jido","doc":"自動 (Jido) - A foundational framework for building autonomous, distributed agent systems in Elixir.\n\nThis module provides the main interface for interacting with Jido components, including:\n- Managing and interacting with Agents through a high-level API\n- Listing and retrieving Actions, Sensors, and Domains\n- Filtering and paginating results\n- Generating unique slugs for components","ref":"Jido.html"},{"type":"behaviour","title":"Agent Interaction Examples - Jido","doc":"# Find and act on an agent\n    \"agent-id\"\n    |> Jido.get_agent_by_id()\n    |> Jido.act(:command, %{param: \"value\"})\n\n    # Act asynchronously\n    {:ok, agent} = Jido.get_agent_by_id(\"agent-id\")\n    Jido.act_async(agent, :command)\n\n    # Send management commands\n    {:ok, agent} = Jido.get_agent_by_id(\"agent-id\")\n    Jido.manage(agent, :pause)","ref":"Jido.html#module-agent-interaction-examples"},{"type":"function","title":"Jido.clone_agent/3","doc":"Clones an existing agent with a new ID.","ref":"Jido.html#clone_agent/3"},{"type":"function","title":"Parameters - Jido.clone_agent/3","doc":"- `source_id`: ID of the agent to clone\n- `new_id`: ID for the new cloned agent\n- `opts`: Optional keyword list of options to override for the new agent","ref":"Jido.html#clone_agent/3-parameters"},{"type":"function","title":"Returns - Jido.clone_agent/3","doc":"- `{:ok, pid}` with the new agent's process ID\n- `{:error, reason}` if cloning fails","ref":"Jido.html#clone_agent/3-returns"},{"type":"function","title":"Examples - Jido.clone_agent/3","doc":"iex> {:ok, new_pid} = Jido.clone_agent(\"source-agent\", \"cloned-agent\")\n    {:ok, #PID<0.125.0>}","ref":"Jido.html#clone_agent/3-examples"},{"type":"type","title":"Jido.component_metadata/0","doc":"","ref":"Jido.html#t:component_metadata/0"},{"type":"callback","title":"Jido.config/0","doc":"","ref":"Jido.html#c:config/0"},{"type":"function","title":"Jido.ensure_started/1","doc":"Callback used by the generated `start_link/0` function.\nThis is where we actually call Jido.Supervisor.start_link.","ref":"Jido.html#ensure_started/1"},{"type":"function","title":"Jido.get_action_by_slug/1","doc":"See  Jido.Discovery.get_action_by_slug/1 .","ref":"Jido.html#get_action_by_slug/1"},{"type":"function","title":"Jido.get_agent/2","doc":"Retrieves a running Agent by its ID.","ref":"Jido.html#get_agent/2"},{"type":"function","title":"Parameters - Jido.get_agent/2","doc":"- `id`: String or atom ID of the agent to retrieve\n- `opts`: Optional keyword list of options:\n  - `:registry`: Override the default agent registry","ref":"Jido.html#get_agent/2-parameters"},{"type":"function","title":"Returns - Jido.get_agent/2","doc":"- `{:ok, pid}` if agent is found and running\n- `{:error, :not_found}` if agent doesn't exist","ref":"Jido.html#get_agent/2-returns"},{"type":"function","title":"Examples - Jido.get_agent/2","doc":"iex> {:ok, agent} = Jido.get_agent(\"my-agent\")\n    {:ok, #PID<0.123.0>}\n\n    # Using a custom registry\n    iex> {:ok, agent} = Jido.get_agent(\"my-agent\", registry: MyApp.Registry)\n    {:ok, #PID<0.123.0>}","ref":"Jido.html#get_agent/2-examples"},{"type":"function","title":"Jido.get_agent!/2","doc":"Pipe-friendly version of get_agent that raises on errors.","ref":"Jido.html#get_agent!/2"},{"type":"function","title":"Parameters - Jido.get_agent!/2","doc":"- `id`: String or atom ID of the agent to retrieve\n- `opts`: Optional keyword list of options:\n  - `:registry`: Override the default agent registry","ref":"Jido.html#get_agent!/2-parameters"},{"type":"function","title":"Returns - Jido.get_agent!/2","doc":"- `pid` if agent is found\n- Raises `RuntimeError` if agent not found","ref":"Jido.html#get_agent!/2-returns"},{"type":"function","title":"Examples - Jido.get_agent!/2","doc":"iex> \"my-agent\" |> Jido.get_agent!() |> Jido.cmd(:command)\n    :ok","ref":"Jido.html#get_agent!/2-examples"},{"type":"function","title":"Jido.get_agent_by_slug/1","doc":"See  Jido.Discovery.get_agent_by_slug/1 .","ref":"Jido.html#get_agent_by_slug/1"},{"type":"function","title":"Jido.get_agent_state/1","doc":"Gets the current state of an agent.","ref":"Jido.html#get_agent_state/1"},{"type":"function","title":"Parameters - Jido.get_agent_state/1","doc":"- `agent_or_id`: Agent pid, ID, or return value from get_agent","ref":"Jido.html#get_agent_state/1-parameters"},{"type":"function","title":"Returns - Jido.get_agent_state/1","doc":"- `{:ok, state}` with the agent's current state\n- `{:error, reason}` if state couldn't be retrieved","ref":"Jido.html#get_agent_state/1-returns"},{"type":"function","title":"Examples - Jido.get_agent_state/1","doc":"iex> {:ok, state} = Jido.get_agent_state(\"my-agent\")\n    {:ok, %Jido.Agent.Server.State{...}}","ref":"Jido.html#get_agent_state/1-examples"},{"type":"function","title":"Jido.get_demo_by_slug/1","doc":"See  Jido.Discovery.get_demo_by_slug/1 .","ref":"Jido.html#get_demo_by_slug/1"},{"type":"function","title":"Jido.get_sensor_by_slug/1","doc":"See  Jido.Discovery.get_sensor_by_slug/1 .","ref":"Jido.html#get_sensor_by_slug/1"},{"type":"function","title":"Jido.get_skill_by_slug/1","doc":"See  Jido.Discovery.get_skill_by_slug/1 .","ref":"Jido.html#get_skill_by_slug/1"},{"type":"function","title":"Jido.list_actions/1","doc":"See  Jido.Discovery.list_actions/1 .","ref":"Jido.html#list_actions/1"},{"type":"function","title":"Jido.list_agents/1","doc":"See  Jido.Discovery.list_agents/1 .","ref":"Jido.html#list_agents/1"},{"type":"function","title":"Jido.list_demos/1","doc":"See  Jido.Discovery.list_demos/1 .","ref":"Jido.html#list_demos/1"},{"type":"function","title":"Jido.list_sensors/1","doc":"See  Jido.Discovery.list_sensors/1 .","ref":"Jido.html#list_sensors/1"},{"type":"function","title":"Jido.list_skills/1","doc":"See  Jido.Discovery.list_skills/1 .","ref":"Jido.html#list_skills/1"},{"type":"function","title":"Jido.resolve_pid/1","doc":"","ref":"Jido.html#resolve_pid/1"},{"type":"type","title":"Jido.server/0","doc":"","ref":"Jido.html#t:server/0"},{"type":"behaviour","title":"Jido.Action","doc":"Defines a discrete, composable unit of functionality within the Jido system.\n\nEach Action represents a delayed computation that can be composed with others\nto build complex workflows. Actions are defined at compile-time\nand provide a consistent interface for validating inputs, executing workflows,\nand handling results.","ref":"Jido.Action.html"},{"type":"behaviour","title":"Features - Jido.Action","doc":"- Compile-time configuration validation\n- Runtime input parameter validation\n- Consistent error handling and formatting\n- Extensible lifecycle hooks\n- JSON serialization support","ref":"Jido.Action.html#module-features"},{"type":"behaviour","title":"Usage - Jido.Action","doc":"To define a new Action, use the `Jido.Action` behavior in your module:\n\n    defmodule MyAction do\n    use Jido.Action,\n    name: \"my_action\",\n    description: \"Performs my action\",\n    category: \"processing\",\n    tags: [\"example\", \"demo\"],\n    vsn: \"1.0.0\",\n    schema: [\n    input: [type: :string, required: true]\n    ],\n         output_schema: [\n        result: [type: :string, required: true]\n      ]\n\n    @impl true\n    def run(params, _context) do\n         # Your action logic here\n         {:ok, %{result: String.upcase(params.input)}}\n       end\n     end","ref":"Jido.Action.html#module-usage"},{"type":"behaviour","title":"Callbacks - Jido.Action","doc":"Implementing modules must define the following callback:\n\n- `c:run/2`: Executes the main logic of the Action.\n\nOptional callbacks for custom behavior:\n\n- `c:on_before_validate_params/1`: Called before parameter validation.\n- `c:on_after_validate_params/1`: Called after parameter validation.\n- `c:on_after_run/1`: Called after the Action's main logic has executed.","ref":"Jido.Action.html#module-callbacks"},{"type":"behaviour","title":"Error Handling - Jido.Action","doc":"Actions use the `OK` monad for consistent error handling. Errors are wrapped\nin `Jido.Error` structs for uniform error reporting across the system.","ref":"Jido.Action.html#module-error-handling"},{"type":"behaviour","title":"AI Tool Example - Jido.Action","doc":"Actions can be converted to LLM compatible tools for use with LLM-based systems. This is particularly\nuseful when building AI agents that need to interact with your system's capabilities:\n\n    # Define a weather action\n    iex> defmodule WeatherAction do\n    ...>   use Jido.Action,\n    ...>     name: \"get_weather\",\n    ...>     description: \"Gets the current weather for a location\",\n    ...>     category: \"weather\",\n    ...>     tags: [\"weather\", \"location\"],\n    ...>     vsn: \"1.0.0\",\n    ...>     schema: [\n    ...>       location: [\n    ...>         type: :string,\n    ...>         required: true,\n    ...>         doc: \"The city or location to get weather for\"\n    ...>       ]\n    ...>     ]\n    ...>\n    ...>   @impl true\n    ...>   def run(params, _context) do\n    ...>     # Weather API logic here\n    ...>     {:ok, %{temperature: 72, conditions: \"sunny\"}}\n    ...>   end\n    ...> end\n    {:module, WeatherAction, ...}\n\n    # Convert to tool format\n    iex> WeatherAction.to_tool()\n    %{\n      \"name\" => \"get_weather\",\n      \"description\" => \"Gets the current weather for a location\",\n      \"parameters\" => %{\n        \"type\" => \"object\",\n        \"properties\" => %{\n          \"location\" => %{\n            \"type\" => \"string\",\n            \"description\" => \"The city or location to get weather for\"\n          }\n        },\n        \"required\" => [\"location\"]\n      }\n    }\n\nThis tool definition can then be used with AI systems like OpenAI's function calling\nor other LLM frameworks that support tool/function specifications. The schema and\nvalidation ensure the AI system receives proper parameter constraints.","ref":"Jido.Action.html#module-ai-tool-example"},{"type":"behaviour","title":"Testing - Jido.Action","doc":"Actions can be tested directly by calling their `run/2` function with test parameters and context:\n\n    defmodule WeatherActionTest do\n      use ExUnit.Case\n\n      test \"gets weather for location\" do\n        params = %{location: \"Portland\"}\n        context = %{}\n\n        assert {:ok, result} = WeatherAction.run(params, context)\n        assert is_map(result)\n        assert result.temperature > 0\n      end\n\n      test \"handles invalid location\" do\n        params = %{location: \"\"}\n        context = %{}\n\n        assert {:error, error} = WeatherAction.run(params, context)\n        assert error.type == :validation_error\n      end\n    end\n\nFor testing Actions in a more complete runtime environment, including signal routing, state\nmanagement, and error handling, use `Jido.Exec`. This provides a full test harness for\nvalidating Action behavior within s:\n\n    test \"weather action in \" do\n      {:ok, result} = Exec.run(WeatherAction, %{location: \"Seattle\"})\n      assert result.weather_data.temperature > 0\n    end\n\nSee `Jido.Exec` documentation for more details on action-based testing.","ref":"Jido.Action.html#module-testing"},{"type":"behaviour","title":"Parameter and Output Validation - Jido.Action","doc":"> **Note on Validation:** The validation process for Actions is intentionally open.\n> Only fields specified in the schema and output_schema are validated. Unspecified \n> fields are not validated, allowing for easier Action composition. This approach \n> enables Actions to accept and pass along additional parameters that may be required \n> by other Actions in a chain without causing validation errors.\n>\n> Output validation works the same way - only fields specified in the output_schema\n> are validated, allowing Actions to return additional data that may be used by\n> downstream Actions or systems.","ref":"Jido.Action.html#module-parameter-and-output-validation"},{"type":"macro","title":"Jido.Action.__using__/1","doc":"Defines a new Action module.\n\nThis macro sets up the necessary structure and callbacks for a Action,\nincluding configuration validation and default implementations.","ref":"Jido.Action.html#__using__/1"},{"type":"macro","title":"Options - Jido.Action.__using__/1","doc":"* `:name` - Required. The name of the Action. Must contain only letters, numbers, and underscores.\n\n* `:description` (`t:String.t/0`) - A description of what the Action does.\n\n* `:category` (`t:String.t/0`) - The category of the Action.\n\n* `:tags` (list of `t:String.t/0`) - A list of tags associated with the Action. The default value is `[]`.\n\n* `:vsn` (`t:String.t/0`) - The version of the Action.\n\n* `:compensation` (`t:keyword/0`) - The default value is `[]`.\n\n  * `:enabled` (`t:boolean/0`) - The default value is `false`.\n\n  * `:max_retries` (`t:non_neg_integer/0`) - The default value is `1`.\n\n  * `:timeout` (`t:non_neg_integer/0`) - The default value is `5000`.\n\n* `:schema` (`t:keyword/0`) - A NimbleOptions schema for validating the Action's input parameters. The default value is `[]`.\n\n* `:output_schema` (`t:keyword/0`) - A NimbleOptions schema for validating the Action's output. Only specified fields are validated. The default value is `[]`.","ref":"Jido.Action.html#__using__/1-options"},{"type":"macro","title":"Examples - Jido.Action.__using__/1","doc":"defmodule MyAction do\n      use Jido.Action,\n        name: \"my_action\",\n        description: \"Performs a specific \",\n        schema: [\n          input: [type: :string, required: true]\n        ]\n\n      @impl true\n      def run(params, _context) do\n        {:ok, %{result: String.upcase(params.input)}}\n      end\n    end","ref":"Jido.Action.html#__using__/1-examples"},{"type":"function","title":"Jido.Action.new/0","doc":"Raises an error indicating that Actions cannot be defined at runtime.\n\nThis function exists to prevent misuse of the Action system, as Actions\nare designed to be defined at compile-time only.","ref":"Jido.Action.html#new/0"},{"type":"function","title":"Returns - Jido.Action.new/0","doc":"Always returns `{:error, reason}` where `reason` is a config error.","ref":"Jido.Action.html#new/0-returns"},{"type":"function","title":"Examples - Jido.Action.new/0","doc":"iex> Jido.Action.new()\n    {:error, %Jido.Error{type: :config_error, message: \"Actions should not be defined at runtime\"}}","ref":"Jido.Action.html#new/0-examples"},{"type":"function","title":"Jido.Action.new/1","doc":"","ref":"Jido.Action.html#new/1"},{"type":"callback","title":"Jido.Action.on_after_run/1","doc":"Called after the Action's main logic has executed.\n\nThis optional callback allows for post-processing of the Action's result\nbefore it is returned to the caller.","ref":"Jido.Action.html#c:on_after_run/1"},{"type":"callback","title":"Parameters - Jido.Action.on_after_run/1","doc":"- `result`: The result map returned by the `run/2` function.","ref":"Jido.Action.html#c:on_after_run/1-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_after_run/1","doc":"- `{:ok, modified_result}` where `modified_result` is a potentially modified result map.\n- `{:error, reason}` if post-processing fails.","ref":"Jido.Action.html#c:on_after_run/1-returns"},{"type":"callback","title":"Jido.Action.on_after_validate_output/1","doc":"Called after output validation.\n\nThis optional callback allows for post-processing of validated output\nbefore it is returned to the caller.","ref":"Jido.Action.html#c:on_after_validate_output/1"},{"type":"callback","title":"Parameters - Jido.Action.on_after_validate_output/1","doc":"- `output`: A map of validated action output.","ref":"Jido.Action.html#c:on_after_validate_output/1-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_after_validate_output/1","doc":"- `{:ok, modified_output}` where `modified_output` is a map of potentially modified output.\n- `{:error, reason}` if post-processing fails.","ref":"Jido.Action.html#c:on_after_validate_output/1-returns"},{"type":"callback","title":"Jido.Action.on_after_validate_params/1","doc":"Called after parameter validation.\n\nThis optional callback allows for post-processing of validated parameters\nbefore they are passed to the `run/2` function.","ref":"Jido.Action.html#c:on_after_validate_params/1"},{"type":"callback","title":"Parameters - Jido.Action.on_after_validate_params/1","doc":"- `params`: A map of validated input parameters.","ref":"Jido.Action.html#c:on_after_validate_params/1-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_after_validate_params/1","doc":"- `{:ok, modified_params}` where `modified_params` is a map of potentially modified parameters.\n- `{:error, reason}` if post-processing fails.","ref":"Jido.Action.html#c:on_after_validate_params/1-returns"},{"type":"callback","title":"Jido.Action.on_before_validate_output/1","doc":"Called before output validation.\n\nThis optional callback allows for pre-processing of action output\nbefore it is validated against the Action's output schema.","ref":"Jido.Action.html#c:on_before_validate_output/1"},{"type":"callback","title":"Parameters - Jido.Action.on_before_validate_output/1","doc":"- `output`: A map of raw action output.","ref":"Jido.Action.html#c:on_before_validate_output/1-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_before_validate_output/1","doc":"- `{:ok, modified_output}` where `modified_output` is a map of potentially modified output.\n- `{:error, reason}` if pre-processing fails.","ref":"Jido.Action.html#c:on_before_validate_output/1-returns"},{"type":"callback","title":"Jido.Action.on_before_validate_params/1","doc":"Called before parameter validation.\n\nThis optional callback allows for pre-processing of input parameters\nbefore they are validated against the Action's schema.","ref":"Jido.Action.html#c:on_before_validate_params/1"},{"type":"callback","title":"Parameters - Jido.Action.on_before_validate_params/1","doc":"- `params`: A map of raw input parameters.","ref":"Jido.Action.html#c:on_before_validate_params/1-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_before_validate_params/1","doc":"- `{:ok, modified_params}` where `modified_params` is a map of potentially modified parameters.\n- `{:error, reason}` if pre-processing fails.","ref":"Jido.Action.html#c:on_before_validate_params/1-returns"},{"type":"callback","title":"Jido.Action.on_error/4","doc":"Handles errors and performs compensation when enabled.\n\nCalled when an error occurs during Action execution if compensation is enabled\nin the Action's configuration.","ref":"Jido.Action.html#c:on_error/4"},{"type":"callback","title":"Parameters - Jido.Action.on_error/4","doc":"- `failed_params`: The parameters that were passed to the failed execution\n- `error`: The Error struct describing what went wrong\n- `context`: The execution context at the time of failure\n- `opts`: Additional options for compensation handling","ref":"Jido.Action.html#c:on_error/4-parameters"},{"type":"callback","title":"Returns - Jido.Action.on_error/4","doc":"- `{:ok, result}` if compensation succeeded\n- `{:error, reason}` if compensation failed","ref":"Jido.Action.html#c:on_error/4-returns"},{"type":"callback","title":"Examples - Jido.Action.on_error/4","doc":"def on_error(params, error, context, opts) do\n      # Perform compensation logic\n      case rollback_changes(params) do\n        :ok -> {:ok, %{compensated: true, original_error: error}}\n        {:error, reason} -> {:error, \"Compensation failed: #{reason}\"}\n      end\n    end","ref":"Jido.Action.html#c:on_error/4-examples"},{"type":"callback","title":"Jido.Action.run/2","doc":"Executes the Action with the given parameters and context.\n\nThis callback must be implemented by modules using `Jido.Action`.","ref":"Jido.Action.html#c:run/2"},{"type":"callback","title":"Parameters - Jido.Action.run/2","doc":"- `params`: A map of validated input parameters.\n- `context`: A map containing any additional context for the .","ref":"Jido.Action.html#c:run/2-parameters"},{"type":"callback","title":"Returns - Jido.Action.run/2","doc":"- `{:ok, result}` where `result` is a map containing the 's output.\n- `{:error, reason}` where `reason` describes why the  failed.","ref":"Jido.Action.html#c:run/2-returns"},{"type":"type","title":"Jido.Action.t/0","doc":"","ref":"Jido.Action.html#t:t/0"},{"type":"behaviour","title":"Jido.Agent","doc":"Defines an Agent within the Jido system - a compile-time defined entity for managing complex s\nthrough a sequence of Actions.","ref":"Jido.Agent.html"},{"type":"behaviour","title":"Overview - Jido.Agent","doc":"An Agent represents a stateful  executor that can plan and execute a series of Actions in a\ntype-safe and composable way. Agents provide a consistent interface for orchestrating complex operations\nwhile maintaining state validation, error handling, and extensibility through lifecycle hooks.","ref":"Jido.Agent.html#module-overview"},{"type":"behaviour","title":"Architecture - Jido.Agent","doc":"","ref":"Jido.Agent.html#module-architecture"},{"type":"behaviour","title":"Key Concepts - Jido.Agent","doc":"* Agents are defined at compile-time using the `use Jido.Agent` macro\n* Each Agent instance is created at server with a guaranteed unique ID\n* Agents maintain their own state schema for validation\n* Actions are registered with Agents and executed through a Runner\n* Lifecycle hooks enable customization of validation, planning and execution flows\n* All operations follow a consistent pattern returning `{:ok, result} | {:error, reason}`","ref":"Jido.Agent.html#module-key-concepts"},{"type":"behaviour","title":"Type Safety & Validation - Jido.Agent","doc":"* Configuration validated at compile-time via NimbleOptions\n* Server state changes validated against defined schema\n* Action modules checked for behavior implementation\n* Consistent return type enforcement across operations","ref":"Jido.Agent.html#module-type-safety-validation"},{"type":"behaviour","title":"Features - Jido.Agent","doc":"* Compile-time configuration validation\n* Server parameter validation via NimbleOptions\n* Comprehensive error handling with recovery hooks\n* Extensible lifecycle callbacks for all operations\n* JSON serialization support for persistence\n* Dynamic Action planning and execution\n* State management with validation and dirty tracking","ref":"Jido.Agent.html#module-features"},{"type":"behaviour","title":"Usage - Jido.Agent","doc":"","ref":"Jido.Agent.html#module-usage"},{"type":"behaviour","title":"Basic Example - Jido.Agent","doc":"defmodule MyAgent do\n      use Jido.Agent,\n        name: \"my_agent\",\n        description: \"Performs a complex \",\n        category: \"processing\",\n        tags: [\"example\", \"demo\"],\n        vsn: \"1.0.0\",\n        schema: [\n          input: [type: :string, required: true],\n          status: [type: :atom, values: [:pending, :running, :complete]]\n        ],\n        actions: [MyAction1, MyAction2]\n    end\n\n    # Create and configure agent\n    {:ok, agent} = MyAgent.new()\n    {:ok, agent} = MyAgent.set(agent, input: \"test data\")\n\n    # Plan and execute actions\n    {:ok, agent} = MyAgent.plan(agent, MyAction1, %{value: 1})\n    {:ok, agent} = MyAgent.run(agent)  # Result stored in agent.result","ref":"Jido.Agent.html#module-basic-example"},{"type":"behaviour","title":"Customizing Behavior - Jido.Agent","doc":"defmodule CustomAgent do\n      use Jido.Agent,\n        name: \"custom_agent\",\n        schema: [status: [type: :atom]]\n\n      # Add pre-execution validation\n      def on_before_run(agent) do\n        if agent.state.status == :ready do\n          {:ok, agent}\n        else\n          {:error, \"Agent not ready\"}\n        end\n      end\n\n      # Custom error recovery\n      def on_error(agent, error) do\n        Logger.warning(\"Agent error\", error: error)\n        {:ok, %{agent | state: %{status: :error}}}\n      end\n    end","ref":"Jido.Agent.html#module-customizing-behavior"},{"type":"behaviour","title":"Callbacks - Jido.Agent","doc":"The following optional callbacks can be implemented to customize agent behavior.\nAll callbacks receive the agent struct and return `{:ok, agent} | {:error, reason}`.\n\n* `on_before_validate_state/1` - Pre-validation processing\n* `on_after_validate_state/1`  - Post-validation processing\n* `on_before_plan/3`           - Pre-planning processing with params\n* `on_before_run/1`            - Pre-execution validation/setup\n* `on_after_run/3`             - Post-execution processing\n* `on_error/2`                 - Error handling and recovery\n\nDefault implementations pass through the agent unchanged.","ref":"Jido.Agent.html#module-callbacks"},{"type":"behaviour","title":"Important Notes - Jido.Agent","doc":"Each Agent module defines its own struct type and behavior. Agent functions must be called\non matching agent structs:\n\n\n```elixir\n  # Correct usage:\n  agent = MyAgent.new()\n  {:ok, agent} = MyAgent.set(agent, attrs)\n\n  # Incorrect usage:\n  agent = MyAgent.new()\n  {:ok, agent} = OtherAgent.set(agent, attrs)  # Will fail - type mismatch\n```","ref":"Jido.Agent.html#module-important-notes"},{"type":"behaviour","title":"Runner Architecture - Jido.Agent","doc":"The Runner executes actions in the agent's pending_instructions queue.\n\n* Default implementation: `Jido.Runner.Simple`\n* Custom runners must implement the `Jido.Runner` behavior\n* Runners handle instruction execution and state management\n* Support for different execution strategies (simple, chain, parallel)","ref":"Jido.Agent.html#module-runner-architecture"},{"type":"behaviour","title":"Error Handling - Jido.Agent","doc":"Errors are returned as tagged tuples: `{:error, reason}`\n\nCommon error types:\n* `:validation_error` - Schema/parameter validation failures\n* `:execution_error`  - Action execution failures\n* `:directive_error`  - Directive application failures\n\nSee `Jido.Action` for implementing compatible Actions.","ref":"Jido.Agent.html#module-error-handling"},{"type":"behaviour","title":"Type Specifications - Jido.Agent","doc":"* `t()` - The Agent struct type\n* `instruction()` - Single action with params\n* `instructions()` - List of instructions\n* `agent_result()` - `{:ok, t()} | {:error, term()}`","ref":"Jido.Agent.html#module-type-specifications"},{"type":"type","title":"Jido.Agent.agent_result/0","doc":"","ref":"Jido.Agent.html#t:agent_result/0"},{"type":"type","title":"Jido.Agent.agent_result_with_directives/0","doc":"","ref":"Jido.Agent.html#t:agent_result_with_directives/0"},{"type":"callback","title":"Jido.Agent.child_spec/1","doc":"","ref":"Jido.Agent.html#c:child_spec/1"},{"type":"macro","title":"Jido.Agent.dbug/2","doc":"","ref":"Jido.Agent.html#dbug/2"},{"type":"function","title":"Jido.Agent.deregister_action/2","doc":"","ref":"Jido.Agent.html#deregister_action/2"},{"type":"macro","title":"Jido.Agent.error/2","doc":"","ref":"Jido.Agent.html#error/2"},{"type":"callback","title":"Jido.Agent.handle_signal/2","doc":"","ref":"Jido.Agent.html#c:handle_signal/2"},{"type":"type","title":"Jido.Agent.instruction/0","doc":"","ref":"Jido.Agent.html#t:instruction/0"},{"type":"type","title":"Jido.Agent.instructions/0","doc":"","ref":"Jido.Agent.html#t:instructions/0"},{"type":"type","title":"Jido.Agent.map_result/0","doc":"","ref":"Jido.Agent.html#t:map_result/0"},{"type":"callback","title":"Jido.Agent.mount/2","doc":"","ref":"Jido.Agent.html#c:mount/2"},{"type":"function","title":"Jido.Agent.new/0","doc":"Raises an error indicating that Agents cannot be defined at server.\n\nThis function exists to prevent misuse of the Agent system, as Agents\nare designed to be defined at compile-time only.","ref":"Jido.Agent.html#new/0"},{"type":"function","title":"Returns - Jido.Agent.new/0","doc":"Always returns `{:error, reason}` where `reason` is a config error.","ref":"Jido.Agent.html#new/0-returns"},{"type":"function","title":"Examples - Jido.Agent.new/0","doc":"iex> Jido.Agent.new()\n    {:error, %Jido.Error{type: :config_error, message: \"Agents should not be defined at server\"}}","ref":"Jido.Agent.html#new/0-examples"},{"type":"function","title":"Jido.Agent.new/1","doc":"","ref":"Jido.Agent.html#new/1"},{"type":"callback","title":"Jido.Agent.on_after_run/3","doc":"Called after successful action execution.\nAllows post-processing of execution results.","ref":"Jido.Agent.html#c:on_after_run/3"},{"type":"callback","title":"Jido.Agent.on_after_validate_state/1","doc":"Called after state validation but before saving changes.\nAllows post-processing of validated state.","ref":"Jido.Agent.html#c:on_after_validate_state/1"},{"type":"callback","title":"Jido.Agent.on_before_plan/3","doc":"Called before planning actions, allows preprocessing of instructions prior to appending to the agent's queue","ref":"Jido.Agent.html#c:on_before_plan/3"},{"type":"callback","title":"Jido.Agent.on_before_run/1","doc":"Called after action planning but before execution.\nAllows inspection/modification of planned actions.","ref":"Jido.Agent.html#c:on_before_run/1"},{"type":"callback","title":"Jido.Agent.on_before_validate_state/1","doc":"Called before validating any state changes to the Agent.\nAllows custom preprocessing of state attributes.","ref":"Jido.Agent.html#c:on_before_validate_state/1"},{"type":"callback","title":"Jido.Agent.on_error/2","doc":"","ref":"Jido.Agent.html#c:on_error/2"},{"type":"function","title":"Jido.Agent.register_action/2","doc":"Registers one or more action modules with the agent at server. Registered actions\ncan be used in planning and execution. Action modules must implement the `Jido.Action`\nbehavior and pass validation checks.","ref":"Jido.Agent.html#register_action/2"},{"type":"function","title":"Action Requirements - Jido.Agent.register_action/2","doc":"* Must be valid Elixir modules implementing `Jido.Action` behavior\n* Must be loaded and available at server\n* Must pass validation via `Jido.Util.validate_actions/1`","ref":"Jido.Agent.html#register_action/2-action-requirements"},{"type":"function","title":"Parameters - Jido.Agent.register_action/2","doc":"* `agent` - The agent struct to update\n* `action_module` - Single action module or list of action modules to register","ref":"Jido.Agent.html#register_action/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.register_action/2","doc":"* `{:ok, updated_agent}` - Agent struct with newly registered actions prepended\n* `{:error, String.t()}` - If action validation fails","ref":"Jido.Agent.html#register_action/2-returns"},{"type":"function","title":"Examples - Jido.Agent.register_action/2","doc":"# Register single action\n    {:ok, agent} = MyAgent.register_action(agent, MyApp.Actions.ProcessFile)\n\n    # Register multiple actions\n    {:ok, agent} = MyAgent.register_action(agent, [Action1, Action2])","ref":"Jido.Agent.html#register_action/2-examples"},{"type":"function","title":"Server Considerations - Jido.Agent.register_action/2","doc":"* Actions persist only for the agent's lifecycle\n* Duplicates are prevented during validation\n* Most recently registered actions take precedence\n\nSee `Jido.Action` for implementing actions and `Jido.Util.validate_actions/1` for validation details.","ref":"Jido.Agent.html#register_action/2-server-considerations"},{"type":"function","title":"Jido.Agent.registered_actions/1","doc":"Returns all action modules registered with the agent in registration order.\nIncludes both compile-time and server-registered actions.","ref":"Jido.Agent.html#registered_actions/1"},{"type":"function","title":"Parameters - Jido.Agent.registered_actions/1","doc":"* `agent` - The agent struct to inspect","ref":"Jido.Agent.html#registered_actions/1-parameters"},{"type":"function","title":"Returns - Jido.Agent.registered_actions/1","doc":"* `[module()]` - Action modules ordered by registration time (newest first)","ref":"Jido.Agent.html#registered_actions/1-returns"},{"type":"function","title":"Examples - Jido.Agent.registered_actions/1","doc":"agent = MyAgent.new()\n    MyAgent.registered_actions(agent) #=> [DefaultAction, CoreAction]\n\n    {:ok, agent} = MyAgent.register_action(agent, CustomAction)\n    MyAgent.registered_actions(agent) #=> [CustomAction, DefaultAction, CoreAction]\n\nSee `register_action/2` for adding actions and `plan/3` for using them.","ref":"Jido.Agent.html#registered_actions/1-examples"},{"type":"callback","title":"Jido.Agent.shutdown/2","doc":"","ref":"Jido.Agent.html#c:shutdown/2"},{"type":"callback","title":"Jido.Agent.start_link/1","doc":"","ref":"Jido.Agent.html#c:start_link/1"},{"type":"type","title":"Jido.Agent.t/0","doc":"","ref":"Jido.Agent.html#t:t/0"},{"type":"callback","title":"Jido.Agent.transform_result/3","doc":"","ref":"Jido.Agent.html#c:transform_result/3"},{"type":"module","title":"Jido.Agent.Server","doc":"GenServer implementation for managing agent processes.\n\nThis server handles the lifecycle and runtime execution of agents, including:\n- Agent initialization and startup\n- Signal processing and routing\n- State management and transitions\n- Child process supervision\n- Graceful shutdown\n\nThe server can be started in different modes (`:auto` or `:manual`) and supports\nboth synchronous (call) and asynchronous (cast) signal handling.","ref":"Jido.Agent.Server.html"},{"type":"function","title":"Jido.Agent.Server.call/3","doc":"Sends a synchronous signal to an agent and waits for the response.","ref":"Jido.Agent.Server.html#call/3"},{"type":"function","title":"Jido.Agent.Server.cast/2","doc":"Sends an asynchronous signal to an agent.","ref":"Jido.Agent.Server.html#cast/2"},{"type":"function","title":"Jido.Agent.Server.child_spec/1","doc":"Returns a child specification for starting the server under a supervisor.","ref":"Jido.Agent.Server.html#child_spec/1"},{"type":"macro","title":"Jido.Agent.Server.dbug/2","doc":"","ref":"Jido.Agent.Server.html#dbug/2"},{"type":"macro","title":"Jido.Agent.Server.error/2","doc":"","ref":"Jido.Agent.Server.html#error/2"},{"type":"function","title":"Jido.Agent.Server.start_link/1","doc":"Starts a new agent server process.","ref":"Jido.Agent.Server.html#start_link/1"},{"type":"function","title":"Options - Jido.Agent.Server.start_link/1","doc":"* `:id` - Unique identifier for the agent (auto-generated if not provided)\n  * `:agent` - Agent module or struct to be managed\n  * `:initial_state` - Initial state map for the agent\n  * `:registry` - Registry for process registration\n  * `:mode` - Operation mode (`:auto` or `:manual`)\n  * `:routes` - Routes for the agent\n  * `:output` - Output destination for agent signals\n  * `:log_level` - Logging level\n  * `:max_queue_size` - Maximum size of pending signals queue","ref":"Jido.Agent.Server.html#start_link/1-options"},{"type":"function","title":"Returns - Jido.Agent.Server.start_link/1","doc":"* `{:ok, pid}` - Successfully started server process\n  * `{:error, reason}` - Failed to start server","ref":"Jido.Agent.Server.html#start_link/1-returns"},{"type":"type","title":"Jido.Agent.Server.start_option/0","doc":"","ref":"Jido.Agent.Server.html#t:start_option/0"},{"type":"function","title":"Jido.Agent.Server.state/1","doc":"Gets the current state of an agent.","ref":"Jido.Agent.Server.html#state/1"},{"type":"function","title":"Jido.Agent.Server.via_tuple/2","doc":"Returns a via tuple for process registration.","ref":"Jido.Agent.Server.html#via_tuple/2"},{"type":"module","title":"Jido.Instruction","doc":"Instructions in Jido represent discrete units of work that can be planned, validated, and executed by agents.\nThink of them as \"work orders\" that tell agents exactly what needs to be done and how to do it.","ref":"Jido.Instruction.html"},{"type":"module","title":"Core Concepts - Jido.Instruction","doc":"An Instruction wraps an Action module with everything it needs to execute:\n- The Action to perform (required)\n- Parameters for the action\n- Execution context\n- Runtime options","ref":"Jido.Instruction.html#module-core-concepts"},{"type":"module","title":"Structure - Jido.Instruction","doc":"Each Instruction contains:\n\n```elixir\n%Instruction{\n  id: \"inst_abc123\",           # Unique identifier\n  action: MyApp.Actions.DoTask, # The action module to execute\n  params: %{value: 42},        # Parameters for the action\n  context: %{user_id: \"123\"},  # Execution context\n  opts: [retry: true],         # Runtime options\n}\n```","ref":"Jido.Instruction.html#module-structure"},{"type":"module","title":"Creating Instructions - Jido.Instruction","doc":"Instructions support multiple creation formats for convenience:","ref":"Jido.Instruction.html#module-creating-instructions"},{"type":"module","title":"1. Full Struct - Jido.Instruction","doc":"```elixir\n%Instruction{\n  action: MyApp.Actions.ProcessOrder,\n  params: %{order_id: \"123\"},\n  context: %{tenant_id: \"456\"}\n}\n```","ref":"Jido.Instruction.html#module-1-full-struct"},{"type":"module","title":"2. Action Module Only - Jido.Instruction","doc":"```elixir\nMyApp.Actions.ProcessOrder\n```","ref":"Jido.Instruction.html#module-2-action-module-only"},{"type":"module","title":"3. Action With Parameters - Jido.Instruction","doc":"```elixir\n{MyApp.Actions.ProcessOrder, %{order_id: \"123\"}}\n```","ref":"Jido.Instruction.html#module-3-action-with-parameters"},{"type":"module","title":"4. Factory Function - Jido.Instruction","doc":"```elixir\nInstruction.new!(%{\n  action: MyApp.Actions.ProcessOrder,\n  params: %{order_id: \"123\"},\n  context: %{tenant_id: \"456\"}\n})\n```","ref":"Jido.Instruction.html#module-4-factory-function"},{"type":"module","title":"Working with Instructions - Jido.Instruction","doc":"","ref":"Jido.Instruction.html#module-working-with-instructions"},{"type":"module","title":"Normalization - Jido.Instruction","doc":"Convert various input formats to standard instruction structs:\n\n```elixir\n# Normalize a single instruction\n{:ok, [instruction]} = Instruction.normalize(MyApp.Actions.ProcessOrder)\n\n# Normalize with context\n{:ok, instructions} = Instruction.normalize(\n  [\n    MyApp.Actions.ValidateOrder,\n    {MyApp.Actions.ProcessOrder, %{priority: \"high\"}}\n  ],\n  %{tenant_id: \"123\"}  # Shared context\n)\n```","ref":"Jido.Instruction.html#module-normalization"},{"type":"module","title":"Validation - Jido.Instruction","doc":"Ensure instructions use allowed actions:\n\n```elixir\nallowed_actions = [\n  MyApp.Actions.ValidateOrder,\n  MyApp.Actions.ProcessOrder\n]\n\n:ok = Instruction.validate_allowed_actions(instructions, allowed_actions)\n```","ref":"Jido.Instruction.html#module-validation"},{"type":"module","title":"Common Patterns - Jido.Instruction","doc":"","ref":"Jido.Instruction.html#module-common-patterns"},{"type":"module","title":"1. Exec Definition - Jido.Instruction","doc":"```elixir\ninstructions = [\n  MyApp.Actions.ValidateInput,\n  {MyApp.Actions.ProcessData, %{format: \"json\"}},\n  MyApp.Actions.SaveResults\n]\n```","ref":"Jido.Instruction.html#module-1-exec-definition"},{"type":"module","title":"2. Conditional Execution - Jido.Instruction","doc":"```elixir\ninstructions = [\n  MyApp.Actions.ValidateOrder,\n  {MyApp.Actions.CheckInventory, %{strict: true}},\n  # Add fulfillment only if in stock\n  if has_stock? do\n    {MyApp.Actions.FulfillOrder, %{warehouse: \"main\"}}\n  end\n]\n|> Enum.reject(&is_nil/1)\n```","ref":"Jido.Instruction.html#module-2-conditional-execution"},{"type":"module","title":"3. Context Sharing - Jido.Instruction","doc":"```elixir\n# All instructions share common context\n{:ok, instructions} = Instruction.normalize(\n  [ValidateUser, ProcessOrder, NotifyUser],\n  %{\n    request_id: \"req_123\",\n    tenant_id: \"tenant_456\",\n  }\n)\n```","ref":"Jido.Instruction.html#module-3-context-sharing"},{"type":"module","title":"See Also - Jido.Instruction","doc":"- `Jido.Action` - Action behavior and implementation\n- `Jido.Runner` - Instruction execution\n- `Jido.Agent` - Agent-based execution","ref":"Jido.Instruction.html#module-see-also"},{"type":"type","title":"Jido.Instruction.action_module/0","doc":"","ref":"Jido.Instruction.html#t:action_module/0"},{"type":"type","title":"Jido.Instruction.action_params/0","doc":"","ref":"Jido.Instruction.html#t:action_params/0"},{"type":"type","title":"Jido.Instruction.action_tuple/0","doc":"","ref":"Jido.Instruction.html#t:action_tuple/0"},{"type":"type","title":"Jido.Instruction.instruction/0","doc":"","ref":"Jido.Instruction.html#t:instruction/0"},{"type":"type","title":"Jido.Instruction.instruction_list/0","doc":"","ref":"Jido.Instruction.html#t:instruction_list/0"},{"type":"function","title":"Jido.Instruction.new/1","doc":"Creates a new Instruction struct from a map or keyword list of attributes.","ref":"Jido.Instruction.html#new/1"},{"type":"function","title":"Parameters - Jido.Instruction.new/1","doc":"* `attrs` - Map or keyword list containing instruction attributes:\n    * `:action` - Action module (required)\n    * `:params` - Map of parameters (optional, default: %{})\n    * `:context` - Context map (optional, default: %{})\n    * `:opts` - Keyword list of options (optional, default: [])\n    * `:id` - String identifier (optional, defaults to UUID)","ref":"Jido.Instruction.html#new/1-parameters"},{"type":"function","title":"Returns - Jido.Instruction.new/1","doc":"* `{:ok, %Instruction{}}` - Successfully created instruction\n  * `{:error, :missing_action}` - If action is not provided\n  * `{:error, :invalid_action}` - If action is not a module","ref":"Jido.Instruction.html#new/1-returns"},{"type":"function","title":"Examples - Jido.Instruction.new/1","doc":"iex> Instruction.new(%{action: MyAction, params: %{value: 1}})\n    {:ok, %Instruction{action: MyAction, params: %{value: 1}}}\n\n    iex> Instruction.new(action: MyAction)\n    {:ok, %Instruction{action: MyAction}}\n\n    iex> Instruction.new(%{params: %{value: 1}})\n    {:error, :missing_action}","ref":"Jido.Instruction.html#new/1-examples"},{"type":"function","title":"Jido.Instruction.new!/1","doc":"Creates a new Instruction struct from a map or keyword list of attributes.\nReturns the struct directly or raises an error.","ref":"Jido.Instruction.html#new!/1"},{"type":"function","title":"Parameters - Jido.Instruction.new!/1","doc":"* `attrs` - Map or keyword list containing instruction attributes:\n    * `:action` - Action module (required)\n    * `:params` - Map of parameters (optional, default: %{})\n    * `:context` - Context map (optional, default: %{})\n    * `:opts` - Keyword list of options (optional, default: [])","ref":"Jido.Instruction.html#new!/1-parameters"},{"type":"function","title":"Returns - Jido.Instruction.new!/1","doc":"* `%Instruction{}` - Successfully created instruction","ref":"Jido.Instruction.html#new!/1-returns"},{"type":"function","title":"Raises - Jido.Instruction.new!/1","doc":"* `Jido.Error` - If action is missing or invalid","ref":"Jido.Instruction.html#new!/1-raises"},{"type":"function","title":"Examples - Jido.Instruction.new!/1","doc":"iex> Instruction.new!(%{action: MyAction, params: %{value: 1}})\n    %Instruction{action: MyAction, params: %{value: 1}}\n\n    iex> Instruction.new!(action: MyAction)\n    %Instruction{action: MyAction}\n\n    iex> Instruction.new!(%{params: %{value: 1}})\n    ** (Jido.Error) missing action","ref":"Jido.Instruction.html#new!/1-examples"},{"type":"function","title":"Jido.Instruction.normalize/3","doc":"Normalizes instruction shorthand input into instruction structs. Accepts a variety of input formats\nand returns a list of normalized instruction structs.","ref":"Jido.Instruction.html#normalize/3"},{"type":"function","title":"Parameters - Jido.Instruction.normalize/3","doc":"* `input` - One of:\n    * Single instruction struct (%Instruction{})\n    * List of instruction structs\n    * Single action module (MyApp.Actions.ProcessOrder)\n    * Action tuple with params ({MyApp.Actions.ProcessOrder, %{order_id: \"123\"}})\n    * Action tuple with empty params ({MyApp.Actions.ProcessOrder, %{}})\n    * Action tuple with context ({MyApp.Actions.ProcessOrder, %{}, %{tenant_id: \"123\"}})\n    * Action tuple with opts ({MyApp.Actions.ProcessOrder, %{}, %{}, [retry: true]})\n    * List of any combination of the above formats\n  * `context` - Optional context map to merge into all instructions (default: %{})\n  * `opts` - Optional keyword list of options (default: [])","ref":"Jido.Instruction.html#normalize/3-parameters"},{"type":"function","title":"Returns - Jido.Instruction.normalize/3","doc":"* `{:ok, [%Instruction{}]}` - List of normalized instruction structs\n  * `{:error, term()}` - If normalization fails","ref":"Jido.Instruction.html#normalize/3-returns"},{"type":"function","title":"Examples - Jido.Instruction.normalize/3","doc":"iex> Instruction.normalize(MyApp.Actions.ProcessOrder)\n    {:ok, [%Instruction{action: MyApp.Actions.ProcessOrder}]}\n\n    iex> Instruction.normalize({MyApp.Actions.ProcessOrder, %{order_id: \"123\"}})\n    {:ok, [%Instruction{action: MyApp.Actions.ProcessOrder, params: %{order_id: \"123\"}}]}\n\n    iex> Instruction.normalize([\n    ...>   MyApp.Actions.ValidateOrder,\n    ...>   {MyApp.Actions.ProcessOrder, %{priority: \"high\"}},\n    ...>   {MyApp.Actions.NotifyUser, %{}, %{user_id: \"123\"}}\n    ...> ])\n    {:ok, [%Instruction{...}, %Instruction{...}, %Instruction{...}]}","ref":"Jido.Instruction.html#normalize/3-examples"},{"type":"function","title":"Jido.Instruction.normalize!/3","doc":"Same as `normalize/3` but raises on error.","ref":"Jido.Instruction.html#normalize!/3"},{"type":"function","title":"Parameters - Jido.Instruction.normalize!/3","doc":"* `instruction` - Instruction to normalize\n  * `context` - Optional context map to merge\n  * `opts` - Optional options to merge","ref":"Jido.Instruction.html#normalize!/3-parameters"},{"type":"function","title":"Returns - Jido.Instruction.normalize!/3","doc":"* `[t()]` - List of normalized instructions","ref":"Jido.Instruction.html#normalize!/3-returns"},{"type":"function","title":"Raises - Jido.Instruction.normalize!/3","doc":"* `Jido.Error` - If instruction cannot be normalized","ref":"Jido.Instruction.html#normalize!/3-raises"},{"type":"function","title":"Examples - Jido.Instruction.normalize!/3","doc":"iex> Instruction.normalize!({MyAction, %{value: 42}})\n    [%Instruction{action: MyAction, params: %{value: 42}}]\n\n    iex> Instruction.normalize!(MyAction)\n    [%Instruction{action: MyAction, params: %{}}]","ref":"Jido.Instruction.html#normalize!/3-examples"},{"type":"function","title":"Jido.Instruction.normalize_single/3","doc":"Normalizes a single instruction into an instruction struct. Unlike normalize/3,\nthis function enforces that the input must be a single instruction and returns\na single instruction struct rather than a list.","ref":"Jido.Instruction.html#normalize_single/3"},{"type":"function","title":"Parameters - Jido.Instruction.normalize_single/3","doc":"* `input` - One of:\n    * Single instruction struct (%Instruction{})\n    * Single action module (MyApp.Actions.ProcessOrder)\n    * Action tuple with params ({MyApp.Actions.ProcessOrder, %{order_id: \"123\"}})\n    * Action tuple with empty params ({MyApp.Actions.ProcessOrder, %{}})\n  * `context` - Optional context map to merge into the instruction (default: %{})\n  * `opts` - Optional keyword list of options (default: [])","ref":"Jido.Instruction.html#normalize_single/3-parameters"},{"type":"function","title":"Returns - Jido.Instruction.normalize_single/3","doc":"* `{:ok, %Instruction{}}` - Successfully normalized instruction\n  * `{:error, term()}` - If normalization fails","ref":"Jido.Instruction.html#normalize_single/3-returns"},{"type":"function","title":"Examples - Jido.Instruction.normalize_single/3","doc":"iex> Instruction.normalize_single(MyApp.Actions.ProcessOrder)\n    {:ok, %Instruction{action: MyApp.Actions.ProcessOrder}}\n\n    iex> Instruction.normalize_single({MyApp.Actions.ProcessOrder, %{order_id: \"123\"}})\n    {:ok, %Instruction{action: MyApp.Actions.ProcessOrder, params: %{order_id: \"123\"}}}","ref":"Jido.Instruction.html#normalize_single/3-examples"},{"type":"type","title":"Jido.Instruction.t/0","doc":"","ref":"Jido.Instruction.html#t:t/0"},{"type":"function","title":"Jido.Instruction.validate_allowed_actions/2","doc":"Validates that all instructions use allowed actions.","ref":"Jido.Instruction.html#validate_allowed_actions/2"},{"type":"function","title":"Parameters - Jido.Instruction.validate_allowed_actions/2","doc":"* `instructions` - List of instruction structs\n  * `allowed_actions` - List of allowed action modules","ref":"Jido.Instruction.html#validate_allowed_actions/2-parameters"},{"type":"function","title":"Returns - Jido.Instruction.validate_allowed_actions/2","doc":"* `:ok` - All actions are allowed\n  * `{:error, term()}` - If any action is not allowed","ref":"Jido.Instruction.html#validate_allowed_actions/2-returns"},{"type":"function","title":"Examples - Jido.Instruction.validate_allowed_actions/2","doc":"iex> instructions = [%Instruction{action: MyAction}, %Instruction{action: OtherAction}]\n    iex> Instruction.validate_allowed_actions(instructions, [MyAction])\n    {:error, \"Actions not allowed: OtherAction\"}\n\n    iex> instructions = [%Instruction{action: MyAction}]\n    iex> Instruction.validate_allowed_actions(instructions, [MyAction])\n    :ok","ref":"Jido.Instruction.html#validate_allowed_actions/2-examples"},{"type":"behaviour","title":"Jido.Sensor","doc":"Defines the behavior and implementation for Sensors in the Jido system.\n\nA Sensor is a GenServer that emits Signals using a Jido.Bus based on specific events and retains a configurable number of last values.","ref":"Jido.Sensor.html"},{"type":"behaviour","title":"Usage - Jido.Sensor","doc":"To define a new Sensor, use the `Jido.Sensor` behavior in your module:\n\n    defmodule MySensor do\n      use Jido.Sensor,\n        name: \"my_sensor\",\n        description: \"Monitors a specific metric\",\n        category: :monitoring,\n        tags: [:example, :demo],\n        vsn: \"1.0.0\",\n        schema: [\n          metric: [type: :string, required: true]\n        ]\n\n      @impl true\n      def generate_signal(state) do\n        # Your sensor logic here\n        {:ok, Jido.Signal.new(%{\n          source: \"#{state.sensor.name}:#{state.id}\",\n          topic: \"metric_update\",\n          payload: %{value: get_metric_value()},\n          timestamp: DateTime.utc_now()\n        })}\n      end\n    end","ref":"Jido.Sensor.html#module-usage"},{"type":"behaviour","title":"Callbacks - Jido.Sensor","doc":"Implementing modules can override the following callbacks:\n\n- `c:mount/1`: Called when the sensor is initialized.\n- `c:deliver_signal/1`: Generates a signal based on the current state.\n- `c:on_before_deliver/2`: Called before a signal is delivered.\n- `c:shutdown/1`: Called when the sensor is shutting down.","ref":"Jido.Sensor.html#module-callbacks"},{"type":"callback","title":"Jido.Sensor.deliver_signal/1","doc":"","ref":"Jido.Sensor.html#c:deliver_signal/1"},{"type":"callback","title":"Jido.Sensor.mount/1","doc":"","ref":"Jido.Sensor.html#c:mount/1"},{"type":"callback","title":"Jido.Sensor.on_before_deliver/2","doc":"","ref":"Jido.Sensor.html#c:on_before_deliver/2"},{"type":"type","title":"Jido.Sensor.options/0","doc":"","ref":"Jido.Sensor.html#t:options/0"},{"type":"callback","title":"Jido.Sensor.shutdown/1","doc":"","ref":"Jido.Sensor.html#c:shutdown/1"},{"type":"type","title":"Jido.Sensor.t/0","doc":"","ref":"Jido.Sensor.html#t:t/0"},{"type":"behaviour","title":"Jido.Runner","doc":"Behavior for executing planned actions on an Agent.\n\nJido provides two built-in runners:\n\n- `Jido.Runner.Simple` - Executes a single instruction from the agent's queue,\n  handling state updates and directives atomically.\n\n- `Jido.Runner.Chain` - Executes multiple instructions sequentially, with results\n  flowing between steps and support for directive-based flow control.","ref":"Jido.Runner.html"},{"type":"type","title":"Jido.Runner.action/0","doc":"","ref":"Jido.Runner.html#t:action/0"},{"type":"callback","title":"Jido.Runner.run/2","doc":"","ref":"Jido.Runner.html#c:run/2"},{"type":"module","title":"Jido.Runner.Chain","doc":"A runner that executes instructions sequentially with support for result chaining.","ref":"Jido.Runner.Chain.html"},{"type":"module","title":"Chain Execution - Jido.Runner.Chain","doc":"Instructions are executed in sequence with the output of each instruction\nbecoming the input for the next instruction in the chain via the merge_results option.","ref":"Jido.Runner.Chain.html#module-chain-execution"},{"type":"module","title":"Features - Jido.Runner.Chain","doc":"* Sequential instruction execution\n* Result chaining between instructions\n* Directive accumulation\n* Comprehensive error handling","ref":"Jido.Runner.Chain.html#module-features"},{"type":"type","title":"Jido.Runner.Chain.chain_opts/0","doc":"","ref":"Jido.Runner.Chain.html#t:chain_opts/0"},{"type":"type","title":"Jido.Runner.Chain.chain_result/0","doc":"","ref":"Jido.Runner.Chain.html#t:chain_result/0"},{"type":"macro","title":"Jido.Runner.Chain.dbug/2","doc":"","ref":"Jido.Runner.Chain.html#dbug/2"},{"type":"macro","title":"Jido.Runner.Chain.error/2","doc":"","ref":"Jido.Runner.Chain.html#error/2"},{"type":"function","title":"Jido.Runner.Chain.run/2","doc":"Executes a chain of instructions sequentially, with optional result merging.","ref":"Jido.Runner.Chain.html#run/2"},{"type":"function","title":"Parameters - Jido.Runner.Chain.run/2","doc":"* `agent` - The agent struct containing:\n    * `pending_instructions` - Queue of pending instructions\n    * `state` - Current agent state\n    * `id` - Agent identifier\n  * `opts` - Optional keyword list of execution options:\n    * `:merge_results` - When true, merges each result into the next instruction's params (default: true)\n    * `:apply_directives?` - When true (default), applies directives during execution\n    * `:timeout` - Timeout in milliseconds for action execution (merged with instruction opts)\n    * `:log_level` - Log level for debugging output","ref":"Jido.Runner.Chain.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.Runner.Chain.run/2","doc":"* `{:ok, updated_agent, directives}` - Chain completed successfully with:\n    * Final result stored in agent.result\n    * List of accumulated directives\n  * `{:error, error}` - Chain execution failed with error details","ref":"Jido.Runner.Chain.html#run/2-returns"},{"type":"function","title":"Examples - Jido.Runner.Chain.run/2","doc":"# Basic chain execution\n    {:ok, updated_agent, directives} = Chain.run(agent)\n\n    # Chain with result merging disabled\n    {:ok, updated_agent, directives} = Chain.run(agent, merge_results: false)\n\n    # Chain without applying directives\n    {:ok, updated_agent, directives} = Chain.run(agent, apply_directives?: false)\n\n    # Chain with custom timeout (runner opts are merged with instruction opts)\n    {:ok, updated_agent, directives} = Chain.run(agent, timeout: 60_000)","ref":"Jido.Runner.Chain.html#run/2-examples"},{"type":"module","title":"Jido.Runner.Simple","doc":"A simple runner that executes a single instruction from an Agent's instruction queue.","ref":"Jido.Runner.Simple.html"},{"type":"module","title":"Overview - Jido.Runner.Simple","doc":"The Simple Runner follows a sequential execution model:\n1. Dequeues a single instruction from the agent's pending queue\n2. Executes the instruction via its action module\n3. Processes the result (either a state update, directive or both)\n4. Applies state changes if configured\n5. Returns the updated agent with the execution results and server directives","ref":"Jido.Runner.Simple.html#module-overview"},{"type":"module","title":"Features - Jido.Runner.Simple","doc":"* Single instruction execution\n* Support for directives and state results\n* Atomic execution guarantees\n* Comprehensive error handling\n* Debug logging at key execution points\n* Optional state application","ref":"Jido.Runner.Simple.html#module-features"},{"type":"module","title":"Error Handling - Jido.Runner.Simple","doc":"* Invalid instructions are rejected\n* Action execution failures return error results\n* Queue empty condition handled gracefully\n* All errors preserve the original agent state","ref":"Jido.Runner.Simple.html#module-error-handling"},{"type":"macro","title":"Jido.Runner.Simple.dbug/2","doc":"","ref":"Jido.Runner.Simple.html#dbug/2"},{"type":"macro","title":"Jido.Runner.Simple.error/2","doc":"","ref":"Jido.Runner.Simple.html#error/2"},{"type":"function","title":"Jido.Runner.Simple.run/2","doc":"Executes a single instruction from the Agent's pending instructions queue.","ref":"Jido.Runner.Simple.html#run/2"},{"type":"function","title":"Execution Process - Jido.Runner.Simple.run/2","doc":"1. Dequeues the oldest instruction from the agent's queue\n2. Creates a new Result struct to track execution\n3. Executes the instruction through its action module\n4. Processes any directives from the execution\n5. Optionally applies state changes\n6. Returns the updated agent with execution results and server directives","ref":"Jido.Runner.Simple.html#run/2-execution-process"},{"type":"function","title":"Parameters - Jido.Runner.Simple.run/2","doc":"* `agent` - The agent struct containing:\n    * `pending_instructions` - Queue of pending instructions\n    * `state` - Current agent state\n    * `id` - Agent identifier\n  * `opts` - Optional keyword list of execution options:\n    * `apply_directives?` - When true (default), applies directives during execution\n    * `timeout` - Timeout in milliseconds for action execution (merged with instruction opts)\n    * `log_level` - Log level for debugging output","ref":"Jido.Runner.Simple.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.Runner.Simple.run/2","doc":"* `{:ok, updated_agent, directives}` - Successful execution with:\n    * Updated state map (for state results)\n    * Updated pending instructions queue\n    * Any server directives from the execution\n  * `{:error, reason}` - Execution failed with:\n    * String error for queue empty condition\n    * Error struct with details for execution failures","ref":"Jido.Runner.Simple.html#run/2-returns"},{"type":"function","title":"Examples - Jido.Runner.Simple.run/2","doc":"# Successful state update\n    {:ok, updated_agent, directives} = Runner.Simple.run(agent_with_state_update)\n\n    # Execute without applying directives\n    {:ok, updated_agent, directives} = Runner.Simple.run(agent_with_state_update, apply_directives?: false)\n\n    # Execute with custom timeout (runner opts are merged with instruction opts)\n    {:ok, updated_agent, directives} = Runner.Simple.run(agent, timeout: 60_000)\n\n    # Empty queue - returns agent unchanged\n    {:ok, agent, []} = Runner.Simple.run(agent_with_empty_queue)\n\n    # Execution error\n    {:error, error} = Runner.Simple.run(agent_with_failing_action)","ref":"Jido.Runner.Simple.html#run/2-examples"},{"type":"function","title":"Option Merging - Jido.Runner.Simple.run/2","doc":"* Runner options are merged with each instruction's options\n  * Instruction options take precedence over runner options\n  * This allows per-instruction customization while providing defaults","ref":"Jido.Runner.Simple.html#run/2-option-merging"},{"type":"function","title":"Error Handling - Jido.Runner.Simple.run/2","doc":"* Returns `{:error, \"No pending instructions\"}` for empty queue\n  * Returns `{:error, error}` with error details for execution failures\n  * All errors preserve the original agent state\n  * Failed executions do not affect the remaining queue","ref":"Jido.Runner.Simple.html#run/2-error-handling"},{"type":"function","title":"Logging - Jido.Runner.Simple.run/2","doc":"Debug logs are emitted at key points:\n  * Runner start with agent ID\n  * Instruction dequeue result\n  * Execution setup and action invocation\n  * Result processing and categorization","ref":"Jido.Runner.Simple.html#run/2-logging"},{"type":"type","title":"Jido.Runner.Simple.run_opts/0","doc":"","ref":"Jido.Runner.Simple.html#t:run_opts/0"},{"type":"type","title":"Jido.Runner.Simple.run_result/0","doc":"","ref":"Jido.Runner.Simple.html#t:run_result/0"},{"type":"module","title":"Jido.Actions.Directives","doc":"A collection of actions that are used to control the behavior of the agent.\n\nThis module provides a set of simple, reusable actions:\n- EnqueueAction: Enqueues another action based on params\n- RegisterAction: Registers a new action module\n- DeregisterAction: Deregisters an existing action module\n\nEach action is implemented as a separate submodule and follows the Jido.Action behavior.","ref":"Jido.Actions.Directives.html"},{"type":"module","title":"Jido.Agent.Directive","doc":"Provides a type-safe way to modify agent state through discrete, validated directives.","ref":"Jido.Agent.Directive.html"},{"type":"module","title":"Overview - Jido.Agent.Directive","doc":"Directives are immutable instructions that can be applied to an agent to modify its state\n  in predefined ways. Each directive type is implemented as a separate struct with its own\n  validation rules, helping ensure type safety and consistent state transitions.","ref":"Jido.Agent.Directive.html#module-overview"},{"type":"module","title":"Available Directives - Jido.Agent.Directive","doc":"* `Enqueue` - Adds a new instruction to the agent's pending queue\n      - Requires an action atom\n      - Supports optional params and context maps\n      - Supports optional opts keyword list\n      - Example: `%Enqueue{action: :move, params: %{location: :kitchen}}`\n\n  * `RegisterAction` - Registers a new action module with the agent\n      - Requires a valid module atom\n      - Example: `%RegisterAction{action_module: MyApp.Actions.Move}`\n\n  * `DeregisterAction` - Removes an action module from the agent\n      - Requires a valid module atom\n      - Example: `%DeregisterAction{action_module: MyApp.Actions.Move}`\n\n  * `Spawn` - Spawns a child process under the agent's supervisor\n      - Requires a module atom and arguments\n      - Example: `%Spawn{module: MyWorker, args: [id: 1]}`\n\n  * `Kill` - Terminates a child process\n      - Requires a valid PID\n      - Example: `%Kill{pid: #PID<0.123.0>}`\n\n  * `StateModification` - Modifies agent state at a given path\n      - Requires an operation and path\n      - Supports optional value\n      - Example: `%StateModification{op: :set, path: [:config, :mode], value: :active}`","ref":"Jido.Agent.Directive.html#module-available-directives"},{"type":"module","title":"Usage - Jido.Agent.Directive","doc":"Directives can be applied to either an Agent or ServerState struct:\n\n      # Apply to Agent - returns updated agent\n      {:ok, updated_agent} = Directive.apply_directives(agent, directives)\n\n      # Apply to ServerState - returns updated state\n      {:ok, updated_state} = Directive.apply_directives(server_state, directives)\n\n  Each function validates directives before applying them and returns either:\n  * `{:ok, updated_state}` - Directives were successfully applied\n  * `{:error, reason}` - Failed to apply directives","ref":"Jido.Agent.Directive.html#module-usage"},{"type":"module","title":"Validation - Jido.Agent.Directive","doc":"Each directive type has its own validation rules:\n\n  * `Enqueue` requires a non-nil atom for the action\n  * `RegisterAction` requires a valid module atom\n  * `DeregisterAction` requires a valid module atom\n  * `Spawn` requires a valid module atom and arguments\n  * `Kill` requires a valid PID\n\n  Failed validation results in an error tuple being returned and processing being halted.","ref":"Jido.Agent.Directive.html#module-validation"},{"type":"module","title":"Error Handling - Jido.Agent.Directive","doc":"The module uses tagged tuples for error handling:\n\n  * `{:ok, updated_state}` - Successful application of directives\n  * `{:error, reason}` - Failed validation or application\n\n  Common error reasons include:\n\n  * `:invalid_action` - The action specified in an `Enqueue` is invalid\n  * `:invalid_action_module` - The module specified in a `Register/DeregisterAction` is invalid\n  * `:invalid_module` - The module specified in a `Spawn` is invalid\n  * `:invalid_pid` - The PID specified in a `Kill` is invalid\n  * `:invalid_topic` - The topic specified in a broadcast/subscribe/unsubscribe directive is invalid","ref":"Jido.Agent.Directive.html#module-error-handling"},{"type":"module","title":"Ideas - Jido.Agent.Directive","doc":"Change Mode\n  Change Verbosity\n  Manage Router (add/remove/etc)\n  Manage Skills (add/remove/etc)\n  Manage Dispatchers (add/remove/etc)","ref":"Jido.Agent.Directive.html#module-ideas"},{"type":"function","title":"Jido.Agent.Directive.agent_directive?/1","doc":"","ref":"Jido.Agent.Directive.html#agent_directive?/1"},{"type":"function","title":"Jido.Agent.Directive.apply_agent_directive/3","doc":"Applies agent directives to an Agent struct.","ref":"Jido.Agent.Directive.html#apply_agent_directive/3"},{"type":"function","title":"Parameters - Jido.Agent.Directive.apply_agent_directive/3","doc":"- agent: The Agent struct to modify\n  - directives: A list of directives to apply\n  - opts: Optional keyword list of options (default: [])","ref":"Jido.Agent.Directive.html#apply_agent_directive/3-parameters"},{"type":"function","title":"Returns - Jido.Agent.Directive.apply_agent_directive/3","doc":"- `{:ok, updated_agent, unapplied_directives}` - Successfully applied agent directives\n  - `{:error, reason}` - Failed to apply directives","ref":"Jido.Agent.Directive.html#apply_agent_directive/3-returns"},{"type":"function","title":"Jido.Agent.Directive.apply_server_directive/3","doc":"Applies only server directives to a ServerState struct.","ref":"Jido.Agent.Directive.html#apply_server_directive/3"},{"type":"function","title":"Parameters - Jido.Agent.Directive.apply_server_directive/3","doc":"- state: The ServerState struct to modify\n  - directives: A list of directives to apply\n  - opts: Optional keyword list of options (default: [])","ref":"Jido.Agent.Directive.html#apply_server_directive/3-parameters"},{"type":"function","title":"Returns - Jido.Agent.Directive.apply_server_directive/3","doc":"- `{:ok, updated_state, unapplied_directives}` - Successfully applied server directives\n  - `{:error, reason}` - Failed to apply directives","ref":"Jido.Agent.Directive.html#apply_server_directive/3-returns"},{"type":"type","title":"Jido.Agent.Directive.directive_result/0","doc":"","ref":"Jido.Agent.Directive.html#t:directive_result/0"},{"type":"function","title":"Jido.Agent.Directive.split_directives/1","doc":"","ref":"Jido.Agent.Directive.html#split_directives/1"},{"type":"type","title":"Jido.Agent.Directive.t/0","doc":"","ref":"Jido.Agent.Directive.html#t:t/0"},{"type":"module","title":"Jido.Agent.Directive.DeregisterAction","doc":"Directive to deregister an existing action module","ref":"Jido.Agent.Directive.DeregisterAction.html"},{"type":"type","title":"Jido.Agent.Directive.DeregisterAction.t/0","doc":"","ref":"Jido.Agent.Directive.DeregisterAction.html#t:t/0"},{"type":"module","title":"Jido.Agent.Directive.Enqueue","doc":"Directive to enqueue a new instruction","ref":"Jido.Agent.Directive.Enqueue.html"},{"type":"function","title":"Jido.Agent.Directive.Enqueue.new/1","doc":"Creates a new Enqueue directive from an Instruction struct.","ref":"Jido.Agent.Directive.Enqueue.html#new/1"},{"type":"function","title":"Parameters - Jido.Agent.Directive.Enqueue.new/1","doc":"* `instruction` - %Instruction{} struct to convert to directive","ref":"Jido.Agent.Directive.Enqueue.html#new/1-parameters"},{"type":"function","title":"Returns - Jido.Agent.Directive.Enqueue.new/1","doc":"* `%Enqueue{}` - New enqueue directive with instruction fields","ref":"Jido.Agent.Directive.Enqueue.html#new/1-returns"},{"type":"type","title":"Jido.Agent.Directive.Enqueue.t/0","doc":"","ref":"Jido.Agent.Directive.Enqueue.html#t:t/0"},{"type":"module","title":"Jido.Agent.Directive.Kill","doc":"Directive to terminate a child process","ref":"Jido.Agent.Directive.Kill.html"},{"type":"type","title":"Jido.Agent.Directive.Kill.t/0","doc":"","ref":"Jido.Agent.Directive.Kill.html#t:t/0"},{"type":"module","title":"Jido.Agent.Directive.RegisterAction","doc":"Directive to register a new action module","ref":"Jido.Agent.Directive.RegisterAction.html"},{"type":"type","title":"Jido.Agent.Directive.RegisterAction.t/0","doc":"","ref":"Jido.Agent.Directive.RegisterAction.html#t:t/0"},{"type":"module","title":"Jido.Agent.Directive.Spawn","doc":"Directive to spawn a child process","ref":"Jido.Agent.Directive.Spawn.html"},{"type":"type","title":"Jido.Agent.Directive.Spawn.t/0","doc":"","ref":"Jido.Agent.Directive.Spawn.html#t:t/0"},{"type":"module","title":"Jido.Actions.Tool","doc":"Provides functionality to convert Jido Execs into tool representations.\n\nThis module allows Jido Execs to be easily integrated with AI systems\nlike LangChain or Instructor by converting them into a standardized tool format.","ref":"Jido.Actions.Tool.html"},{"type":"function","title":"Jido.Actions.Tool.build_parameters_schema/1","doc":"Builds a parameters schema for the tool based on the action's schema.","ref":"Jido.Actions.Tool.html#build_parameters_schema/1"},{"type":"function","title":"Arguments - Jido.Actions.Tool.build_parameters_schema/1","doc":"* `schema` - The NimbleOptions schema from the action.","ref":"Jido.Actions.Tool.html#build_parameters_schema/1-arguments"},{"type":"function","title":"Returns - Jido.Actions.Tool.build_parameters_schema/1","doc":"A map representing the parameters schema in a format compatible with LangChain.","ref":"Jido.Actions.Tool.html#build_parameters_schema/1-returns"},{"type":"function","title":"Jido.Actions.Tool.convert_params_using_schema/2","doc":"","ref":"Jido.Actions.Tool.html#convert_params_using_schema/2"},{"type":"function","title":"Jido.Actions.Tool.execute_action/3","doc":"Executes an action and formats the result for tool output.\n\nThis function is typically used as the function value in the tool representation.","ref":"Jido.Actions.Tool.html#execute_action/3"},{"type":"function","title":"Jido.Actions.Tool.nimble_type_to_json_schema_type/1","doc":"Converts a NimbleOptions type to a JSON Schema type.","ref":"Jido.Actions.Tool.html#nimble_type_to_json_schema_type/1"},{"type":"function","title":"Arguments - Jido.Actions.Tool.nimble_type_to_json_schema_type/1","doc":"* `type` - The NimbleOptions type.","ref":"Jido.Actions.Tool.html#nimble_type_to_json_schema_type/1-arguments"},{"type":"function","title":"Returns - Jido.Actions.Tool.nimble_type_to_json_schema_type/1","doc":"A string representing the equivalent JSON Schema type.","ref":"Jido.Actions.Tool.html#nimble_type_to_json_schema_type/1-returns"},{"type":"function","title":"Jido.Actions.Tool.parameter_to_json_schema/1","doc":"Converts a NimbleOptions parameter definition to a JSON Schema representation.","ref":"Jido.Actions.Tool.html#parameter_to_json_schema/1"},{"type":"function","title":"Arguments - Jido.Actions.Tool.parameter_to_json_schema/1","doc":"* `opts` - The options for a single parameter from the NimbleOptions schema.","ref":"Jido.Actions.Tool.html#parameter_to_json_schema/1-arguments"},{"type":"function","title":"Returns - Jido.Actions.Tool.parameter_to_json_schema/1","doc":"A map representing the parameter in JSON Schema format.","ref":"Jido.Actions.Tool.html#parameter_to_json_schema/1-returns"},{"type":"function","title":"Jido.Actions.Tool.to_tool/1","doc":"Converts a Jido Exec into a tool representation.","ref":"Jido.Actions.Tool.html#to_tool/1"},{"type":"function","title":"Arguments - Jido.Actions.Tool.to_tool/1","doc":"* `action` - The module implementing the Jido.Action behavior.","ref":"Jido.Actions.Tool.html#to_tool/1-arguments"},{"type":"function","title":"Returns - Jido.Actions.Tool.to_tool/1","doc":"A map representing the action as a tool, compatible with systems like LangChain.","ref":"Jido.Actions.Tool.html#to_tool/1-returns"},{"type":"function","title":"Examples - Jido.Actions.Tool.to_tool/1","doc":"iex> tool = Jido.Actions.Tool.to_tool(MyExec)\n    %{\n      name: \"my_action\",\n      description: \"Performs a specific task\",\n      function: #Function<...>,\n      parameters_schema: %{...}\n    }","ref":"Jido.Actions.Tool.html#to_tool/1-examples"},{"type":"type","title":"Jido.Actions.Tool.tool/0","doc":"","ref":"Jido.Actions.Tool.html#t:tool/0"},{"type":"behaviour","title":"Jido.Skill","doc":"Defines the core behavior and structure for Jido Skills, the fundamental building blocks\nof agent capabilities in the Jido framework.","ref":"Jido.Skill.html"},{"type":"behaviour","title":"Overview - Jido.Skill","doc":"Skills encapsulate discrete sets of functionality that agents can use to accomplish tasks.\nThink of them as feature packs that give agents new abilities - similar to how a person might\nlearn skills like \"cooking\" or \"programming\". Each Skill provides:\n\n- Signal routing and handling patterns\n- Isolated state management\n- Process supervision\n- Configuration validation\n- Runtime adaptation","ref":"Jido.Skill.html#module-overview"},{"type":"behaviour","title":"Core Concepts - Jido.Skill","doc":"","ref":"Jido.Skill.html#module-core-concepts"},{"type":"behaviour","title":"State Isolation - Jido.Skill","doc":"Skills use schema-based state isolation to prevent different capabilities from interfering\nwith each other. Each skill defines:\n\n- A unique `opts_key` for namespace isolation\n- Validation rules for configuration","ref":"Jido.Skill.html#module-state-isolation"},{"type":"behaviour","title":"Signal Patterns - Jido.Skill","doc":"Skills define what signals they can handle through pattern matching:\n\n```elixir\nuse Jido.Skill,\n  name: \"weather_monitor\",\n  signal_patterns: [\n    \"weather.data.*\",\n    \"weather.alert.**\"\n  ]\n```\n\nPattern rules:\n- Exact matches: \"user.created\"\n- Single wildcards: \"user.*.updated\"\n- Multi-wildcards: \"audit.**\"","ref":"Jido.Skill.html#module-signal-patterns"},{"type":"behaviour","title":"Configuration Management - Jido.Skill","doc":"Skills provide schema-based config validation:\n\n```elixir\nconfig: [\n  api_key: [\n    type: :string,\n    required: true,\n    doc: \"API key for weather service\"\n  ],\n  update_interval: [\n    type: :pos_integer,\n    default: 60_000,\n    doc: \"Update interval in milliseconds\"\n  ]\n]\n```","ref":"Jido.Skill.html#module-configuration-management"},{"type":"behaviour","title":"Process Supervision - Jido.Skill","doc":"Skills can define child processes through the `child_spec/1` callback:\n\n```elixir\ndef child_spec(config) do\n  [\n    {WeatherAPI.Client, config.api_key},\n    {MetricsCollector, name: config.metrics_name}\n  ]\nend\n```","ref":"Jido.Skill.html#module-process-supervision"},{"type":"behaviour","title":"Usage Example - Jido.Skill","doc":"Here's a complete skill example:\n\n```elixir\ndefmodule MyApp.WeatherSkill do\n  use Jido.Skill,\n    name: \"weather_monitor\",\n    description: \"Monitors weather conditions and generates alerts\",\n    category: \"monitoring\",\n    tags: [\"weather\", \"alerts\"],\n    vsn: \"1.0.0\",\n    opts_key: :weather,\n    signal_patterns: [\n      \"weather.data.*\",\n      \"weather.alert.**\"\n    ],\n    config: [\n      api_key: [type: :string, required: true]\n    ]\n\n  def child_spec(config) do\n    [\n      {WeatherAPI.Client, config.api_key}\n    ]\n  end\n\n  def handle_signal(%Signal{type: \"weather.data.updated\"} = signal, _skill) do\n    # Handle weather updates\n    {:ok, signal}\n  end\n\n  def transform_result(%Signal{} = signal, result, _skill) do\n    # Transform the result\n    {:ok, result}\n  end\nend\n```","ref":"Jido.Skill.html#module-usage-example"},{"type":"behaviour","title":"Callbacks - Jido.Skill","doc":"Skills implement these callbacks:\n\n- `child_spec/1` - Returns child process specifications\n- `router/0` - Returns signal routing rules\n- `handle_signal/2` - Processes incoming signals\n- `transform_result/3` - Post-processes signal handling results\n- `mount/2` - Mounts the skill to an agent","ref":"Jido.Skill.html#module-callbacks"},{"type":"behaviour","title":"Behavior - Jido.Skill","doc":"The Skill behavior enforces a consistent interface:\n\n```elixir\n@callback child_spec(config :: map()) :: Supervisor.child_spec() | [Supervisor.child_spec()]\n@callback router() :: [map()]\n@callback handle_signal(signal :: Signal.t(), skill :: t()) :: {:ok, Signal.t()} | {:error, term()}\n@callback transform_result(signal :: Signal.t(), result :: term(), skill :: t()) ::\n            {:ok, term()} | {:error, term()}\n@callback mount(agent :: Jido.Agent.t(), opts :: keyword()) :: Jido.Agent.t()\n```","ref":"Jido.Skill.html#module-behavior"},{"type":"behaviour","title":"Configuration - Jido.Skill","doc":"Skills validate their configuration at compile time using these fields:\n\n- `name` - Unique identifier (required)\n- `description` - Human-readable explanation\n- `category` - Broad classification\n- `tags` - List of searchable tags\n- `vsn` - Version string\n- `opts_key` - State namespace key\n- `signal_patterns` - Input/output patterns\n- `opts_schema` - Configuration schema","ref":"Jido.Skill.html#module-configuration"},{"type":"behaviour","title":"Best Practices - Jido.Skill","doc":"1. **State Isolation**\n   - Use meaningful opts_key names\n   - Keep state focused and minimal\n   - Document state structure\n\n2. **Signal Design**\n   - Use consistent naming patterns\n   - Document signal formats\n   - Consider routing efficiency\n\n3. **Configuration**\n   - Validate thoroughly\n   - Provide good defaults\n   - Document all options\n\n4. **Process Management**\n   - Supervise child processes\n   - Handle crashes gracefully\n   - Monitor resource usage","ref":"Jido.Skill.html#module-best-practices"},{"type":"behaviour","title":"See Also - Jido.Skill","doc":"- `Jido.Signal` - Signal structure and validation\n- `Jido.Error` - Error handling\n- `Jido.Agent` - Agent integration","ref":"Jido.Skill.html#module-see-also"},{"type":"macro","title":"Jido.Skill.__using__/1","doc":"Implements the skill behavior and configuration validation.\n\nThis macro:\n1. Validates configuration at compile time\n2. Defines metadata accessors\n3. Provides JSON serialization\n4. Sets up default implementations","ref":"Jido.Skill.html#__using__/1"},{"type":"macro","title":"Example - Jido.Skill.__using__/1","doc":"defmodule MySkill do\n      use Jido.Skill,\n        name: \"my_skill\",\n        opts_key: :my_skill,\n        signals: [\n          input: [\"my.event.*\"],\n          output: [\"my.result.*\"]\n        ]\n    end","ref":"Jido.Skill.html#__using__/1-example"},{"type":"callback","title":"Jido.Skill.child_spec/1","doc":"","ref":"Jido.Skill.html#c:child_spec/1"},{"type":"function","title":"Jido.Skill.get_opts_schema/1","doc":"Gets a skill's configuration schema.","ref":"Jido.Skill.html#get_opts_schema/1"},{"type":"function","title":"Parameters - Jido.Skill.get_opts_schema/1","doc":"- `skill_module`: The skill module to inspect","ref":"Jido.Skill.html#get_opts_schema/1-parameters"},{"type":"function","title":"Returns - Jido.Skill.get_opts_schema/1","doc":"- `{:ok, schema}`: The skill's config schema\n- `{:error, reason}`: Schema not found","ref":"Jido.Skill.html#get_opts_schema/1-returns"},{"type":"function","title":"Example - Jido.Skill.get_opts_schema/1","doc":"Skill.get_config_schema(WeatherSkill)","ref":"Jido.Skill.html#get_opts_schema/1-example"},{"type":"callback","title":"Jido.Skill.handle_signal/2","doc":"","ref":"Jido.Skill.html#c:handle_signal/2"},{"type":"callback","title":"Jido.Skill.mount/2","doc":"","ref":"Jido.Skill.html#c:mount/2"},{"type":"function","title":"Jido.Skill.new/0","doc":"Skills must be defined at compile time, not runtime.\n\nThis function always returns an error to enforce compile-time definition.","ref":"Jido.Skill.html#new/0"},{"type":"callback","title":"Jido.Skill.router/1","doc":"","ref":"Jido.Skill.html#c:router/1"},{"type":"type","title":"Jido.Skill.t/0","doc":"Represents a skill's core structure and metadata.\n\nFields:\n- `name`: Unique identifier for the skill\n- `description`: Human-readable explanation of purpose\n- `category`: Broad classification for organization\n- `tags`: List of searchable tags\n- `vsn`: Version string for compatibility\n- `opts_key`: Atom key for state namespace\n- `signal_patterns`: Input/output signal patterns\n- `opts_schema`: Configuration schema","ref":"Jido.Skill.html#t:t/0"},{"type":"callback","title":"Jido.Skill.transform_result/3","doc":"","ref":"Jido.Skill.html#c:transform_result/3"},{"type":"function","title":"Jido.Skill.validate_opts/2","doc":"Validates a skill's configuration against its schema.","ref":"Jido.Skill.html#validate_opts/2"},{"type":"function","title":"Parameters - Jido.Skill.validate_opts/2","doc":"- `skill_module`: The skill module to validate\n- `config`: Configuration map to validate","ref":"Jido.Skill.html#validate_opts/2-parameters"},{"type":"function","title":"Returns - Jido.Skill.validate_opts/2","doc":"- `{:ok, validated_config}`: Successfully validated config\n- `{:error, reason}`: Validation failed","ref":"Jido.Skill.html#validate_opts/2-returns"},{"type":"function","title":"Example - Jido.Skill.validate_opts/2","doc":"Skill.validate_opts(WeatherSkill, %{\n      api_key: \"abc123\",\n      interval: 1000\n    })","ref":"Jido.Skill.html#validate_opts/2-example"},{"type":"module","title":"Jido.Skills.Arithmetic","doc":"Provides basic arithmetic operations as a Skill.\n\nThis skill exposes arithmetic operations like addition, subtraction, multiplication,\ndivision and squaring through a signal-based interface.","ref":"Jido.Skills.Arithmetic.html"},{"type":"function","title":"Jido.Skills.Arithmetic.handle_signal/1","doc":"Handle an arithmetic signal.","ref":"Jido.Skills.Arithmetic.html#handle_signal/1"},{"type":"function","title":"Jido.Skills.Arithmetic.router/1","doc":"Skill: Arithmetic\nSignal Contracts:\n- Incoming:\n  * arithmetic.add: Add two numbers\n  * arithmetic.subtract: Subtract two numbers\n  * arithmetic.multiply: Multiply two numbers\n  * arithmetic.divide: Divide two numbers\n  * arithmetic.square: Square a number\n  * arithmetic.eval: Evaluate a mathematical expression\n- Outgoing:\n  * arithmetic.result: Result of arithmetic operation\n  * arithmetic.error: Error from arithmetic operation","ref":"Jido.Skills.Arithmetic.html#router/1"},{"type":"function","title":"Jido.Skills.Arithmetic.transform_result/2","doc":"Process the result of an arithmetic operation.","ref":"Jido.Skills.Arithmetic.html#transform_result/2"},{"type":"module","title":"Jido.Actions.Arithmetic","doc":"Provides basic arithmetic operations as actions. The operations defined here are obviously trivial.\nThis module is intended to be used as a reference for how to write your own actions.\n\nThis module defines a set of arithmetic actions that can be used in actions:\n- Add: Adds two numbers together\n- Subtract: Subtracts one number from another\n- Multiply: Multiplies two numbers\n- Divide: Divides one number by another, handling division by zero\n- Square: Squares a number\n\nEach action is implemented as a separate submodule and follows the Jido.Action behavior.","ref":"Jido.Actions.Arithmetic.html"},{"type":"module","title":"Jido.Actions.Basic","doc":"A collection of basic actions for common actions.\n\nThis module provides a set of simple, reusable actions:\n- Sleep: Pauses execution for a specified duration\n- Log: Logs a message with a specified level\n- Todo: Logs a todo item as a placeholder or reminder\n- RandomSleep: Introduces a random delay within a specified range\n- Increment: Increments a value by 1\n- Decrement: Decrements a value by 1\n- Noop: No operation, returns input unchanged\n- Today: Returns the current date in specified format","ref":"Jido.Actions.Basic.html"},{"type":"module","title":"Jido.Actions.Files","doc":"A collection of file system actions for common file operations.\n\nThis module provides a set of actions for working with files and directories:\n- WriteFile: Writes content to a file with optional directory creation\n- ReadFile: Reads content from a file\n- CopyFile: Copies a file from source to destination\n- MoveFile: Moves/renames a file from source to destination\n- DeleteFile: Deletes a file or directory with optional recursive deletion\n- MakeDirectory: Creates a new directory with optional recursive creation\n- ListDirectory: Lists directory contents with optional pattern matching and recursion\n\nEach action is implemented as a separate submodule and follows the Jido.Action behavior.\nThe actions provide comprehensive file system operations with error handling and options\nlike recursive deletion, force flags, and parent directory creation.","ref":"Jido.Actions.Files.html"},{"type":"module","title":"Jido.Actions.Simplebot","doc":"A collection of actions for a simple robot simulation. These are intended to be used as an example and reference for how to write your own bot logic.\n\nThis module provides actions for:\n- Move: Simulates moving the robot to a specified location\n- Idle: Simulates the robot idling\n- DoWork: Simulates the robot performing work tasks\n- Report: Simulates the robot reporting its status\n- Recharge: Simulates recharging the robot's battery","ref":"Jido.Actions.Simplebot.html"},{"type":"module","title":"Jido.Sensors.Cron","doc":"A sensor that emits signals based on cron schedules via Quantum.\n\nBy default, the sensor uses the Quantum scheduler referenced by `:jido_quantum`,\nbut you can override the scheduler name by specifying `quantum_ref` in the sensor's\nstart options.\n\nYou can also specify a list of cron jobs to be automatically added at startup via\nthe `jobs` parameter. Each entry can be:\n- `{ ,  }` -> auto-generated job name\n- `{ ,  ,  }` -> manual job name\n\nExample Usage:\n\n    {:ok, sensor} =\n      Jido.Sensors.Cron.start_link(\n        id: \"my_cron_sensor\",\n        target: {:bus, [target: :my_bus, stream: \"some_stream\"]},\n        scheduler: Jido.Scheduler,\n        jobs: [\n          # Auto-named job\n          {~e\"* * * * * *\"e, :task1},\n          # Named job\n          {:my_job, ~e\"0 */2 * * * *\"e, :task2}\n        ]\n      )\n\n    # Add a new job later\n    :ok = Jido.Sensors.Cron.add_job(sensor, :manual_job, ~e\"* * * * *\"e, :another_task)\n\n    # Remove the job\n    :ok = Jido.Sensors.Cron.remove_job(sensor, :manual_job)\n\n    # Run a job immediately\n    :ok = Jido.Sensors.Cron.run_job(sensor, :my_job)","ref":"Jido.Sensors.Cron.html"},{"type":"function","title":"Jido.Sensors.Cron.activate_job/2","doc":"Activates a cron job by name.","ref":"Jido.Sensors.Cron.html#activate_job/2"},{"type":"function","title":"Jido.Sensors.Cron.add_job/4","doc":"Adds a new cron job with the given name, schedule, and task.\n\n`name` must be an atom.\n`schedule` is a Crontab.CronExpression (supports `~e\"\"` sigil or built manually).\n`task` can be any term you want included in the dispatched signal's data.","ref":"Jido.Sensors.Cron.html#add_job/4"},{"type":"function","title":"Jido.Sensors.Cron.category/0","doc":"Returns the configured category of the sensor.","ref":"Jido.Sensors.Cron.html#category/0"},{"type":"function","title":"Jido.Sensors.Cron.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Jido.Sensors.Cron.html#child_spec/1"},{"type":"function","title":"Jido.Sensors.Cron.deactivate_job/2","doc":"Deactivates a cron job by name.","ref":"Jido.Sensors.Cron.html#deactivate_job/2"},{"type":"function","title":"Jido.Sensors.Cron.description/0","doc":"Returns the configured description of the sensor.","ref":"Jido.Sensors.Cron.html#description/0"},{"type":"function","title":"Jido.Sensors.Cron.get_config/1","doc":"Retrieves the complete configuration of a sensor.","ref":"Jido.Sensors.Cron.html#get_config/1"},{"type":"function","title":"Parameters - Jido.Sensors.Cron.get_config/1","doc":"* `sensor` - The sensor to get configuration from. Can be a PID, atom name, or string name.","ref":"Jido.Sensors.Cron.html#get_config/1-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Cron.get_config/1","doc":"* `{:ok, config}` - The complete configuration map\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Cron.html#get_config/1-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Cron.get_config/1","doc":"iex> {:ok, config} = MySensor.get_config(sensor_pid)\n    {:ok, %{id: \"sensor1\", target: {:bus, :my_bus}}}\n\n    iex> MySensor.get_config(:nonexistent_sensor)\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Cron.html#get_config/1-examples"},{"type":"function","title":"Jido.Sensors.Cron.get_config/2","doc":"Retrieves a specific configuration value from a sensor.","ref":"Jido.Sensors.Cron.html#get_config/2"},{"type":"function","title":"Parameters - Jido.Sensors.Cron.get_config/2","doc":"* `sensor` - The sensor to get configuration from. Can be a PID, atom name, or string name.\n  * `key` - The configuration key to retrieve","ref":"Jido.Sensors.Cron.html#get_config/2-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Cron.get_config/2","doc":"* `{:ok, value}` - The configuration value for the key\n  * `{:error, :not_found}` - If the key does not exist\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Cron.html#get_config/2-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Cron.get_config/2","doc":"iex> {:ok, value} = MySensor.get_config(sensor_pid, :target)\n    {:ok, {:bus, :my_bus}}\n\n    iex> MySensor.get_config(sensor_pid, :nonexistent_key)\n    {:error, :not_found}","ref":"Jido.Sensors.Cron.html#get_config/2-examples"},{"type":"function","title":"Jido.Sensors.Cron.name/0","doc":"Returns the configured name of the sensor.","ref":"Jido.Sensors.Cron.html#name/0"},{"type":"function","title":"Jido.Sensors.Cron.remove_job/2","doc":"Removes a cron job by name.","ref":"Jido.Sensors.Cron.html#remove_job/2"},{"type":"function","title":"Jido.Sensors.Cron.run_job/2","doc":"Runs a job immediately (outside its normal schedule).","ref":"Jido.Sensors.Cron.html#run_job/2"},{"type":"function","title":"Jido.Sensors.Cron.schema/0","doc":"Returns the configured schema for the sensor.","ref":"Jido.Sensors.Cron.html#schema/0"},{"type":"type","title":"Jido.Sensors.Cron.sensor_result/0","doc":"","ref":"Jido.Sensors.Cron.html#t:sensor_result/0"},{"type":"function","title":"Jido.Sensors.Cron.set_config/2","doc":"Updates multiple configuration values for a sensor.","ref":"Jido.Sensors.Cron.html#set_config/2"},{"type":"function","title":"Parameters - Jido.Sensors.Cron.set_config/2","doc":"* `sensor` - The sensor to update. Can be a PID, atom name, or string name.\n  * `config` - A map containing the configuration key-value pairs to update","ref":"Jido.Sensors.Cron.html#set_config/2-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Cron.set_config/2","doc":"* `:ok` - The configuration was updated successfully\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Cron.html#set_config/2-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Cron.set_config/2","doc":"iex> MySensor.set_config(sensor_pid, %{key1: \"value1\", key2: \"value2\"})\n    :ok\n\n    iex> MySensor.set_config(:nonexistent_sensor, %{key: \"value\"})\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Cron.html#set_config/2-examples"},{"type":"function","title":"Jido.Sensors.Cron.set_config/3","doc":"Updates a single configuration value for a sensor.","ref":"Jido.Sensors.Cron.html#set_config/3"},{"type":"function","title":"Parameters - Jido.Sensors.Cron.set_config/3","doc":"* `sensor` - The sensor to update. Can be a PID, atom name, or string name.\n  * `key` - The configuration key to update\n  * `value` - The new value to set","ref":"Jido.Sensors.Cron.html#set_config/3-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Cron.set_config/3","doc":"* `:ok` - The configuration was updated successfully\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Cron.html#set_config/3-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Cron.set_config/3","doc":"iex> MySensor.set_config(sensor_pid, :some_key, \"new_value\")\n    :ok\n\n    iex> MySensor.set_config(:nonexistent_sensor, :key, \"value\")\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Cron.html#set_config/3-examples"},{"type":"function","title":"Jido.Sensors.Cron.start_link/1","doc":"Starts a new Sensor process.","ref":"Jido.Sensors.Cron.html#start_link/1"},{"type":"function","title":"Options - Jido.Sensors.Cron.start_link/1","doc":"* `:id` (`t:String.t/0`) - Unique identifier for the sensor instance\n\n* `:target` - Required. Target for signal delivery. Can be a single dispatch config tuple or a keyword list of named configurations.\n\n* `:retain_last` (`t:pos_integer/0`) - Number of last values to retain The default value is `10`.\n\n* `:scheduler` (`t:atom/0`) - Reference to the Quantum scheduler module to use The default value is `Jido.Scheduler`.\n\n* `:jobs` (list of `t:term/0`) - A list of cron jobs to be added at sensor startup. Each entry can be:\n    - {cron_expr, task}\n    - {name, cron_expr, task} The default value is `[]`.","ref":"Jido.Sensors.Cron.html#start_link/1-options"},{"type":"function","title":"Return Values - Jido.Sensors.Cron.start_link/1","doc":"* `{:ok, pid}` - The sensor was started successfully\n  * `{:error, reason}` - The sensor failed to start","ref":"Jido.Sensors.Cron.html#start_link/1-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Cron.start_link/1","doc":"iex> MySensor.start_link(id: \"sensor1\", target: {:bus, :my_bus})\n    {:ok, #PID<0.123.0>}\n\n    iex> MySensor.start_link(id: \"sensor1\", target: {:invalid, :target})\n    {:error, \"invalid target specification\"}","ref":"Jido.Sensors.Cron.html#start_link/1-examples"},{"type":"type","title":"Jido.Sensors.Cron.t/0","doc":"","ref":"Jido.Sensors.Cron.html#t:t/0"},{"type":"function","title":"Jido.Sensors.Cron.tags/0","doc":"Returns the configured tags for the sensor.","ref":"Jido.Sensors.Cron.html#tags/0"},{"type":"function","title":"Jido.Sensors.Cron.to_json/0","doc":"Converts the sensor metadata to a JSON-compatible map.\n\nReturns a map containing the sensor's name, description, category, tags,\nversion and schema configuration.","ref":"Jido.Sensors.Cron.html#to_json/0"},{"type":"function","title":"Example - Jido.Sensors.Cron.to_json/0","doc":"iex> MySensor.to_json()\n    %{\n      name: \"my_sensor\",\n      description: \"A test sensor\",\n      category: :test,\n      tags: [:test, :example],\n      vsn: \"1.0.0\",\n      schema: []\n    }","ref":"Jido.Sensors.Cron.html#to_json/0-example"},{"type":"function","title":"Jido.Sensors.Cron.vsn/0","doc":"Returns the configured version of the sensor.","ref":"Jido.Sensors.Cron.html#vsn/0"},{"type":"module","title":"Jido.Sensors.Heartbeat","doc":"A sensor that emits heartbeat signals at configurable intervals.","ref":"Jido.Sensors.Heartbeat.html"},{"type":"function","title":"Jido.Sensors.Heartbeat.category/0","doc":"Returns the configured category of the sensor.","ref":"Jido.Sensors.Heartbeat.html#category/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Jido.Sensors.Heartbeat.html#child_spec/1"},{"type":"function","title":"Jido.Sensors.Heartbeat.description/0","doc":"Returns the configured description of the sensor.","ref":"Jido.Sensors.Heartbeat.html#description/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.get_config/1","doc":"Retrieves the complete configuration of a sensor.","ref":"Jido.Sensors.Heartbeat.html#get_config/1"},{"type":"function","title":"Parameters - Jido.Sensors.Heartbeat.get_config/1","doc":"* `sensor` - The sensor to get configuration from. Can be a PID, atom name, or string name.","ref":"Jido.Sensors.Heartbeat.html#get_config/1-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Heartbeat.get_config/1","doc":"* `{:ok, config}` - The complete configuration map\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Heartbeat.html#get_config/1-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Heartbeat.get_config/1","doc":"iex> {:ok, config} = MySensor.get_config(sensor_pid)\n    {:ok, %{id: \"sensor1\", target: {:bus, :my_bus}}}\n\n    iex> MySensor.get_config(:nonexistent_sensor)\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Heartbeat.html#get_config/1-examples"},{"type":"function","title":"Jido.Sensors.Heartbeat.get_config/2","doc":"Retrieves a specific configuration value from a sensor.","ref":"Jido.Sensors.Heartbeat.html#get_config/2"},{"type":"function","title":"Parameters - Jido.Sensors.Heartbeat.get_config/2","doc":"* `sensor` - The sensor to get configuration from. Can be a PID, atom name, or string name.\n  * `key` - The configuration key to retrieve","ref":"Jido.Sensors.Heartbeat.html#get_config/2-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Heartbeat.get_config/2","doc":"* `{:ok, value}` - The configuration value for the key\n  * `{:error, :not_found}` - If the key does not exist\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Heartbeat.html#get_config/2-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Heartbeat.get_config/2","doc":"iex> {:ok, value} = MySensor.get_config(sensor_pid, :target)\n    {:ok, {:bus, :my_bus}}\n\n    iex> MySensor.get_config(sensor_pid, :nonexistent_key)\n    {:error, :not_found}","ref":"Jido.Sensors.Heartbeat.html#get_config/2-examples"},{"type":"function","title":"Jido.Sensors.Heartbeat.name/0","doc":"Returns the configured name of the sensor.","ref":"Jido.Sensors.Heartbeat.html#name/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.schema/0","doc":"Returns the configured schema for the sensor.","ref":"Jido.Sensors.Heartbeat.html#schema/0"},{"type":"type","title":"Jido.Sensors.Heartbeat.sensor_result/0","doc":"","ref":"Jido.Sensors.Heartbeat.html#t:sensor_result/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.set_config/2","doc":"Updates multiple configuration values for a sensor.","ref":"Jido.Sensors.Heartbeat.html#set_config/2"},{"type":"function","title":"Parameters - Jido.Sensors.Heartbeat.set_config/2","doc":"* `sensor` - The sensor to update. Can be a PID, atom name, or string name.\n  * `config` - A map containing the configuration key-value pairs to update","ref":"Jido.Sensors.Heartbeat.html#set_config/2-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Heartbeat.set_config/2","doc":"* `:ok` - The configuration was updated successfully\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Heartbeat.html#set_config/2-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Heartbeat.set_config/2","doc":"iex> MySensor.set_config(sensor_pid, %{key1: \"value1\", key2: \"value2\"})\n    :ok\n\n    iex> MySensor.set_config(:nonexistent_sensor, %{key: \"value\"})\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Heartbeat.html#set_config/2-examples"},{"type":"function","title":"Jido.Sensors.Heartbeat.set_config/3","doc":"Updates a single configuration value for a sensor.","ref":"Jido.Sensors.Heartbeat.html#set_config/3"},{"type":"function","title":"Parameters - Jido.Sensors.Heartbeat.set_config/3","doc":"* `sensor` - The sensor to update. Can be a PID, atom name, or string name.\n  * `key` - The configuration key to update\n  * `value` - The new value to set","ref":"Jido.Sensors.Heartbeat.html#set_config/3-parameters"},{"type":"function","title":"Return Values - Jido.Sensors.Heartbeat.set_config/3","doc":"* `:ok` - The configuration was updated successfully\n  * `{:error, reason}` - If the sensor cannot be found or accessed","ref":"Jido.Sensors.Heartbeat.html#set_config/3-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Heartbeat.set_config/3","doc":"iex> MySensor.set_config(sensor_pid, :some_key, \"new_value\")\n    :ok\n\n    iex> MySensor.set_config(:nonexistent_sensor, :key, \"value\")\n    {:error, :invalid_sensor}","ref":"Jido.Sensors.Heartbeat.html#set_config/3-examples"},{"type":"function","title":"Jido.Sensors.Heartbeat.start_link/1","doc":"Starts a new Sensor process.","ref":"Jido.Sensors.Heartbeat.html#start_link/1"},{"type":"function","title":"Options - Jido.Sensors.Heartbeat.start_link/1","doc":"* `:id` (`t:String.t/0`) - Unique identifier for the sensor instance\n\n* `:target` - Required. Target for signal delivery. Can be a single dispatch config tuple or a keyword list of named configurations.\n\n* `:retain_last` (`t:pos_integer/0`) - Number of last values to retain The default value is `10`.\n\n* `:interval` (`t:pos_integer/0`) - Interval between heartbeats in milliseconds The default value is `5000`.\n\n* `:message` (`t:String.t/0`) - Message to include in heartbeat signal The default value is `\"heartbeat\"`.","ref":"Jido.Sensors.Heartbeat.html#start_link/1-options"},{"type":"function","title":"Return Values - Jido.Sensors.Heartbeat.start_link/1","doc":"* `{:ok, pid}` - The sensor was started successfully\n  * `{:error, reason}` - The sensor failed to start","ref":"Jido.Sensors.Heartbeat.html#start_link/1-return-values"},{"type":"function","title":"Examples - Jido.Sensors.Heartbeat.start_link/1","doc":"iex> MySensor.start_link(id: \"sensor1\", target: {:bus, :my_bus})\n    {:ok, #PID<0.123.0>}\n\n    iex> MySensor.start_link(id: \"sensor1\", target: {:invalid, :target})\n    {:error, \"invalid target specification\"}","ref":"Jido.Sensors.Heartbeat.html#start_link/1-examples"},{"type":"type","title":"Jido.Sensors.Heartbeat.t/0","doc":"","ref":"Jido.Sensors.Heartbeat.html#t:t/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.tags/0","doc":"Returns the configured tags for the sensor.","ref":"Jido.Sensors.Heartbeat.html#tags/0"},{"type":"function","title":"Jido.Sensors.Heartbeat.to_json/0","doc":"Converts the sensor metadata to a JSON-compatible map.\n\nReturns a map containing the sensor's name, description, category, tags,\nversion and schema configuration.","ref":"Jido.Sensors.Heartbeat.html#to_json/0"},{"type":"function","title":"Example - Jido.Sensors.Heartbeat.to_json/0","doc":"iex> MySensor.to_json()\n    %{\n      name: \"my_sensor\",\n      description: \"A test sensor\",\n      category: :test,\n      tags: [:test, :example],\n      vsn: \"1.0.0\",\n      schema: []\n    }","ref":"Jido.Sensors.Heartbeat.html#to_json/0-example"},{"type":"function","title":"Jido.Sensors.Heartbeat.vsn/0","doc":"Returns the configured version of the sensor.","ref":"Jido.Sensors.Heartbeat.html#vsn/0"},{"type":"module","title":"Jido.Agent.Server.State","doc":"Defines the state management structure and transition logic for Agent Servers.\n\nThe Server.State module implements a finite state machine (FSM) that governs\nthe lifecycle of agent workers in the Jido system. It ensures type safety and\nenforces valid state transitions while providing telemetry and logging for\nobservability.","ref":"Jido.Agent.Server.State.html"},{"type":"module","title":"State Machine - Jido.Agent.Server.State","doc":"The worker can be in one of the following states:\n- `:initializing` - Initial state when worker is starting up\n- `:idle` - Server is inactive and ready to accept new commands\n- `:planning` - Server is planning but not yet executing actions\n- `:running` - Server is actively executing commands\n- `:paused` - Server execution is temporarily suspended","ref":"Jido.Agent.Server.State.html#module-state-machine"},{"type":"module","title":"State Transitions - Jido.Agent.Server.State","doc":"Valid state transitions are:\n```\ninitializing -> idle        (initialization_complete)\nidle         -> planning    (plan_initiated)\nidle         -> running     (direct_execution)\nplanning     -> running     (plan_completed)\nplanning     -> idle        (plan_cancelled)\nrunning      -> paused      (execution_paused)\nrunning      -> idle        (execution_completed)\npaused       -> running     (execution_resumed)\npaused       -> idle        (execution_cancelled)\n```","ref":"Jido.Agent.Server.State.html#module-state-transitions"},{"type":"module","title":"Fields - Jido.Agent.Server.State","doc":"- `:agent` - The Agent struct being managed by this worker (required)\n- `:pubsub` - PubSub module for event broadcasting (required)\n- `:topic` - PubSub topic for worker events (required)\n- `:subscriptions` - List of subscribed topics (default: [])\n- `:status` - Current state of the worker (default: :idle)\n- `:pending_signals` - Queue of pending signals awaiting execution\n- `:max_queue_size` - Maximum number of commands that can be queued (default: 10000)\n- `:child_supervisor` - Dynamic supervisor PID for managing child processes","ref":"Jido.Agent.Server.State.html#module-fields"},{"type":"module","title":"Example - Jido.Agent.Server.State","doc":"iex> state = %Server.State{\n    ...>   agent: my_agent,\n    ...>   pubsub: MyApp.PubSub,\n    ...>   topic: \"agent.worker.1\",\n    ...>   status: :idle\n    ...> }\n    iex> {:ok, new_state} = Server.State.transition(state, :running)\n    iex> new_state.status\n    :running","ref":"Jido.Agent.Server.State.html#module-example"},{"type":"function","title":"Jido.Agent.Server.State.check_queue_size/1","doc":"Checks the current size of the pending signals queue.\n\nReturns the queue size as an integer if within limits, or :queue_overflow error if exceeded.","ref":"Jido.Agent.Server.State.html#check_queue_size/1"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.check_queue_size/1","doc":"- `state` - Current server state","ref":"Jido.Agent.Server.State.html#check_queue_size/1-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.check_queue_size/1","doc":"- `{:ok, size}` - Current queue size as integer\n- `{:error, :queue_overflow}` - Queue size exceeds maximum","ref":"Jido.Agent.Server.State.html#check_queue_size/1-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.check_queue_size/1","doc":"iex> state = %Server.State{pending_signals: queue_with_items, max_queue_size: 100}\n    iex> Server.State.check_queue_size(state)\n    {:ok, 5}\n\n    iex> state = %Server.State{pending_signals: large_queue, max_queue_size: 10}\n    iex> Server.State.check_queue_size(state)\n    {:error, :queue_overflow}","ref":"Jido.Agent.Server.State.html#check_queue_size/1-examples"},{"type":"function","title":"Jido.Agent.Server.State.clear_queue/1","doc":"Empties the pending queue in the server state.\n\nReturns a new state with an empty queue.","ref":"Jido.Agent.Server.State.html#clear_queue/1"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.clear_queue/1","doc":"- `state` - Current server state","ref":"Jido.Agent.Server.State.html#clear_queue/1-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.clear_queue/1","doc":"- `{:ok, new_state}` - Queue was successfully emptied","ref":"Jido.Agent.Server.State.html#clear_queue/1-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.clear_queue/1","doc":"iex> state = %Server.State{pending_signals: queue_with_items}\n    iex> Server.State.clear_queue(state)\n    {:ok, %Server.State{pending_signals: :queue.new()}}","ref":"Jido.Agent.Server.State.html#clear_queue/1-examples"},{"type":"macro","title":"Jido.Agent.Server.State.dbug/2","doc":"","ref":"Jido.Agent.Server.State.html#dbug/2"},{"type":"function","title":"Jido.Agent.Server.State.dequeue/1","doc":"Dequeues a signal from the state's pending queue.\n\nReturns the next signal and updated state with the signal removed from the queue.\nReturns error if queue is empty.","ref":"Jido.Agent.Server.State.html#dequeue/1"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.dequeue/1","doc":"- `state` - Current server state","ref":"Jido.Agent.Server.State.html#dequeue/1-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.dequeue/1","doc":"- `{:ok, signal, new_state}` - Signal was successfully dequeued\n- `{:error, :empty_queue}` - Queue is empty","ref":"Jido.Agent.Server.State.html#dequeue/1-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.dequeue/1","doc":"iex> state = %Server.State{pending_signals: queue_with_items}\n    iex> Server.State.dequeue(state)\n    {:ok, %Signal{type: \"test\"}, %Server.State{pending_signals: updated_queue}}\n\n    iex> state = %Server.State{pending_signals: :queue.new()}\n    iex> Server.State.dequeue(state)\n    {:error, :empty_queue}","ref":"Jido.Agent.Server.State.html#dequeue/1-examples"},{"type":"type","title":"Jido.Agent.Server.State.dispatch_config/0","doc":"","ref":"Jido.Agent.Server.State.html#t:dispatch_config/0"},{"type":"function","title":"Jido.Agent.Server.State.enqueue/2","doc":"Enqueues a signal into the state's pending signals queue.\n\nValidates that the queue size is within the configured maximum before adding.\nEmits a queue_overflow event if the queue is full.","ref":"Jido.Agent.Server.State.html#enqueue/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.enqueue/2","doc":"- `state` - Current server state\n- `signal` - Signal to enqueue","ref":"Jido.Agent.Server.State.html#enqueue/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.enqueue/2","doc":"- `{:ok, new_state}` - Signal was successfully enqueued\n- `{:error, :queue_overflow}` - Queue is at max capacity","ref":"Jido.Agent.Server.State.html#enqueue/2-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.enqueue/2","doc":"iex> state = %Server.State{pending_signals: :queue.new(), max_queue_size: 2}\n    iex> Server.State.enqueue(state, %Signal{type: \"test\"})\n    {:ok, %Server.State{pending_signals: updated_queue}}\n\n    iex> state = %Server.State{pending_signals: full_queue, max_queue_size: 1}\n    iex> Server.State.enqueue(state, %Signal{type: \"test\"})\n    {:error, :queue_overflow}","ref":"Jido.Agent.Server.State.html#enqueue/2-examples"},{"type":"function","title":"Jido.Agent.Server.State.enqueue_front/2","doc":"Enqueues a signal at the front of the state's pending signals queue.\n\nValidates that the queue size is within the configured maximum before adding.\nEmits a queue_overflow event if the queue is full.","ref":"Jido.Agent.Server.State.html#enqueue_front/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.enqueue_front/2","doc":"- `state` - Current server state\n- `signal` - Signal to enqueue at front","ref":"Jido.Agent.Server.State.html#enqueue_front/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.enqueue_front/2","doc":"- `{:ok, new_state}` - Signal was successfully enqueued at front\n- `{:error, :queue_overflow}` - Queue is at max capacity","ref":"Jido.Agent.Server.State.html#enqueue_front/2-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.enqueue_front/2","doc":"iex> state = %Server.State{pending_signals: :queue.new(), max_queue_size: 2}\n    iex> Server.State.enqueue_front(state, %Signal{type: \"test\"})\n    {:ok, %Server.State{pending_signals: updated_queue}}\n\n    iex> state = %Server.State{pending_signals: full_queue, max_queue_size: 1}\n    iex> Server.State.enqueue_front(state, %Signal{type: \"test\"})\n    {:error, :queue_overflow}","ref":"Jido.Agent.Server.State.html#enqueue_front/2-examples"},{"type":"macro","title":"Jido.Agent.Server.State.error/2","doc":"","ref":"Jido.Agent.Server.State.html#error/2"},{"type":"function","title":"Jido.Agent.Server.State.get_reply_ref/2","doc":"Retrieves a stored reply reference for a signal.","ref":"Jido.Agent.Server.State.html#get_reply_ref/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.get_reply_ref/2","doc":"- `state` - Current server state\n- `signal_id` - ID of the signal to get ref for","ref":"Jido.Agent.Server.State.html#get_reply_ref/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.get_reply_ref/2","doc":"The stored GenServer.from() tuple or nil if not found","ref":"Jido.Agent.Server.State.html#get_reply_ref/2-returns"},{"type":"type","title":"Jido.Agent.Server.State.log_levels/0","doc":"","ref":"Jido.Agent.Server.State.html#t:log_levels/0"},{"type":"type","title":"Jido.Agent.Server.State.modes/0","doc":"","ref":"Jido.Agent.Server.State.html#t:modes/0"},{"type":"function","title":"Jido.Agent.Server.State.remove_reply_ref/2","doc":"Removes a stored reply reference for a signal.","ref":"Jido.Agent.Server.State.html#remove_reply_ref/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.remove_reply_ref/2","doc":"- `state` - Current server state\n- `signal_id` - ID of the signal to remove ref for","ref":"Jido.Agent.Server.State.html#remove_reply_ref/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.remove_reply_ref/2","doc":"Updated state with reply ref removed","ref":"Jido.Agent.Server.State.html#remove_reply_ref/2-returns"},{"type":"type","title":"Jido.Agent.Server.State.status/0","doc":"Represents the possible states of a worker.\n\n- `:initializing` - Server is starting up\n- `:idle` - Server is inactive\n- `:planning` - Server is planning actions\n- `:running` - Server is executing actions\n- `:paused` - Server execution is suspended","ref":"Jido.Agent.Server.State.html#t:status/0"},{"type":"function","title":"Jido.Agent.Server.State.store_reply_ref/3","doc":"Stores a reply reference for a signal.","ref":"Jido.Agent.Server.State.html#store_reply_ref/3"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.store_reply_ref/3","doc":"- `state` - Current server state\n- `signal_id` - ID of the signal to store ref for\n- `from` - GenServer.from() tuple to store","ref":"Jido.Agent.Server.State.html#store_reply_ref/3-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.store_reply_ref/3","doc":"Updated state with stored reply ref","ref":"Jido.Agent.Server.State.html#store_reply_ref/3-returns"},{"type":"type","title":"Jido.Agent.Server.State.t/0","doc":"","ref":"Jido.Agent.Server.State.html#t:t/0"},{"type":"function","title":"Jido.Agent.Server.State.transition/2","doc":"Attempts to transition the worker to a new state.\n\nThis function enforces the state machine rules defined in @transitions.\nIt logs state transitions for debugging and monitoring purposes.","ref":"Jido.Agent.Server.State.html#transition/2"},{"type":"function","title":"Parameters - Jido.Agent.Server.State.transition/2","doc":"- `state` - Current Server.State struct\n- `desired` - Desired target state","ref":"Jido.Agent.Server.State.html#transition/2-parameters"},{"type":"function","title":"Returns - Jido.Agent.Server.State.transition/2","doc":"- `{:ok, new_state}` - Transition was successful\n- `{:error, {:invalid_transition, current, desired}}` - Invalid state transition","ref":"Jido.Agent.Server.State.html#transition/2-returns"},{"type":"function","title":"Examples - Jido.Agent.Server.State.transition/2","doc":"iex> state = %Server.State{status: :idle}\n    iex> Server.State.transition(state, :running)\n    {:ok, %Server.State{status: :running}}\n\n    iex> state = %Server.State{status: :idle}\n    iex> Server.State.transition(state, :paused)\n    {:error, {:invalid_transition, :idle, :paused}}","ref":"Jido.Agent.Server.State.html#transition/2-examples"},{"type":"module","title":"Jido.Discovery","doc":"The Discovery module is Jido's component registry system, providing efficient caching and lookup\nof system components like Actions, Sensors, Agents, and Skills. Think of it as a \"service registry\"\nthat helps different parts of your system find and interact with each other.","ref":"Jido.Discovery.html"},{"type":"module","title":"Core Concepts - Jido.Discovery","doc":"","ref":"Jido.Discovery.html#module-core-concepts"},{"type":"module","title":"Component Discovery - Jido.Discovery","doc":"Discovery works by scanning all loaded applications for components that implement Jido's\nmetadata protocols. It automatically finds and indexes:\n\n- **Actions** - Discrete units of work\n- **Sensors** - Event monitoring components\n- **Agents** - Autonomous workers\n- **Skills** - Reusable capability packs\n- **Demos** - Example implementations - used in the Jido Workbench (https://github.com/agentjido/jido_workbench)\n\nThe module uses Erlang's `:persistent_term` for optimal lookup performance","ref":"Jido.Discovery.html#module-component-discovery"},{"type":"module","title":"Component Metadata - Jido.Discovery","doc":"Each discovered component includes the following metadata:\n\n```elixir\n%{\n  module: MyApp.CoolAction,        # The actual module\n  name: \"cool_action\",            # Human-readable name\n  description: \"Does cool stuff\", # What it does\n  slug: \"abc123de\",              # Unique identifier\n  category: :utility,            # Broad classification\n  tags: [:cool, :stuff]          # Searchable tags\n}\n```","ref":"Jido.Discovery.html#module-component-metadata"},{"type":"module","title":"Usage Examples - Jido.Discovery","doc":"","ref":"Jido.Discovery.html#module-usage-examples"},{"type":"module","title":"Basic Component Lookup - Jido.Discovery","doc":"Find components by their unique slugs:\n\n```elixir\n# Find a specific action\ncase Discovery.get_action_by_slug(\"abc123de\") do\n  %{module: module} ->\n    # Use the action module\n    {:ok, result} = module.run()\n  nil ->\n    # Handle missing action\nend\n\n# Find a sensor\nsensor = Discovery.get_sensor_by_slug(\"def456gh\")\n```","ref":"Jido.Discovery.html#module-basic-component-lookup"},{"type":"module","title":"Filtered Component Lists - Jido.Discovery","doc":"Get filtered lists of components:\n\n```elixir\n# List all monitoring sensors\nsensors = Discovery.list_sensors(\n  category: :monitoring,\n  tag: :metrics\n)\n\n# Get the first 10 utility actions\nactions = Discovery.list_actions(\n  category: :utility,\n  limit: 10\n)\n\n# Search agents by name\nagents = Discovery.list_agents(\n  name: \"processor\",\n  offset: 5,\n  limit: 5\n)\n```","ref":"Jido.Discovery.html#module-filtered-component-lists"},{"type":"module","title":"Cache Management - Jido.Discovery","doc":"Control the discovery cache lifecycle:\n\n```elixir\n# Initialize cache (usually done at startup)\n:ok = Discovery.init()\n\n# Force cache refresh if needed\n:ok = Discovery.refresh()\n\n# Check last update time\n{:ok, last_updated} = Discovery.last_updated()\n```","ref":"Jido.Discovery.html#module-cache-management"},{"type":"module","title":"Component Registration - Jido.Discovery","doc":"Components are automatically discovered when they:\n1. Are loaded in any application in the system\n2. Implement the appropriate metadata callback\n3. Include required metadata fields\n\nExample component:\n```elixir\ndefmodule MyApp.CoolAction do\n  use Jido.Action,\n    name: \"cool_action\",\n    description: \"Does cool stuff\",\n    category: :utility,\n    tags: [:cool, :stuff]\n\n  # Metadata is automatically generated from use params\n  # def __action_metadata__ do\n  #   %{\n  #     name: \"cool_action\",\n  #     description: \"Does cool stuff\",\n  #     category: :utility,\n  #     tags: [:cool, :stuff]\n  #   }\n  # end\nend\n```","ref":"Jido.Discovery.html#module-component-registration"},{"type":"module","title":"Cache Structure - Jido.Discovery","doc":"The discovery cache maintains separate collections for each component type:\n\n```elixir\n%{\n  version: \"1.0\",              # Cache format version\n  last_updated: ~U[...],       # Last refresh timestamp\n  actions: [...],              # List of actions\n  sensors: [...],              # List of sensors\n  agents: [...],               # List of agents\n  skills: [...],              # List of skills\n  demos: [...]                # List of demos\n}\n```","ref":"Jido.Discovery.html#module-cache-structure"},{"type":"module","title":"Filtering Options - Jido.Discovery","doc":"All list functions support these filters:\n\n- `:limit` - Maximum results to return\n- `:offset` - Results to skip (pagination)\n- `:name` - Filter by name (partial match)\n- `:description` - Filter by description (partial match)\n- `:category` - Filter by category (exact match)\n- `:tag` - Filter by tag (must have exact tag)","ref":"Jido.Discovery.html#module-filtering-options"},{"type":"module","title":"Important Notes - Jido.Discovery","doc":"- Cache is shared across all processes\n- Components must be loaded before discovery\n- Metadata changes require cache refresh\n- Slug generation is deterministic\n- Filter options are additive (AND logic)","ref":"Jido.Discovery.html#module-important-notes"},{"type":"module","title":"See Also - Jido.Discovery","doc":"- `Jido.Action` - Action component behavior\n- `Jido.Sensor` - Sensor component behavior\n- `Jido.Agent` - Agent component behavior\n- `Jido.Skill` - Skill component behavior","ref":"Jido.Discovery.html#module-see-also"},{"type":"type","title":"Jido.Discovery.cache_entry/0","doc":"","ref":"Jido.Discovery.html#t:cache_entry/0"},{"type":"type","title":"Jido.Discovery.component_metadata/0","doc":"","ref":"Jido.Discovery.html#t:component_metadata/0"},{"type":"type","title":"Jido.Discovery.component_type/0","doc":"","ref":"Jido.Discovery.html#t:component_type/0"},{"type":"function","title":"Jido.Discovery.get_action_by_slug/1","doc":"Retrieves an Action by its slug.","ref":"Jido.Discovery.html#get_action_by_slug/1"},{"type":"function","title":"Parameters - Jido.Discovery.get_action_by_slug/1","doc":"- `slug`: A string representing the unique identifier of the Action.","ref":"Jido.Discovery.html#get_action_by_slug/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.get_action_by_slug/1","doc":"The Action metadata if found, otherwise `nil`.","ref":"Jido.Discovery.html#get_action_by_slug/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.get_action_by_slug/1","doc":"iex> Jido.get_action_by_slug(\"abc123de\")\n    %{module: MyApp.SomeAction, name: \"some_action\", description: \"Does something\", slug: \"abc123de\"}\n\n    iex> Jido.get_action_by_slug(\"nonexistent\")\n    nil","ref":"Jido.Discovery.html#get_action_by_slug/1-examples"},{"type":"function","title":"Jido.Discovery.get_agent_by_slug/1","doc":"Retrieves an Agent by its slug.","ref":"Jido.Discovery.html#get_agent_by_slug/1"},{"type":"function","title":"Parameters - Jido.Discovery.get_agent_by_slug/1","doc":"- `slug`: A string representing the unique identifier of the Agent.","ref":"Jido.Discovery.html#get_agent_by_slug/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.get_agent_by_slug/1","doc":"The Agent metadata if found, otherwise `nil`.","ref":"Jido.Discovery.html#get_agent_by_slug/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.get_agent_by_slug/1","doc":"iex> Jido.get_agent_by_slug(\"ghi789jk\")\n    %{module: MyApp.SomeAgent, name: \"some_agent\", description: \"Represents an agent\", slug: \"ghi789jk\"}\n\n    iex> Jido.get_agent_by_slug(\"nonexistent\")\n    nil","ref":"Jido.Discovery.html#get_agent_by_slug/1-examples"},{"type":"function","title":"Jido.Discovery.get_demo_by_slug/1","doc":"Retrieves a Demo by its slug.","ref":"Jido.Discovery.html#get_demo_by_slug/1"},{"type":"function","title":"Parameters - Jido.Discovery.get_demo_by_slug/1","doc":"- `slug`: A string representing the unique identifier of the Demo.","ref":"Jido.Discovery.html#get_demo_by_slug/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.get_demo_by_slug/1","doc":"The Demo metadata if found, otherwise `nil`.","ref":"Jido.Discovery.html#get_demo_by_slug/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.get_demo_by_slug/1","doc":"iex> Jido.get_demo_by_slug(\"mno345pq\")\n    %{module: MyApp.SomeDemo, name: \"some_demo\", description: \"Demonstrates something\", slug: \"mno345pq\"}\n\n    iex> Jido.get_demo_by_slug(\"nonexistent\")\n    nil","ref":"Jido.Discovery.html#get_demo_by_slug/1-examples"},{"type":"function","title":"Jido.Discovery.get_sensor_by_slug/1","doc":"Retrieves a Sensor by its slug.","ref":"Jido.Discovery.html#get_sensor_by_slug/1"},{"type":"function","title":"Parameters - Jido.Discovery.get_sensor_by_slug/1","doc":"- `slug`: A string representing the unique identifier of the Sensor.","ref":"Jido.Discovery.html#get_sensor_by_slug/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.get_sensor_by_slug/1","doc":"The Sensor metadata if found, otherwise `nil`.","ref":"Jido.Discovery.html#get_sensor_by_slug/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.get_sensor_by_slug/1","doc":"iex> Jido.get_sensor_by_slug(\"def456gh\")\n    %{module: MyApp.SomeSensor, name: \"some_sensor\", description: \"Monitors something\", slug: \"def456gh\"}\n\n    iex> Jido.get_sensor_by_slug(\"nonexistent\")\n    nil","ref":"Jido.Discovery.html#get_sensor_by_slug/1-examples"},{"type":"function","title":"Jido.Discovery.get_skill_by_slug/1","doc":"Retrieves a Skill by its slug.","ref":"Jido.Discovery.html#get_skill_by_slug/1"},{"type":"function","title":"Parameters - Jido.Discovery.get_skill_by_slug/1","doc":"- `slug`: A string representing the unique identifier of the Skill.","ref":"Jido.Discovery.html#get_skill_by_slug/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.get_skill_by_slug/1","doc":"The Skill metadata if found, otherwise `nil`.","ref":"Jido.Discovery.html#get_skill_by_slug/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.get_skill_by_slug/1","doc":"iex> Jido.get_skill_by_slug(\"jkl012mn\")\n    %{module: MyApp.SomeSkill, name: \"some_skill\", description: \"Provides some capability\", slug: \"jkl012mn\"}\n\n    iex> Jido.get_skill_by_slug(\"nonexistent\")\n    nil","ref":"Jido.Discovery.html#get_skill_by_slug/1-examples"},{"type":"function","title":"Jido.Discovery.init/0","doc":"Initializes the discovery cache. Should be called during application startup.","ref":"Jido.Discovery.html#init/0"},{"type":"function","title":"Returns - Jido.Discovery.init/0","doc":"- `:ok` if cache was initialized successfully\n- `{:error, reason}` if initialization failed","ref":"Jido.Discovery.html#init/0-returns"},{"type":"function","title":"Jido.Discovery.last_updated/0","doc":"Gets the last time the cache was updated.","ref":"Jido.Discovery.html#last_updated/0"},{"type":"function","title":"Returns - Jido.Discovery.last_updated/0","doc":"- `{:ok, datetime}` with the last update time\n- `{:error, :not_initialized}` if cache hasn't been initialized","ref":"Jido.Discovery.html#last_updated/0-returns"},{"type":"function","title":"Jido.Discovery.list_actions/1","doc":"Lists all Actions with optional filtering and pagination.","ref":"Jido.Discovery.html#list_actions/1"},{"type":"function","title":"Parameters - Jido.Discovery.list_actions/1","doc":"- `opts`: A keyword list of options for filtering and pagination. Available options:\n  - `:limit`: Maximum number of results to return.\n  - `:offset`: Number of results to skip before starting to return.\n  - `:name`: Filter Actions by name (partial match).\n  - `:description`: Filter Actions by description (partial match).\n  - `:category`: Filter Actions by category (exact match).\n  - `:tag`: Filter Actions by tag (must have the exact tag).","ref":"Jido.Discovery.html#list_actions/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.list_actions/1","doc":"A list of Action metadata.","ref":"Jido.Discovery.html#list_actions/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.list_actions/1","doc":"iex> Jido.list_actions(limit: 10, offset: 5, category: :utility)\n    [%{module: MyApp.SomeAction, name: \"some_action\", description: \"Does something\", slug: \"abc123de\", category: :utility}]","ref":"Jido.Discovery.html#list_actions/1-examples"},{"type":"function","title":"Jido.Discovery.list_agents/1","doc":"Lists all Agents with optional filtering and pagination.","ref":"Jido.Discovery.html#list_agents/1"},{"type":"function","title":"Parameters - Jido.Discovery.list_agents/1","doc":"- `opts`: A keyword list of options for filtering and pagination. Available options:\n  - `:limit`: Maximum number of results to return.\n  - `:offset`: Number of results to skip before starting to return.\n  - `:name`: Filter Agents by name (partial match).\n  - `:description`: Filter Agents by description (partial match).\n  - `:category`: Filter Agents by category (exact match).\n  - `:tag`: Filter Agents by tag (must have the exact tag).","ref":"Jido.Discovery.html#list_agents/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.list_agents/1","doc":"A list of Agent metadata.","ref":"Jido.Discovery.html#list_agents/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.list_agents/1","doc":"iex> Jido.list_agents(limit: 10, offset: 5, category: :business)\n    [%{module: MyApp.SomeAgent, name: \"some_agent\", description: \"Represents an agent\", slug: \"ghi789jk\", category: :business}]","ref":"Jido.Discovery.html#list_agents/1-examples"},{"type":"function","title":"Jido.Discovery.list_demos/1","doc":"Lists all Demos with optional filtering and pagination.","ref":"Jido.Discovery.html#list_demos/1"},{"type":"function","title":"Parameters - Jido.Discovery.list_demos/1","doc":"- `opts`: A keyword list of options for filtering and pagination. Available options:\n  - `:limit`: Maximum number of results to return.\n  - `:offset`: Number of results to skip before starting to return.\n  - `:name`: Filter Demos by name (partial match).\n  - `:description`: Filter Demos by description (partial match).\n  - `:category`: Filter Demos by category (exact match).\n  - `:tag`: Filter Demos by tag (must have the exact tag).","ref":"Jido.Discovery.html#list_demos/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.list_demos/1","doc":"A list of Demo metadata.","ref":"Jido.Discovery.html#list_demos/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.list_demos/1","doc":"iex> Jido.list_demos(limit: 10, offset: 5, category: :example)\n    [%{module: MyApp.SomeDemo, name: \"some_demo\", description: \"Demonstrates something\", slug: \"mno345pq\", category: :example}]","ref":"Jido.Discovery.html#list_demos/1-examples"},{"type":"function","title":"Jido.Discovery.list_sensors/1","doc":"Lists all Sensors with optional filtering and pagination.","ref":"Jido.Discovery.html#list_sensors/1"},{"type":"function","title":"Parameters - Jido.Discovery.list_sensors/1","doc":"- `opts`: A keyword list of options for filtering and pagination. Available options:\n  - `:limit`: Maximum number of results to return.\n  - `:offset`: Number of results to skip before starting to return.\n  - `:name`: Filter Sensors by name (partial match).\n  - `:description`: Filter Sensors by description (partial match).\n  - `:category`: Filter Sensors by category (exact match).\n  - `:tag`: Filter Sensors by tag (must have the exact tag).","ref":"Jido.Discovery.html#list_sensors/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.list_sensors/1","doc":"A list of Sensor metadata.","ref":"Jido.Discovery.html#list_sensors/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.list_sensors/1","doc":"iex> Jido.list_sensors(limit: 10, offset: 5, category: :monitoring)\n    [%{module: MyApp.SomeSensor, name: \"some_sensor\", description: \"Monitors something\", slug: \"def456gh\", category: :monitoring}]","ref":"Jido.Discovery.html#list_sensors/1-examples"},{"type":"function","title":"Jido.Discovery.list_skills/1","doc":"Lists all Skills with optional filtering and pagination.","ref":"Jido.Discovery.html#list_skills/1"},{"type":"function","title":"Parameters - Jido.Discovery.list_skills/1","doc":"- `opts`: A keyword list of options for filtering and pagination. Available options:\n  - `:limit`: Maximum number of results to return.\n  - `:offset`: Number of results to skip before starting to return.\n  - `:name`: Filter Skills by name (partial match).\n  - `:description`: Filter Skills by description (partial match).\n  - `:category`: Filter Skills by category (exact match).\n  - `:tag`: Filter Skills by tag (must have the exact tag).","ref":"Jido.Discovery.html#list_skills/1-parameters"},{"type":"function","title":"Returns - Jido.Discovery.list_skills/1","doc":"A list of Skill metadata.","ref":"Jido.Discovery.html#list_skills/1-returns"},{"type":"function","title":"Examples - Jido.Discovery.list_skills/1","doc":"iex> Jido.list_skills(limit: 10, offset: 5, category: :capability)\n    [%{module: MyApp.SomeSkill, name: \"some_skill\", description: \"Provides some capability\", slug: \"jkl012mn\", category: :capability}]","ref":"Jido.Discovery.html#list_skills/1-examples"},{"type":"function","title":"Jido.Discovery.refresh/0","doc":"Forces a refresh of the discovery cache.","ref":"Jido.Discovery.html#refresh/0"},{"type":"function","title":"Returns - Jido.Discovery.refresh/0","doc":"- `:ok` if cache was refreshed successfully\n- `{:error, reason}` if refresh failed","ref":"Jido.Discovery.html#refresh/0-returns"},{"type":"module","title":"Jido.Error","doc":"Defines error structures and helper functions for Jido\n\nThis module provides a standardized way to create and handle errors within the Jido system.\nIt offers a set of predefined error types and functions to create, manipulate, and convert\nerror structures consistently across the application.\n\n> Why not use Exceptions?\n>\n> Jido is designed to be a functional system, strictly adhering to the use of result tuples.\n> This approach provides several benefits:\n>\n> 1. Consistent error handling: By using `{:ok, result}` or `{:error, reason}` tuples,\n>    we ensure a uniform way of handling success and failure cases throughout the system.\n>\n> 2. Composability: Monadic actions can be easily chained together, allowing for\n>    cleaner and more maintainable code.\n>\n> 3. Explicit error paths: The use of result tuples makes error cases explicit,\n>    reducing the likelihood of unhandled errors.\n>\n> 4. No silent failures: Unlike exceptions, which can be silently caught and ignored,\n>    result tuples require explicit handling of both success and error cases.\n>\n> 5. Better testability: Monadic actions are easier to test, as both success and\n>    error paths can be explicitly verified.\n>\n> By using this approach instead of exceptions, we gain more control over the flow of our\n> actions and ensure that errors are handled consistently across the entire system.","ref":"Jido.Error.html"},{"type":"module","title":"Usage - Jido.Error","doc":"Use this module to create specific error types when exceptions occur in your Jido actions.\nThis allows for consistent error handling and reporting throughout the system.\n\nExample:\n\n    defmodule MyExec do\n      alias Jido.Error\n\n      def run(params) do\n        case validate(params) do\n          :ok -> perform_action(params)\n          {:error, reason} -> Error.validation_error(\"Invalid parameters\")\n        end\n      end\n    end","ref":"Jido.Error.html#module-usage"},{"type":"function","title":"Jido.Error.action_error/3","doc":"Creates a new action error.\n\nUse this for general action-related errors that don't fit into other categories.","ref":"Jido.Error.html#action_error/3"},{"type":"function","title":"Parameters - Jido.Error.action_error/3","doc":"- `message`: A string describing the action error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#action_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.action_error/3","doc":"iex> Jido.Error.action_error(\"Exec 'ProcessOrder' failed\", %{order_id: 12345})\n    %Jido.Error{\n      type: :action_error,\n      message: \"Exec 'ProcessOrder' failed\",\n      details: %{order_id: 12345},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#action_error/3-example"},{"type":"function","title":"Jido.Error.bad_request/3","doc":"Creates a new bad request error.\n\nUse this when the client sends an invalid or malformed request.","ref":"Jido.Error.html#bad_request/3"},{"type":"function","title":"Parameters - Jido.Error.bad_request/3","doc":"- `message`: A string describing the error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#bad_request/3-parameters"},{"type":"function","title":"Example - Jido.Error.bad_request/3","doc":"iex> Jido.Error.bad_request(\"Missing required parameter 'user_id'\")\n    %Jido.Error{\n      type: :bad_request,\n      message: \"Missing required parameter 'user_id'\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#bad_request/3-example"},{"type":"function","title":"Jido.Error.capture_stacktrace/0","doc":"Captures the current stacktrace.\n\nThis function is useful when you want to capture the stacktrace at a specific point\nin your code, rather than at the point where the error is created. It drops the first\ntwo entries from the stacktrace to remove internal function calls related to this module.","ref":"Jido.Error.html#capture_stacktrace/0"},{"type":"function","title":"Returns - Jido.Error.capture_stacktrace/0","doc":"The current stacktrace as a list.","ref":"Jido.Error.html#capture_stacktrace/0-returns"},{"type":"function","title":"Example - Jido.Error.capture_stacktrace/0","doc":"iex> stacktrace = Jido.Error.capture_stacktrace()\n    iex> is_list(stacktrace)\n    true","ref":"Jido.Error.html#capture_stacktrace/0-example"},{"type":"function","title":"Jido.Error.compensation_error/3","doc":"Creates a new compensation error with details about the original error and compensation attempt.","ref":"Jido.Error.html#compensation_error/3"},{"type":"function","title":"Parameters - Jido.Error.compensation_error/3","doc":"- `original_error`: The error that triggered compensation\n- `details`: Optional map containing:\n  - `:compensated` - Boolean indicating if compensation succeeded\n  - `:compensation_result` - Result from successful compensation\n  - `:compensation_error` - Error from failed compensation\n- `stacktrace`: Optional stacktrace for debugging","ref":"Jido.Error.html#compensation_error/3-parameters"},{"type":"function","title":"Examples - Jido.Error.compensation_error/3","doc":"iex> original_error = Jido.Error.execution_error(\"Failed to process payment\")\n    iex> Jido.Error.compensation_error(original_error, %{\n    ...>   compensated: true,\n    ...>   compensation_result: %{refund_id: \"ref_123\"}\n    ...> })\n    %Jido.Error{\n      type: :compensation_error,\n      message: \"Compensation completed for: Failed to process payment\",\n      details: %{\n        compensated: true,\n        compensation_result: %{refund_id: \"ref_123\"},\n        original_error: %Jido.Error{...}\n      }\n    }\n\n    iex> # For failed compensation:\n    iex> Jido.Error.compensation_error(original_error, %{\n    ...>   compensated: false,\n    ...>   compensation_error: \"Refund failed\"\n    ...> })","ref":"Jido.Error.html#compensation_error/3-examples"},{"type":"function","title":"Jido.Error.config_error/3","doc":"Creates a new config error.\n\nUse this when there's an issue with the system or action configuration.","ref":"Jido.Error.html#config_error/3"},{"type":"function","title":"Parameters - Jido.Error.config_error/3","doc":"- `message`: A string describing the configuration error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#config_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.config_error/3","doc":"iex> Jido.Error.config_error(\"Invalid database connection string\")\n    %Jido.Error{\n      type: :config_error,\n      message: \"Invalid database connection string\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#config_error/3-example"},{"type":"function","title":"Jido.Error.dispatch_error/3","doc":"Creates a new dispatch error.\n\nUse this when an error occurs during signal dispatching.","ref":"Jido.Error.html#dispatch_error/3"},{"type":"function","title":"Parameters - Jido.Error.dispatch_error/3","doc":"- `message`: A string describing the dispatch error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#dispatch_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.dispatch_error/3","doc":"iex> Jido.Error.dispatch_error(\"Failed to deliver signal\", %{adapter: :http, reason: :timeout})\n    %Jido.Error{\n      type: :dispatch_error,\n      message: \"Failed to deliver signal\",\n      details: %{adapter: :http, reason: :timeout},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#dispatch_error/3-example"},{"type":"type","title":"Jido.Error.error_type/0","doc":"Defines the possible error types in the Jido system.\n\n- `:invalid_action`: Used when a action is improperly defined or used.\n- `:invalid_sensor`: Used when a sensor is improperly defined or used.\n- `:bad_request`: Indicates an invalid request from the client.\n- `:validation_error`: Used when input validation fails.\n- `:config_error`: Indicates a configuration issue.\n- `:execution_error`: Used when an error occurs during action execution.\n- `:action_error`: General action-related errors.\n- `:internal_server_error`: Indicates an unexpected internal error.\n- `:timeout`: Used when an action exceeds its time limit.\n- `:invalid_async_ref`: Indicates an invalid asynchronous action reference.\n- `:compensation_error`: Indicates an error occurred during compensation.\n- `:planning_error`: Used when an error occurs during action planning.\n- `:routing_error`: Used when an error occurs during action routing.\n- `:dispatch_error`: Used when an error occurs during signal dispatching.","ref":"Jido.Error.html#t:error_type/0"},{"type":"function","title":"Jido.Error.execution_error/3","doc":"Creates a new execution error.\n\nUse this when an error occurs during the execution of an action.","ref":"Jido.Error.html#execution_error/3"},{"type":"function","title":"Parameters - Jido.Error.execution_error/3","doc":"- `message`: A string describing the execution error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#execution_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.execution_error/3","doc":"iex> Jido.Error.execution_error(\"Failed to process data\", %{step: \"data_transformation\"})\n    %Jido.Error{\n      type: :execution_error,\n      message: \"Failed to process data\",\n      details: %{step: \"data_transformation\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#execution_error/3-example"},{"type":"function","title":"Jido.Error.format_nimble_config_error/3","doc":"Formats a NimbleOptions validation error for configuration validation.\nUsed when validating configuration options at compile or runtime.","ref":"Jido.Error.html#format_nimble_config_error/3"},{"type":"function","title":"Parameters - Jido.Error.format_nimble_config_error/3","doc":"- `error`: The NimbleOptions.ValidationError to format\n- `module_type`: String indicating the module type (e.g. \"Action\", \"Agent\", \"Sensor\")","ref":"Jido.Error.html#format_nimble_config_error/3-parameters"},{"type":"function","title":"Examples - Jido.Error.format_nimble_config_error/3","doc":"iex> error = %NimbleOptions.ValidationError{keys_path: [:name], message: \"is required\"}\n    iex> Jido.Error.format_nimble_config_error(error, \"Action\")\n    \"Invalid configuration given to use Jido.Action for key [:name]: is required\"","ref":"Jido.Error.html#format_nimble_config_error/3-examples"},{"type":"function","title":"Jido.Error.format_nimble_validation_error/3","doc":"Formats a NimbleOptions validation error for parameter validation.\nUsed when validating runtime parameters.","ref":"Jido.Error.html#format_nimble_validation_error/3"},{"type":"function","title":"Parameters - Jido.Error.format_nimble_validation_error/3","doc":"- `error`: The NimbleOptions.ValidationError to format\n- `module_type`: String indicating the module type (e.g. \"Action\", \"Agent\", \"Sensor\")","ref":"Jido.Error.html#format_nimble_validation_error/3-parameters"},{"type":"function","title":"Examples - Jido.Error.format_nimble_validation_error/3","doc":"iex> error = %NimbleOptions.ValidationError{keys_path: [:input], message: \"is required\"}\n    iex> Jido.Error.format_nimble_validation_error(error, \"Action\")\n    \"Invalid parameters for Action at [:input]: is required\"","ref":"Jido.Error.html#format_nimble_validation_error/3-examples"},{"type":"function","title":"Jido.Error.internal_server_error/3","doc":"Creates a new internal server error.\n\nUse this for unexpected errors that occur within the system.","ref":"Jido.Error.html#internal_server_error/3"},{"type":"function","title":"Parameters - Jido.Error.internal_server_error/3","doc":"- `message`: A string describing the internal server error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#internal_server_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.internal_server_error/3","doc":"iex> Jido.Error.internal_server_error(\"Unexpected error in data processing\")\n    %Jido.Error{\n      type: :internal_server_error,\n      message: \"Unexpected error in data processing\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#internal_server_error/3-example"},{"type":"function","title":"Jido.Error.invalid_action/3","doc":"Creates a new invalid action error.\n\nUse this when a action is improperly defined or used within the Jido system.","ref":"Jido.Error.html#invalid_action/3"},{"type":"function","title":"Parameters - Jido.Error.invalid_action/3","doc":"- `message`: A string describing the error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#invalid_action/3-parameters"},{"type":"function","title":"Example - Jido.Error.invalid_action/3","doc":"iex> Jido.Error.invalid_action(\"Action 'MyAction' is missing required callback\")\n    %Jido.Error{\n      type: :invalid_action,\n      message: \"Action 'MyAction' is missing required callback\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#invalid_action/3-example"},{"type":"function","title":"Jido.Error.invalid_async_ref/3","doc":"Creates a new invalid async ref error.\n\nUse this when an invalid reference to an asynchronous action is encountered.","ref":"Jido.Error.html#invalid_async_ref/3"},{"type":"function","title":"Parameters - Jido.Error.invalid_async_ref/3","doc":"- `message`: A string describing the invalid async ref error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#invalid_async_ref/3-parameters"},{"type":"function","title":"Example - Jido.Error.invalid_async_ref/3","doc":"iex> Jido.Error.invalid_async_ref(\"Invalid or expired async action reference\")\n    %Jido.Error{\n      type: :invalid_async_ref,\n      message: \"Invalid or expired async action reference\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#invalid_async_ref/3-example"},{"type":"function","title":"Jido.Error.invalid_sensor/3","doc":"Creates a new invalid sensor error.\n\nUse this when a sensor is improperly defined or used within the Jido system.","ref":"Jido.Error.html#invalid_sensor/3"},{"type":"function","title":"Parameters - Jido.Error.invalid_sensor/3","doc":"- `message`: A string describing the error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#invalid_sensor/3-parameters"},{"type":"function","title":"Example - Jido.Error.invalid_sensor/3","doc":"iex> Jido.Error.invalid_sensor(\"Sensor 'MySensor' is missing required callback\")\n    %Jido.Error{\n      type: :invalid_sensor,\n      message: \"Sensor 'MySensor' is missing required callback\",\n      details: nil,\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#invalid_sensor/3-example"},{"type":"function","title":"Jido.Error.new/4","doc":"Creates a new error struct with the given type and message.\n\nThis is a low-level function used by other error creation functions in this module.\nConsider using the specific error creation functions unless you need fine-grained control.","ref":"Jido.Error.html#new/4"},{"type":"function","title":"Parameters - Jido.Error.new/4","doc":"- `type`: The error type (see `t:error_type/0`).\n- `message`: A string describing the error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#new/4-parameters"},{"type":"function","title":"Examples - Jido.Error.new/4","doc":"iex> Jido.Error.new(:config_error, \"Invalid configuration\")\n    %Jido.Error{\n      type: :config_error,\n      message: \"Invalid configuration\",\n      details: nil,\n      stacktrace: [...]\n    }\n\n    iex> Jido.Error.new(:execution_error, \"Exec failed\", %{step: \"data_processing\"})\n    %Jido.Error{\n      type: :execution_error,\n      message: \"Exec failed\",\n      details: %{step: \"data_processing\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#new/4-examples"},{"type":"function","title":"Jido.Error.planning_error/3","doc":"Creates a new planning error.\n\nUse this when an error occurs during action planning.","ref":"Jido.Error.html#planning_error/3"},{"type":"function","title":"Parameters - Jido.Error.planning_error/3","doc":"- `message`: A string describing the planning error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#planning_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.planning_error/3","doc":"iex> Jido.Error.planning_error(\"Failed to plan action\", %{step: \"goal_analysis\"})\n    %Jido.Error{\n      type: :planning_error,\n      message: \"Failed to plan action\",\n      details: %{step: \"goal_analysis\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#planning_error/3-example"},{"type":"function","title":"Jido.Error.routing_error/3","doc":"Creates a new routing error.\n\nUse this when an error occurs during action routing.","ref":"Jido.Error.html#routing_error/3"},{"type":"function","title":"Parameters - Jido.Error.routing_error/3","doc":"- `message`: A string describing the routing error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#routing_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.routing_error/3","doc":"iex> Jido.Error.routing_error(\"Invalid route configuration\", %{route: \"user_action\"})\n    %Jido.Error{\n      type: :routing_error,\n      message: \"Invalid route configuration\",\n      details: %{route: \"user_action\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#routing_error/3-example"},{"type":"type","title":"Jido.Error.t/0","doc":"Represents a structured error in the Jido system.\n\nFields:\n- `type`: The category of the error (see `t:error_type/0`).\n- `message`: A human-readable description of the error.\n- `details`: Optional map containing additional error context.\n- `stacktrace`: Optional list representing the error's stacktrace.","ref":"Jido.Error.html#t:t/0"},{"type":"function","title":"Jido.Error.timeout/3","doc":"Creates a new timeout error.\n\nUse this when an action exceeds its allocated time limit.","ref":"Jido.Error.html#timeout/3"},{"type":"function","title":"Parameters - Jido.Error.timeout/3","doc":"- `message`: A string describing the timeout error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#timeout/3-parameters"},{"type":"function","title":"Example - Jido.Error.timeout/3","doc":"iex> Jido.Error.timeout(\"Exec timed out after 30 seconds\", %{action: \"FetchUserData\"})\n    %Jido.Error{\n      type: :timeout,\n      message: \"Exec timed out after 30 seconds\",\n      details: %{action: \"FetchUserData\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#timeout/3-example"},{"type":"function","title":"Jido.Error.to_map/1","doc":"Converts the error struct to a plain map.\n\nThis function transforms the error struct into a plain map,\nincluding the error type and stacktrace if available. It's useful\nfor serialization or when working with APIs that expect plain maps.","ref":"Jido.Error.html#to_map/1"},{"type":"function","title":"Parameters - Jido.Error.to_map/1","doc":"- `error`: An error struct of type `t:t/0`.","ref":"Jido.Error.html#to_map/1-parameters"},{"type":"function","title":"Returns - Jido.Error.to_map/1","doc":"A map representation of the error.","ref":"Jido.Error.html#to_map/1-returns"},{"type":"function","title":"Example - Jido.Error.to_map/1","doc":"iex> error = Jido.Error.validation_error(\"Invalid input\")\n    iex> Jido.Error.to_map(error)\n    %{\n      type: :validation_error,\n      message: \"Invalid input\",\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#to_map/1-example"},{"type":"function","title":"Jido.Error.validation_error/3","doc":"Creates a new validation error.\n\nUse this when input validation fails for an action.","ref":"Jido.Error.html#validation_error/3"},{"type":"function","title":"Parameters - Jido.Error.validation_error/3","doc":"- `message`: A string describing the validation error.\n- `details`: (optional) A map containing additional error details.\n- `stacktrace`: (optional) The stacktrace at the point of error.","ref":"Jido.Error.html#validation_error/3-parameters"},{"type":"function","title":"Example - Jido.Error.validation_error/3","doc":"iex> Jido.Error.validation_error(\"Invalid email format\", %{field: \"email\", value: \"not-an-email\"})\n    %Jido.Error{\n      type: :validation_error,\n      message: \"Invalid email format\",\n      details: %{field: \"email\", value: \"not-an-email\"},\n      stacktrace: [...]\n    }","ref":"Jido.Error.html#validation_error/3-example"},{"type":"module","title":"Jido.Scheduler","doc":"Defines a quantum Scheduler.\n\nWhen used, the quantum scheduler expects the `:otp_app` as option.\nThe `:otp_app` should point to an OTP application that has\nthe quantum runner configuration. For example, the quantum scheduler:\n\n    defmodule Jido.Scheduler do\n      use Quantum, otp_app: :jido\n    end\n\nCould be configured with:\n\n    config :jido, Jido.Scheduler,\n      jobs: [\n        {\"@daily\", {Backup, :backup, []}},\n      ]","ref":"Jido.Scheduler.html"},{"type":"module","title":"Configuration: - Jido.Scheduler","doc":"* `:clock_broadcaster_name` - GenServer name of clock broadcaster \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:execution_broadcaster_name` - GenServer name of execution broadcaster \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:executor_supervisor_name` - GenServer name of execution supervisor \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:debug_logging` - Turn on debug logging\n\n  * `:jobs` - list of cron jobs to execute\n\n  * `:job_broadcaster_name` - GenServer name of job broadcaster \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:name` - GenServer name of scheduler \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:node_selector_broadcaster_name` - GenServer name of node selector broadcaster \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:overlap` - Default overlap of new Job\n\n  * `:otp_app` - Application where scheduler runs\n\n  * `:run_strategy` - Default Run Strategy of new Job\n\n  * `:schedule` - Default schedule of new Job\n\n  * `:storage` - Storage to use for persistence\n\n  * `:storage_name` - GenServer name of storage \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:supervisor_module` - Module to supervise scheduler \\\n    Can be overwritten to supervise processes differently (for example for clustering) \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:task_registry_name` - GenServer name of task registry \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:task_supervisor_name` - GenServer name of task supervisor \\\n    *(unstable, may break without major release until declared stable)*\n\n  * `:timeout` - Sometimes, you may come across GenServer timeout errors\n    esp. when you have too many jobs or high load. The default `GenServer.call/3`\n    timeout is `5_000`.\n\n  * `:timezone` - Default timezone of new Job","ref":"Jido.Scheduler.html#module-configuration"},{"type":"module","title":"Telemetry - Jido.Scheduler","doc":"* `[:quantum, :job, :add]`\n  * Description: dispatched when a job is added\n  * Measurements: `%{}`\n  * Metadata: `%{job: Quantum.Job.t(), scheduler: atom()}`\n\n* `[:quantum, :job, :update]`\n  * Description: dispatched when a job is updated\n  * Measurements: `%{}`\n  * Metadata: `%{job: Quantum.Job.t(), scheduler: atom()}`\n\n* `[:quantum, :job, :delete]`\n  * Description: dispatched when a job is deleted\n  * Measurements: `%{}`\n  * Metadata: `%{job: Quantum.Job.t(), scheduler: atom()}`\n\n* `[:quantum, :job, :start]`\n  * Description: dispatched on job execution start\n  * Measurements: `%{system_time: integer()}`\n  * Metadata: `%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom()}`\n\n* `[:quantum, :job, :stop]`\n  * Description: dispatched on job execution end\n  * Measurements: `%{duration: integer()}`\n  * Metadata: `%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom(), result: term()}`\n\n* `[:quantum, :job, :exception]`\n  * Description: dispatched on job execution fail\n  * Measurements: `%{duration: integer()}`\n  * Metadata: `%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom(), kind: :throw | :error | :exit, reason: term(), stacktrace: list()}`","ref":"Jido.Scheduler.html#module-telemetry"},{"type":"module","title":"Examples - Jido.Scheduler","doc":"iex(1)> :telemetry_registry.discover_all(:quantum)\n    :ok\n    iex(2)> :telemetry_registry.spannable_events()\n    [{[:quantum, :job], [:start, :stop, :exception]}]\n    iex(3)> :telemetry_registry.list_events\n    [\n      {[:quantum, :job, :add], Quantum,\n       %{\n         description: \"dispatched when a job is added\",\n         measurements: \"%{}\",\n         metadata: \"%{job: Quantum.Job.t(), scheduler: atom()}\"\n       }},\n      {[:quantum, :job, :delete], Quantum,\n       %{\n         description: \"dispatched when a job is deleted\",\n         measurements: \"%{}\",\n         metadata: \"%{job: Quantum.Job.t(), scheduler: atom()}\"\n       }},\n      {[:quantum, :job, :exception], Quantum,\n       %{\n         description: \"dispatched on job execution fail\",\n         measurements: \"%{duration: integer()}\",\n         metadata: \"%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom(), kind: :throw | :error | :exit, reason: term(), stacktrace: list()}\"\n       }},\n      {[:quantum, :job, :start], Quantum,\n       %{\n         description: \"dispatched on job execution start\",\n         measurements: \"%{system_time: integer()}\",\n         metadata: \"%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom()}\"\n       }},\n      {[:quantum, :job, :stop], Quantum,\n       %{\n         description: \"dispatched on job execution end\",\n         measurements: \"%{duration: integer()}\",\n         metadata: \"%{telemetry_span_context: term(), job: Quantum.Job.t(), node: Node.t(), scheduler: atom(), result: term()}\"\n       }},\n      {[:quantum, :job, :update], Quantum,\n       %{\n         description: \"dispatched when a job is updated\",\n         measurements: \"%{}\",\n         metadata: \"%{job: Quantum.Job.t(), scheduler: atom()}\"\n       }}\n    ]","ref":"Jido.Scheduler.html#module-examples"},{"type":"function","title":"Jido.Scheduler.child_spec/1","doc":"","ref":"Jido.Scheduler.html#child_spec/1"},{"type":"module","title":"Jido.Supervisor","doc":"A helper supervisor that starts and manages the resources for a specific Jido instance.\n\nEach consumer of Jido defines their own module:\n\n    defmodule MyApp.Jido do\n      use Jido, otp_app: :my_app\n    end\n\nThen in your application’s supervision tree:\n\n    children = [\n      MyApp.Jido\n    ]\n\n    Supervisor.start_link(children, strategy: :one_for_one)","ref":"Jido.Supervisor.html"},{"type":"function","title":"Jido.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Jido.Supervisor.html#child_spec/1"},{"type":"function","title":"Jido.Supervisor.start_link/2","doc":"","ref":"Jido.Supervisor.html#start_link/2"},{"type":"module","title":"Jido.Util","doc":"A collection of utility functions for the Jido framework.\n\nThis module provides various helper functions that are used throughout the Jido framework,\nincluding:\n\n- ID generation\n- Name validation\n- Error handling\n- Logging utilities\n\nThese utilities are designed to support common operations and maintain consistency\nacross the Jido ecosystem. They encapsulate frequently used patterns and provide\na centralized location for shared functionality.\n\nMany of the functions in this module are used internally by other Jido modules,\nbut they can also be useful for developers building applications with Jido.","ref":"Jido.Util.html"},{"type":"function","title":"Jido.Util.cond_log/4","doc":"Conditionally logs a message based on comparing threshold and message log levels.\n\nThis function provides a way to conditionally log messages by comparing a threshold level\nagainst the message's intended log level. The message will only be logged if the threshold\nlevel is less than or equal to the message level.","ref":"Jido.Util.html#cond_log/4"},{"type":"function","title":"Parameters - Jido.Util.cond_log/4","doc":"- `threshold_level`: The minimum log level threshold (e.g. :debug, :info, etc)\n- `message_level`: The log level for this specific message\n- `message`: The message to potentially log\n- `opts`: Additional options passed to Logger.log/3","ref":"Jido.Util.html#cond_log/4-parameters"},{"type":"function","title":"Returns - Jido.Util.cond_log/4","doc":"- `:ok` in all cases","ref":"Jido.Util.html#cond_log/4-returns"},{"type":"function","title":"Examples - Jido.Util.cond_log/4","doc":"# Will log since :info >= :info\n    iex> cond_log(:info, :info, \"test message\")\n    :ok\n\n    # Won't log since :info > :debug\n    iex> cond_log(:info, :debug, \"test message\")\n    :ok\n\n    # Will log since :debug <= :info\n    iex> cond_log(:debug, :info, \"test message\")\n    :ok","ref":"Jido.Util.html#cond_log/4-examples"},{"type":"function","title":"Jido.Util.generate_id/0","doc":"Generates a unique ID.","ref":"Jido.Util.html#generate_id/0"},{"type":"type","title":"Jido.Util.server/0","doc":"","ref":"Jido.Util.html#t:server/0"},{"type":"function","title":"Jido.Util.string_to_binary!/1","doc":"Converts a string to a binary.","ref":"Jido.Util.html#string_to_binary!/1"},{"type":"function","title":"Jido.Util.validate_actions/1","doc":"Validates that all modules in a list implement the Jido.Action behavior.\nUsed as a custom validator for NimbleOptions.\n\nThis function ensures that all provided modules are valid Jido.Action implementations\nby checking that they:\n1. Are valid Elixir modules that can be loaded\n2. Export the required __action_metadata__/0 function that indicates Jido.Action behavior","ref":"Jido.Util.html#validate_actions/1"},{"type":"function","title":"Parameters - Jido.Util.validate_actions/1","doc":"- `actions`: A list of module atoms or a single module atom to validate","ref":"Jido.Util.html#validate_actions/1-parameters"},{"type":"function","title":"Returns - Jido.Util.validate_actions/1","doc":"- `{:ok, actions}` if all modules are valid Jido.Action implementations\n- `{:error, reason}` if any module is invalid","ref":"Jido.Util.html#validate_actions/1-returns"},{"type":"function","title":"Examples - Jido.Util.validate_actions/1","doc":"iex> defmodule ValidAction do\n    ...>   use Jido.Action,\n    ...>     name: \"valid_action\"\n    ...> end\n    ...> Jido.Util.validate_actions([ValidAction])\n    {:ok, [ValidAction]}\n\n    iex> Jido.Util.validate_actions([InvalidModule])\n    {:error, \"All actions must implement the Jido.Action behavior\"}\n\n    # Single module validation\n    iex> Jido.Util.validate_actions(ValidAction)\n    {:ok, [ValidAction]}","ref":"Jido.Util.html#validate_actions/1-examples"},{"type":"function","title":"Jido.Util.validate_name/1","doc":"Validates the name of a Action.\n\nThe name must contain only letters, numbers, and underscores.","ref":"Jido.Util.html#validate_name/1"},{"type":"function","title":"Parameters - Jido.Util.validate_name/1","doc":"- `name`: The name to validate.","ref":"Jido.Util.html#validate_name/1-parameters"},{"type":"function","title":"Returns - Jido.Util.validate_name/1","doc":"- `{:ok, name}` if the name is valid.\n- `{:error, reason}` if the name is invalid.","ref":"Jido.Util.html#validate_name/1-returns"},{"type":"function","title":"Examples - Jido.Util.validate_name/1","doc":"iex> Jido.Action.validate_name(\"valid_name_123\")\n    {:ok, \"valid_name_123\"}\n\n    iex> Jido.Action.validate_name(\"invalid-name\")\n    {:error, \"The name must contain only letters, numbers, and underscores.\"}","ref":"Jido.Util.html#validate_name/1-examples"},{"type":"function","title":"Jido.Util.validate_runner/1","doc":"Validates that a module implements the Jido.Runner behavior.\n\nThis function ensures that the provided module is a valid Jido.Runner implementation\nby checking that it:\n1. Is a valid Elixir module that can be loaded\n2. Exports the required run/2 function that indicates Jido.Runner behavior","ref":"Jido.Util.html#validate_runner/1"},{"type":"function","title":"Parameters - Jido.Util.validate_runner/1","doc":"- `module`: The module atom to validate","ref":"Jido.Util.html#validate_runner/1-parameters"},{"type":"function","title":"Returns - Jido.Util.validate_runner/1","doc":"- `{:ok, module}` if the module is a valid Jido.Runner implementation\n- `{:error, Jido.Error.t()}` if the module is invalid","ref":"Jido.Util.html#validate_runner/1-returns"},{"type":"function","title":"Examples - Jido.Util.validate_runner/1","doc":"iex> defmodule ValidRunner do\n    ...>   @behaviour Jido.Runner\n    ...>   def run(agent, opts), do: {:ok, agent}\n    ...> end\n    ...> Jido.Util.validate_runner(ValidRunner)\n    {:ok, ValidRunner}\n\n    iex> Jido.Util.validate_runner(InvalidModule)\n    {:error, %Jido.Error{type: :validation_error, message: \"Module InvalidModule must implement run/2\"}}","ref":"Jido.Util.html#validate_runner/1-examples"},{"type":"function","title":"Jido.Util.via_tuple/2","doc":"Creates a via tuple for process registration with a registry.","ref":"Jido.Util.html#via_tuple/2"},{"type":"function","title":"Parameters - Jido.Util.via_tuple/2","doc":"- name: The name to register (atom, string, or {name, registry} tuple)\n- opts: Options list\n  - :registry - The registry module to use (defaults to Jido.Registry)","ref":"Jido.Util.html#via_tuple/2-parameters"},{"type":"function","title":"Returns - Jido.Util.via_tuple/2","doc":"A via tuple for use with process registration","ref":"Jido.Util.html#via_tuple/2-returns"},{"type":"function","title":"Examples - Jido.Util.via_tuple/2","doc":"iex> Jido.Util.via_tuple(:my_process)\n    {:via, Registry, {Jido.Registry, \"my_process\"}}\n\n    iex> Jido.Util.via_tuple(:my_process, registry: MyRegistry)\n    {:via, Registry, {MyRegistry, \"my_process\"}}\n\n    iex> Jido.Util.via_tuple({:my_process, MyRegistry})\n    {:via, Registry, {MyRegistry, \"my_process\"}}","ref":"Jido.Util.html#via_tuple/2-examples"},{"type":"function","title":"Jido.Util.whereis/2","doc":"Finds a process by name, pid, or {name, registry} tuple.","ref":"Jido.Util.html#whereis/2"},{"type":"function","title":"Parameters - Jido.Util.whereis/2","doc":"- server: The process identifier (pid, name, or {name, registry} tuple)\n- opts: Options list\n  - :registry - The registry module to use (defaults to Jido.Registry)","ref":"Jido.Util.html#whereis/2-parameters"},{"type":"function","title":"Returns - Jido.Util.whereis/2","doc":"- `{:ok, pid}` if process is found\n- `{:error, :not_found}` if process is not found","ref":"Jido.Util.html#whereis/2-returns"},{"type":"function","title":"Examples - Jido.Util.whereis/2","doc":"iex> Jido.Util.whereis(pid)\n    {:ok, #PID<0.123.0>}\n\n    iex> Jido.Util.whereis(:my_process)\n    {:ok, #PID<0.124.0>}\n\n    iex> Jido.Util.whereis({:my_process, MyRegistry})\n    {:ok, #PID<0.125.0>}","ref":"Jido.Util.html#whereis/2-examples"},{"type":"extras","title":"Home","doc":"# Jido (自動)\n\nJido is a toolkit for building autonomous, distributed agent systems in Elixir.\n\nThe name \"Jido\" (自動) comes from the Japanese word meaning \"automatic\" or \"automated\", where 自 (ji) means \"self\" and 動 (dō) means \"movement\".\n\n[![Hex Version](https://img.shields.io/hexpm/v/jido.svg)](https://hex.pm/packages/jido)\n[![Hex Docs](http://img.shields.io/badge/hex.pm-docs-green.svg?style=flat)](https://hexdocs.pm/jido)\n[![Mix Test](https://github.com/agentjido/jido/actions/workflows/elixir-ci.yml/badge.svg)](https://github.com/agentjido/jido/actions/workflows/elixir-ci.yml)\n[![Coverage Status](https://coveralls.io/repos/github/agentjido/jido/badge.svg?branch=main)](https://coveralls.io/github/agentjido/jido?branch=main)\n[![Apache 2 License](https://img.shields.io/hexpm/l/jido)](https://opensource.org/licenses/Apache-2.0)","ref":"readme.html"},{"type":"extras","title":"🚨 Important Notice - Home","doc":"As of March 3rd, 2025, I'm working out a few final issues in prep for the v1.1 release. The `main` branch will always represent the latest release - but it may have a few quality issues that don't represent the final release. I welcome input and contributions!  You can find me in the usual Elixir community locations.","ref":"readme.html#important-notice"},{"type":"extras","title":"Overview - Home","doc":"Jido provides the foundation for building autonomous agents that can plan, execute, and adapt their behavior in distributed Elixir applications. Think of it as a toolkit for creating smart, composable workflows that can evolve and respond to their environment.\n\nThis package is geared towards Agent builders. It contains the basis building blocks for creating advanced agentic systems. This is why there's no AI baked into the core of this framework.\n\nTo see demo's and examples, check out our [Jido Workbench](https://github.com/agentjido/jido_workbench). It includes many examples of agents and workflows, including:\n\n- Agents with Tools\n- ChatBots\n- Agents acting as a Team\n- Multi-modal input & output\n- ... and many more examples\n\nJido Workbench relies on the following packages to extend Jido's capabilities:\n\n- [`jido_ai`](https://github.com/agentjido/jido_ai) package for the AI capabilities.\n- [`jido_chat`](https://github.com/agentjido/jido_chat) package for the chat capabilities.\n- [`jido_memory`](https://github.com/agentjido/jido_memory) package for the memory capabilities.","ref":"readme.html#overview"},{"type":"extras","title":"Key Features - Home","doc":"- 📦 **State Management**: Core state primitives for agents\n- 🧩 **Composable Actions**: Build complex behaviors from simple, reusable actions\n- 🤖 **Agent Data Structures**: Stateless agentic data structures for planning and execution\n- 🔥 **Agent GenServer**: OTP integration for agents, with dynamic supervisors\n- 📡 **Real-time Sensors**: Event-driven data gathering and monitoring\n\n- 🧠 **Skills**: Reusable, composable behavior modules - Plugins for agents\n- ⚡ **Distributed by Design**: Built for multi-node Elixir clusters\n- 🧪 **Testing Tools**: Rich helpers for unit and property-based testing","ref":"readme.html#key-features"},{"type":"extras","title":"Installation - Home","doc":"Add Jido to your dependencies:\n\n```elixir\ndef deps do\n  [\n    {:jido, \"~> 1.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Core Concepts - Home","doc":"","ref":"readme.html#core-concepts"},{"type":"extras","title":"Actions - Home","doc":"Actions are the fundamental building blocks in Jido. Each Action is a discrete, reusable unit of work with a clear interface:\n\n```elixir\ndefmodule MyApp.Actions.FormatUser do\n  use Jido.Action,\n    name: \"format_user\",\n    description: \"Formats user data by trimming whitespace and normalizing email\",\n    schema: [\n      name: [type: :string, required: true],\n      email: [type: :string, required: true]\n    ]\n\n  def run(params, _context) do\n    {:ok, %{\n      formatted_name: String.trim(params.name),\n      email: String.downcase(params.email)\n    }}\n  end\nend\n\n# Execute a single Action via the Workflow system\n{:ok, result} = Jido.Workflow.run(FormatUser, %{name: \"John Doe\", email: \"john@example.com\"})\n```\n\n[Learn more about Actions →](guides/actions/overview.md)","ref":"readme.html#actions"},{"type":"extras","title":"Agents - Home","doc":"Agents are stateful entities that can plan and execute Actions. They maintain their state through a schema and can adapt their behavior:\n\n```elixir\ndefmodule MyApp.CalculatorAgent do\n  use Jido.Agent,\n    name: \"calculator\",\n    description: \"An adaptive calculating agent\",\n    actions: [\n      MyApp.Actions.Add,\n      MyApp.Actions.Multiply,\n      Jido.Actions.Directives.RegisterAction\n    ],\n    schema: [\n      value: [type: :float, default: 0.0],\n      operations: [type: {:list, :atom}, default: []]\n    ]\nend\n\n# Start the agent\n{:ok, pid} = MyApp.CalculatorAgent.start_link()\n\n# Send instructions directly to the agent\n{:ok, result} = MyApp.CalculatorAgent.cmd(pid, [\n  %Jido.Instruction{action: \"add\", params: %{a: 1, b: 2}}\n])\n```\n\n[Learn more about Agents →](guides/agents/overview.md)","ref":"readme.html#agents"},{"type":"extras","title":"Sensors - Home","doc":"Sensors provide real-time monitoring and data gathering for your agents:\n\n```elixir\ndefmodule MyApp.Sensors.OperationCounter do\n  use Jido.Sensor,\n    name: \"operation_counter\",\n    description: \"Tracks operation usage metrics\",\n    schema: [\n      emit_interval: [type: :pos_integer, default: 1000]\n    ]\n\n  def mount(opts) do\n    {:ok, Map.merge(opts, %{counts: %{}})}\n  end\n\n  def handle_info({:operation, name}, state) do\n    new_counts = Map.update(state.counts, name, 1, & &1 + 1)\n    {:noreply, %{state | counts: new_counts}}\n  end\nend\n```\n\n[Learn more about Sensors →](guides/sensors/overview.md)","ref":"readme.html#sensors"},{"type":"extras","title":"Running in Production - Home","doc":"Start your agents under supervision:\n\n```elixir\n# In your application.ex\nchildren = [\n  # Agents fit into your existing supervision tree\n  # Specify an id to always uniquely identify the agent\n  {MyApp.CalculatorAgent, id: \"calculator_1\"}\n]\n\nSupervisor.start_link(children, strategy: :one_for_one)\n```","ref":"readme.html#running-in-production"},{"type":"extras","title":"Documentation - Home","doc":"- [📘 Getting Started Guide](guides/getting-started.livemd)\n- [🧩 Actions & Workflows](guides/actions/overview.md)\n- [🤖 Building Agents](guides/agents/overview.md)\n- [📡 Sensors & Monitoring](guides/sensors/overview.md)\n- [🔄 Agent Directives](guides/agents/directives.md)","ref":"readme.html#documentation"},{"type":"extras","title":"Contributing - Home","doc":"We welcome contributions! Here's how to get started:\n\n1. Fork the repository\n2. Run tests: `mix test`\n3. Run quality checks: `mix quality`\n4. Submit a PR\n\nPlease include tests for any new features or bug fixes.\n\nSee our [Contributing Guide](CONTRIBUTING.md) for detailed guidelines.","ref":"readme.html#contributing"},{"type":"extras","title":"Testing - Home","doc":"Jido is built with a test-driven mindset and provides comprehensive testing tools for building reliable agent systems. Our testing philosophy emphasizes:\n\n- Thorough test coverage for core functionality\n- Property-based testing for complex behaviors\n- Regression tests for every bug fix\n- Extensive testing helpers and utilities","ref":"readme.html#testing"},{"type":"extras","title":"Testing Utilities - Home","doc":"Jido provides several testing helpers:\n\n- `Jido.TestSupport` - Common testing utilities\n- Property-based testing via StreamData\n- Mocking support through Mimic\n- PubSub testing helpers","ref":"readme.html#testing-utilities"},{"type":"extras","title":"Running Tests - Home","doc":"```bash\n# Run the test suite\nmix test\n\n# Run with coverage reporting\nmix test --cover\n\n# Run the full quality check suite\nmix quality\n```\n\nWhile we strive for 100% test coverage, we prioritize meaningful tests that verify behavior over simple line coverage. Every new feature and bug fix includes corresponding tests to prevent regressions.","ref":"readme.html#running-tests"},{"type":"extras","title":"License - Home","doc":"Apache License 2.0 - See [LICENSE.md](LICENSE.md) for details.","ref":"readme.html#license"},{"type":"extras","title":"Support - Home","doc":"- 📚 [Documentation](https://hexdocs.pm/jido)\n- 💬 [GitHub Discussions](https://github.com/agentjido/jido/discussions)\n- 🐛 [Issue Tracker](https://github.com/agentjido/jido/issues)","ref":"readme.html#support"},{"type":"extras","title":"Hello World","doc":"# Your First Agent\n\n_Part of the \"Examples\" section in the documentation._\n\nThis LiveBook guide walks you through creating your first agent with Jido. It provides a hands-on introduction to agent creation, configuration, and basic operations.","ref":"hello-world.html"},{"type":"extras","title":"Quick Start","doc":"# Getting Started with Jido","ref":"getting-started.html"},{"type":"extras","title":"Introduction - Quick Start","doc":"Welcome to Jido! In this interactive guide, we'll explore how to build composable actions and workflows. We'll create a complete user registration system that you can run and experiment with right here in Livebook.\n\nFirst, let's install the required dependencies:\n\n```elixir\nMix.install([\n  {:jido, \"~> 1.0.0-rc.5\"},\n  {:jason, \"~> 1.4\"}\n])\n```","ref":"getting-started.html#introduction"},{"type":"extras","title":"Understanding Actions - Quick Start","doc":"Before we dive into code, let's understand why Jido exists and when you should use it.\n\nYou might be wondering: \"Why should I wrap my code in Actions when I could just write regular Elixir functions?\" This is an excellent question. If you're building a standard Elixir application without AI agents, you probably shouldn't use Actions – regular Elixir modules and functions would be simpler and more direct.\n\nActions exist specifically to support AI agent systems. When you're building agents that need to make autonomous decisions about what steps to take, you need a way to package functionality into discrete, composable units that the agent can reason about and combine in novel ways. Think of Actions as LEGO bricks for agents – standardized, well-described building blocks that can be assembled in different combinations to solve problems.\n\nLet's create our first Action to see how this works in practice:\n\n```elixir\ndefmodule FormatUser do\n  use Jido.Action,\n    name: \"format_user\",\n    description: \"Formats and validates user data\",\n    schema: [\n      name: [\n        type: :string,\n        required: true,\n        doc: \"User's full name\"\n      ],\n      email: [\n        type: :string,\n        required: true,\n        doc: \"User's email address\"\n      ],\n      age: [\n        type: :integer,\n        required: true,\n        doc: \"User's age\"\n      ]\n    ]\n\n  @impl true\n  def run(params, _context) do\n    # Extract params (they're already validated by the schema)\n    %{name: name, email: email, age: age} = params\n\n    # Return formatted data\n    {:ok, %{\n      formatted_name: String.trim(name),\n      email: String.downcase(email),\n      age: age,\n      is_adult: age >= 18\n    }}\n  end\nend\n```\n\nLet's try running our FormatUser action with some test data:\n\n```elixir\n# Notice the trailing space and uppercase email - our Action will clean these\ntest_data = %{\n  name: \"John Doe \",\n  email: \"JOHN@EXAMPLE.COM\",\n  age: 30\n}\n\n# Run the action directly\n{:ok, result} = FormatUser.run(test_data, %{})\n\n# Let's see what we got\nIO.inspect(result, label: \"Formatted User Data\")\n```\n\nNow let's create an action to enrich our user data with additional information:\n\n```elixir\ndefmodule EnrichUserData do\n  use Jido.Action,\n    name: \"enrich_user_data\",\n    description: \"Adds username and avatar URL to user data\",\n    schema: [\n      formatted_name: [type: :string, required: true],\n      email: [type: :string, required: true]\n    ]\n\n  def run(%{formatted_name: name, email: email}, _context) do\n    {:ok, %{\n      username: generate_username(name),\n      avatar_url: get_gravatar_url(email)\n    }}\n  end\n\n  defp generate_username(name) do\n    name\n    |> String.downcase()\n    |> String.replace(\" \", \".\")\n  end\n\n  defp get_gravatar_url(email) do\n    hash = :crypto.hash(:md5, email) |> Base.encode16(case: :lower)\n    \"https://www.gravatar.com/avatar/#{hash}\"\n  end\nend\n```\n\nLet's try our enrichment action:\n\n```elixir\n# Use the result from our previous FormatUser action\n{:ok, enriched_result} = EnrichUserData.run(result, %{})\n\nIO.inspect(enriched_result, label: \"Enriched User Data\")\n```\n\nFinally, let's create an action to simulate sending a welcome notification:\n\n```elixir\ndefmodule NotifyUser do\n  use Jido.Action,\n    name: \"notify_user\",\n    description: \"Sends welcome notification to user\",\n    schema: [\n      email: [type: :string, required: true],\n      username: [type: :string, required: true]\n    ]\n\n  require Logger\n\n  def run(%{email: email, username: username}, _context) do\n    # In a real app, you'd send an actual email\n    Logger.info(\"Sending welcome email to #{email}\")\n\n    {:ok, %{\n      notification_sent: true,\n      notification_type: \"welcome_email\",\n      recipient: %{\n        email: email,\n        username: username\n      }\n    }}\n  end\nend\n```\n\nNow that we have our individual actions, let's see how we can chain them together using Jido's workflow system:\n\n```elixir\nalias Jido.Exec.Chain\n\n# Our initial test data\nuser_data = %{\n  name: \"Jane Smith \",          # Notice the trailing space\n  email: \"JANE@EXAMPLE.COM\",    # Will be downcased\n  age: 25\n}\n\n# Chain all three actions together\n{:ok, final_result} = Chain.chain(\n  [\n    FormatUser,\n    EnrichUserData,\n    NotifyUser\n  ],\n  user_data\n)\n\n# Let's see the complete result\nIO.inspect(final_result, label: \"Complete Workflow Result\")\n```\n\nLet's break down what happened in this chain:\n\n1. `FormatUser` processed the raw input:\n\n   - Trimmed the name\n   - Converted email to lowercase\n   - Added the is_adult flag\n\n2. `EnrichUserData` added profile information:\n\n   - Generated a username\n   - Created an avatar URL\n   - Results were merged with existing data\n\n3. `NotifyUser` simulated sending a welcome message:\n   - Used the email and username from previous steps\n   - Added notification status to the results","ref":"getting-started.html#understanding-actions"},{"type":"extras","title":"Experimenting with Chains - Quick Start","doc":"Try modifying the chain! Here are some experiments you can run:\n\n1. Change the order of actions:\n\n```elixir\n# What happens if we try to notify before enriching?\n{:ok, result} = Chain.chain(\n  [\n    FormatUser,\n    NotifyUser,     # This will fail! Why?\n    EnrichUserData\n  ],\n  user_data\n)\n```\n\n2. Add context data:\n\n```elixir\n# Pass additional context to all actions\n{:ok, result} = Chain.chain(\n  [FormatUser, EnrichUserData, NotifyUser],\n  user_data,\n  context: %{\n    tenant_id: \"123\",\n    environment: \"test\"\n  }\n)\n```\n\n3. Override parameters for specific actions:\n\n```elixir\n# Override the name just for FormatUser\n{:ok, result} = Chain.chain(\n  [\n    {FormatUser, [name: \"Override Name\"]},\n    EnrichUserData,\n    NotifyUser\n  ],\n  user_data\n)\n```","ref":"getting-started.html#experimenting-with-chains"},{"type":"extras","title":"Error Handling - Quick Start","doc":"Let's see how Jido handles errors in chains:\n\n```elixir\n# Try with invalid data\ninvalid_data = %{\n  name: \"John Doe\",\n  email: nil,     # This will fail validation\n  age: 30\n}\n\ncase Chain.chain([FormatUser, EnrichUserData, NotifyUser], invalid_data) do\n  {:ok, result} ->\n    IO.puts(\"Success!\")\n    IO.inspect(result)\n\n  {:error, error} ->\n    IO.puts(\"Failed with error:\")\n    IO.inspect(error)\nend\n```","ref":"getting-started.html#error-handling"},{"type":"extras","title":"Configuration - Quick Start","doc":"","ref":"getting-started.html#configuration"},{"type":"extras","title":"Global Timeout Settings - Quick Start","doc":"By default, Jido actions have a 30-second timeout. You can configure this globally in your application:\n\n```elixir\n# config/config.exs\nconfig :jido, default_timeout: 60_000  # 60 seconds\n```","ref":"getting-started.html#global-timeout-settings"},{"type":"extras","title":"Per-Action Timeouts - Quick Start","doc":"You can also set timeouts for individual actions:\n\n```elixir\n# Run with a custom timeout\n{:ok, result} = Jido.Exec.run(FormatUser, %{name: \"Alice\", email: \"alice@example.com\", age: 30}, %{}, timeout: 10_000)\n\n# Disable timeout completely for long-running operations\n{:ok, result} = Jido.Exec.run(LongRunningAction, params, %{}, timeout: 0)\n```","ref":"getting-started.html#per-action-timeouts"},{"type":"extras","title":"Next Steps - Quick Start","doc":"Now that you understand the basics of Jido actions and workflows, you can:\n\n1. Create your own actions for different domains\n2. Build more complex workflows with branching and conditions\n3. Add error compensation and rollback handling\n4. Create agents that use these actions\n5. Configure timeouts and other execution options for your use case\n\nThe complete Jido documentation has more examples and advanced features to explore!","ref":"getting-started.html#next-steps"},{"type":"extras","title":"What is Jido?","doc":"# What is Jido?\n\n_Part of the \"About Jido\" section in the documentation._\n\nThis guide provides a high-level overview of what Jido is, its core purpose, and where it fits in the landscape of agent-based systems. It serves as the primary introduction to the framework and explains the fundamental concepts that make Jido unique.","ref":"what-is-jido.html"},{"type":"extras","title":"Design Principles","doc":"# Design Principles","ref":"design-principles.html"},{"type":"extras","title":"Overview - Design Principles","doc":"Jido follows a set of core design principles that shape its architecture and guide implementation decisions. These principles emphasize reliability, clarity, and flexibility while maintaining strong guarantees about system behavior.","ref":"design-principles.html#overview"},{"type":"extras","title":"Core Principles - Design Principles","doc":"","ref":"design-principles.html#core-principles"},{"type":"extras","title":"1. Error Tuples Over Exceptions - Design Principles","doc":"Jido adopts a strict \"no exceptions\" policy, using tagged tuples to handle errors explicitly:\n\n```elixir\n# Good - Using error tuples\ndef process_data(input) do\n  case validate_input(input) do\n    {:ok, validated} -> perform_processing(validated)\n    {:error, reason} -> {:error, \"Invalid input: #{reason}\"}\n  end\nend\n\n# Bad - Using exceptions\ndef process_data(input) do\n  validated = validate_input!(input)  # May raise\n  perform_processing(validated)\nrescue\n  e -> handle_error(e)  # Hidden control flow\nend\n```\n\nThis approach provides:\n\n- Explicit error handling paths\n- Clear function contracts\n- Predictable control flow\n- Easy composition with `with` statements","ref":"design-principles.html#1-error-tuples-over-exceptions"},{"type":"extras","title":"2. Data-First Architecture - Design Principles","doc":"Jido prioritizes data transformation over behavioral inheritance:\n\n```elixir\n# Data-centric approach\ndefmodule DataProcessor do\n  def process(%{type: \"user\", data: data} = signal) do\n    with {:ok, enriched} <- enrich_user_data(data),\n         {:ok, validated} <- validate_user(enriched) do\n      {:ok, %{signal | data: validated}}\n    end\n  end\nend\n\n# Instead of behavioral inheritance\ndefmodule UserProcessor do\n  @behaviour Processor\n  def process(signal), do: # Implementation\nend\n```\n\nBenefits:\n\n- Simpler testing and reasoning\n- Easier refactoring\n- Natural composition\n- Clear data flow","ref":"design-principles.html#2-data-first-architecture"},{"type":"extras","title":"3. Rich Compile-Time Discovery - Design Principles","doc":"Jido leverages compile-time metadata to enable rich discovery and validation:\n\n```elixir\ndefmodule MyApp.UserAction do\n  use Jido.Action,\n    name: \"process_user\",\n    description: \"Processes user data with validation\",\n    category: :users,\n    tags: [:processing, :validation],\n    schema: [\n      user_id: [\n        type: :string,\n        required: true,\n        doc: \"Unique user identifier\"\n      ],\n      options: [\n        type: :map,\n        default: %{},\n        doc: \"Processing options\"\n      ]\n    ]\nend\n```\n\nThis enables:\n\n- Automatic documentation generation\n- Schema validation\n- Runtime introspection\n- Tool integration","ref":"design-principles.html#3-rich-compile-time-discovery"},{"type":"extras","title":"4. Event-Driven Processing - Design Principles","doc":"The system is built around event-driven communication using actions and instructions:\n\n```elixir\n# Create an instruction\ninstruction = %Jido.Instruction{\n  action: \"process_user\",\n  params: %{user_data: user_data, source: \"/users\"}\n}\n\n# Process instruction through agent\ndef run(%{user_data: data}, context) do\n  with {:ok, processed} <- process_user(data),\n       {:ok, notification} <- generate_notification(processed) do\n    {:ok, notification}\n  end\nend\n```\n\nKey aspects:\n\n- Decoupled components\n- Asynchronous processing\n- Clear action paths\n- Flexible routing","ref":"design-principles.html#4-event-driven-processing"},{"type":"extras","title":"5. Agents as Dynamic ETL - Design Principles","doc":"Agents function as dynamic Extract-Transform-Load processors:\n\n```elixir\ndefmodule DataTransformAgent do\n  use Jido.Agent,\n    name: \"data_transformer\"\n\n  def process_data(data) do\n    with {:ok, extracted} <- extract_data(data),\n         {:ok, transformed} <- apply_transformations(extracted),\n         {:ok, loaded} <- load_result(transformed) do\n      {:ok, loaded}\n    end\n  end\n\n  # Transformation steps are composed dynamically\n  defp apply_transformations(data) do\n    transformations = [\n      &validate_format/1,\n      &enrich_data/1,\n      &normalize_values/1\n    ]\n\n    Enum.reduce_while(transformations, {:ok, data}, fn transform, {:ok, acc} ->\n      case transform.(acc) do\n        {:ok, result} -> {:cont, {:ok, result}}\n        {:error, _} = error -> {:halt, error}\n      end\n    end)\n  end\nend\n```\n\nBenefits:\n\n- Flexible processing pipelines\n- Clear data transformations\n- Composable operations\n- Runtime adaptation","ref":"design-principles.html#5-agents-as-dynamic-etl"},{"type":"extras","title":"6. Balanced Data Validation - Design Principles","doc":"Jido implements a \"validate what you know\" approach to data handling:\n\n```elixir\ndefmodule FlexibleProcessor do\n  # Schema defines only known fields\n  use Jido.Action,\n    schema: [\n      id: [type: :string, required: true],\n      status: [type: {:in, [:pending, :complete]}]\n    ]\n\n  def process(params) do\n    # Unknown fields pass through unchanged\n    case validate_required_fields(params) do\n      {:ok, validated} ->\n        # Process while preserving unknown fields\n        result = do_process(validated)\n        {:ok, Map.merge(params, result)}\n\n      {:error, _} = error -> error\n    end\n  end\nend\n```\n\nThis approach:\n\n- Validates critical fields\n- Preserves extensibility\n- Enables forward compatibility\n- Reduces maintenance burden","ref":"design-principles.html#6-balanced-data-validation"},{"type":"extras","title":"7. Robust Error Recovery - Design Principles","doc":"Following Erlang's \"let it crash\" philosophy while maintaining system stability:\n\n```elixir\ndefmodule ResilientAgent do\n  use Jido.Agent,\n    name: \"resilient_processor\"\n\n  # Supervisor ensures recovery\n  def child_spec(opts) do\n    %{\n      id: __MODULE__,\n      start: {__MODULE__, :start_link, [opts]},\n      restart: :transient,\n      shutdown: 5000\n    }\n  end\n\n  # Trap exits for cleanup\n  def init(state) do\n    Process.flag(:trap_exit, true)\n    {:ok, state}\n  end\n\n  # Handle known errors\n  def handle_error({:error, :recoverable} = error, state) do\n    Logger.warning(\"Recovering from error\", error: error)\n    {:ok, reset_state(state)}\n  end\n\n  # Let unknown errors crash\n  def handle_error(error, _state) do\n    Logger.error(\"Unhandled error\", error: error)\n    {:stop, error}\n  end\nend\n```\n\nKey features:\n\n- Supervision hierarchies\n- Process isolation\n- Clean error separation\n- Graceful degradation","ref":"design-principles.html#7-robust-error-recovery"},{"type":"extras","title":"See Also - Design Principles","doc":"- [Agent Overview](agents/overview.md)\n- [Action Overview](actions/overview.md)","ref":"design-principles.html#see-also"},{"type":"extras","title":"Do You Need an Agent?","doc":"# Do You Need an Agent?","ref":"do-you-need-an-agent.html"},{"type":"extras","title":"Overview - Do You Need an Agent?","doc":"This guide helps you evaluate whether your application would benefit from an agent-based architecture using Jido. We'll explore what agents are, when they're most valuable, and when simpler alternatives might be more appropriate.","ref":"do-you-need-an-agent.html#overview"},{"type":"extras","title":"What Makes Something an Agent? - Do You Need an Agent?","doc":"At its core, an agent is a software entity that can:\n\n1. Observe its environment through sensors\n2. Make decisions based on those observations\n3. Take actions that affect its environment\n4. Learn from the results of its actions (optional)\n\nIn Jido specifically, agents are systems where either Large Language Models (LLMs) or classical planning algorithms dynamically direct their own processes.","ref":"do-you-need-an-agent.html#what-makes-something-an-agent"},{"type":"extras","title":"When Agents Excel - Do You Need an Agent?","doc":"","ref":"do-you-need-an-agent.html#when-agents-excel"},{"type":"extras","title":"Complex Decision Making - Do You Need an Agent?","doc":"- Multiple data sources need to be analyzed together\n- Decisions require contextual understanding\n- Actions need to adapt based on previous outcomes\n\nExample:\n\n```elixir\ndefmodule ContentModerationAgent do\n  use Jido.Agent,\n    name: \"content_moderator\",\n    actions: [\n      AnalyzeText,\n      AnalyzeImage,\n      CheckPolicyCompliance,\n      TakeModeratorAction\n    ]\n\n  # This agent excels because it needs to:\n  # 1. Consider multiple types of content\n  # 2. Apply context-specific policies\n  # 3. Take appropriate actions based on violations\nend\n```","ref":"do-you-need-an-agent.html#complex-decision-making"},{"type":"extras","title":"Dynamic Workflows - Do You Need an Agent?","doc":"- Process flow isn't fixed\n- Steps depend on intermediate results\n- Multiple paths to goal achievement\n\nExample:\n\n```elixir\ndefmodule CustomerSupportAgent do\n  use Jido.Agent,\n    name: \"support_assistant\",\n    actions: [\n      ClassifyTicket,\n      SearchKnowledgeBase,\n      EscalateToHuman,\n      GenerateResponse\n    ]\n\n  # Workflow varies based on:\n  # - Ticket complexity\n  # - Available solutions\n  # - Need for human intervention\nend\n```","ref":"do-you-need-an-agent.html#dynamic-workflows"},{"type":"extras","title":"Autonomous Operation - Do You Need an Agent?","doc":"- System needs to operate independently\n- Real-time response to changing conditions\n- Self-correction and recovery","ref":"do-you-need-an-agent.html#autonomous-operation"},{"type":"extras","title":"When You Don't Need an Agent - Do You Need an Agent?","doc":"","ref":"do-you-need-an-agent.html#when-you-don-t-need-an-agent"},{"type":"extras","title":"Simple Linear Processes - Do You Need an Agent?","doc":"If your workflow follows a fixed sequence of steps, consider a pipeline or GenServer:\n\n```elixir\ndefmodule SimpleProcessor do\n  use GenServer\n\n  def process_data(data) do\n    data\n    |> validate()\n    |> transform()\n    |> store()\n  end\nend\n```","ref":"do-you-need-an-agent.html#simple-linear-processes"},{"type":"extras","title":"Basic CRUD Operations - Do You Need an Agent?","doc":"Standard web applications with straightforward database operations rarely need agents:\n\n```elixir\ndefmodule UserController do\n  use MyApp.Web, :controller\n\n  def create(conn, params) do\n    # Simple user creation logic\n    changeset = User.changeset(%User{}, params)\n    case Repo.insert(changeset) do\n      {:ok, user} -> json(conn, user)\n      {:error, changeset} -> json(conn, %{errors: changeset})\n    end\n  end\nend\n```","ref":"do-you-need-an-agent.html#basic-crud-operations"},{"type":"extras","title":"Static Business Rules - Do You Need an Agent?","doc":"When decisions follow clear, unchanging rules:\n\n```elixir\ndefmodule PricingCalculator do\n  def calculate_price(base_price, customer_tier) do\n    case customer_tier do\n      :premium -> base_price * 0.9  # 10% discount\n      :standard -> base_price\n      :basic -> base_price * 1.1    # 10% markup\n    end\n  end\nend\n```","ref":"do-you-need-an-agent.html#static-business-rules"},{"type":"extras","title":"Cost-Benefit Analysis - Do You Need an Agent?","doc":"","ref":"do-you-need-an-agent.html#cost-benefit-analysis"},{"type":"extras","title":"Agent Costs - Do You Need an Agent?","doc":"1. Development Complexity\n\n   - More moving parts\n   - Complex state management\n   - Additional testing requirements\n\n2. Operational Overhead\n\n   - Higher computation needs\n   - LLM API costs (if using)\n   - Monitoring complexity\n\n3. Maintenance Burden\n   - More sophisticated debugging\n   - Regular LLM prompt tuning\n   - Complex failure modes","ref":"do-you-need-an-agent.html#agent-costs"},{"type":"extras","title":"Agent Benefits - Do You Need an Agent?","doc":"1. Flexibility\n\n   - Easily adapt to new requirements\n   - Handle edge cases gracefully\n   - Scale complexity without rewrites\n\n2. Intelligence\n\n   - Natural language understanding\n   - Complex pattern recognition\n   - Learning from experience\n\n3. Autonomy\n   - Reduced human intervention\n   - 24/7 operation capability\n   - Self-healing potential","ref":"do-you-need-an-agent.html#agent-benefits"},{"type":"extras","title":"Decision Framework - Do You Need an Agent?","doc":"Ask yourself these questions:\n\n1. Complexity Assessment\n\n   - Does your problem require dynamic decision-making?\n   - Are there multiple valid approaches to solving it?\n   - Do solutions need to adapt based on context?\n\n2. Resource Evaluation\n\n   - Can you afford LLM API costs?\n   - Do you have expertise to maintain agent systems?\n   - Is the development time investment justified?\n\n3. Alternative Analysis\n   - Could a simple script handle this?\n   - Would a traditional web service suffice?\n   - Is this actually a data pipeline problem?","ref":"do-you-need-an-agent.html#decision-framework"},{"type":"extras","title":"Getting Started - Do You Need an Agent?","doc":"If you've decided an agent is right for you:\n\n1. Start Small\n\n   ```elixir\n   defmodule MyFirstAgent do\n     use Jido.Agent,\n       name: \"starter_agent\",\n       actions: [SimpleAction]\n\n     # Begin with basic functionality\n     # Add complexity incrementally\n   end\n   ```\n\n2. Measure Success\n\n   - Define clear metrics\n   - Monitor agent performance\n   - Track resource usage\n\n3. Iterate Carefully\n   - Add capabilities gradually\n   - Test thoroughly\n   - Document decision points","ref":"do-you-need-an-agent.html#getting-started"},{"type":"extras","title":"Common Pitfalls - Do You Need an Agent?","doc":"1. Over-engineering\n\n   - Adding agents where simple code would suffice\n   - Using LLMs for deterministic tasks\n   - Creating complex architectures prematurely\n\n2. Under-preparation\n\n   - Insufficient error handling\n   - Poor monitoring setup\n   - Lack of fallback mechanisms\n\n3. Misaligned Expectations\n   - Expecting perfect decisions\n   - Underestimating maintenance needs\n   - Ignoring cost implications","ref":"do-you-need-an-agent.html#common-pitfalls"},{"type":"extras","title":"Conclusion - Do You Need an Agent?","doc":"Agents are powerful tools when used appropriately. They excel at complex, dynamic tasks requiring autonomous decision-making. However, they come with costs and complexity that aren't always justified.\n\nBefore implementing an agent-based solution:\n\n- Carefully evaluate your needs\n- Consider simpler alternatives\n- Plan for maintenance and scaling\n- Start small and iterate\n\nRemember: The best architecture is often the simplest one that meets your needs effectively.","ref":"do-you-need-an-agent.html#conclusion"},{"type":"extras","title":"Where is the AI?","doc":"# Where is the AI?","ref":"where-is-the-ai.html"},{"type":"extras","title":"Overview - Where is the AI?","doc":"Jido's core framework is purposely AI-agnostic. While Jido is excellent for building AI-powered agent systems, the core package doesn't include direct integrations with language models or other AI components.","ref":"where-is-the-ai.html#overview"},{"type":"extras","title":"AI Integration - Where is the AI?","doc":"For AI capabilities, we provide a companion package called `jido_ai` that adds:\n\n- Language model integrations (OpenAI, Anthropic, etc.)\n- Embeddings and vector stores\n- AI-specific actions and skills\n- Prompt templates and management","ref":"where-is-the-ai.html#ai-integration"},{"type":"extras","title":"Usage Example - Where is the AI?","doc":"```elixir\n# Add jido_ai to your dependencies\ndef deps do\n  [\n    {:jido, \"~> 0.1.0\"},\n    {:jido_ai, \"~> 0.1.0\"} # For AI capabilities\n  ]\nend\n```","ref":"where-is-the-ai.html#usage-example"},{"type":"extras","title":"Why Separate? - Where is the AI?","doc":"This separation allows:\n\n- Lighter core package for non-AI use cases\n- Freedom to choose AI providers\n- Easier testing and development\n- Independent versioning of AI features\n\nThe core Jido framework focuses on agent fundamentals - signals, actions, and coordination. Add `jido_ai` when you need AI capabilities in your agent system.","ref":"where-is-the-ai.html#why-separate"},{"type":"extras","title":"Alternatives","doc":"# Alternatives\n\nThis guide explores alternative solutions to building agent and workflow systems in Elixir. Understanding these alternatives helps you make informed decisions about when to use Jido versus other approaches.","ref":"alternatives.html"},{"type":"extras","title":"Built-in Elixir Solutions - Alternatives","doc":"","ref":"alternatives.html#built-in-elixir-solutions"},{"type":"extras","title":"Agent Module - Alternatives","doc":"The built-in [Agent](https://hexdocs.pm/elixir/Agent.html) module provides simple state management without the complexity of full agent systems. Use it when you need basic state management without complex behaviors or signal routing.\n\n```elixir\n{:ok, agent} = Agent.start_link(fn -> %{} end)\nAgent.update(agent, fn state -> Map.put(state, :key, \"value\") end)\n```","ref":"alternatives.html#agent-module"},{"type":"extras","title":"GenServer - Alternatives","doc":"[GenServer](https://hexdocs.pm/elixir/GenServer.html) offers process management and state machines. Choose it for direct process communication and simple request/response patterns without complex workflows.","ref":"alternatives.html#genserver"},{"type":"extras","title":"Data Processing Frameworks - Alternatives","doc":"","ref":"alternatives.html#data-processing-frameworks"},{"type":"extras","title":"Broadway - Alternatives","doc":"[Broadway](https://github.com/dashbitco/broadway) excels at data ingestion and processing. Ideal for stream processing with back-pressure and rate limiting, without agent-based decision making.","ref":"alternatives.html#broadway"},{"type":"extras","title":"Flow - Alternatives","doc":"[Flow](https://github.com/dashbitco/flow) provides data-flow processing for parallel operations. Best for MapReduce-style operations when you don't need persistent agent state.","ref":"alternatives.html#flow"},{"type":"extras","title":"Oban - Alternatives","doc":"[Oban](https://github.com/sorentwo/oban) offers PostgreSQL-backed job processing. Choose it for durable background jobs and scheduling without agent behaviors.","ref":"alternatives.html#oban"},{"type":"extras","title":"Agent Systems - Alternatives","doc":"","ref":"alternatives.html#agent-systems"},{"type":"extras","title":"Swarm.ex - Alternatives","doc":"[Swarm.ex](https://github.com/nrrso/swarm_ex) provides a swarm intelligence framework. Suitable for collective behavior simulations and distributed problem-solving without Jido's focus on individual agent reasoning.","ref":"alternatives.html#swarm-ex"},{"type":"extras","title":"When to Choose Jido - Alternatives","doc":"Select Jido when you need:\n\n1. Complex agent behaviors with multi-step reasoning\n2. Distributed intelligence with sensor-driven responses\n3. Extensible architecture with custom skills and pluggable sensors\n\nWant to add or edit this list? Open a [pull request](https://github.com/agentjido/jido/edit/main/guides/about/alternatives.md).\n\nFor a broader list of Elixir packages, visit [Awesome Elixir](https://github.com/h4cc/awesome-elixir).","ref":"alternatives.html#when-to-choose-jido"},{"type":"extras","title":"Contributing","doc":"# Contributing to Jido\n\nWelcome to the Jido contributor's guide! We're excited that you're interested in contributing to Jido, our framework for building autonomous, distributed agent systems in Elixir. This guide will help you understand our development process and standards.","ref":"contributing.html"},{"type":"extras","title":"Getting Started - Contributing","doc":"","ref":"contributing.html#getting-started"},{"type":"extras","title":"Development Environment - Contributing","doc":"1. **Elixir Version Requirements**\n   - Jido requires Elixir ~> 1.17\n   - We recommend using asdf or similar version manager\n\n2. **Initial Setup**\n   ```bash\n   # Clone the repository\n   git clone https://github.com/agentjido/jido.git\n   cd jido\n\n   # Install dependencies\n   mix deps.get\n\n   # Run tests to verify your setup\n   mix test\n   ```\n\n3. **Quality Checks**\n   ```bash\n   # Run the full quality check suite\n   mix quality\n\n   # Or individual checks\n   mix format                    # Format code\n   mix compile --warnings-as-errors  # Check compilation\n   mix dialyzer                  # Type checking\n   mix credo --all              # Static analysis\n   ```","ref":"contributing.html#development-environment"},{"type":"extras","title":"Code Organization - Contributing","doc":"","ref":"contributing.html#code-organization"},{"type":"extras","title":"Project Structure - Contributing","doc":"```\n.\n├── lib/\n│   ├── jido/\n│   │   ├── actions/     # Core action implementations\n│   │   ├── agents/      # Agent behaviors and implementations\n│   │   ├── sensors/     # Sensor system components\n│   │   ├── workflows/   # Workflow execution engines\n│   │   └── utils/       # Utility functions\n│   └── jido.ex          # Main entry point\n├── test/\n│   ├── jido/\n│   │   └── ...         # Tests mirroring lib structure\n│   ├── support/        # Test helpers and shared fixtures\n│   └── test_helper.exs\n├── guides/            # Documentation guides\n└── mix.exs\n```","ref":"contributing.html#project-structure"},{"type":"extras","title":"Core Components - Contributing","doc":"- **Actions**: Discrete, composable units of work\n- **Workflows**: Sequences of actions that accomplish larger goals\n- **Agents**: Stateful entities that can plan and execute workflows\n- **Sensors**: Real-time monitoring and data gathering components","ref":"contributing.html#core-components"},{"type":"extras","title":"Development Guidelines - Contributing","doc":"","ref":"contributing.html#development-guidelines"},{"type":"extras","title":"Code Style - Contributing","doc":"1. **Formatting**\n   - Run `mix format` before committing\n   - Follow standard Elixir style guide\n   - Use `snake_case` for functions and variables\n   - Use `PascalCase` for module names\n\n2. **Documentation**\n   - Add `@moduledoc` to every module\n   - Document all public functions with `@doc`\n   - Include examples when helpful\n   - Keep guides up-to-date in the `guides/` directory\n   - Use doctests for simple examples\n\n3. **Type Specifications**\n   ```elixir\n   @type validation_error :: :invalid_name | :invalid_status\n   \n   @spec process(String.t()) :: {:ok, term()} | {:error, validation_error()}\n   def process(input) do\n     # Implementation\n   end\n   ```","ref":"contributing.html#code-style"},{"type":"extras","title":"Testing - Contributing","doc":"1. **Test Organization**\n   ```elixir\n   defmodule Jido.Test.Actions.FormatUserTest do\n     use ExUnit.Case, async: true\n     \n     describe \"run/2\" do\n       test \"formats user data correctly\" do\n         # Test implementation\n       end\n       \n       test \"handles invalid input\" do\n         # Error case testing\n       end\n     end\n   end\n   ```\n\n2. **Coverage Requirements**\n   - Maintain high test coverage\n   - Test both success and error paths\n   - Include property-based tests for complex logic\n   - Test async behavior where applicable\n\n3. **Running Tests**\n   ```bash\n   # Run full test suite\n   mix test\n\n   # Run with coverage\n   mix test --cover\n\n   # Run specific test file\n   mix test test/jido/actions/format_user_test.exs\n   ```","ref":"contributing.html#testing"},{"type":"extras","title":"Error Handling - Contributing","doc":"1. **Use With Patterns**\n   ```elixir\n   def complex_operation(input) do\n     with {:ok, validated} <- validate(input),\n          {:ok, processed} <- process(validated) do\n       {:ok, processed}\n     end\n   end\n   ```\n\n2. **Return Values**\n   - Use tagged tuples: `{:ok, result}` or `{:error, reason}`\n   - Create specific error types for different failures\n   - Never intentionally raise Exceptions, the Jido framework intentionally minimizes the use of exceptions.\n   - Avoid silent failures\n   - Document error conditions","ref":"contributing.html#error-handling"},{"type":"extras","title":"Performance Considerations - Contributing","doc":"1. **Optimization**\n   - Profile before optimizing\n   - Document performance characteristics\n   - Consider resource usage in distributed environments\n   - Implement appropriate timeouts\n\n2. **Resource Management**\n   - Clean up resources properly\n   - Handle large data sets efficiently\n   - Consider memory usage in long-running processes","ref":"contributing.html#performance-considerations"},{"type":"extras","title":"Pull Request Process - Contributing","doc":"1. **Before Submitting**\n   - Run the full quality check suite: `mix quality`\n   - Ensure all tests pass\n   - Update documentation if needed\n   - Add tests for new functionality\n\n2. **PR Guidelines**\n   - Create a feature branch from `main`\n   - Use descriptive commit messages\n   - Reference any related issues\n   - Keep changes focused and atomic\n\n3. **Review Process**\n   - PRs require at least one review\n   - Address all review comments\n   - Maintain a clean commit history\n   - Update your branch if needed","ref":"contributing.html#pull-request-process"},{"type":"extras","title":"Release Process - Contributing","doc":"1. **Version Numbers**\n   - Follow semantic versioning\n   - Update version in `mix.exs`\n   - Update CHANGELOG.md\n\n2. **Documentation**\n   - Update guides if needed\n   - Check all docstrings\n   - Verify README is current","ref":"contributing.html#release-process"},{"type":"extras","title":"Additional Resources - Contributing","doc":"- [Hex Documentation](https://hexdocs.pm/jido)\n- [GitHub Issues](https://github.com/agentjido/jido/issues)\n- [GitHub Discussions](https://github.com/agentjido/jido/discussions)","ref":"contributing.html#additional-resources"},{"type":"extras","title":"Questions or Problems? - Contributing","doc":"If you have questions about contributing:\n- Open a GitHub Discussion\n- Check existing issues\n- Review the guides directory\n\nThank you for contributing to Jido!","ref":"contributing.html#questions-or-problems"},{"type":"extras","title":"Changelog","doc":"# CHANGELOG\n\n<!-- %% CHANGELOG_ENTRIES %% -->","ref":"changelog.html"},{"type":"extras","title":"1.1.0-rc.1 - 2025-02-18 - Changelog","doc":"- Address open Credo Errors\n- Add documentation\n- Clean up README in prep for 1.1 release","ref":"changelog.html#1-1-0-rc-1-2025-02-18"},{"type":"extras","title":"1.1.0-rc - 2025-02-08 - Changelog","doc":"- Stateful Agents","ref":"changelog.html#1-1-0-rc-2025-02-08"},{"type":"extras","title":"Apache 2.0 License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2019 Parker Selbert\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"Agents with Tools","doc":"# Tool Use in Agents\n\n_Part of the \"Examples\" section in the documentation._\n\nThis LiveBook guide demonstrates how to implement and use tools with agents. It provides practical examples of tool definition, integration with AI systems, and common tool usage patterns.","ref":"tool-use.html"},{"type":"extras","title":"Think-Plan-Act","doc":"# Think-Plan-Act Cycle\n\n_Part of the \"Examples\" section in the documentation._\n\nThis LiveBook guide demonstrates implementing the Think-Plan-Act cycle in agents. It shows how to create agents that can analyze situations, plan responses, and execute actions in a coordinated way.","ref":"think-plan-act.html"},{"type":"extras","title":"Chain of Thought","doc":"# Chain of Thought Reasoning\n\n_Part of the \"Examples\" section in the documentation._\n\nThis LiveBook guide explores implementing chain-of-thought reasoning in agents. It demonstrates how to build agents that can break down complex problems and reason through solutions step by step.","ref":"chain-of-thought.html"},{"type":"extras","title":"Multi-Agent Systems","doc":"# Multi-Agent Systems\n\n_Part of the \"Examples\" section in the documentation._\n\nThis LiveBook guide explores building systems with multiple cooperating agents. It demonstrates patterns for agent communication, coordination, and collaboration in solving complex problems.","ref":"multi-agent.html"},{"type":"extras","title":"Overview","doc":"# Actions Overview\n\nActions are the fundamental building blocks of agent behavior in Jido. Each Action represents a discrete, composable unit of functionality that can be executed as part of a workflow. This guide explores how to create, use, and compose Actions effectively.","ref":"overview-1.html"},{"type":"extras","title":"Core Concepts - Overview","doc":"Actions in Jido follow several key design principles:\n\n1. **Self-Contained**: Each Action encapsulates a specific piece of functionality with clear inputs and outputs\n2. **Composable**: Actions can be chained together to create complex workflows\n3. **Validated**: Input parameters are validated using schemas\n4. **Context-Aware**: Actions receive execution context for enhanced flexibility\n5. **Error-Resilient**: Built-in error handling and compensation mechanisms","ref":"overview-1.html#core-concepts"},{"type":"extras","title":"Defining Actions - Overview","doc":"Here's a simple Action that adds two numbers:\n\n```elixir\ndefmodule MyApp.Actions.Add do\n  use Jido.Action,\n    name: \"add\",\n    description: \"Adds two numbers together\",\n    schema: [\n      value: [type: :number, required: true, doc: \"First number\"],\n      amount: [type: :number, required: true, doc: \"Second number\"]\n    ]\n\n  @impl true\n  def run(%{value: value, amount: amount}, _context) do\n    {:ok, %{result: value + amount}}\n  end\nend\n```","ref":"overview-1.html#defining-actions"},{"type":"extras","title":"Key Components - Overview","doc":"1. **Module Definition**: Actions are Elixir modules that use the `Jido.Action` behavior\n2. **Configuration**:\n   - `name`: Unique identifier for the Action\n   - `description`: Human-readable description\n   - `schema`: Parameter validation rules using NimbleOptions\n3. **Run Implementation**: The `run/2` callback defines the Action's core logic","ref":"overview-1.html#key-components"},{"type":"extras","title":"Action Lifecycle - Overview","doc":"When an Action is executed, it goes through several phases:\n\n1. **Parameter Validation**: Input is checked against the schema\n2. **Execution**: The `run/2` callback is invoked\n3. **Result Processing**: Output is normalized and returned\n4. **Error Handling**: Failures are caught and processed","ref":"overview-1.html#action-lifecycle"},{"type":"extras","title":"Example Workflow - Overview","doc":"```elixir\ndefmodule MyApp.Actions.ProcessOrder do\n  use Jido.Action,\n    name: \"process_order\",\n    description: \"Processes a customer order\",\n    schema: [\n      order_id: [type: :string, required: true],\n      customer_id: [type: :string, required: true]\n    ]\n\n  @impl true\n  def run(params, context) do\n    with {:ok, order} <- fetch_order(params.order_id),\n         {:ok, processed} <- apply_processing(order, context) do\n      {:ok, %{\n        order_id: params.order_id,\n        status: \"processed\",\n        result: processed\n      }}\n    else\n      {:error, reason} -> {:error, \"Failed to process order: #{reason}\"}\n    end\n  end\nend\n```","ref":"overview-1.html#example-workflow"},{"type":"extras","title":"Error Handling - Overview","doc":"Actions support multiple error handling patterns:","ref":"overview-1.html#error-handling"},{"type":"extras","title":"1. Basic Error Return - Overview","doc":"```elixir\ndef run(%{value: 0}, _context) do\n  {:error, \"Cannot process zero value\"}\nend\n```","ref":"overview-1.html#1-basic-error-return"},{"type":"extras","title":"2. Compensation Logic - Overview","doc":"```elixir\ndefmodule MyApp.Actions.RiskyOperation do\n  use Jido.Action,\n    name: \"risky_operation\",\n    compensation: [enabled: true]\n\n  def on_error(failed_params, error, _context, _opts) do\n    # Compensation logic here\n    {:ok, %{compensated: true, original_error: error}}\n  end\nend\n```","ref":"overview-1.html#2-compensation-logic"},{"type":"extras","title":"3. Error Context - Overview","doc":"```elixir\n{:error, %Jido.Error{\n  type: :validation_error,\n  message: \"Invalid input\",\n  details: %{field: :value, reason: \"must be positive\"}\n}}\n```","ref":"overview-1.html#3-error-context"},{"type":"extras","title":"Composing Actions - Overview","doc":"Actions can be composed in several ways:","ref":"overview-1.html#composing-actions"},{"type":"extras","title":"1. Sequential Chaining - Overview","doc":"```elixir\nalias MyApp.Actions.{ValidateOrder, ProcessOrder, NotifyCustomer}\n\ninstructions = [\n  ValidateOrder,\n  {ProcessOrder, %{priority: \"high\"}},\n  NotifyCustomer\n]\n\nJido.Workflow.run_chain(instructions, %{order_id: \"123\"})\n```","ref":"overview-1.html#1-sequential-chaining"},{"type":"extras","title":"2. Conditional Execution - Overview","doc":"```elixir\ndef process_with_notification(params) do\n  base_instructions = [ValidateOrder, ProcessOrder]\n\n  instructions =\n    if params.notify do\n      base_instructions ++ [NotifyCustomer]\n    else\n      base_instructions\n    end\n\n  Jido.Workflow.run_chain(instructions, params)\nend\n```","ref":"overview-1.html#2-conditional-execution"},{"type":"extras","title":"Built-in Actions - Overview","doc":"Jido provides several built-in Action modules:","ref":"overview-1.html#built-in-actions"},{"type":"extras","title":"Basic Operations - Overview","doc":"```elixir\nalias Jido.Actions.Basic\n\n# Sleep for a duration\nBasic.Sleep.run(%{duration_ms: 1000}, %{})\n\n# Log a message\nBasic.Log.run(%{level: :info, message: \"Processing\"}, %{})\n```","ref":"overview-1.html#basic-operations"},{"type":"extras","title":"File Operations - Overview","doc":"```elixir\nalias Jido.Actions.Files\n\n# Write to a file\nFiles.WriteFile.run(%{\n  path: \"output.txt\",\n  content: \"Hello\",\n  create_dirs: true\n}, %{})\n```","ref":"overview-1.html#file-operations"},{"type":"extras","title":"Arithmetic Operations - Overview","doc":"```elixir\nalias Jido.Actions.Arithmetic\n\n# Add numbers\nArithmetic.Add.run(%{value: 5, amount: 3}, %{})\n\n# Multiply numbers\nArithmetic.Multiply.run(%{value: 4, amount: 2}, %{})\n```","ref":"overview-1.html#arithmetic-operations"},{"type":"extras","title":"Testing Actions - Overview","doc":"Actions can be tested using standard ExUnit tests:\n\n```elixir\ndefmodule MyApp.Actions.AddTest do\n  use ExUnit.Case\n\n  test \"adds two numbers\" do\n    params = %{value: 5, amount: 3}\n    assert {:ok, %{result: 8}} = MyApp.Actions.Add.run(params, %{})\n  end\n\n  test \"validates required parameters\" do\n    params = %{value: 5}\n    assert {:error, _} = MyApp.Actions.Add.run(params, %{})\n  end\nend\n```","ref":"overview-1.html#testing-actions"},{"type":"extras","title":"Best Practices - Overview","doc":"1. **Keep Actions Focused**: Each Action should do one thing well\n2. **Validate Inputs**: Use comprehensive schemas to catch issues early\n3. **Handle Errors**: Implement proper error handling and compensation\n4. **Provide Context**: Use the context parameter for shared state\n5. **Document Well**: Include clear descriptions and parameter documentation","ref":"overview-1.html#best-practices"},{"type":"extras","title":"Next Steps - Overview","doc":"- Learn about [Action Configuration](configuration.md) including timeout settings\n- Learn about [Action Workflows](workflows.html)\n- Explore [Testing Actions](testing.html)\n- Understand [Action Directives](directives.html)\n- See [Actions as Tools](actions-as-tools.html)","ref":"overview-1.html#next-steps"},{"type":"extras","title":"See Also - Overview","doc":"- [Action Configuration](configuration.md)\n- [Signal Overview](../signals/overview.livemd)\n- [Agent Overview](../agents/overview.md)\n- [Action Testing](testing.md)","ref":"overview-1.html#see-also"},{"type":"extras","title":"Executing Actions","doc":"# Executing Actions with Workflows","ref":"workflows.html"},{"type":"extras","title":"Overview - Executing Actions","doc":"The Jido `Workflow` module provides a robust execution engine for running Actions. It handles parameter validation, error handling, timeouts, retries, and telemetry - giving you a production-ready foundation for executing Actions in your agent systems.","ref":"workflows.html#overview"},{"type":"extras","title":"Basic Usage - Executing Actions","doc":"The `Workflow.run/4` function can accept either Action parameters or an Instruction struct. Instructions provide a way to encapsulate the complete execution context for an Action. See the [Instructions guide](instructions.md) for more details on working with Instructions.\n\n```elixir\n# Using an Action module directly\n{:ok, result} = Workflow.run(MyAction, %{param1: \"value\"})\n\n# Using an Instruction struct\ninstruction = %Instruction{\n  action: MyAction,\n  params: %{param1: \"value\"},\n  context: %{user_id: 123},\n  opts: [timeout: 10_000]\n}\n{:ok, result} = Workflow.run(instruction)\n\n# Basic module execution\n{:ok, result} = Workflow.run(MyAction, %{param1: \"value\"})\n\n# Basic execution\n{:ok, result} = Workflow.run(MyAction, %{param1: \"value\"})\n\n# With context\n{:ok, result} = Workflow.run(MyAction, %{param1: \"value\"}, %{user_id: 123})\n\n# With options\n{:ok, result} = Workflow.run(MyAction, %{param1: \"value\"}, %{}, timeout: 10_000)\n```","ref":"workflows.html#basic-usage"},{"type":"extras","title":"Parameters - Executing Actions","doc":"The `run/4` function accepts:\n\n```elixir\n# With Action module:\nWorkflow.run(action, params \\\\ %{}, context \\\\ %{}, opts \\\\ [])\n\n# With Instruction struct:\nWorkflow.run(%Instruction{} = instruction)\n```\n\n- `action` - The Action module to execute\n- `params` - Map of parameters for the Action (validated against schema)\n- `context` - Additional context data passed to the Action\n- `opts` - Execution options (see below)","ref":"workflows.html#parameters"},{"type":"extras","title":"Execution Options - Executing Actions","doc":"","ref":"workflows.html#execution-options"},{"type":"extras","title":"Timeouts - Executing Actions","doc":"By default, Actions have a 30 second timeout. You can customize this globally or per-action:\n\n```elixir\n# Global configuration (in config.exs)\nconfig :jido, default_timeout: 60_000  # 60 seconds\n\n# Disable timeout completely\nWorkflow.run(MyAction, %{}, %{}, timeout: 0)\n\n# Set custom timeout (in milliseconds)\nWorkflow.run(MyAction, %{}, %{}, timeout: 10_000) # 10 seconds\n```","ref":"workflows.html#timeouts"},{"type":"extras","title":"Retries - Executing Actions","doc":"Actions support automatic retries with exponential backoff:\n\n```elixir\n# Configure max retries and initial backoff\nWorkflow.run(MyAction, %{}, %{},\n  max_retries: 3,          # Maximum retry attempts (default: 1)\n  backoff: 250            # Initial backoff in ms, doubles each retry (default: 250)\n)\n```\n\nThe backoff duration doubles after each retry, up to a maximum of 30 seconds.","ref":"workflows.html#retries"},{"type":"extras","title":"Telemetry - Executing Actions","doc":"Actions emit telemetry events for monitoring. You can control the level of detail:\n\n```elixir\n# Full telemetry (default)\nWorkflow.run(MyAction, %{}, %{}, telemetry: :full)\n\n# Basic telemetry\nWorkflow.run(MyAction, %{}, %{}, telemetry: :minimal)\n\n# Disable telemetry\nWorkflow.run(MyAction, %{}, %{}, telemetry: :silent)\n```","ref":"workflows.html#telemetry"},{"type":"extras","title":"Asynchronous Execution - Executing Actions","doc":"For long-running Actions, you can execute them asynchronously:\n\n```elixir\n# Start async execution\nasync_ref = Workflow.run_async(MyAction, params)\n\n# Do other work...\n\n# Wait for result\n{:ok, result} = Workflow.await(async_ref)\n\n# Wait with timeout\n{:ok, result} = Workflow.await(async_ref, 10_000)\n\n# Cancel execution\n:ok = Workflow.cancel(async_ref)\n```","ref":"workflows.html#asynchronous-execution"},{"type":"extras","title":"Task Supervision - Executing Actions","doc":"Async Actions run under a Task Supervisor, providing:\n\n- Automatic process cleanup\n- Crash isolation\n- Timeout handling\n- Cancellation support\n\nThe Jido framework starts a Task Supervisor by default. You can customize this by setting the `task_supervisor` option:\n\n```elixir\n# In your application.ex\nchildren = [\n  {Task.Supervisor, name: MyApp.TaskSupervisor}\n]\n\n# Configure Jido to use your supervisor\nconfig :jido,\n  task_supervisor: MyApp.TaskSupervisor\n```","ref":"workflows.html#task-supervision"},{"type":"extras","title":"Error Handling - Executing Actions","doc":"Actions should use standard `{:ok, result}` and `{:error, error}` tuples for consistent error handling:\n\n```elixir\ncase Workflow.run(MyAction, params) do\n  {:ok, result} ->\n    # Success case\n    handle_success(result)\n\n  {:error, %Error{type: :timeout}} ->\n    # Timeout error\n    handle_timeout()\n\n  {:error, %Error{type: :validation_error}} ->\n    # Parameter validation failed\n    handle_validation_error()\n\n  {:error, error} ->\n    # Other error cases\n    handle_error(error)\nend\n```\n\nCommon error types:\n\n- `:timeout` - Action exceeded timeout duration\n- `:validation_error` - Invalid parameters\n- `:execution_error` - Runtime error in Action\n- `:compensation_error` - Error during compensation","ref":"workflows.html#error-handling"},{"type":"extras","title":"Compensation - Executing Actions","doc":"Actions can define compensation logic that runs on failure:\n\n```elixir\ndefmodule MyAction do\n  use Jido.Action,\n    name: \"my_action\",\n    compensation: [\n      enabled: true,           # Enable compensation\n      max_retries: 3,          # Retry compensation attempts\n      timeout: 5000           # Compensation timeout\n    ]\n\n  def on_error(failed_params, error, context, opts) do\n    # Compensation logic here\n    rollback_changes(failed_params)\n  end\nend\n```","ref":"workflows.html#compensation"},{"type":"extras","title":"Best Practices - Executing Actions","doc":"1. **Always Set Timeouts**\n\n   - Use explicit timeouts for Actions\n   - Consider the Action's expected duration\n   - Allow extra time for retries\n\n2. **Handle All Error Cases**\n\n   - Pattern match on specific error types\n   - Provide descriptive error messages\n   - Consider using compensation for cleanup\n\n3. **Use Async for Long-Running Actions**\n\n   - Move expensive operations to async execution\n   - Set appropriate timeouts\n   - Handle cancellation gracefully\n\n4. **Monitor with Telemetry**\n   - Enable full telemetry in production\n   - Track execution times and error rates\n   - Set up alerts for timeout/error thresholds","ref":"workflows.html#best-practices"},{"type":"extras","title":"Testing - Executing Actions","doc":"The `Workflow` module provides testing utilities:\n\n```elixir\ndefmodule MyActionTest do\n  use ExUnit.Case\n\n  test \"executes successfully\" do\n    {:ok, result} = Workflow.run(MyAction, test_params())\n    assert result.status == :success\n  end\n\n  test \"handles timeout\" do\n    {:error, error} = Workflow.run(MyAction, %{}, %{}, timeout: 1)\n    assert error.type == :timeout\n  end\n\n  test \"validates params\" do\n    {:error, error} = Workflow.run(MyAction, %{invalid: true})\n    assert error.type == :validation_error\n  end\nend\n```","ref":"workflows.html#testing"},{"type":"extras","title":"See Also - Executing Actions","doc":"- `Jido.Action` - Action behavior and implementation\n- `Jido.Instruction` - Working with Instructions and execution context\n- `Jido.Runner` - Action execution strategies\n- `Jido.Error` - Error handling and compensation\n- `Jido.Telemetry` - Monitoring and metrics","ref":"workflows.html#see-also"},{"type":"extras","title":"Instructions","doc":"# Instructions in Jido\n\nInstructions represent discrete units of work that can be planned, validated, and executed by agents. Think of them as \"work orders\" that specify exactly what needs to be done and how to do it.","ref":"instructions.html"},{"type":"extras","title":"Core Concepts - Instructions","doc":"An Instruction wraps an Action module with everything it needs to execute:\n\n- The Action to perform (required)\n- Parameters for the action\n- Execution context\n- Runtime options","ref":"instructions.html#core-concepts"},{"type":"extras","title":"Instruction Structure - Instructions","doc":"Each Instruction contains:\n\n```elixir\n%Instruction{\n  id: \"inst_abc123\",           # Unique identifier\n  action: MyApp.Actions.DoTask, # The action module to execute\n  params: %{value: 42},        # Parameters for the action, always a map\n  context: %{user_id: \"123\"},  # Execution context\n  opts: [retry: true],         # Runtime options\n}\n```","ref":"instructions.html#instruction-structure"},{"type":"extras","title":"Creating Instructions - Instructions","doc":"Jido supports multiple formats for creating instructions, offering flexibility while maintaining type safety:","ref":"instructions.html#creating-instructions"},{"type":"extras","title":"1. Full Instruction Struct - Instructions","doc":"```elixir\n%Instruction{\n  action: MyApp.Actions.ProcessOrder,\n  params: %{order_id: \"123\"},\n  context: %{tenant_id: \"456\"}\n}\n```","ref":"instructions.html#1-full-instruction-struct"},{"type":"extras","title":"2. Action Module Only - Instructions","doc":"```elixir\nMyApp.Actions.ProcessOrder\n```","ref":"instructions.html#2-action-module-only"},{"type":"extras","title":"3. Action With Parameters - Instructions","doc":"```elixir\n{MyApp.Actions.ProcessOrder, %{order_id: \"123\"}}\n```","ref":"instructions.html#3-action-with-parameters"},{"type":"extras","title":"4. Factory Function - Instructions","doc":"```elixir\nInstruction.new!(%{\n  action: MyApp.Actions.ProcessOrder,\n  params: %{order_id: \"123\"},\n  context: %{tenant_id: \"456\"}\n})\n```","ref":"instructions.html#4-factory-function"},{"type":"extras","title":"5. Lists of any of the above - Instructions","doc":"```elixir\n[\n  MyApp.Actions.ProcessOrder,\n  %Instruction{\n    action: MyApp.Actions.ProcessOrder,\n    params: %{order_id: \"123\"},\n    context: %{tenant_id: \"456\"}\n  }\n]\n```","ref":"instructions.html#5-lists-of-any-of-the-above"},{"type":"extras","title":"Working with Instructions - Instructions","doc":"","ref":"instructions.html#working-with-instructions"},{"type":"extras","title":"Normalization - Instructions","doc":"Convert various input formats to standard instruction structs:\n\n```elixir\n# Normalize a single instruction\n{:ok, [instruction]} = Instruction.normalize(MyApp.Actions.ProcessOrder)\n\n# Normalize with context\n{:ok, instructions} = Instruction.normalize(\n  [\n    MyApp.Actions.ValidateOrder,\n    {MyApp.Actions.ProcessOrder, %{priority: \"high\"}}\n  ],\n  %{tenant_id: \"123\"}  # Shared context\n)\n```","ref":"instructions.html#normalization"},{"type":"extras","title":"Validation - Instructions","doc":"Ensure instructions use allowed actions:\n\n```elixir\nagent_allowed_actions = [\n  MyApp.Actions.ValidateOrder,\n  MyApp.Actions.ProcessOrder\n]\n\n:ok = Instruction.validate_allowed_actions(instructions, agent_allowed_actions)\n```","ref":"instructions.html#validation"},{"type":"extras","title":"Common Patterns - Instructions","doc":"","ref":"instructions.html#common-patterns"},{"type":"extras","title":"1. Workflow Definition - Instructions","doc":"```elixir\ninstructions = [\n  MyApp.Actions.ValidateInput,\n  {MyApp.Actions.ProcessData, %{format: \"json\"}},\n  MyApp.Actions.SaveResults\n]\n```","ref":"instructions.html#1-workflow-definition"},{"type":"extras","title":"2. Conditional Execution - Instructions","doc":"```elixir\ninstructions = [\n  MyApp.Actions.ValidateOrder,\n  {MyApp.Actions.CheckInventory, %{strict: true}},\n  # Add fulfillment only if in stock\n  if has_stock? do\n    {MyApp.Actions.FulfillOrder, %{warehouse: \"main\"}}\n  end\n]\n|> Enum.reject(&is_nil/1)\n```","ref":"instructions.html#2-conditional-execution"},{"type":"extras","title":"3. Context Sharing - Instructions","doc":"```elixir\n# All instructions share common context\n{:ok, instructions} = Instruction.normalize(\n  [ValidateUser, ProcessOrder, NotifyUser],\n  %{\n    request_id: \"req_123\",\n    tenant_id: \"tenant_456\",\n  }\n)\n```","ref":"instructions.html#3-context-sharing"},{"type":"extras","title":"Instruction Execution - Instructions","doc":"Instructions are executed by Runners, which handle state management and error handling:\n\n```elixir\n# Simple execution of a single instruction\n{:ok, result} = Jido.Runner.Simple.run(agent)\n\n# Chain multiple instructions together\n{:ok, result} = Jido.Runner.Chain.run(agent)\n```\n\nSee the [Runners](actions/runners.md) guide for more details on how to execute instructions.","ref":"instructions.html#instruction-execution"},{"type":"extras","title":"Error Handling - Instructions","doc":"Instructions use the `OK` monad for consistent error handling:\n\n```elixir\ndef process_instruction(instruction) do\n  with {:ok, validated} <- validate_instruction(instruction),\n       {:ok, processed} <- execute_instruction(validated) do\n    {:ok, processed}\n  else\n    {:error, reason} -> handle_error(reason)\n  end\nend\n```","ref":"instructions.html#error-handling"},{"type":"extras","title":"Testing Instructions - Instructions","doc":"Instructions can be tested both in isolation and as part of workflows:\n\n```elixir\ndefmodule InstructionTest do\n  use ExUnit.Case\n\n  test \"creates valid instruction\" do\n    assert {:ok, instruction} = Instruction.new(%{\n      action: MyApp.Actions.ProcessOrder,\n      params: %{order_id: \"123\"}\n    })\n    assert instruction.action == MyApp.Actions.ProcessOrder\n  end\n\n  test \"normalizes action tuple\" do\n    assert {:ok, [instruction]} = Instruction.normalize(\n      {MyApp.Actions.ProcessOrder, %{order_id: \"123\"}}\n    )\n    assert instruction.params.order_id == \"123\"\n  end\nend\n```","ref":"instructions.html#testing-instructions"},{"type":"extras","title":"Best Practices - Instructions","doc":"1. **Explicit Intent**: Use the most explicit instruction format that fits your use case\n\n   ```elixir\n   # Good - Clear intent with full struct\n   %Instruction{action: ProcessOrder, params: %{id: order_id}}\n\n   # Less Clear - Relies on normalization\n   {ProcessOrder, [id: order_id]}\n   ```\n\n2. **Context Management**: Keep context focused and relevant\n\n   ```elixir\n   # Good - Relevant context\n   context = %{user_id: user.id, tenant_id: tenant.id}\n\n   # Bad - Excessive context\n   context = %{entire_user: user, database_connection: conn}\n   ```\n\n3. **Error Handling**: Implement comprehensive error handling\n\n   ```elixir\n   def handle_instruction(instruction) do\n     case execute(instruction) do\n       {:ok, result} -> {:ok, result}\n       {:error, :invalid_params} -> {:error, \"Invalid parameters\"}\n       {:error, reason} -> {:error, \"Execution failed: #{reason}\"}\n     end\n   end\n   ```\n\n4. **Validation**: Always validate instructions before execution\n   ```elixir\n   def safe_execute(instruction) do\n     with :ok <- validate_allowed_actions([instruction], allowed_actions()),\n          {:ok, normalized} <- normalize(instruction),\n          {:ok, result} <- execute(normalized) do\n       {:ok, result}\n     end\n   end\n   ```","ref":"instructions.html#best-practices"},{"type":"extras","title":"Common Questions - Instructions","doc":"","ref":"instructions.html#common-questions"},{"type":"extras","title":"When should I use full structs vs. tuples? - Instructions","doc":"Use full structs when:\n\n- You need explicit control over all instruction fields\n- The code benefits from clarity over brevity\n- You're defining complex workflows\n\nUse tuples when:\n\n- You only need action and params\n- You're defining simple, linear workflows\n- The brevity improves readability","ref":"instructions.html#when-should-i-use-full-structs-vs-tuples"},{"type":"extras","title":"How do I share context between instructions? - Instructions","doc":"Pass context during normalization:\n\n```elixir\nshared_context = %{tenant_id: \"123\"}\n{:ok, instructions} = Instruction.normalize(workflow, shared_context)\n```","ref":"instructions.html#how-do-i-share-context-between-instructions"},{"type":"extras","title":"Can I modify instructions during execution? - Instructions","doc":"No, instructions are immutable by design. Instead:\n\n1. Create new instructions with modified parameters\n2. Use the agent's directive system to enqueue modified instructions","ref":"instructions.html#can-i-modify-instructions-during-execution"},{"type":"extras","title":"See Also - Instructions","doc":"- [Actions Overview](actions/overview.md) - Learn about implementing actions\n- [Runners](actions/runners.md) - Understanding instruction execution\n- [Testing](actions/testing.md) - Comprehensive testing guide","ref":"instructions.html#see-also"},{"type":"extras","title":"Directives","doc":"# Directives in Jido\n\nDirectives are the control system of Jido agents, providing a safe, validated way to modify agent behavior and state at runtime. They act as discrete, immutable instructions that tell agents how to change their state or behavior.","ref":"directives-2.html"},{"type":"extras","title":"Overview - Directives","doc":"Directives serve two main purposes:\n\n1. Modifying agent state through validated operations\n2. Controlling server behavior in agent processes\n\nEach directive is implemented as a distinct struct with its own validation rules, helping ensure type safety and consistent state transitions.","ref":"directives-2.html#overview"},{"type":"extras","title":"Agent Directives - Directives","doc":"Agent directives modify the core agent struct and its internal state. They handle tasks like:\n\n- Queueing new instructions\n- Managing action registrations\n- Managing child processes","ref":"directives-2.html#agent-directives"},{"type":"extras","title":"Available Agent Directives - Directives","doc":"#### Enqueue\n\nAdds a new instruction to the agent's pending queue:\n\n```elixir\n%Directive.Enqueue{\n  action: :calculate_sum,\n  params: %{numbers: [1, 2, 3]},\n  context: %{user_id: \"123\"},\n  opts: [retry: true]\n}\n```\n\n#### RegisterAction\n\nRegisters a new action module with the agent:\n\n```elixir\n%Directive.RegisterAction{\n  action_module: MyApp.Actions.Calculate\n}\n```\n\n#### DeregisterAction\n\nRemoves an action module from the agent:\n\n```elixir\n%Directive.DeregisterAction{\n  action_module: MyApp.Actions.Calculate\n}\n```","ref":"directives-2.html#available-agent-directives"},{"type":"extras","title":"Using Agent Directives - Directives","doc":"Actions can return directives to modify agent behavior. This is done by returning a tuple with both the result and directive:\n\n```elixir\ndefmodule MyAction do\n  use Jido.Action\n\n  def run(_params, _context) do\n    # Return both a result and a directive\n    directive = %Directive.Enqueue{\n      action: :next_step,\n      params: %{value: 42}\n    }\n\n    {:ok, %{completed: true}, directive}\n  end\nend\n```\n\nMultiple directives can be returned as a list:\n\n```elixir\ndef run(_params, _context) do\n  directives = [\n    %Directive.Enqueue{action: :step_one},\n    %Directive.Enqueue{action: :step_two}\n  ]\n\n  {:ok, %{completed: true}, directives}\nend\n```","ref":"directives-2.html#using-agent-directives"},{"type":"extras","title":"Server Directives - Directives","doc":"Server directives control the behavior of the underlying GenServer that hosts the agent. They handle operations like:\n\n- Process spawning and termination\n- Router management\n- Event subscription","ref":"directives-2.html#server-directives"},{"type":"extras","title":"Available Server Directives - Directives","doc":"#### Spawn\n\nSpawns a child process under the agent's supervisor:\n\n```elixir\n%Directive.Spawn{\n  module: MyWorker,\n  args: [id: 1]\n}\n```\n\n#### Kill\n\nTerminates a child process:\n\n```elixir\n%Directive.Kill{\n  pid: worker_pid\n}\n```","ref":"directives-2.html#available-server-directives"},{"type":"extras","title":"Using Server Directives - Directives","doc":"Server directives are typically used in system management actions:\n\n```elixir\ndefmodule SpawnWorker do\n  use Jido.Action\n\n  def run(%{worker_module: module} = params, _context) do\n    directive = %Directive.Spawn{\n      module: module,\n      args: params.args\n    }\n\n    {:ok, %{spawned: true}, directive}\n  end\nend\n```","ref":"directives-2.html#using-server-directives"},{"type":"extras","title":"Directive Processing - Directives","doc":"When an action returns a directive, it goes through several stages:\n\n1. Validation - The directive structure and content are validated\n2. Classification - Directives are split into agent and server types\n3. Application - Each directive is applied in order\n4. State Update - The agent/server state is updated accordingly","ref":"directives-2.html#directive-processing"},{"type":"extras","title":"Validation Rules - Directives","doc":"Each directive type has specific validation rules:\n\n```elixir\n# Enqueue requires a valid action atom\nvalidate_directive(%Enqueue{action: nil})\n  # => {:error, :invalid_action}\n\n# RegisterAction requires a valid module\nvalidate_directive(%RegisterAction{action_module: MyAction})\n  # => :ok\n```","ref":"directives-2.html#validation-rules"},{"type":"extras","title":"Error Handling - Directives","doc":"Directive application uses tagged tuples for consistent error handling:\n\n```elixir\ncase Directive.apply_directives(agent, directives) do\n  {:ok, updated_agent, server_directives} ->\n    # Handle success\n\n  {:error, reason} ->\n    # Handle error\nend\n```","ref":"directives-2.html#error-handling"},{"type":"extras","title":"Best Practices - Directives","doc":"1. **Atomic Changes**\n\n   - Return related directives together\n   - Keep directive changes focused and minimal\n\n2. **Validation**\n\n   - Always validate input parameters\n   - Use strict typing for directive fields\n\n3. **Error Handling**\n\n   - Implement compensation logic for failures\n   - Handle partial directive application\n\n4. **Testing**\n   - Test directive validation\n   - Verify state changes\n   - Check error conditions","ref":"directives-2.html#best-practices"},{"type":"extras","title":"Common Patterns - Directives","doc":"","ref":"directives-2.html#common-patterns"},{"type":"extras","title":"Sequential Operations - Directives","doc":"Chain multiple operations using Enqueue directives:\n\n```elixir\ndirectives = [\n  %Directive.Enqueue{action: :validate_input},\n  %Directive.Enqueue{action: :process_data},\n  %Directive.Enqueue{action: :save_results}\n]\n```","ref":"directives-2.html#sequential-operations"},{"type":"extras","title":"Dynamic Action Registration - Directives","doc":"Register actions based on runtime conditions:\n\n```elixir\ndef run(%{feature_enabled: true} = _params, _context) do\n  directive = %Directive.RegisterAction{\n    action_module: MyApp.Actions.FeatureAction\n  }\n  {:ok, %{}, directive}\nend\n```","ref":"directives-2.html#dynamic-action-registration"},{"type":"extras","title":"Worker Management - Directives","doc":"Manage worker processes with spawn/kill directives:\n\n```elixir\ndef run(%{worker_count: count} = _params, _context) do\n  directives = for i <- 1..count do\n    %Directive.Spawn{\n      module: MyApp.Worker,\n      args: [id: i]\n    }\n  end\n\n  {:ok, %{}, directives}\nend\n```","ref":"directives-2.html#worker-management"},{"type":"extras","title":"See Also - Directives","doc":"- [Agent State Management](../agents/stateful.md)\n- [Action Development](overview.md)\n- [Testing Actions](testing.md)","ref":"directives-2.html#see-also"},{"type":"extras","title":"Runners","doc":"# Understanding Jido Runners\n\nRunners are the execution engines that power Jido's agent system, responsible for processing instructions and managing state transitions. This guide explores both built-in runners and how to create custom implementations.","ref":"runners.html"},{"type":"extras","title":"Core Concepts - Runners","doc":"Runners serve as the bridge between agent instructions and their execution. They handle:\n\n- Instruction processing\n- State management\n- Directive handling\n- Error recovery\n- Context propagation","ref":"runners.html#core-concepts"},{"type":"extras","title":"Built-in Runners - Runners","doc":"Jido provides two built-in runners optimized for different use cases:","ref":"runners.html#built-in-runners"},{"type":"extras","title":"Simple Runner - Runners","doc":"The Simple Runner processes one instruction at a time, providing atomic execution and clear state transitions.\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"simple_example\",\n    runner: Jido.Runner.Simple\nend\n```\n\n#### Key Features\n\n- Single instruction execution\n- Atomic state updates\n- Clear error boundaries\n- Predictable behavior\n\n#### State Flow\n\n```elixir\n# Simple Runner execution flow\n{:ok, agent, directives} = Jido.Runner.Simple.run(agent, opts)\n\n# Internal process:\n# 1. Dequeue single instruction\n# 2. Execute via action module\n# 3. Update state atomically\n# 4. Process any directives\n# 5. Return updated agent\n```","ref":"runners.html#simple-runner"},{"type":"extras","title":"Chain Runner - Runners","doc":"The Chain Runner enables sequential execution of multiple instructions with state flowing between steps.\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"chain_example\",\n    runner: Jido.Runner.Chain\nend\n```\n\n#### Key Features\n\n- Sequential instruction processing\n- State flows between steps\n- Directive accumulation\n- Comprehensive error handling\n\n#### State Flow\n\n```elixir\n# Chain Runner execution flow\n{:ok, agent, directives} = Jido.Runner.Chain.run(agent, opts)\n\n# Internal process:\n# 1. Convert queue to instruction list\n# 2. Execute instructions sequentially\n# 3. Flow state between steps\n# 4. Accumulate directives\n# 5. Apply final state\n```","ref":"runners.html#chain-runner"},{"type":"extras","title":"Context and State Management - Runners","doc":"Both runners handle agent state through context propagation:\n\n```elixir\n# State is automatically included in context\ndef run(%{action: action, params: params, context: context}, _opts) do\n  # Context includes agent state\n  enhanced_context = Map.put(context, :state, agent.state)\n\n  case Jido.Workflow.run(action, params, enhanced_context) do\n    {:ok, result} -> handle_success(result)\n    {:error, reason} -> handle_error(reason)\n  end\nend\n```","ref":"runners.html#context-and-state-management"},{"type":"extras","title":"Directive Processing - Runners","doc":"Runners handle directives that modify agent behavior:\n\n```elixir\n# Example directive processing\ndefp handle_directive_result(agent, state_map, directives) do\n  case Directive.apply_agent_directive(agent, directives) do\n    {:ok, updated_agent, server_directives} ->\n      {:ok, updated_agent, server_directives}\n\n    {:error, reason} ->\n      {:error, Error.validation_error(\"Invalid directive\", reason)}\n  end\nend\n```","ref":"runners.html#directive-processing"},{"type":"extras","title":"Creating Custom Runners - Runners","doc":"Implement the `Jido.Runner` behavior to create custom runners:\n\n```elixir\ndefmodule MyCustomRunner do\n  @behaviour Jido.Runner\n\n  @impl true\n  def run(agent, opts \\\\ []) do\n    # Custom execution logic here\n    # Must return {:ok, updated_agent, directives} | {:error, reason}\n  end\n\n  # Helper functions\n  defp process_instructions(instructions, agent) do\n    # Custom instruction processing\n  end\n\n  defp update_agent_state(agent, result) do\n    # Custom state update logic\n  end\nend\n```","ref":"runners.html#creating-custom-runners"},{"type":"extras","title":"Implementation Guidelines - Runners","doc":"1. **State Management**\n\n   - Handle state updates atomically\n   - Preserve agent state on errors\n   - Validate state transitions\n\n2. **Error Handling**\n\n   - Implement comprehensive error handling\n   - Provide clear error messages\n   - Consider retry strategies\n\n3. **Directive Support**\n\n   - Process directives consistently\n   - Validate directive types\n   - Handle directive errors gracefully\n\n4. **Performance**\n   - Consider concurrency implications\n   - Optimize for your use case\n   - Handle resource cleanup","ref":"runners.html#implementation-guidelines"},{"type":"extras","title":"Integration with Agents - Runners","doc":"Runners are automatically integrated into Agents when specified in the configuration. This means you typically won't interact with runners directly, but rather through the Agent interface:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"example_agent\",\n    runner: Jido.Runner.Chain  # Runner is automatically integrated\n\n  # All runner operations are handled internally\n  def process_workflow(data) do\n    enqueue(ProcessData, %{input: data})\n  end\nend\n```\n\nThis guide serves primarily as a reference for understanding runner behavior and creating custom implementations when needed.","ref":"runners.html#integration-with-agents"},{"type":"extras","title":"Timeout Configuration - Runners","doc":"Runners support flexible timeout configuration at multiple levels, providing fine-grained control over action execution timing.","ref":"runners.html#timeout-configuration"},{"type":"extras","title":"Global Timeout Configuration - Runners","doc":"Configure the default timeout for all actions in your application:\n\n```elixir\n# config/config.exs\nconfig :jido, default_timeout: 60_000  # 60 seconds (default: 30 seconds)\n```","ref":"runners.html#global-timeout-configuration"},{"type":"extras","title":"Runner-Level Timeouts - Runners","doc":"Set timeouts that apply to all instructions processed by a runner:\n\n```elixir\n# Simple Runner with timeout\n{:ok, agent, directives} = Jido.Runner.Simple.run(agent, timeout: 45_000)\n\n# Chain Runner with timeout\n{:ok, agent, directives} = Jido.Runner.Chain.run(agent, timeout: 120_000)\n```","ref":"runners.html#runner-level-timeouts"},{"type":"extras","title":"Instruction-Level Timeouts - Runners","doc":"Individual instructions can specify their own timeouts, which take precedence over runner-level timeouts:\n\n```elixir\n# Instruction with specific timeout\ninstruction = %Instruction{\n  action: LongRunningAction,\n  params: %{data: large_dataset},\n  opts: [timeout: 300_000]  # 5 minutes for this specific action\n}\n\n# This instruction will use 300 seconds, others use runner or global timeout\n{:ok, agent, directives} = Jido.Runner.Simple.run(agent, timeout: 30_000)\n```","ref":"runners.html#instruction-level-timeouts"},{"type":"extras","title":"Timeout Precedence Rules - Runners","doc":"Timeout options follow a clear precedence hierarchy:\n\n1. **Instruction-level timeout** (highest precedence)\n2. **Runner-level timeout** \n3. **Global configuration timeout** (lowest precedence)\n\n```elixir\n# Example showing precedence\ninstructions = [\n  %Instruction{\n    action: FastAction,\n    opts: [timeout: 5_000]    # This instruction: 5 seconds\n  },\n  %Instruction{\n    action: NormalAction,\n    opts: []                  # This instruction: 45 seconds (runner timeout)\n  }\n]\n\n# Runner timeout applies to instructions without specific timeout\nJido.Runner.Chain.run(agent, timeout: 45_000)\n```","ref":"runners.html#timeout-precedence-rules"},{"type":"extras","title":"Special Timeout Values - Runners","doc":"- **`timeout: 0`** - Disables timeout completely, action can run indefinitely\n- **Positive integers** - Timeout in milliseconds\n\n```elixir\n# Disable timeout for long-running batch operations\nbatch_instruction = %Instruction{\n  action: BatchProcessor,\n  params: %{items: thousands_of_items},\n  opts: [timeout: 0]  # No timeout limit\n}\n```","ref":"runners.html#special-timeout-values"},{"type":"extras","title":"Integration with Agent Configuration - Runners","doc":"Agents can specify default timeouts for their runners:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"timeout_example\",\n    runner: Jido.Runner.Simple\n  \n  # Override start_link to set default runner options\n  def start_link(opts \\\\ []) do\n    runner_opts = Keyword.get(opts, :runner_opts, [])\n    runner_opts = Keyword.put_new(runner_opts, :timeout, 120_000)  # 2 minutes\n    \n    opts = Keyword.put(opts, :runner_opts, runner_opts)\n    super(opts)\n  end\nend\n```","ref":"runners.html#integration-with-agent-configuration"},{"type":"extras","title":"Best Practices - Runners","doc":"1. **Choose the Right Runner**\n\n   - Use Simple Runner for atomic operations\n   - Use Chain Runner for complex workflows\n   - Create custom runners for specific needs\n\n2. **State Management**\n\n   - Keep state transitions explicit\n   - Validate state changes\n   - Handle edge cases\n\n3. **Timeout Management**\n\n   - Set appropriate global defaults in configuration\n   - Use runner-level timeouts for consistent behavior\n   - Override with instruction-level timeouts for special cases\n   - Use `timeout: 0` sparingly and only for truly long-running operations\n   - Monitor timeout patterns to optimize performance\n\n4. **Error Handling**\n\n   - Implement comprehensive error handling\n   - Provide clear error messages\n   - Consider recovery strategies\n\n5. **Testing**\n   - Test happy paths thoroughly\n   - Test error conditions\n   - Test state transitions\n   - Test directive handling\n   - Test timeout scenarios","ref":"runners.html#best-practices"},{"type":"extras","title":"Next Steps - Runners","doc":"- Explore the source code of built-in runners\n- Implement custom runners for specific needs\n- Contribute improvements to the community\n\nRemember that runners are a critical part of your agent system. Choose and implement them carefully based on your specific requirements.","ref":"runners.html#next-steps"},{"type":"extras","title":"Actions as LLM Tools","doc":"# Actions as Tools","ref":"actions-as-tools.html"},{"type":"extras","title":"Overview - Actions as LLM Tools","doc":"Jido Actions can be converted into tools compatible with LLM frameworks like Langchain. This guide demonstrates how to transform your Actions into Langchain tools, enabling seamless integration with AI-powered workflows.","ref":"actions-as-tools.html#overview"},{"type":"extras","title":"Key Concepts - Actions as LLM Tools","doc":"- An Action defines a discrete unit of functionality with validated inputs and outputs\n- Langchain tools represent capabilities that can be invoked by LLMs\n- The `Jido.Actions.Tool` module handles the conversion between these formats","ref":"actions-as-tools.html#key-concepts"},{"type":"extras","title":"Basic Tool Conversion - Actions as LLM Tools","doc":"Let's start with a simple example of converting a basic Action to a Langchain tool:\n\n```elixir\ndefmodule WeatherAction do\n  use Jido.Action,\n    name: \"get_weather\",\n    description: \"Gets the current weather for a location\",\n    schema: [\n      location: [\n        type: :string,\n        required: true,\n        doc: \"The city or location to get weather for\"\n      ],\n      units: [\n        type: {:in, [\"celsius\", \"fahrenheit\"]},\n        default: \"celsius\",\n        doc: \"Temperature units to use\"\n      ]\n    ]\n\n  @impl true\n  def run(%{location: location, units: units}, _context) do\n    # Simulated weather API call\n    {:ok, %{\n      temperature: 22,\n      units: units,\n      conditions: \"sunny\",\n      location: location\n    }}\n  end\nend\n```\n\nConvert this Action to a Langchain tool:\n\n```elixir\n# Convert to tool format\nweather_tool = WeatherAction.to_tool()\n\n# The tool can now be used with Langchain\n{:ok, chain} = Langchain.Chain.new([\n  weather_tool,\n  Langchain.Chains.ChatPrompt\n])\n```","ref":"actions-as-tools.html#basic-tool-conversion"},{"type":"extras","title":"Tool Schema Generation - Actions as LLM Tools","doc":"The `to_tool/0` function automatically generates a JSON Schema for the tool's parameters based on your Action's schema:\n\n```elixir\n%{\n  \"name\" => \"get_weather\",\n  \"description\" => \"Gets the current weather for a location\",\n  \"parameters\" => %{\n    \"type\" => \"object\",\n    \"properties\" => %{\n      \"location\" => %{\n        \"type\" => \"string\",\n        \"description\" => \"The city or location to get weather for\"\n      },\n      \"units\" => %{\n        \"type\" => \"string\",\n        \"enum\" => [\"celsius\", \"fahrenheit\"],\n        \"description\" => \"Temperature units to use\"\n      }\n    },\n    \"required\" => [\"location\"]\n  }\n}\n```","ref":"actions-as-tools.html#tool-schema-generation"},{"type":"extras","title":"Advanced Tool Patterns - Actions as LLM Tools","doc":"","ref":"actions-as-tools.html#advanced-tool-patterns"},{"type":"extras","title":"1. Complex Parameter Validation - Actions as LLM Tools","doc":"For tools with complex parameter requirements:\n\n```elixir\ndefmodule DataProcessingAction do\n  use Jido.Action,\n    name: \"process_data\",\n    description: \"Processes data with specified options\",\n    schema: [\n      input_format: [\n        type: {:in, [\"json\", \"csv\", \"xml\"]},\n        required: true,\n        doc: \"Format of the input data\"\n      ],\n      transformations: [\n        type: {:list, :atom},\n        default: [],\n        doc: \"List of transformations to apply\"\n      ],\n      options: [\n        type: :map,\n        default: %{},\n        doc: \"Additional processing options\"\n      ]\n    ]\n\n  @impl true\n  def run(params, context) do\n    # Processing logic here\n    {:ok, %{result: \"processed\"}}\n  end\nend\n```","ref":"actions-as-tools.html#1-complex-parameter-validation"},{"type":"extras","title":"2. Error Handling in Tools - Actions as LLM Tools","doc":"Tools should provide clear error messages that can be understood by the LLM:\n\n```elixir\ndefmodule RobustAction do\n  use Jido.Action,\n    name: \"robust_operation\",\n    description: \"Performs an operation with comprehensive error handling\",\n    schema: [\n      input: [type: :string, required: true]\n    ]\n\n  @impl true\n  def run(%{input: input}, _context) do\n    case process_input(input) do\n      {:ok, result} ->\n        {:ok, %{result: result}}\n\n      {:error, :invalid_format} ->\n        {:error, \"Input must be in valid format X,Y,Z\"}\n\n      {:error, :not_found} ->\n        {:error, \"The requested resource could not be found\"}\n    end\n  end\nend\n```","ref":"actions-as-tools.html#2-error-handling-in-tools"},{"type":"extras","title":"3. Contextual Tool Execution - Actions as LLM Tools","doc":"Pass relevant context to your tools:\n\n```elixir\ndefmodule ContextAwareAction do\n  use Jido.Action,\n    name: \"context_aware\",\n    description: \"Uses execution context for enhanced functionality\",\n    schema: [\n      operation: [type: :string, required: true]\n    ]\n\n  @impl true\n  def run(params, %{user_id: user_id, tenant: tenant}) do\n    # Use context in processing\n    {:ok, %{\n      operation: params.operation,\n      user: user_id,\n      tenant: tenant\n    }}\n  end\nend\n\n# Use with Langchain\n{:ok, chain} = Langchain.Chain.new([\n  {ContextAwareAction.to_tool(), context: %{\n    user_id: \"user_123\",\n    tenant: \"tenant_456\"\n  }},\n  Langchain.Chains.ChatPrompt\n])\n```","ref":"actions-as-tools.html#3-contextual-tool-execution"},{"type":"extras","title":"Integration with LangChain - Actions as LLM Tools","doc":"Here's a complete example of using a Jido Action as a tool in a Langchain workflow:\n\n```elixir\ndefmodule CalculatorAction do\n  use Jido.Action,\n    name: \"calculate\",\n    description: \"Performs basic arithmetic calculations\",\n    schema: [\n      operation: [\n        type: {:in, [\"add\", \"subtract\", \"multiply\", \"divide\"]},\n        required: true,\n        doc: \"The arithmetic operation to perform\"\n      ],\n      x: [type: :float, required: true, doc: \"First number\"],\n      y: [type: :float, required: true, doc: \"Second number\"]\n    ]\n\n  @impl true\n  def run(%{operation: op, x: x, y: y}, _context) do\n    result = case op do\n      \"add\" -> x + y\n      \"subtract\" -> x - y\n      \"multiply\" -> x * y\n      \"divide\" when y != 0 -> x / y\n      \"divide\" -> {:error, \"Division by zero\"}\n    end\n\n    case result do\n      {:error, reason} -> {:error, reason}\n      value -> {:ok, %{result: value}}\n    end\n  end\nend\n\n# Create Langchain workflow\ndefmodule MathWorkflow do\n  def execute(prompt) do\n    # Convert calculator to tool\n    calculator_tool = CalculatorAction.to_tool()\n\n    # Create chain with tool\n    {:ok, chain} = Langchain.Chain.new([\n      calculator_tool,\n      {Langchain.Chains.ChatPrompt,\n       prompt: \"\"\"\n       You are a helpful math assistant. Use the calculator tool to solve problems.\n       User query: #{prompt}\n       \"\"\"}\n    ])\n\n    # Execute chain\n    Langchain.run(chain)\n  end\nend\n\n# Example usage\nMathWorkflow.execute(\"What is 123.45 multiplied by 67.89?\")\n```","ref":"actions-as-tools.html#integration-with-langchain"},{"type":"extras","title":"Best Practices - Actions as LLM Tools","doc":"1. **Clear Descriptions**\n\n   - Provide detailed descriptions for both the tool and its parameters\n   - Include examples in parameter documentation\n   - Use consistent terminology\n\n2. **Robust Validation**\n\n   - Implement comprehensive parameter validation\n   - Return clear error messages\n   - Handle edge cases explicitly\n\n3. **Context Handling**\n\n   - Pass relevant context through the tool chain\n   - Document expected context requirements\n   - Provide defaults for missing context\n\n4. **Error Handling**\n\n   - Return structured error responses\n   - Include actionable error messages\n   - Handle both expected and unexpected errors\n\n5. **Testing**\n   - Test tool conversion explicitly\n   - Verify schema generation\n   - Test integration with Langchain","ref":"actions-as-tools.html#best-practices"},{"type":"extras","title":"Common Issues and Solutions - Actions as LLM Tools","doc":"","ref":"actions-as-tools.html#common-issues-and-solutions"},{"type":"extras","title":"1. Schema Conversion - Actions as LLM Tools","doc":"If your Action schema uses custom types, implement custom type conversion:\n\n```elixir\ndefmodule CustomTypeAction do\n  use Jido.Action,\n    name: \"custom_type_action\",\n    description: \"Handles custom types\",\n    schema: [\n      date: [\n        type: :date,\n        required: true,\n        doc: \"Date in ISO format\"\n      ]\n    ]\n\n  # Custom type validation\n  def validate_params(%{date: date} = params) when is_binary(date) do\n    case Date.from_iso8601(date) do\n      {:ok, _valid_date} -> {:ok, params}\n      {:error, _} -> {:error, \"Invalid date format\"}\n    end\n  end\nend\n```","ref":"actions-as-tools.html#1-schema-conversion"},{"type":"extras","title":"2. Context Persistence - Actions as LLM Tools","doc":"Ensure context is properly passed through the tool chain:\n\n```elixir\n# Create chain with persistent context\n{:ok, chain} = Langchain.Chain.new([\n  {MyAction.to_tool(),\n   context: %{tenant_id: \"t1\"},\n   persist_context: true},\n  Langchain.Chains.ChatPrompt\n])\n```","ref":"actions-as-tools.html#2-context-persistence"},{"type":"extras","title":"Testing Tools - Actions as LLM Tools","doc":"Example test cases for your tools:\n\n```elixir\ndefmodule WeatherActionTest do\n  use ExUnit.Case\n\n  test \"converts to valid tool\" do\n    tool = WeatherAction.to_tool()\n\n    assert tool.name == \"get_weather\"\n    assert tool.description =~ \"Gets the current weather\"\n    assert Map.has_key?(tool.parameters_schema[\"properties\"], \"location\")\n  end\n\n  test \"executes as tool\" do\n    tool = WeatherAction.to_tool()\n\n    assert {:ok, result} = tool.function.(%{\n      \"location\" => \"Portland\",\n      \"units\" => \"celsius\"\n    }, %{})\n\n    assert is_binary(result)\n    assert Jason.decode!(result)[\"temperature\"]\n  end\nend\n```","ref":"actions-as-tools.html#testing-tools"},{"type":"extras","title":"See Also - Actions as LLM Tools","doc":"- [Langchain Integration Guide](https://hexdocs.pm/langchain)\n- [JSON Schema Documentation](https://json-schema.org/)\n- [Testing Guide](testing.html)","ref":"actions-as-tools.html#see-also"},{"type":"extras","title":"Testing","doc":"# Testing Actions\n\nThis guide covers comprehensive testing strategies for Jido Actions, including unit testing, property-based testing, integration testing, and testing complex scenarios like compensation and concurrency.","ref":"testing-3.html"},{"type":"extras","title":"Core Testing Principles - Testing","doc":"When testing Actions, focus on:\n\n1. Input validation and parameter handling\n2. Core business logic execution\n3. Error handling and compensation\n4. Context propagation\n5. Integration with other system components","ref":"testing-3.html#core-testing-principles"},{"type":"extras","title":"Basic Test Structure - Testing","doc":"Here's a basic test module structure for Actions:\n\n```elixir\ndefmodule MyApp.Actions.CalculatorTest do\n  use ExUnit.Case, async: true\n  alias MyApp.Actions.Calculator\n\n  describe \"basic execution\" do\n    test \"adds two numbers correctly\" do\n      params = %{value: 5, amount: 3}\n      assert {:ok, %{result: 8}} = Calculator.run(params, %{})\n    end\n\n    test \"validates required parameters\" do\n      params = %{value: 5}\n      assert {:error, error} = Calculator.run(params, %{})\n      assert error.type == :validation_error\n    end\n  end\nend\n```","ref":"testing-3.html#basic-test-structure"},{"type":"extras","title":"Testing Parameter Validation - Testing","doc":"Test both valid and invalid parameter scenarios:\n\n```elixir\ndescribe \"parameter validation\" do\n  test \"accepts valid parameters\" do\n    params = %{name: \"test\", count: 42}\n    assert {:ok, validated} = MyAction.validate_params(params)\n    assert validated.name == \"test\"\n    assert validated.count == 42\n  end\n\n  test \"rejects invalid parameter types\" do\n    params = %{name: 123, count: \"not a number\"}\n    assert {:error, error} = MyAction.validate_params(params)\n    assert error.type == :validation_error\n  end\n\n  test \"handles missing required parameters\" do\n    params = %{name: \"test\"}\n    assert {:error, error} = MyAction.validate_params(params)\n    assert error.message =~ \"Required key :count not found\"\n  end\n\n  test \"allows additional parameters\" do\n    params = %{name: \"test\", count: 42, extra: \"data\"}\n    assert {:ok, validated} = MyAction.validate_params(params)\n    assert validated.extra == \"data\"\n  end\nend\n```","ref":"testing-3.html#testing-parameter-validation"},{"type":"extras","title":"Testing Error Handling - Testing","doc":"Test various error scenarios and compensation logic:\n\n```elixir\ndescribe \"error handling\" do\n  test \"handles runtime errors\" do\n    assert {:error, error} = ErrorAction.run(%{error_type: :runtime}, %{})\n    assert error.type == :execution_error\n  end\n\n  test \"handles validation errors\" do\n    assert {:error, error} = ErrorAction.run(%{error_type: :validation}, %{})\n    assert error.type == :validation_error\n  end\n\n  test \"compensates for failures when enabled\" do\n    params = %{should_fail: true}\n    assert {:error, error} = CompensatingAction.run(params, %{})\n    assert {:ok, result} = CompensatingAction.on_error(params, error, %{}, [])\n    assert result.compensated == true\n  end\nend\n```","ref":"testing-3.html#testing-error-handling"},{"type":"extras","title":"Testing Asynchronous Actions - Testing","doc":"For Actions with async operations:\n\n```elixir\ndescribe \"async operations\" do\n  setup do\n    # Start any required processes\n    {:ok, pid} = start_supervised(MyApp.AsyncProcessor)\n    %{processor: pid}\n  end\n\n  test \"processes async operations\", %{processor: pid} do\n    params = %{data: \"test\", processor: pid}\n    assert {:ok, result} = AsyncAction.run(params, %{})\n    assert_receive {:processing_complete, ^result}, 1000\n  end\n\n  test \"handles async timeouts\", %{processor: pid} do\n    params = %{data: \"slow\", processor: pid}\n    assert {:error, error} = AsyncAction.run(params, %{timeout: 50})\n    assert error.type == :timeout\n  end\nend\n```","ref":"testing-3.html#testing-asynchronous-actions"},{"type":"extras","title":"Property-Based Testing - Testing","doc":"Use property-based testing for comprehensive input coverage:\n\n```elixir\ndefmodule CalcActionTest do\n  use ExUnit.Case\n  use ExUnitProperties\n\n  describe \"arithmetic operations\" do\n    property \"addition is commutative\" do\n      check all(\n        x <- integer(),\n        y <- integer()\n      ) do\n        params1 = %{value: x, amount: y}\n        params2 = %{value: y, amount: x}\n\n        assert {:ok, result1} = AddAction.run(params1, %{})\n        assert {:ok, result2} = AddAction.run(params2, %{})\n        assert result1.result == result2.result\n      end\n    end\n\n    property \"multiplication by zero yields zero\" do\n      check all(x <- integer()) do\n        params = %{value: x, amount: 0}\n        assert {:ok, %{result: 0}} = MultiplyAction.run(params, %{})\n      end\n    end\n  end\nend\n```","ref":"testing-3.html#property-based-testing"},{"type":"extras","title":"Testing Context Propagation - Testing","doc":"Verify that Actions properly handle and propagate context:\n\n```elixir\ndescribe \"context handling\" do\n  test \"propagates context through execution\" do\n    context = %{user_id: \"user_123\", tenant: \"tenant_456\"}\n    params = %{operation: \"test\"}\n\n    assert {:ok, result} = ContextAwareAction.run(params, context)\n    assert result.user_id == \"user_123\"\n    assert result.tenant == \"tenant_456\"\n  end\n\n  test \"enriches context during execution\" do\n    initial_context = %{request_id: \"req_123\"}\n    params = %{add_timestamp: true}\n\n    assert {:ok, result} = ContextAction.run(params, initial_context)\n    assert result.context.request_id == \"req_123\"\n    assert is_integer(result.context.timestamp)\n  end\nend\n```","ref":"testing-3.html#testing-context-propagation"},{"type":"extras","title":"Testing Complex Workflows - Testing","doc":"Test Actions as part of larger workflows:\n\n```elixir\ndescribe \"workflow integration\" do\n  test \"executes in workflow chain\" do\n    {:ok, result} = Jido.Workflow.run_chain(\n      [\n        ValidateAction,\n        ProcessAction,\n        NotifyAction\n      ],\n      %{input: \"test data\"},\n      %{context_key: \"value\"}\n    )\n\n    assert result.validated == true\n    assert result.processed == true\n    assert result.notified == true\n  end\n\n  test \"handles workflow failures\" do\n    {:error, error} = Jido.Workflow.run_chain(\n      [\n        ValidateAction,\n        FailingAction,\n        NotifyAction\n      ],\n      %{input: \"test data\"}\n    )\n\n    assert error.type == :execution_error\n    assert error.message =~ \"Workflow failed\"\n  end\nend\n```","ref":"testing-3.html#testing-complex-workflows"},{"type":"extras","title":"Testing Concurrent Operations - Testing","doc":"For Actions that perform concurrent operations:\n\n```elixir\ndescribe \"concurrent operations\" do\n  test \"processes items concurrently\" do\n    inputs = [1, 2, 3, 4, 5]\n    assert {:ok, %{results: results}} =\n      ConcurrentAction.run(%{inputs: inputs}, %{})\n\n    assert length(results) == 5\n    assert Enum.all?(results, fn r -> is_integer(r) end)\n  end\n\n  test \"handles partial failures in concurrent operations\" do\n    inputs = [1, :error, 3, :error, 5]\n    assert {:ok, %{results: results, errors: errors}} =\n      ConcurrentAction.run(%{inputs: inputs}, %{})\n\n    assert length(results) == 3\n    assert length(errors) == 2\n  end\nend\n```","ref":"testing-3.html#testing-concurrent-operations"},{"type":"extras","title":"Testing Helper Functions - Testing","doc":"Common test helpers for Action testing:\n\n```elixir\ndefmodule ActionTestHelper do\n  def assert_validation_error(result, expected_message) do\n    assert {:error, error} = result\n    assert error.type == :validation_error\n    assert error.message =~ expected_message\n  end\n\n  def assert_execution_error(result, expected_message) do\n    assert {:error, error} = result\n    assert error.type == :execution_error\n    assert error.message =~ expected_message\n  end\n\n  def with_timeout(timeout, fun) do\n    Task.await(Task.async(fun), timeout)\n  end\nend\n```","ref":"testing-3.html#testing-helper-functions"},{"type":"extras","title":"Best Practices - Testing","doc":"1. **Test Organization**\n\n   - Group related tests using `describe` blocks\n   - Use meaningful test names that describe behavior\n   - Keep test cases focused and isolated\n\n2. **Validation Testing**\n\n   - Test all schema constraints\n   - Include edge cases and boundary values\n   - Test optional parameter handling\n\n3. **Error Handling**\n\n   - Test all error paths\n   - Verify error types and messages\n   - Test compensation logic when enabled\n\n4. **Asynchronous Testing**\n\n   - Use appropriate timeouts\n   - Test timeout handling\n   - Clean up resources in `on_exit` callbacks\n\n5. **Context Management**\n   - Test context propagation\n   - Verify context modifications\n   - Test context-dependent behavior","ref":"testing-3.html#best-practices"},{"type":"extras","title":"Common Issues and Solutions - Testing","doc":"1. **Flaky Tests**\n\n   ```elixir\n   # Bad - timing dependent\n   test \"processes async operation\" do\n     {:ok, pid} = AsyncAction.run(params, %{})\n     Process.sleep(100)\n     assert Process.alive?(pid)\n   end\n\n   # Good - use assertions with timeouts\n   test \"processes async operation\" do\n     {:ok, pid} = AsyncAction.run(params, %{})\n     assert_receive {:operation_complete, ^pid}, 1000\n   end\n   ```\n\n2. **Resource Cleanup**\n\n   ```elixir\n   describe \"file operations\" do\n     setup do\n       path = \"/tmp/test_#{:rand.uniform(1000)}\"\n       on_exit(fn -> File.rm_rf!(path) end)\n       {:ok, path: path}\n     end\n\n     test \"writes file\", %{path: path} do\n       assert {:ok, _} = FileAction.run(%{path: path}, %{})\n     end\n   end\n   ```\n\n3. **Context Isolation**\n   ```elixir\n   # Use setup blocks for shared context\n   setup do\n     context = %{\n       request_id: \"req_#{System.unique_integer()}\",\n       timestamp: System.system_time()\n     }\n     {:ok, context: context}\n   end\n   ```","ref":"testing-3.html#common-issues-and-solutions"},{"type":"extras","title":"See Also - Testing","doc":"- [Actions Overview](actions/overview.md)\n- [Workflow Testing](workflow/testing.md)\n- [ExUnit Documentation](https://hexdocs.pm/ex_unit/)\n- [StreamData Documentation](https://hexdocs.pm/stream_data/)","ref":"testing-3.html#see-also"},{"type":"extras","title":"Overview","doc":"# Sensors Overview","ref":"overview-4.html"},{"type":"extras","title":"Introduction - Overview","doc":"Sensors are processes in Jido that enable agents to perceive and react to events in their environment. They act as the gateway for external events to be translated into Signals that your Jido Agents can consume. They are the eyes and ears of your agent-based application, providing a standardized way to monitor, detect, and emit signals based on various triggers and conditions.","ref":"overview-4.html#introduction"},{"type":"extras","title":"Core Concepts - Overview","doc":"","ref":"overview-4.html#core-concepts"},{"type":"extras","title":"What is a Sensor? - Overview","doc":"A Sensor is a specialized GenServer that:\n\n- Monitors specific events or conditions\n- Emits standardized Signals when triggered\n- Maintains configurable state\n- Integrates with Jido's signal dispatch system","ref":"overview-4.html#what-is-a-sensor"},{"type":"extras","title":"Key Features - Overview","doc":"- **Event Detection**: Monitor system events, time-based triggers, or external conditions\n- **Signal Generation**: Emit structured CloudEvents-compatible signals\n- **Configurable**: Easy customization through options and runtime configuration\n- **State Management**: Maintain and track sensor-specific state\n- **Flexible Dispatch**: Route signals to various destinations using Jido's dispatch system","ref":"overview-4.html#key-features"},{"type":"extras","title":"Basic Usage - Overview","doc":"","ref":"overview-4.html#basic-usage"},{"type":"extras","title":"Creating a Simple Sensor - Overview","doc":"```elixir\ndefmodule MyApp.TemperatureSensor do\n  use Jido.Sensor,\n    name: \"temperature_sensor\",\n    description: \"Monitors temperature readings\",\n    category: :monitoring,\n    tags: [:temperature, :environmental],\n    vsn: \"1.0.0\",\n    schema: [\n      threshold: [\n        type: :float,\n        default: 25.0,\n        doc: \"Temperature threshold in Celsius\"\n      ]\n    ]\n\n  @impl true\n  def mount(opts) do\n    state = %{\n      id: opts.id,\n      target: opts.target,\n      config: %{\n        threshold: opts.threshold\n      }\n    }\n    {:ok, state}\n  end\n\n  @impl true\n  def deliver_signal(state) do\n    current_temp = read_temperature()\n\n    {:ok, Jido.Signal.new(%{\n      source: \"#{state.sensor.name}:#{state.id}\",\n      type: \"temperature.reading\",\n      data: %{\n        temperature: current_temp,\n        threshold: state.config.threshold,\n        exceeds_threshold: current_temp > state.config.threshold\n      }\n    })}\n  end\nend\n```","ref":"overview-4.html#creating-a-simple-sensor"},{"type":"extras","title":"Starting a Sensor - Overview","doc":"```elixir\n# Start with default configuration\n{:ok, sensor} = MyApp.TemperatureSensor.start_link(\n  id: \"temp_sensor_1\",\n  target: {:bus, target: :system_bus}\n)\n\n# Start with custom configuration\n{:ok, sensor} = MyApp.TemperatureSensor.start_link(\n  id: \"temp_sensor_2\",\n  target: {:bus, target: :system_bus},\n  threshold: 30.0\n)\n```","ref":"overview-4.html#starting-a-sensor"},{"type":"extras","title":"Built-in Sensors - Overview","doc":"Jido provides several built-in sensors for common use cases:","ref":"overview-4.html#built-in-sensors"},{"type":"extras","title":"Cron Sensor - Overview","doc":"The Cron sensor emits signals based on scheduled intervals using cron expressions:\n\n```elixir\nalias Jido.Sensors.Cron\n\n{:ok, cron} = Cron.start_link(\n  id: \"scheduled_task\",\n  target: {:bus, target: :system_bus},\n  jobs: [\n    # Run every minute\n    {~e\"* * * * *\"e, :minute_task},\n    # Run every hour on the hour\n    {:hourly, ~e\"0 * * * *\"e, :hour_task}\n  ]\n)\n\n# Add a new job later\n:ok = Cron.add_job(cron, :custom_job, ~e\"*/5 * * * *\"e, :five_minute_task)\n```","ref":"overview-4.html#cron-sensor"},{"type":"extras","title":"Heartbeat Sensor - Overview","doc":"The Heartbeat sensor emits regular signals to indicate system health:\n\n```elixir\nalias Jido.Sensors.Heartbeat\n\n{:ok, heartbeat} = Heartbeat.start_link(\n  id: \"system_health\",\n  target: {:bus, target: :monitoring_bus},\n  interval: 5000,  # 5 seconds\n  message: \"system_heartbeat\"\n)\n```","ref":"overview-4.html#heartbeat-sensor"},{"type":"extras","title":"Implementing Custom Sensors - Overview","doc":"","ref":"overview-4.html#implementing-custom-sensors"},{"type":"extras","title":"Sensor Behavior - Overview","doc":"Custom sensors must implement these callbacks:\n\n- `mount/1`: Initialize sensor state\n- `deliver_signal/1`: Generate signals based on current state\n- `on_before_deliver/2`: Pre-processing hook for signals (optional)\n- `shutdown/1`: Cleanup when sensor stops (optional)","ref":"overview-4.html#sensor-behavior"},{"type":"extras","title":"Example: File Change Sensor - Overview","doc":"```elixir\ndefmodule MyApp.FileWatcher do\n  use Jido.Sensor,\n    name: \"file_watcher\",\n    description: \"Monitors file changes\",\n    category: :filesystem,\n    tags: [:files, :monitoring],\n    schema: [\n      path: [\n        type: :string,\n        required: true,\n        doc: \"Path to watch for changes\"\n      ]\n    ]\n\n  @impl true\n  def mount(opts) do\n    state = %{\n      id: opts.id,\n      target: opts.target,\n      config: %{\n        path: opts.path,\n        last_modified: get_last_modified(opts.path)\n      }\n    }\n    schedule_check()\n    {:ok, state}\n  end\n\n  @impl true\n  def deliver_signal(state) do\n    current_modified = get_last_modified(state.config.path)\n\n    if current_modified > state.config.last_modified do\n      {:ok, Jido.Signal.new(%{\n        source: \"#{state.sensor.name}:#{state.id}\",\n        type: \"file.changed\",\n        data: %{\n          path: state.config.path,\n          last_modified: current_modified\n        }\n      })}\n    else\n      {:ok, nil}\n    end\n  end\n\n  # Private helpers\n  defp schedule_check do\n    Process.send_after(self(), :check_file, 1000)\n  end\n\n  defp get_last_modified(path) do\n    case File.stat(path) do\n      {:ok, stat} -> stat.mtime\n      _ -> nil\n    end\n  end\nend\n```","ref":"overview-4.html#example-file-change-sensor"},{"type":"extras","title":"Best Practices - Overview","doc":"","ref":"overview-4.html#best-practices"},{"type":"extras","title":"Configuration Management - Overview","doc":"1. **Validation**: Define clear schema options for configuration\n2. **Defaults**: Provide sensible default values\n3. **Runtime Updates**: Support configuration changes during operation\n\n```elixir\n# Define schema with validation\nschema: [\n  interval: [\n    type: :pos_integer,\n    default: 5000,\n    doc: \"Check interval in milliseconds\"\n  ],\n  retries: [\n    type: :non_neg_integer,\n    default: 3,\n    doc: \"Number of retry attempts\"\n  ]\n]\n\n# Update configuration at runtime\nMyApp.FileWatcher.set_config(sensor, :interval, 10000)\n```","ref":"overview-4.html#configuration-management"},{"type":"extras","title":"Error Handling - Overview","doc":"1. **Graceful Degradation**: Handle failures without crashing\n2. **Retry Logic**: Implement appropriate retry mechanisms\n3. **Logging**: Record important events and errors\n\n```elixir\ndef deliver_signal(state) do\n  case read_sensor_data() do\n    {:ok, data} ->\n      {:ok, build_signal(state, data)}\n\n    {:error, :timeout} ->\n      Logger.warn(\"Sensor timeout, retrying...\")\n      retry_with_backoff(state)\n\n    {:error, reason} ->\n      Logger.error(\"Sensor error: #{inspect(reason)}\")\n      {:error, reason}\n  end\nend\n```","ref":"overview-4.html#error-handling"},{"type":"extras","title":"Performance Considerations - Overview","doc":"1. **Resource Usage**: Monitor memory and CPU usage\n2. **Batching**: Group related signals when appropriate\n3. **Throttling**: Implement rate limiting if needed","ref":"overview-4.html#performance-considerations"},{"type":"extras","title":"Testing - Overview","doc":"Jido provides testing utilities for sensors:\n\n```elixir\ndefmodule MyApp.SensorTest do\n  use JidoTest.Case, async: true\n\n  test \"sensor emits signals on events\" do\n    {:ok, sensor} = MySensor.start_link(\n      id: \"test_sensor\",\n      target: {:pid, target: self()}\n    )\n\n    # Trigger the sensor\n    send(sensor, :check_condition)\n\n    # Assert signal received\n    assert_receive {:signal, {:ok, signal}}, 1000\n    assert signal.type == \"expected.event\"\n  end\nend\n```","ref":"overview-4.html#testing"},{"type":"extras","title":"See Also - Overview","doc":"- [Cron & Heartbeat Sensors](cron-heartbeat.md)\n- [Signal Overview](../signals/overview.livemd)\n- [Signal Testing](../signals/testing.md)\n- [Signal Dispatching](../signals/dispatching.md)\n\nFor API details, see:\n\n- `Jido.Sensor` - Core sensor behavior\n- `Jido.Signal` - Signal structure and creation\n- `Jido.Signal.Dispatch` - Signal dispatch system","ref":"overview-4.html#see-also"},{"type":"extras","title":"Cron & Heartbeat","doc":"# System Monitoring with CRON and Heartbeat Sensors","ref":"cron-heartbeat.html"},{"type":"extras","title":"Overview - Cron & Heartbeat","doc":"Jido provides two included system monitoring sensors: CRON and Heartbeat. These sensors form the foundation of scheduled task execution and system health monitoring in your agent-based applications. This guide explores their implementation, configuration patterns, and best practices for production use.","ref":"cron-heartbeat.html#overview"},{"type":"extras","title":"Core Concepts - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#core-concepts"},{"type":"extras","title":"CRON Sensor - Cron & Heartbeat","doc":"The CRON sensor integrates with [Quantum](https://hexdocs.pm/quantum/) to provide schedule-based signal emission. Key features:\n\n- Schedule-based task execution\n- Dynamic job management\n- Configurable dispatch targets\n- Built-in error handling","ref":"cron-heartbeat.html#cron-sensor"},{"type":"extras","title":"Heartbeat Sensor - Cron & Heartbeat","doc":"The Heartbeat sensor provides continuous system health monitoring through:\n\n- Configurable interval-based signals\n- Customizable health messages\n- Multi-target dispatch support\n- Timestamp tracking","ref":"cron-heartbeat.html#heartbeat-sensor"},{"type":"extras","title":"Implementation Guide - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#implementation-guide"},{"type":"extras","title":"Setting Up CRON Monitoring - Cron & Heartbeat","doc":"#### Basic Configuration\n\n```elixir\n# Initialize a CRON sensor with basic jobs\n{:ok, cron_sensor} = Jido.Sensors.Cron.start_link(\n  id: \"system_tasks\",\n  target: {:bus, [target: :system_bus, stream: \"scheduled_events\"]},\n  scheduler: Jido.Scheduler,\n  jobs: [\n    # Run every minute\n    {~e\"* * * * *\"e, :minute_task},\n    # Run at specific times\n    {:daily_backup, ~e\"0 0 * * *\"e, :backup_task},\n    {:weekly_cleanup, ~e\"0 0 * * 0\"e, :cleanup_task}\n  ]\n)\n```\n\n#### Dynamic Job Management\n\n```elixir\n# Add a new job\n:ok = Jido.Sensors.Cron.add_job(cron_sensor,\n  :metrics_collection,\n  ~e\"*/5 * * * *\"e,  # Every 5 minutes\n  :collect_metrics\n)\n\n# Temporary deactivation\n:ok = Jido.Sensors.Cron.deactivate_job(cron_sensor, :metrics_collection)\n\n# Reactivation\n:ok = Jido.Sensors.Cron.activate_job(cron_sensor, :metrics_collection)\n\n# Manual execution\n:ok = Jido.Sensors.Cron.run_job(cron_sensor, :metrics_collection)\n\n# Remove job\n:ok = Jido.Sensors.Cron.remove_job(cron_sensor, :metrics_collection)\n```","ref":"cron-heartbeat.html#setting-up-cron-monitoring"},{"type":"extras","title":"Setting Up Health Monitoring - Cron & Heartbeat","doc":"#### Basic Heartbeat Configuration\n\n```elixir\n# Initialize a basic heartbeat monitor\n{:ok, heartbeat} = Jido.Sensors.Heartbeat.start_link(\n  id: \"service_health\",\n  target: {:bus, [target: :monitoring_bus]},\n  interval: 5000,  # 5 second interval\n  message: \"service_health_check\"\n)\n```\n\n#### Advanced Multi-Target Setup\n\n```elixir\n# Configure heartbeat with multiple dispatch targets\n{:ok, critical_service_monitor} = Jido.Sensors.Heartbeat.start_link(\n  id: \"critical_service\",\n  target: [\n    {:bus, [target: :monitoring_bus, stream: \"health\"]},\n    {:logger, [level: :info]},\n    {:pubsub, [topic: \"system.health\"]}\n  ],\n  interval: 1000,  # 1 second for critical services\n  message: \"critical_service_status\"\n)\n```","ref":"cron-heartbeat.html#setting-up-health-monitoring"},{"type":"extras","title":"Signal Structure and Handling - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#signal-structure-and-handling"},{"type":"extras","title":"CRON Signals - Cron & Heartbeat","doc":"CRON sensors emit signals with the following structure:\n\n```elixir\n%Jido.Signal{\n  source: \"cron_sensor:system_tasks:daily_backup\",\n  type: \"cron_trigger\",\n  data: %{\n    name: :daily_backup,\n    schedule: \"0 0 * * *\",\n    task: :backup_task,\n    triggered_at: ~U[2024-02-11 00:00:00Z]\n  }\n}\n```","ref":"cron-heartbeat.html#cron-signals"},{"type":"extras","title":"Heartbeat Signals - Cron & Heartbeat","doc":"Heartbeat sensors emit signals structured as:\n\n```elixir\n%Jido.Signal{\n  source: \"heartbeat_sensor:service_health\",\n  type: \"heartbeat\",\n  data: %{\n    message: \"service_health_check\",\n    timestamp: ~U[2024-02-11 10:00:00Z],\n    last_beat: ~U[2024-02-11 09:59:55Z]\n  }\n}\n```","ref":"cron-heartbeat.html#heartbeat-signals"},{"type":"extras","title":"Best Practices - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#best-practices"},{"type":"extras","title":"CRON Job Management - Cron & Heartbeat","doc":"1. **Naming Conventions**\n\n   - Use descriptive atom names (e.g., `:daily_user_cleanup`)\n   - Follow consistent naming patterns\n   - Add domain-specific prefixes for large systems\n\n2. **Schedule Planning**\n\n   ```elixir\n   # Spread out resource-intensive jobs\n   jobs: [\n     {:heavy_task_1, ~e\"0 */4 * * *\"e, :resource_intensive_1},\n     {:heavy_task_2, ~e\"0 2-23/4 * * *\"e, :resource_intensive_2}\n   ]\n   ```\n\n3. **Error Handling**\n\n   ```elixir\n   defmodule TaskHandler do\n     def handle_signal(%{type: \"cron_trigger\"} = signal) do\n       try do\n         signal.data.task\n         |> execute_task()\n         |> handle_task_result()\n       rescue\n         error ->\n           Logger.error(\"Task execution failed: #{inspect(error)}\")\n           {:error, :task_failed}\n       catch\n         kind, reason ->\n           Logger.error(\"Unexpected error: #{inspect({kind, reason})}\")\n           {:error, :unexpected_failure}\n       end\n     end\n\n     defp handle_task_result({:ok, _} = result), do: result\n     defp handle_task_result({:error, _} = error), do: error\n     defp handle_task_result(_), do: {:error, :invalid_result}\n   end\n   ```","ref":"cron-heartbeat.html#cron-job-management"},{"type":"extras","title":"Heartbeat Monitoring - Cron & Heartbeat","doc":"1. **Interval Configuration**\n\n   ```elixir\n   # Adjust intervals based on service criticality\n   defmodule MonitoringConfig do\n     def get_interval(:critical), do: 1_000    # 1 second\n     def get_interval(:important), do: 5_000   # 5 seconds\n     def get_interval(:routine), do: 30_000    # 30 seconds\n   end\n   ```\n\n2. **Health Check Implementation**\n\n   ```elixir\n   defmodule HealthMonitor do\n     use Jido.Agent,\n       name: \"health_monitor\"\n\n     @max_delay_ms 10_000  # Maximum acceptable delay\n\n     def handle_signal(%{type: \"heartbeat\"} = signal) do\n       delay = calculate_delay(signal.data)\n\n       cond do\n         delay > @max_delay_ms ->\n           trigger_alert(signal.source, delay)\n\n         delay > @max_delay_ms / 2 ->\n           Logger.warning(\"Service #{signal.source} showing increased latency\")\n\n         true ->\n           Logger.debug(\"Service #{signal.source} healthy\")\n       end\n     end\n\n     defp calculate_delay(%{timestamp: current, last_beat: last}) do\n       DateTime.diff(current, last, :millisecond)\n     end\n   end\n   ```","ref":"cron-heartbeat.html#heartbeat-monitoring"},{"type":"extras","title":"Testing Strategies - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#testing-strategies"},{"type":"extras","title":"CRON Testing - Cron & Heartbeat","doc":"```elixir\ndefmodule CronSensorTest do\n  use ExUnit.Case\n\n  setup do\n    {:ok, sensor} = Jido.Sensors.Cron.start_link(\n      id: \"test_cron\",\n      target: {:pid, target: self()},\n      scheduler: Jido.Scheduler\n    )\n\n    {:ok, sensor: sensor}\n  end\n\n  test \"schedules and executes jobs\", %{sensor: sensor} do\n    :ok = Jido.Sensors.Cron.add_job(\n      sensor,\n      :test_job,\n      ~e\"* * * * * *\"e,\n      :test_task\n    )\n\n    assert_receive {:signal, {:ok, signal}}, 1000\n    assert signal.type == \"cron_trigger\"\n    assert signal.data.name == :test_job\n  end\n\n  test \"handles job deactivation\", %{sensor: sensor} do\n    :ok = Jido.Sensors.Cron.add_job(\n      sensor,\n      :inactive_job,\n      ~e\"* * * * * *\"e,\n      :test_task\n    )\n\n    :ok = Jido.Sensors.Cron.deactivate_job(sensor, :inactive_job)\n    refute_receive {:signal, _}, 1500\n  end\nend\n```","ref":"cron-heartbeat.html#cron-testing"},{"type":"extras","title":"Heartbeat Testing - Cron & Heartbeat","doc":"```elixir\ndefmodule HeartbeatSensorTest do\n  use ExUnit.Case\n\n  test \"emits regular heartbeats with correct data\" do\n    {:ok, _sensor} = Jido.Sensors.Heartbeat.start_link(\n      id: \"test_heartbeat\",\n      target: {:pid, target: self()},\n      interval: 100,\n      message: \"test_heartbeat\"\n    )\n\n    # Verify multiple heartbeats\n    for _i <- 1..3 do\n      assert_receive {:signal, {:ok, signal}}, 200\n      assert signal.type == \"heartbeat\"\n      assert signal.data.message == \"test_heartbeat\"\n      assert %DateTime{} = signal.data.timestamp\n      assert %DateTime{} = signal.data.last_beat\n    end\n  end\nend\n```","ref":"cron-heartbeat.html#heartbeat-testing"},{"type":"extras","title":"Production Patterns - Cron & Heartbeat","doc":"","ref":"cron-heartbeat.html#production-patterns"},{"type":"extras","title":"System Maintenance Automation - Cron & Heartbeat","doc":"```elixir\ndefmodule MaintenanceOrchestrator do\n  def start_maintenance_sensors do\n    # Daily maintenance tasks\n    {:ok, _daily} = Jido.Sensors.Cron.start_link(\n      id: \"daily_maintenance\",\n      target: {:bus, [target: :maintenance_bus]},\n      jobs: [\n        {:log_rotation, ~e\"0 0 * * *\"e, :rotate_logs},\n        {:temp_cleanup, ~e\"0 4 * * *\"e, :clean_temp},\n        {:metrics_rollup, ~e\"*/30 * * * *\"e, :rollup_metrics}\n      ]\n    )\n\n    # Health monitoring\n    {:ok, _health} = Jido.Sensors.Heartbeat.start_link(\n      id: \"system_health\",\n      target: [\n        {:bus, [target: :health_bus]},\n        {:logger, [level: :info]}\n      ],\n      interval: 10_000\n    )\n  end\nend\n```","ref":"cron-heartbeat.html#system-maintenance-automation"},{"type":"extras","title":"Service Health Dashboard - Cron & Heartbeat","doc":"```elixir\ndefmodule HealthDashboard do\n  use Jido.Agent,\n    name: \"health_dashboard\"\n\n  def init(state) do\n    {:ok, Map.put(state, :service_status, %{})}\n  end\n\n  def handle_signal(%{type: \"heartbeat\"} = signal) do\n    service = signal.source\n    status = evaluate_health(signal.data)\n\n    update_status(service, status)\n    maybe_trigger_alerts(service, status)\n  end\n\n  defp evaluate_health(data) do\n    case calculate_delay(data) do\n      delay when delay > 30_000 -> :critical\n      delay when delay > 10_000 -> :warning\n      _ -> :healthy\n    end\n  end\n\n  defp calculate_delay(%{timestamp: current, last_beat: last}) do\n    DateTime.diff(current, last, :millisecond)\n  end\nend\n```","ref":"cron-heartbeat.html#service-health-dashboard"},{"type":"extras","title":"See Also - Cron & Heartbeat","doc":"- [Signal System Overview](signals/overview.md)\n- [Signal Dispatching](signals/dispatching.md)\n- [Agent System](agents/overview.md)\n- [Testing Guide](testing.md)","ref":"cron-heartbeat.html#see-also"},{"type":"extras","title":"Contributing - Cron & Heartbeat","doc":"Found an issue or have a suggestion? Please open an issue or submit a pull request on our [GitHub repository](https://github.com/your-org/jido).","ref":"cron-heartbeat.html#contributing"},{"type":"extras","title":"Overview","doc":"# Agents Overview\n\n_Part of the \"Agents\" section in the documentation._\n\nThis guide provides a comprehensive introduction to agents in Jido. It covers the core concepts of agents, their role in the system, and how they integrate with actions, sensors, and signals to create autonomous behaviors.\n\n# Understanding Agents and State Management","ref":"overview-5.html"},{"type":"extras","title":"Overview - Overview","doc":"Agents are the foundational building blocks of Jido applications. They represent stateful processes that encapsulate business logic, manage state transitions, and coordinate workflows. Built on top of OTP's GenServer, agents provide a robust, fault-tolerant way to maintain state while handling concurrent operations.","ref":"overview-5.html#overview"},{"type":"extras","title":"Core Principles - Overview","doc":"1. **State Encapsulation**\n\n   - Each agent maintains its own isolated state\n   - State changes are validated through schema definitions\n   - Lifecycle hooks for state transition control\n\n2. **Instruction Processing**\n\n   - Queue-based execution model\n   - Support for synchronous and asynchronous operations\n   - Built-in compensation handling\n\n3. **Fault Tolerance**\n   - OTP supervision integration\n   - Graceful error handling\n   - State recovery mechanisms","ref":"overview-5.html#core-principles"},{"type":"extras","title":"Implementation - Overview","doc":"","ref":"overview-5.html#implementation"},{"type":"extras","title":"Basic Agent Structure - Overview","doc":"```elixir\ndefmodule MyApp.TaskAgent do\n  use Jido.Agent\n\n  @type status :: :pending | :running | :completed | :failed\n  @type t :: %__MODULE__{\n    id: String.t(),\n    name: String.t(),\n    status: status(),\n    metadata: map()\n  }\n\n  schema do\n    field :id, :string, required: true\n    field :name, :string, required: true\n    field :status, :atom, default: :pending\n    field :metadata, :map, default: %{}\n  end\n\n  @impl true\n  def on_before_validate_state(%{status: new_status} = state) do\n    if valid_status_transition?(state.status, new_status) do\n      {:ok, state}\n    else\n      {:error, :invalid_transition}\n    end\n  end\n\n  @impl true\n  def on_after_validate_state(state) do\n    Logger.info(\"Task state updated: #{inspect(state)}\")\n    {:ok, state}\n  end\n\n  # Private Helpers\n\n  defp valid_status_transition?(current, next) do\n    transitions = %{\n      pending: [:running],\n      running: [:completed, :failed],\n      completed: [],\n      failed: [:pending]\n    }\n\n    next in Map.get(transitions, current, [])\n  end\nend\n```","ref":"overview-5.html#basic-agent-structure"},{"type":"extras","title":"Agent Server Implementation - Overview","doc":"The agent server handles the core lifecycle and state management:\n\n```elixir\ndefmodule MyApp.TaskAgent.Server do\n  use Jido.Agent.Server\n\n  @impl true\n  def init(opts) do\n    initial_state = %{\n      id: opts[:id] || Jido.ID.generate(),\n      name: opts[:name] || \"Task-#{:rand.uniform(1000)}\",\n      status: :pending,\n      metadata: %{}\n    }\n\n    {:ok, initial_state}\n  end\n\n  @impl true\n  def handle_instruction({action, params}, state) do\n    case apply_instruction(action, params, state) do\n      {:ok, new_state} -> {:ok, new_state}\n      {:error, reason} -> {:error, reason, state}\n    end\n  end\n\n  # Private Helpers\n\n  defp apply_instruction(action, params, state) do\n    with {:ok, validated} <- validate_params(params),\n         {:ok, new_state} <- action.run(state, validated) do\n      {:ok, new_state}\n    end\n  end\nend\n```","ref":"overview-5.html#agent-server-implementation"},{"type":"extras","title":"State Management - Overview","doc":"","ref":"overview-5.html#state-management"},{"type":"extras","title":"Schema Validation - Overview","doc":"Jido uses NimbleOptions for schema validation:\n\n```elixir\ndefmodule MyApp.TaskAgent.Schema do\n  @schema [\n    id: [\n      type: :string,\n      required: true,\n      doc: \"Unique identifier for the task\"\n    ],\n    name: [\n      type: :string,\n      required: true,\n      doc: \"Human-readable task name\"\n    ],\n    status: [\n      type: :atom,\n      values: [:pending, :running, :completed, :failed],\n      default: :pending,\n      doc: \"Current task status\"\n    ],\n    metadata: [\n      type: :map,\n      default: %{},\n      doc: \"Additional task metadata\"\n    ]\n  ]\n\n  def validate(params) do\n    NimbleOptions.validate(params, @schema)\n  end\nend\n```","ref":"overview-5.html#schema-validation"},{"type":"extras","title":"State Transitions - Overview","doc":"State transitions are managed through lifecycle hooks:\n\n1. **Before Validation**\n\n   ```elixir\n   @impl true\n   def on_before_validate_state(state) do\n     # Custom validation logic\n     {:ok, state}\n   end\n   ```\n\n2. **After Validation**\n\n   ```elixir\n   @impl true\n   def on_after_validate_state(state) do\n     # Post-validation processing\n     {:ok, state}\n   end\n   ```\n\n3. **Error Handling**\n   ```elixir\n   @impl true\n   def on_validation_error(error, state) do\n     Logger.error(\"Validation failed: #{inspect(error)}\")\n     {:error, error}\n   end\n   ```","ref":"overview-5.html#state-transitions"},{"type":"extras","title":"Testing & Verification - Overview","doc":"","ref":"overview-5.html#testing-verification"},{"type":"extras","title":"Unit Tests - Overview","doc":"```elixir\ndefmodule MyApp.TaskAgentTest do\n  use ExUnit.Case\n  use Jido.Test.AgentCase\n\n  alias MyApp.TaskAgent\n\n  describe \"state transitions\" do\n    test \"allows valid transitions\" do\n      {:ok, agent} = start_supervised_agent(TaskAgent, id: \"test-1\", name: \"Test Task\")\n\n      assert {:ok, %{status: :running}} =\n        Jido.Agent.cmd(agent, MyApp.Actions.StartTask, %{})\n\n      assert {:ok, %{status: :completed}} =\n        Jido.Agent.cmd(agent, MyApp.Actions.CompleteTask, %{})\n    end\n\n    test \"prevents invalid transitions\" do\n      {:ok, agent} = start_supervised_agent(TaskAgent, id: \"test-2\", name: \"Test Task\")\n\n      assert {:error, :invalid_transition} =\n        Jido.Agent.cmd(agent, MyApp.Actions.CompleteTask, %{})\n    end\n  end\n\n  describe \"state validation\" do\n    test \"enforces schema rules\" do\n      assert {:error, _} = TaskAgent.start_link([])  # Missing required fields\n\n      assert {:ok, pid} = TaskAgent.start_link(id: \"test-3\", name: \"Valid Task\")\n      assert is_pid(pid)\n    end\n  end\nend\n```","ref":"overview-5.html#unit-tests"},{"type":"extras","title":"Property-Based Tests - Overview","doc":"```elixir\ndefmodule MyApp.TaskAgent.PropertyTest do\n  use ExUnit.Case\n  use PropCheck\n\n  property \"state transitions maintain invariants\" do\n    forall {id, name, transitions} <- {\n      string(:alphanumeric),\n      string(:alphanumeric),\n      list(transition())\n    } do\n      {:ok, agent} = start_supervised_agent(TaskAgent, id: id, name: name)\n\n      Enum.all?(transitions, fn transition ->\n        case apply_transition(agent, transition) do\n          {:ok, _} -> true\n          {:error, :invalid_transition} -> true\n          _ -> false\n        end\n      end)\n    end\n  end\n\n  # Generators\n\n  def transition do\n    oneof([\n      {:start, :running},\n      {:complete, :completed},\n      {:fail, :failed},\n      {:retry, :pending}\n    ])\n  end\nend\n```","ref":"overview-5.html#property-based-tests"},{"type":"extras","title":"Production Readiness - Overview","doc":"","ref":"overview-5.html#production-readiness"},{"type":"extras","title":"Configuration - Overview","doc":"```elixir\n# config/runtime.exs\nconfig :my_app, MyApp.TaskAgent,\n  max_queue_size: 1000,\n  shutdown_timeout: :timer.seconds(30),\n  retry_count: 3,\n  retry_backoff: :timer.seconds(5)\n```","ref":"overview-5.html#configuration"},{"type":"extras","title":"Monitoring - Overview","doc":"1. **Telemetry Events**\n\n   ```elixir\n   :telemetry.attach(\n     \"task-agent-metrics\",\n     [:jido, :agent, :state_transition],\n     &MyApp.Metrics.handle_state_transition/4,\n     nil\n   )\n   ```\n\n2. **Health Checks**\n   ```elixir\n   def health_check(agent) do\n     case Jido.Agent.get_state(agent) do\n       {:ok, %{status: :failed}} -> {:error, :agent_failed}\n       {:ok, _} -> :ok\n       _ -> {:error, :agent_unavailable}\n     end\n   end\n   ```","ref":"overview-5.html#monitoring"},{"type":"extras","title":"Common Issues - Overview","doc":"1. **Queue Overflow**\n\n   - Monitor queue size with `:telemetry`\n   - Implement backpressure mechanisms\n   - Consider scaling horizontally\n\n2. **State Corruption**\n\n   - Use strict schema validation\n   - Implement state recovery mechanisms\n   - Log all state transitions\n\n3. **Performance**\n   - Profile state update patterns\n   - Optimize validation logic\n   - Consider state partitioning","ref":"overview-5.html#common-issues"},{"type":"extras","title":"Best Practices - Overview","doc":"1. **State Design**\n\n   - Keep state minimal and focused\n   - Use strict typing and validation\n   - Document state transitions\n\n2. **Error Handling**\n\n   - Implement proper compensation\n   - Log validation failures\n   - Use telemetry for monitoring\n\n3. **Testing**\n\n   - Write comprehensive unit tests\n   - Use property-based testing\n   - Test concurrent operations\n\n4. **Production**\n   - Monitor queue sizes\n   - Set appropriate timeouts\n   - Implement health checks","ref":"overview-5.html#best-practices"},{"type":"extras","title":"Further Reading - Overview","doc":"- [Actions and Workflows](../actions/overview.md)\n- [Signal Routing](../signals/overview.md)","ref":"overview-5.html#further-reading"},{"type":"extras","title":"See Also - Overview","doc":"- [Agent State Management](stateful.md)\n- [Agent Output](output.md)\n- [Signal Overview](../signals/overview.livemd)\n- [Testing Guide](../signals/testing.md)\n- [Child Processes](child-processes.md)\n- [Directives](directives.md)","ref":"overview-5.html#see-also"},{"type":"extras","title":"Stateless Agents","doc":"# Building Stateless Agents in Jido","ref":"stateless.html"},{"type":"extras","title":"Overview - Stateless Agents","doc":"Jido Agents may be used in either a stateful or stateless manner. Stateless agents provide an immutable, functional approach to workflow orchestration allowing the developer to overlay their own OTP lifecycle as needed. Stateless agents are also ideal for testing and development, as they can be manipulated and inspected as pure Elixir data structures.\n\nAlternatively, you may use the `Jido.Agent.Server` module to create a stateful agent that uses a GenServer for its lifecycle. Learn more about [stateful agents](stateful.md) in the next section.","ref":"stateless.html#overview"},{"type":"extras","title":"Core Design Principles - Stateless Agents","doc":"1. **Immutability**: All state transitions create new agent instances\n2. **Pure Functions**: Operations have no side effects\n3. **Explicit State Flow**: State changes are always returned, never mutated\n4. **Functional Composition**: Operations chain through return values","ref":"stateless.html#core-design-principles"},{"type":"extras","title":"Implementation Guide - Stateless Agents","doc":"","ref":"stateless.html#implementation-guide"},{"type":"extras","title":"Basic Agent Structure - Stateless Agents","doc":"```elixir\ndefmodule MyApp.StatelessAgent do\n  use Jido.Agent,\n    name: \"stateless_agent\",\n    description: \"Pure functional workflow processor\",\n    schema: [\n      input: [\n        type: :map,\n        required: true,\n        doc: \"Input data to process\"\n      ],\n      format: [\n        type: {:in, [\"json\", \"xml\", \"yaml\"]},\n        required: true,\n        doc: \"Data format\"\n      ],\n      metadata: [\n        type: :map,\n        default: %{},\n        doc: \"Optional processing metadata\"\n      ],\n      status: [\n        type: {:in, [:pending, :processing, :complete]},\n        default: :pending,\n        doc: \"Processing status\"\n      ]\n    ],\n    actions: [\n      MyApp.Actions.ValidateInput,\n      MyApp.Actions.TransformData,\n      MyApp.Actions.EnrichMetadata\n    ]\n\n  # No GenServer callbacks or state mutation\n  # All operations use core Agent module functions\nend\n```","ref":"stateless.html#basic-agent-structure"},{"type":"extras","title":"Understanding the Agent Struct - Stateless Agents","doc":"At its core, a Jido agent is an Elixir struct that can be freely inspected and pattern matched against. This transparency is crucial for testing and debugging:\n\n```elixir\n%MyApp.StatelessAgent{\n  id: \"agent_123\",           # Unique identifier\n  state: %{},               # Current validated state\n  pending_instructions: queue, # Erlang queue of pending actions\n  actions: [],              # List of allowed action modules\n  dirty_state?: false,      # State modification tracking\n  result: nil               # Last execution result\n}\n```","ref":"stateless.html#understanding-the-agent-struct"},{"type":"extras","title":"Inspecting Agent State - Stateless Agents","doc":"You can pattern match and inspect any aspect of the agent:\n\n```elixir\n# Pattern match on specific states\ndef handle_agent(%{state: %{status: :complete}} = agent) do\n  # Handle completed agent\nend\n\n# Inspect pending instructions\ninstruction_count = :queue.len(agent.pending_instructions)\n\n# Check allowed actions\nallowed_actions = agent.actions\n```","ref":"stateless.html#inspecting-agent-state"},{"type":"extras","title":"Core Operations - Stateless Agents","doc":"","ref":"stateless.html#core-operations"},{"type":"extras","title":"Action Registration - Stateless Agents","doc":"Before an agent can execute actions, they must be registered either at compile-time or runtime:\n\n```elixir\n# Compile-time registration\nuse Jido.Agent,\n  actions: [\n    MyApp.Actions.ValidateInput,\n    MyApp.Actions.ProcessData\n  ]\n\n# Runtime registration\n{:ok, agent} = Jido.Agent.register_action(agent, MyApp.Actions.NewAction)\n{:ok, agent} = Jido.Agent.register_action(agent, [Action1, Action2])\n\n# Remove action\n{:ok, agent} = Jido.Agent.deregister_action(agent, MyApp.Actions.OldAction)\n\n# Check registration\nactions = Jido.Agent.registered_actions(agent)\n```\n\nOnly registered actions can be used in planning - this provides a safety mechanism against executing unintended code.","ref":"stateless.html#action-registration"},{"type":"extras","title":"Core Method Architecture - Stateless Agents","doc":"Jido agents provide four primary methods that work together for workflow orchestration:\n\nNew agent instances are created through the core Agent module:\n\n```elixir\n# Basic creation\nagent = MyApp.StatelessAgent.new()\n\n# With initial state\nagent = MyApp.StatelessProcessor.new(\"custom_id\", %{\n  input: %{key: \"value\"},\n  format: \"json\"\n})\n```\n\n#### 1. State Management with `set/3`\n\nThe `set/3` function manages agent state through immutable updates:\n\n```elixir\n@spec set(agent :: t(), attrs :: map() | keyword(), opts :: keyword()) ::\n  {:ok, t()} | {:error, Error.t()}\n```\n\nParameters:\n\n- `agent`: The agent struct to update\n- `attrs`: Map or keyword list of attributes to merge into state\n- `opts`: Configuration options\n  - `:strict_validation` - Enable/disable strict schema validation (default: false)\n\nThe set operation:\n\n1. Deep merges new attributes with existing state\n2. Validates against the agent's schema\n3. Sets the dirty_state? flag\n4. Returns a new agent instance\n\n```elixir\n# Basic state update\n{:ok, updated} = Jido.Agent.set(agent, %{\n  status: :processing,\n  metadata: %{started_at: DateTime.utc_now()}\n})\n\n# With strict validation\n{:ok, validated} = Jido.Agent.set(agent, attrs, strict_validation: true)\n```\n\n```elixir\n{:ok, updated_agent} = Jido.Agent.set(agent, %{\n  input: new_input,\n  metadata: %{processed_at: DateTime.utc_now()}\n})\n\n# Validation happens automatically\n{:error, reason} = Jido.Agent.set(agent, %{\n  format: \"invalid\"  # Will fail format validation\n})\n```\n\n#### 2. Workflow Planning with `plan/3`\n\nThe `plan/3` function builds an immutable queue of instructions:\n\n```elixir\n@spec plan(agent :: t(), instructions :: instruction() | [instruction()], context :: map()) ::\n  {:ok, t()} | {:error, Error.t()}\n```\n\nParameters:\n\n- `agent`: The agent struct to plan actions for\n- `instructions`: Single action module or list of instruction specifications\n  - Single module: `MyAction`\n  - With params: `{MyAction, %{param: value}}`\n  - Multiple actions: `[Action1, {Action2, %{}}]`\n- `context`: Shared context map passed to all instructions\n\nThe planning process:\n\n1. Validates that all actions are registered\n2. Normalizes instructions into consistent format\n3. Adds instructions to pending queue\n4. Returns new agent with updated queue\n\n````elixir\n# Single action\n{:ok, agent} = Jido.Agent.plan(agent, ValidateAction)\n\n# Multiple actions with context\n{:ok, agent} = Jido.Agent.plan(\n  agent,\n  [\n    ValidateAction,\n    {ProcessAction, %{mode: :strict}},\n    FinalizeAction\n  ],\n  %{request_id: \"req_123\"}\n)\n\n```elixir\n{:ok, agent_with_plan} = Jido.Agent.plan(agent, [\n  ValidateInput,\n  {TransformData, %{target_format: \"xml\"}},\n  EnrichMetadata\n])\n\n# Planning preserves immutability\nassert agent != agent_with_plan\n````\n\n#### 3. Execution with `run/2`\n\nThe `run/2` function executes pending instructions through a runner:\n\n```elixir\n@spec run(agent :: t(), opts :: keyword()) ::\n  {:ok, t(), [Directive.t()]} | {:error, Error.t()}\n```\n\nParameters:\n\n- `agent`: The agent struct containing pending instructions\n- `opts`: Execution options\n  - `:runner` - Custom runner module (default: agent's configured runner)\n  - `:apply_state` - Merge results into agent state (default: true)\n  - `:timeout` - Execution timeout in milliseconds\n  - `:retry` - Enable automatic retries (default: false)\n  - `:max_retries` - Maximum retry attempts\n  - `:backoff` - Retry backoff strategy\n\nThe execution process:\n\n1. Validates runner configuration\n2. Executes pending instructions in order\n3. Handles any returned directives\n4. Returns new agent with results and directives\n\n````elixir\n# Basic execution\n{:ok, agent, directives} = Jido.Agent.run(agent)\n\n# With custom options\n{:ok, agent, directives} = Jido.Agent.run(agent,\n  runner: CustomRunner,\n  apply_state: false,\n  timeout: 5000,\n  retry: true,\n  max_retries: 3\n)\n\n```elixir\n{:ok, final_agent, directives} = Jido.Agent.run(agent_with_plan)\n\n# Results stored in agent\nresult = final_agent.result\n\n# Original agent unchanged\nassert agent_with_plan != final_agent\n````\n\n#### 4. Composite Operations with `cmd/4`\n\nThe `cmd/4` function composes set, plan, and run operations into a single call:\n\n```elixir\n@spec cmd(agent :: t(), instructions :: instruction() | [instruction()],\n    attrs :: map(), opts :: keyword()) ::\n  {:ok, t(), [Directive.t()]} | {:error, Error.t()}\n```\n\nParameters:\n\n- `agent`: The agent struct to operate on\n- `instructions`: Action specifications to plan\n- `attrs`: State attributes to set\n- `opts`: Combined options for all operations\n  - All options from `set/3`\n  - All options from `plan/3`\n  - All options from `run/2`\n\nThe command process:\n\n1. Sets new state with validation\n2. Plans specified instructions\n3. Executes instructions with runner\n4. Returns final agent state and directives\n\n````elixir\n# Complete workflow in one call\n{:ok, agent, directives} = Jido.Agent.cmd(\n  agent,\n  [ValidateAction, ProcessAction],\n  %{status: :processing, input: data},\n  strict_validation: true,\n  timeout: 10_000\n)\n\n```elixir\n{:ok, final_agent, directives} = Jido.Agent.cmd(\n  agent,\n  [ValidateInput, TransformData],\n  %{input: new_data, format: \"json\"}\n)\n````","ref":"stateless.html#core-method-architecture"},{"type":"extras","title":"Purpose and Testing Philosophy - Stateless Agents","doc":"Stateless agents serve a crucial role in Jido's development workflow:\n\n1. **Test-First Development**\n\n   - Write and test agent logic before adding server capabilities\n   - Focus on pure business logic without distributed system complexity\n   - Ensure core workflows work correctly in isolation\n\n2. **Predictable Testing**\n\n   - Every operation produces new agent instances\n   - No hidden state or side effects\n   - Deterministic results for given inputs\n\n3. **Comprehensive Coverage**\n   - Test state validation rules\n   - Verify action planning logic\n   - Ensure proper error handling\n   - Validate workflow composition\n\nExample test suite:\n\n```elixir\ndefmodule MyApp.StatelessAgentTest do\n  use ExUnit.Case\n\n  setup do\n    agent = MyApp.StatelessAgent.new(\"test_id\", %{\n      status: :pending\n    })\n    {:ok, agent: agent}\n  end\n\n  test \"validates state updates\", %{agent: agent} do\n    # Test state validation\n    {:error, error} = Jido.Agent.set(agent, %{\n      status: :invalid_status\n    })\n    assert error.type == :validation_error\n\n    # Test successful update\n    {:ok, updated} = Jido.Agent.set(agent, %{\n      status: :processing\n    })\n    assert updated.state.status == :processing\n  end\n\n  test \"plans allowed actions only\", %{agent: agent} do\n    # Test unregistered action\n    {:error, error} = Jido.Agent.plan(agent, UnregisteredAction)\n\n    # Register and plan action\n    {:ok, agent} = Jido.Agent.register_action(agent, AllowedAction)\n    {:ok, agent} = Jido.Agent.plan(agent, AllowedAction)\n    assert :queue.len(agent.pending_instructions) == 1\n  end\n\n  test \"executes complete workflow\", %{agent: agent} do\n    {:ok, final_agent, _directives} = Jido.Agent.cmd(\n      agent,\n      [ValidateAction, ProcessAction],\n      %{input: test_data()}\n    )\n\n    assert final_agent.state.status == :complete\n    assert final_agent.result != nil\n  end\nend\n```\n\nOnce core logic is verified, you can add server capabilities with confidence that the underlying agent behavior works correctly.","ref":"stateless.html#purpose-and-testing-philosophy"},{"type":"extras","title":"Advanced Patterns - Stateless Agents","doc":"","ref":"stateless.html#advanced-patterns"},{"type":"extras","title":"Functional Composition - Stateless Agents","doc":"Chain operations using pattern matching:\n\n```elixir\ndef process_data(agent, input) do\n  with {:ok, agent1} <- Jido.Agent.set(agent, %{input: input}),\n       {:ok, agent2} <- Jido.Agent.plan(agent1, ValidateInput),\n       {:ok, agent3, _} <- Jido.Agent.run(agent2) do\n    {:ok, agent3}\n  end\nend\n```","ref":"stateless.html#functional-composition"},{"type":"extras","title":"State Flow Management - Stateless Agents","doc":"Track state transitions explicitly:\n\n```elixir\ndef safe_transform(agent, data) do\n  with {:ok, agent_with_data} <- set_with_validation(agent, data),\n       {:ok, agent_with_plan} <- plan_transformation(agent_with_data),\n       {:ok, final_agent, _} <- execute_transformation(agent_with_plan) do\n    {:ok, final_agent}\n  else\n    {:error, reason} -> handle_transform_error(reason)\n  end\nend\n\ndefp set_with_validation(agent, data) do\n  Jido.Agent.set(agent, %{\n    input: data,\n    status: :processing\n  })\nend\n\ndefp plan_transformation(agent) do\n  Jido.Agent.plan(agent, [\n    ValidateInput,\n    TransformData,\n    EnrichMetadata\n  ])\nend\n\ndefp execute_transformation(agent) do\n  Jido.Agent.run(agent)\nend\n```","ref":"stateless.html#state-flow-management"},{"type":"extras","title":"Error Recovery - Stateless Agents","doc":"Implement explicit error handling:\n\n```elixir\ndef transform_with_retry(agent, data, opts \\\\ []) do\n  max_attempts = Keyword.get(opts, :max_attempts, 3)\n\n  do_transform_with_retry(agent, data, 1, max_attempts)\nend\n\ndefp do_transform_with_retry(agent, data, attempt, max_attempts) do\n  case safe_transform(agent, data) do\n    {:ok, transformed} ->\n      {:ok, transformed}\n\n    {:error, reason} when attempt  \n      :timer.sleep(exponential_backoff(attempt))\n      do_transform_with_retry(agent, data, attempt + 1, max_attempts)\n\n    {:error, reason} ->\n      {:error, %{reason: reason, attempts: attempt}}\n  end\nend\n```","ref":"stateless.html#error-recovery"},{"type":"extras","title":"Best Practices - Stateless Agents","doc":"","ref":"stateless.html#best-practices"},{"type":"extras","title":"1. State Management - Stateless Agents","doc":"- Keep state minimal and focused\n- Use computed properties when possible\n- Validate state transitions early\n- Return descriptive errors","ref":"stateless.html#1-state-management"},{"type":"extras","title":"2. Action Planning - Stateless Agents","doc":"- Build complete instruction sets\n- Validate action sequences\n- Consider compensation strategies\n- Plan for retries","ref":"stateless.html#2-action-planning"},{"type":"extras","title":"3. Execution - Stateless Agents","doc":"- Handle all error cases\n- Use timeouts appropriately\n- Implement backoff strategies\n- Consider partial successes","ref":"stateless.html#3-execution"},{"type":"extras","title":"4. Testing - Stateless Agents","doc":"Stateless agents enable simple testing:\n\n```elixir\ntest \"processes data immutably\" do\n  agent = StatelessAgent.new()\n\n  {:ok, updated} = Jido.Agent.set(agent, %{\n    input: test_data,\n    format: \"json\"\n  })\n\n  assert agent != updated\n  assert updated.state.input == test_data\nend\n```","ref":"stateless.html#4-testing"},{"type":"extras","title":"Key Benefits - Stateless Agents","doc":"1. **Predictable Behavior**: Pure functions with no side effects\n2. **Thread Safety**: Immutable state eliminates race conditions\n3. **Easy Testing**: Deterministic outputs for given inputs\n4. **Simple Reasoning**: Explicit state transitions\n5. **Functional Composition**: Natural operation chaining","ref":"stateless.html#key-benefits"},{"type":"extras","title":"Anti-Patterns to Avoid - Stateless Agents","doc":"1. **State Mutation**: Never modify agent state directly\n2. **Hidden Side Effects**: Keep operations pure and explicit\n3. **Implicit Dependencies**: Make requirements clear in function signatures\n4. **Complex State**: Keep state minimal and focused\n5. **Mixed Paradigms**: Don't mix stateless and stateful approaches","ref":"stateless.html#anti-patterns-to-avoid"},{"type":"extras","title":"See Also - Stateless Agents","doc":"- [Agent Overview](overview.md)\n- [Signal Overview](../signals/overview.livemd)\n- [Action Development](../actions/overview.md)\n- [Testing Guide](../signals/testing.md)","ref":"stateless.html#see-also"},{"type":"extras","title":"Next Steps - Stateless Agents","doc":"1. Review the [Agent module documentation](https://hexdocs.pm/jido/Jido.Agent.html)\n2. Explore the examples in the [Getting Started Guide](../getting-started.livemd)\n3. Join the [GitHub Discussions](https://github.com/agentjido/jido/discussions)\n\nThis pattern provides a solid foundation for building predictable, maintainable agent workflows while leveraging Jido's core orchestration capabilities.","ref":"stateless.html#next-steps"},{"type":"extras","title":"Stateful Agents","doc":"# Building Stateful Agents in Jido","ref":"stateful.html"},{"type":"extras","title":"Overview - Stateful Agents","doc":"Jido's stateful agents combine the power of Elixir's GenServer with Jido's agent capabilities, providing a robust foundation for building long-running, stateful processes. By implementing `start_link/1`, your agent automatically integrates with OTP supervision trees while maintaining all the workflow orchestration features of Jido.","ref":"stateful.html#overview"},{"type":"extras","title":"Core Design Principles - Stateful Agents","doc":"1. **OTP Integration**: Seamless integration with Elixir's supervision trees\n2. **Signal-Based Communication**: Asynchronous message passing using signals\n3. **State Management**: Server-managed state with validation\n4. **Lifecycle Management**: OTP-compliant process lifecycle","ref":"stateful.html#core-design-principles"},{"type":"extras","title":"Implementation Guide - Stateful Agents","doc":"","ref":"stateful.html#implementation-guide"},{"type":"extras","title":"Basic Agent Structure - Stateful Agents","doc":"```elixir\ndefmodule MyApp.StatefulAgent do\n  use Jido.Agent,\n    name: \"stateful_agent\",\n    description: \"OTP-integrated workflow processor\",\n    actions: [\n      MyApp.Actions.ProcessData,\n      MyApp.Actions.GenerateResponse\n    ]\n\n  # Server startup configuration\n  def start_link(opts) do\n    Jido.Agent.Server.start_link(\n      id: opts[:id],              # Unique identifier\n      agent: __MODULE__,          # This module\n      mode: :auto,                # Execution mode\n      log_level: :debug,          # Logging verbosity\n      routes: [                   # Signal routing\n        {\"process.data\", %Instruction{\n          action: MyApp.Actions.ProcessData,\n          opts: [timeout: 5000]\n        }}\n      ],\n      sensors: [                  # Background processes\n        {MyApp.Sensors.Monitor, []}\n      ],\n      skills: [                   # Additional capabilities\n        MyApp.Skills.DataProcessor\n      ]\n    )\n  end\n\n  # Signal handling\n  def handle_signal(%Signal{type: \"process.data\"} = signal) do\n    {:ok, signal}\n  end\n\n  # Result processing\n  def transform_result(%Signal{type: \"process.data\"}, result) do\n    {:ok, result}\n  end\nend\n```","ref":"stateful.html#basic-agent-structure"},{"type":"extras","title":"Understanding Server Configuration - Stateful Agents","doc":"The `start_link/1` function configures several key aspects:\n\n```elixir\ndef start_link(opts) do\n  Jido.Agent.Server.start_link(\n    # Required configuration\n    id: opts[:id],          # Unique process identifier\n    agent: __MODULE__,      # The agent module itself\n\n    # Execution configuration\n    mode: :auto,            # :auto or :manual execution\n    log_level: :debug,      # Logging verbosity\n    max_queue_size: 1000,   # Maximum pending signals\n\n    # Communication setup\n    routes: [              # Signal routing rules\n      {\"pattern.match\", instruction}\n    ],\n    dispatch: {:logger, []}, # Output configuration\n\n    # Process management\n    registry: MyApp.Registry,  # Process registry\n    sensors: [...],           # Background processes\n    skills: [...]            # Additional capabilities\n  )\nend\n```\n\nFor more details on configuration options, see [Agent Directives](directives.md).","ref":"stateful.html#understanding-server-configuration"},{"type":"extras","title":"Signal Processing Flow - Stateful Agents","doc":"1. **Signal Reception**: Signals arrive via cast/call\n2. **Pattern Matching**: Signal matched against routes\n3. **Instruction Generation**: Matched routes create instructions\n4. **Execution**: Instructions processed by runner\n5. **Result Handling**: Results processed through callbacks\n\nFor more details on signal routing and processing, see [Signal Routing](../signals/routing.md) and [Signal Dispatching](../signals/dispatching.md).","ref":"stateful.html#signal-processing-flow"},{"type":"extras","title":"Interacting with Stateful Agents - Stateful Agents","doc":"```elixir\n# Start the agent under supervision\nchildren = [\n  {MyApp.StatefulAgent, [id: \"agent_1\"]}\n]\nSupervisor.start_link(children, strategy: :one_for_one)\n\n# Send signals to the agent\nsignal = %{\n  type: \"process.data\",\n  data: %{value: 42}\n} |> Signal.new!()\n\n# Synchronous call\n{:ok, result} = MyApp.StatefulAgent.call(\"agent_1\", signal)\n\n# Asynchronous cast\n{:ok, signal_id} = MyApp.StatefulAgent.cast(\"agent_1\", signal)\n```","ref":"stateful.html#interacting-with-stateful-agents"},{"type":"extras","title":"Lifecycle Callbacks - Stateful Agents","doc":"Implement OTP callbacks for lifecycle management:\n\n```elixir\ndefmodule MyApp.StatefulAgent do\n  use Jido.Agent, name: \"lifecycle_agent\"\n\n  # Initialization\n  def mount(state, _opts) do\n    {:ok, state}\n  end\n\n  # Clean shutdown\n  def shutdown(state, reason) do\n    {:ok, state}\n  end\n\n  # Code upgrades\n  def code_change(state, old_vsn, extra) do\n    {:ok, state}\n  end\nend\n```\n\nFor more details on agent callbacks and lifecycle management, see [Agent Callbacks](callbacks.md).","ref":"stateful.html#lifecycle-callbacks"},{"type":"extras","title":"Signal Handling - Stateful Agents","doc":"Customize signal processing through callbacks:\n\n```elixir\ndefmodule MyApp.StatefulAgent do\n  use Jido.Agent, name: \"signal_processor\"\n\n  # Transform incoming signals\n  def handle_signal(%Signal{type: \"custom.event\"} = signal) do\n    transformed_data = transform_data(signal.data)\n    {:ok, %Signal{signal | data: transformed_data}}\n  end\n\n  # Process execution results\n  def transform_result(%Signal{type: \"custom.event\"}, result) do\n    {:ok, process_output(result)}\n  end\nend\n```","ref":"stateful.html#signal-handling"},{"type":"extras","title":"Advanced Patterns - Stateful Agents","doc":"","ref":"stateful.html#advanced-patterns"},{"type":"extras","title":"Dynamic Route Configuration - Stateful Agents","doc":"```elixir\ndef start_link(opts) do\n  routes = [\n    # Basic pattern matching\n    {\"event.basic\", basic_instruction()},\n\n    # With parameters\n    {\"event.params.*\", parameterized_instruction()},\n\n    # Complex matching\n    {fn signal ->\n      String.starts_with?(signal.type, \"custom.\")\n    end, dynamic_instruction()}\n  ]\n\n  Jido.Agent.Server.start_link(\n    id: opts[:id],\n    agent: __MODULE__,\n    routes: routes\n  )\nend\n```","ref":"stateful.html#dynamic-route-configuration"},{"type":"extras","title":"State Management - Stateful Agents","doc":"```elixir\ndefmodule MyApp.StatefulAgent do\n  use Jido.Agent,\n    name: \"state_manager\",\n    schema: [\n      status: [type: :atom, values: [:idle, :processing]],\n      data: [type: :map, default: %{}]\n    ]\n\n  def handle_signal(%Signal{type: \"update.state\"} = signal) do\n    # State updates handled by server\n    {:ok, signal}\n  end\nend\n\n# Update state\n{:ok, _} = MyApp.StatefulAgent.set(\"agent_1\", %{\n  status: :processing,\n  data: %{started_at: DateTime.utc_now()}\n})\n```","ref":"stateful.html#state-management"},{"type":"extras","title":"Integration with Skills - Stateful Agents","doc":"Skills extend agent capabilities:\n\n```elixir\ndefmodule MyApp.Skills.DataProcessor do\n  use Jido.Skill,\n    name: \"data_processor\",\n    signals: %{\n      input: [\"data.process.*\"],\n      output: [\"data.processed.*\"]\n    }\n\n  def handle_signal(%Signal{} = signal) do\n    {:ok, signal}\n  end\n\n  def transform_result(_signal, result) do\n    {:ok, result}\n  end\nend\n\ndefmodule MyApp.StatefulAgent do\n  use Jido.Agent, name: \"skilled_agent\"\n\n  def start_link(opts) do\n    Jido.Agent.Server.start_link(\n      id: opts[:id],\n      agent: __MODULE__,\n      skills: [MyApp.Skills.DataProcessor]\n    )\n  end\nend\n```","ref":"stateful.html#integration-with-skills"},{"type":"extras","title":"Background Processing with Sensors - Stateful Agents","doc":"Sensors provide background processing:\n\n```elixir\ndefmodule MyApp.Sensors.Monitor do\n  use Jido.Sensor,\n    name: \"system_monitor\"\n\n  def start_link(opts) do\n    GenServer.start_link(__MODULE__, opts)\n  end\n\n  def init(opts) do\n    schedule_check()\n    {:ok, opts}\n  end\n\n  def handle_info(:check, state) do\n    # Perform monitoring\n    schedule_check()\n    {:noreply, state}\n  end\n\n  defp schedule_check do\n    Process.send_after(self(), :check, 5000)\n  end\nend\n```\n\nFor more details on implementing sensors, see [Agent Sensors](sensors.md).\n\ndefmodule MyApp.StatefulAgent do\nuse Jido.Agent, name: \"monitored_agent\"\n\ndef start_link(opts) do\nJido.Agent.Server.start_link(\nid: opts[:id],\nagent: **MODULE**,\nsensors: [{MyApp.Sensors.Monitor, []}]\n)\nend\nend\n\n````","ref":"stateful.html#background-processing-with-sensors"},{"type":"extras","title":"Best Practices - Stateful Agents","doc":"1. **Process Registration**\n\n   - Use meaningful, unique IDs\n   - Consider namespacing for large systems\n   - Implement consistent naming conventions\n\n2. **Signal Design**\n\n   - Use hierarchical signal types\n   - Include necessary context in data\n   - Consider signal versioning\n\n3. **Error Handling**\n\n   - Implement proper supervision\n   - Use descriptive error returns\n   - Consider retry strategies\n\n4. **State Management**\n   - Keep state minimal\n   - Validate state transitions\n   - Consider persistence needs","ref":"stateful.html#best-practices"},{"type":"extras","title":"Anti-Patterns to Avoid - Stateful Agents","doc":"1. **Direct State Mutation**\n\n   - Don't bypass signal system\n   - Avoid direct GenServer calls\n   - Use proper state update mechanisms\n\n2. **Complex Signal Processing**\n\n   - Keep signal handling simple\n   - Move complex logic to actions\n   - Use skills for extensions\n\n3. **Blocking Operations**\n   - Avoid long-running handlers\n   - Use async processing\n   - Consider task supervision","ref":"stateful.html#anti-patterns-to-avoid"},{"type":"extras","title":"Testing Strategies - Stateful Agents","doc":"```elixir\ndefmodule MyApp.StatefulAgentTest do\n  use ExUnit.Case\n\n  setup do\n    start_supervised!({MyApp.StatefulAgent, [id: \"test_agent\"]})\n    :ok\n  end\n\n  test \"processes signals correctly\" do\n    signal = Signal.new!(%{\n      type: \"test.event\",\n      data: %{value: 42}\n    })\n\n    assert {:ok, result} = MyApp.StatefulAgent.call(\"test_agent\", signal)\n    assert result.processed == true\n  end\nend\n````\n\nFor comprehensive testing strategies and patterns, see [Signal Testing](../signals/testing.md).","ref":"stateful.html#testing-strategies"},{"type":"extras","title":"See Also - Stateful Agents","doc":"- [Signal Overview](../signals/overview.livemd)\n- [Agent Overview](overview.md)\n- [Agent Routing](routing.md)\n- [Agent Output Configuration](output.md)\n- [Child Processes](child-processes.md)\n- [Runtime Configuration](runtime.md)\n\nThis implementation pattern provides a robust foundation for building distributed, stateful workflows while leveraging Elixir's OTP capabilities.","ref":"stateful.html#see-also"},{"type":"extras","title":"Directives","doc":"# Agent Directives Guide","ref":"directives-6.html"},{"type":"extras","title":"Overview - Directives","doc":"Directives provide a type-safe mechanism for modifying agent behavior and state at runtime. They act as discrete, immutable instructions that tell agents how to change their state or behavior. This guide covers directive types, usage patterns, and state management considerations.","ref":"directives-6.html#overview"},{"type":"extras","title":"Core Concepts - Directives","doc":"Directives in Jido fall into two main categories:\n\n1. **Agent Directives**: Modify the core agent struct and its internal state\n\n   - Queueing instructions\n   - Managing action registrations\n   - State transitions\n\n2. **Server Directives**: Control server behavior in agent processes\n   - Process spawning and termination\n   - Router management\n   - Event subscription","ref":"directives-6.html#core-concepts"},{"type":"extras","title":"Agent Directives - Directives","doc":"","ref":"directives-6.html#agent-directives"},{"type":"extras","title":"Enqueue Directive - Directives","doc":"The most common directive type, used to add new instructions to an agent's pending queue:\n\n```elixir\n%Directive.Enqueue{\n  action: :process_data,\n  params: %{file: \"data.csv\"},\n  context: %{user_id: \"123\"},\n  opts: [retry: true]\n}\n```","ref":"directives-6.html#enqueue-directive"},{"type":"extras","title":"RegisterAction Directive - Directives","doc":"Registers a new action module with the agent:\n\n```elixir\n%Directive.RegisterAction{\n  action_module: MyApp.Actions.ProcessData\n}\n```","ref":"directives-6.html#registeraction-directive"},{"type":"extras","title":"DeregisterAction Directive - Directives","doc":"Removes an action module from the agent:\n\n```elixir\n%Directive.DeregisterAction{\n  action_module: MyApp.Actions.ProcessData\n}\n```","ref":"directives-6.html#deregisteraction-directive"},{"type":"extras","title":"Server Directives - Directives","doc":"","ref":"directives-6.html#server-directives"},{"type":"extras","title":"Spawn Directive - Directives","doc":"Spawns a child process under the agent's supervisor:\n\n```elixir\n%Directive.Spawn{\n  module: MyWorker,\n  args: [id: 1]\n}\n```","ref":"directives-6.html#spawn-directive"},{"type":"extras","title":"Kill Directive - Directives","doc":"Terminates a specific child process:\n\n```elixir\n%Directive.Kill{\n  pid: worker_pid\n}\n```","ref":"directives-6.html#kill-directive"},{"type":"extras","title":"Returning Directives from Actions - Directives","doc":"Actions can return directives in several ways:","ref":"directives-6.html#returning-directives-from-actions"},{"type":"extras","title":"1. Return a Single Directive - Directives","doc":"```elixir\ndefmodule MyAction do\n  use Jido.Action\n\n  def run(_params, _context) do\n    directive = %Directive.Enqueue{\n      action: :next_step,\n      params: %{value: 42}\n    }\n\n    {:ok, %{completed: true}, directive}\n  end\nend\n```","ref":"directives-6.html#1-return-a-single-directive"},{"type":"extras","title":"2. Return Multiple Directives - Directives","doc":"```elixir\ndefmodule ChainedAction do\n  use Jido.Action\n\n  def run(_params, _context) do\n    directives = [\n      %Directive.Enqueue{action: :validate_data},\n      %Directive.Enqueue{action: :process_data},\n      %Directive.Enqueue{action: :save_results}\n    ]\n\n    {:ok, %{chain_started: true}, directives}\n  end\nend\n```","ref":"directives-6.html#2-return-multiple-directives"},{"type":"extras","title":"3. Return Instructions Directly - Directives","doc":"Instructions are automatically converted to Enqueue directives:\n\n```elixir\ndefmodule InstructionAction do\n  use Jido.Action\n\n  def run(_params, _context) do\n    instruction = %Instruction{\n      action: :process_data,\n      params: %{file: \"data.csv\"}\n    }\n\n    {:ok, %{setup_complete: true}, instruction}\n  end\nend\n```","ref":"directives-6.html#3-return-instructions-directly"},{"type":"extras","title":"State Management Considerations - Directives","doc":"","ref":"directives-6.html#state-management-considerations"},{"type":"extras","title":"Stateless Agents - Directives","doc":"Stateless agents ([see Stateless Agents Guide](agents/stateless.md)) handle directives differently:\n\n- Will enqueue instructions but not execute them\n- Return the full queue for external processing\n- Ignore state-modifying directives\n- Maintain immutability guarantees\n\nExample of stateless agent behavior:\n\n```elixir\ndefmodule StatelessAgent do\n  use Jido.Agent,\n    name: \"stateless_example\",\n    state_type: :stateless\n\n  def run(_params, _context) do\n    # Instructions are queued but not executed\n    directive = %Directive.Enqueue{action: :process}\n    {:ok, %{queued: true}, directive}\n  end\nend\n```","ref":"directives-6.html#stateless-agents"},{"type":"extras","title":"Stateful Agents - Directives","doc":"Stateful agents ([see Stateful Agents Guide](agents/stateful.md)) provide full directive support:\n\n- Execute queued instructions\n- Apply state modifications\n- Handle all directive types\n- Maintain execution context\n\nExample of stateful agent behavior:\n\n```elixir\ndefmodule StatefulAgent do\n  use Jido.Agent,\n    name: \"stateful_example\",\n    state_type: :stateful\n\n  def run(_params, _context) do\n    # Instructions are queued and executed\n    directives = [\n      %Directive.Enqueue{action: :validate},\n      %Directive.Enqueue{action: :process},\n      %Directive.RegisterAction{action_module: NewAction}\n    ]\n    {:ok, %{processing: true}, directives}\n  end\nend\n```","ref":"directives-6.html#stateful-agents"},{"type":"extras","title":"Directive Processing - Directives","doc":"When an action returns a directive, it goes through several stages:\n\n1. **Validation**: The directive structure and content are validated\n2. **Classification**: Directives are split into agent and server types\n3. **Application**: Each directive is applied in order\n4. **State Update**: The agent/server state is updated accordingly","ref":"directives-6.html#directive-processing"},{"type":"extras","title":"Validation Rules - Directives","doc":"Each directive type has specific validation rules:\n\n```elixir\n# Enqueue requires a valid action atom\nvalidate_directive(%Enqueue{action: nil})\n  # => {:error, :invalid_action}\n\n# RegisterAction requires a valid module\nvalidate_directive(%RegisterAction{action_module: MyAction})\n  # => :ok\n```","ref":"directives-6.html#validation-rules"},{"type":"extras","title":"Error Handling - Directives","doc":"Directive application uses tagged tuples for consistent error handling:\n\n```elixir\ncase Directive.apply_directives(agent, directives) do\n  {:ok, updated_agent, server_directives} ->\n    # Handle success\n\n  {:error, reason} ->\n    # Handle error\nend\n```","ref":"directives-6.html#error-handling"},{"type":"extras","title":"Best Practices - Directives","doc":"1. **Atomic Changes**\n\n   - Return related directives together\n   - Keep directive changes focused and minimal\n\n2. **Validation**\n\n   - Always validate input parameters\n   - Use strict typing for directive fields\n\n3. **Error Handling**\n\n   - Implement compensation logic for failures\n   - Handle partial directive application\n\n4. **Testing**\n   - Test directive validation\n   - Verify state changes\n   - Check error conditions","ref":"directives-6.html#best-practices"},{"type":"extras","title":"Common Patterns - Directives","doc":"","ref":"directives-6.html#common-patterns"},{"type":"extras","title":"Sequential Operations - Directives","doc":"Chain multiple operations using Enqueue directives:\n\n```elixir\ndirectives = [\n  %Directive.Enqueue{action: :validate_input},\n  %Directive.Enqueue{action: :process_data},\n  %Directive.Enqueue{action: :save_results}\n]\n```","ref":"directives-6.html#sequential-operations"},{"type":"extras","title":"Dynamic Action Registration - Directives","doc":"Register actions based on runtime conditions:\n\n```elixir\ndef run(%{feature_enabled: true} = _params, _context) do\n  directive = %Directive.RegisterAction{\n    action_module: MyApp.Actions.FeatureAction\n  }\n  {:ok, %{}, directive}\nend\n```","ref":"directives-6.html#dynamic-action-registration"},{"type":"extras","title":"Worker Management - Directives","doc":"Manage worker processes with spawn/kill directives:\n\n```elixir\ndef run(%{worker_count: count} = _params, _context) do\n  directives = for i <- 1..count do\n    %Directive.Spawn{\n      module: MyApp.Worker,\n      args: [id: i]\n    }\n  end\n\n  {:ok, %{}, directives}\nend\n```","ref":"directives-6.html#worker-management"},{"type":"extras","title":"Future Considerations - Directives","doc":"The directive system is designed for extensibility. Future directives might include:\n\n- Mode changes\n- Verbosity controls\n- Router management\n- Skill management\n- Dispatcher configuration","ref":"directives-6.html#future-considerations"},{"type":"extras","title":"See Also - Directives","doc":"- [Agent State Management](../agents/stateful.md)\n- [Action Development](overview.md)\n- [Testing Actions](testing.md)","ref":"directives-6.html#see-also"},{"type":"extras","title":"Runtime","doc":"# Agent Runtime\n\n_Part of the \"Agents\" section in the documentation._\n\nThis guide explains the agent runtime system that manages agent lifecycle and execution. It covers runtime configuration, supervision strategies, and how to manage agent processes in production environments.","ref":"runtime.html"},{"type":"extras","title":"Output","doc":"# Agent Signal Output Guide","ref":"output.html"},{"type":"extras","title":"Overview - Output","doc":"Agent signal output provides a comprehensive event and error emission system for tracking agent execution, state changes, and instruction results. The output system ensures consistent monitoring and traceability across your agent-based applications.","ref":"output.html#overview"},{"type":"extras","title":"Output Types - Output","doc":"","ref":"output.html#output-types"},{"type":"extras","title":"1. Event Signals - Output","doc":"Event signals track lifecycle and state transition events within the agent system. Events follow the pattern `jido.agent.event. . `.\n\nCommon event categories include:\n\n#### Process Events\n\n```elixir\n# Process lifecycle events\n\"jido.agent.event.process.started\"     # Process started successfully\n\"jido.agent.event.process.terminated\"  # Process terminated normally\n\"jido.agent.event.process.failed\"      # Process failed to start/execute\n\"jido.agent.event.process.restarted\"   # Process was restarted\n```\n\n#### State Transition Events\n\n```elixir\n\"jido.agent.event.transition.succeeded\"  # State transition completed\n\"jido.agent.event.transition.failed\"     # State transition failed\n```\n\n#### Queue Management Events\n\n```elixir\n\"jido.agent.event.queue.overflow\"  # Queue size exceeded maximum\n\"jido.agent.event.queue.cleared\"   # Queue was emptied\n```","ref":"output.html#1-event-signals"},{"type":"extras","title":"2. Error Signals - Output","doc":"Error signals provide detailed error reporting when operations fail. They follow the pattern `jido.agent.err. . `.\n\n```elixir\n# Common error signal types\n\"jido.agent.err.execution.error\"    # Runtime execution errors\n\"jido.agent.err.validation.error\"   # State/parameter validation errors\n\"jido.agent.err.directive.error\"    # Directive application errors\n```\n\nError signals include:\n\n- Detailed error message\n- Error context and metadata\n- Stack trace when available\n- Related entity IDs (agent, process, etc.)","ref":"output.html#2-error-signals"},{"type":"extras","title":"3. Signal Output - Output","doc":"Signal output represents the results of processing incoming signals. These follow the pattern `jido.agent.out.signal. `.\n\n```elixir\n# Signal output types\n\"jido.agent.out.signal.result\"     # Final signal processing result\n\"jido.agent.out.signal.processed\"  # Signal successfully processed\n\"jido.agent.out.signal.rejected\"   # Signal rejected/invalid\n```","ref":"output.html#3-signal-output"},{"type":"extras","title":"4. Instruction Output - Output","doc":"Instruction output tracks the execution results of individual instructions. These follow the pattern `jido.agent.out.instruction. `.\n\n```elixir\n# Instruction output example\n\"jido.agent.out.instruction.result\"  # Individual instruction result\n```\n\nImportant: When a signal triggers multiple instructions, each instruction generates its own output signal. This provides granular visibility into the execution flow.","ref":"output.html#4-instruction-output"},{"type":"extras","title":"Output Structure - Output","doc":"All output signals contain consistent base fields:\n\n```elixir\n%{\n  id: \"sig_abc123\",           # Unique signal ID\n  type: \"jido.agent. \",  # Signal type\n  source: \"agent:worker_1\",   # Signal origin\n  subject: \"jido://agent/worker_1/abc123\",  # Subject URI\n  time: \"2024-02-11T12:00:00Z\",  # ISO 8601 timestamp\n  data: %{                    # Signal-specific payload\n    result: \"success\",\n    details: %{...}\n  }\n}\n```","ref":"output.html#output-structure"},{"type":"extras","title":"Signal Subject Format - Output","doc":"The `subject` field follows a specific URI format for signals emitted by Jido agents:\n\n```elixir\n\"jido://agent/ / \"\n```\n\nFor example:\n\n- Named agent: `\"jido://agent/data_processor/abc123\"`\n- Anonymous agent: `\"jido://agent/abc123\"` (when no name is specified)\n\nThis subject field is automatically set by the agent when emitting signals, ensuring consistent identification and routing. The agent's name and ID are preserved across all signals it emits, making it easier to:\n\n- Track signal chains through the system\n- Filter and route signals by agent\n- Associate related events and outputs\n- Debug issues across distributed deployments","ref":"output.html#signal-subject-format"},{"type":"extras","title":"Example Flow - Output","doc":"Here's how different output types work together during execution:\n\n```elixir\n# 1. Agent receives signal with multiple instructions\nsignal = %Signal{\n  type: \"process.data\",\n  data: %{items: [1, 2, 3]}\n}\n\n# 2. Event signals emitted for processing\n\"jido.agent.event.started\"              # Agent starts processing\n\"jido.agent.event.transition.succeeded\" # State transition to :running\n\n# 3. Individual instruction outputs\n\"jido.agent.out.instruction.result\"     # ValidateData result\n\"jido.agent.out.instruction.result\"     # ProcessItems result\n\"jido.agent.out.instruction.result\"     # SaveResults result\n\n# 4. Final signal output\n\"jido.agent.out.signal.result\"          # Overall processing result\n\n# 5. Completion events\n\"jido.agent.event.transition.succeeded\" # State transition to :idle\n```","ref":"output.html#example-flow"},{"type":"extras","title":"Best Practices - Output","doc":"","ref":"output.html#best-practices"},{"type":"extras","title":"1. Output Handling - Output","doc":"- Subscribe to relevant output types based on monitoring needs\n- Implement proper error handling for each output type\n- Consider output persistence for audit trails\n- Use structured logging for output signals","ref":"output.html#1-output-handling"},{"type":"extras","title":"2. Signal Design - Output","doc":"- Keep payloads focused and relevant\n- Include necessary context in metadata\n- Use consistent naming conventions\n- Follow type-specific patterns","ref":"output.html#2-signal-design"},{"type":"extras","title":"3. Monitoring - Output","doc":"- Track error rates by type\n- Monitor queue sizes and overflow events\n- Alert on critical state transitions\n- Analyze instruction completion patterns\n- Set up dashboards for key metrics","ref":"output.html#3-monitoring"},{"type":"extras","title":"4. Error Handling - Output","doc":"```elixir\n# Implement comprehensive error handling\ncase handle_signal(signal) do\n  {:ok, result} ->\n    # Normal output handling\n    emit_output(\"jido.agent.out.signal.result\", result)\n\n  {:error, reason} ->\n    # Error output handling\n    emit_error(\"jido.agent.err.execution.error\", %{\n      reason: reason,\n      signal_id: signal.id,\n      context: get_error_context()\n    })\nend\n```","ref":"output.html#4-error-handling"},{"type":"extras","title":"Testing Output - Output","doc":"```elixir\ndefmodule OutputTest do\n  use ExUnit.Case\n\n  test \"emits instruction results\" do\n    {:ok, agent} = MyAgent.new()\n\n    # Execute multi-instruction signal\n    {:ok, _result} = MyAgent.process([\n      ValidateAction,\n      ProcessAction,\n      SaveAction\n    ])\n\n    # Assert output signals\n    assert_receive {:signal, %{type: \"jido.agent.out.instruction.result\"}}\n    assert_receive {:signal, %{type: \"jido.agent.out.instruction.result\"}}\n    assert_receive {:signal, %{type: \"jido.agent.out.instruction.result\"}}\n  end\n\n  test \"handles errors appropriately\" do\n    {:ok, agent} = MyAgent.new()\n\n    # Trigger error condition\n    {:error, _reason} = MyAgent.process(InvalidAction)\n\n    # Assert error output\n    assert_receive {:signal, %{\n      type: \"jido.agent.err.execution.error\",\n      data: %{reason: :invalid_action}\n    }}\n  end\nend\n```","ref":"output.html#testing-output"},{"type":"extras","title":"See Also - Output","doc":"- [Signal Overview](../signals/overview.livemd)\n- [Signal Testing](../signals/testing.md)\n- [Agent Testing](../signals/testing.md)\n- [Signal Dispatching](../signals/dispatching.md)","ref":"output.html#see-also"},{"type":"extras","title":"Routing","doc":"# Agent Routing","ref":"routing.html"},{"type":"extras","title":"Overview - Routing","doc":"Agent routing in Jido provides a flexible mechanism for directing signals to agents and handling their responses. While agents have predefined command signal types for core operations, they primarily interact through a generic `call/cast` interface that supports custom signal routing.","ref":"routing.html#overview"},{"type":"extras","title":"Core Concepts - Routing","doc":"- **Signal Types**: Predefined and custom message formats\n- **Call/Cast Interface**: Synchronous and asynchronous messaging\n- **Router Configuration**: Pattern-based signal routing\n- **Signal Dispatch**: Configurable output handling","ref":"routing.html#core-concepts"},{"type":"extras","title":"Default Signal Types - Routing","doc":"Jido provides default command signal types for core agent operations:\n\n```elixir\n# Server-defined command signals\n@cmd_state \"jido.agent.cmd.state\"         # Get agent state\n@cmd_queue_size \"jido.agent.cmd.queuesize\" # Check queue size\n@cmd_set \"jido.agent.cmd.set\"             # Update agent state\n@cmd_validate \"jido.agent.cmd.validate\"    # Validate agent state\n@cmd_plan \"jido.agent.cmd.plan\"           # Plan new actions\n@cmd_run \"jido.agent.cmd.run\"             # Execute pending actions\n@cmd_cmd \"jido.agent.cmd.cmd\"             # Combined plan+run\n```","ref":"routing.html#default-signal-types"},{"type":"extras","title":"Call/Cast Interface - Routing","doc":"The primary method for interacting with agents is through the `call/cast` interface:\n\n```elixir\n# Synchronous call (waits for response)\ndef call(agent, signal, timeout \\\\ 5000) do\n  with {:ok, pid} <- Jido.resolve_pid(agent) do\n    case GenServer.call(pid, {:signal, signal}, timeout) do\n      {:ok, response} -> {:ok, response}\n      other -> other\n    end\n  end\nend\n\n# Asynchronous cast (fire and forget)\ndef cast(agent, signal) do\n  with {:ok, pid} <- Jido.resolve_pid(agent) do\n    GenServer.cast(pid, {:signal, signal})\n    {:ok, signal.id}\n  end\nend\n```","ref":"routing.html#call-cast-interface"},{"type":"extras","title":"Using Call/Cast - Routing","doc":"```elixir\n# Create a signal\nsignal = %Signal{\n  type: \"custom.event\",\n  data: %{value: 42}\n}\n\n# Synchronous request (waits for response)\n{:ok, result} = MyAgent.call(agent, signal)\n\n# Asynchronous request (returns immediately)\n{:ok, signal_id} = MyAgent.cast(agent, signal)\n```","ref":"routing.html#using-call-cast"},{"type":"extras","title":"Router Configuration - Routing","doc":"Agents use the `Jido.Signal.Router` module to handle signal routing. Routers can be configured with pattern-based routes:\n\n```elixir\n# Configure agent with routes by overriding start_link\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"my_agent\"\n\n  def start_link(opts \\\\ []) do\n    # Define routes for the agent\n    routes = [\n      {\"custom.event\", HandleCustomEvent},\n      {\"metrics.*\", CollectMetrics},\n      {\"audit.**\", AuditLog}\n    ]\n\n    # Pass routes to Agent.Server.start_link\n    opts = Keyword.merge(opts, [routes: routes])\n    Agent.Server.start_link(opts)\n  end\nend\n\n# Add routes at runtime\n{:ok, agent} = Server.Router.add(agent, [\n  {\"user.created\", HandleUserCreated},\n  {\"payment.processed\", HandlePayment}\n])\n```\n\nSee the [Signal Routing](signals/routing.md) guide for detailed pattern matching syntax.","ref":"routing.html#router-configuration"},{"type":"extras","title":"Signal Dispatch and Response Correlation - Routing","doc":"Agents handle signal dispatch configuration and response correlation through a robust mechanism that ensures message traceability.","ref":"routing.html#signal-dispatch-and-response-correlation"},{"type":"extras","title":"Dispatch Configuration - Routing","doc":"Dispatch options must be configured by overriding the agent's `start_link` function:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"my_agent\"\n\n  def start_link(opts \\\\ []) do\n    # Configure dispatch options\n    dispatch_opts = [\n      {:pubsub, [topic: \"events\"]},\n      {:logger, [level: :info]}\n    ]\n\n    opts = Keyword.merge(opts, [dispatch: dispatch_opts])\n    Agent.Server.start_link(opts)\n  end\nend\n```","ref":"routing.html#dispatch-configuration"},{"type":"extras","title":"Response Correlation - Routing","doc":"When an agent processes a signal and broadcasts responses, it automatically correlates responses with the originating request by:\n\n1. Setting the response's `source` field to the original signal's `id`\n2. Maintaining the correlation through broadcast chains\n3. Enabling response tracking and request-response mapping\n\n```elixir\n# Original request signal\nrequest = %Signal{\n  id: \"req_123\",\n  type: \"get.user.data\",\n  data: %{user_id: \"456\"}\n}\n\n# Response signal (automatically correlated)\nresponse = %Signal{\n  id: \"resp_789\",\n  type: \"user.data.retrieved\",\n  source: \"req_123\",  # References original request ID\n  data: %{user: user_data}\n}\n```\n\nThis correlation mechanism enables:\n\n- Request-response tracking\n- Response aggregation\n- Event chain reconstruction\n- Debugging and monitoring\n\nSee the [Signal Output](agents/output.md) guide for detailed information about signal response handling and output patterns.","ref":"routing.html#response-correlation"},{"type":"extras","title":"Best Practices - Routing","doc":"","ref":"routing.html#best-practices"},{"type":"extras","title":"1. Signal Design - Routing","doc":"- Use consistent naming patterns for signal types\n- Include relevant context in signal data\n- Consider response format requirements\n\n```elixir\n# Good signal design\nsignal = %Signal{\n  type: \"order.payment.processed\",\n  source: \"/payments\",\n  data: %{\n    order_id: \"123\",\n    amount: 99.99,\n    currency: \"USD\"\n  }\n}\n```","ref":"routing.html#1-signal-design"},{"type":"extras","title":"2. Route Organization - Routing","doc":"- Group related routes together\n- Use specific routes before wildcards\n- Document routing patterns\n\n```elixir\n# Organized routes with priority\nroutes = [\n  # High priority exact matches\n  {\"payment.processed\", HandlePayment},\n\n  # Domain-specific patterns\n  {\"order.*.updated\", HandleOrderUpdate},\n\n  # Catch-all audit logging\n  {\"audit.**\", AuditLog}\n]\n```","ref":"routing.html#2-route-organization"},{"type":"extras","title":"3. Error Handling - Routing","doc":"- Implement comprehensive error handling\n- Use timeouts appropriately\n- Log routing failures\n\n```elixir\ndef handle_payment(signal) do\n  case MyAgent.call(agent, signal, timeout: 10_000) do\n    {:ok, result} ->\n      handle_success(result)\n\n    {:error, :timeout} ->\n      handle_timeout(signal)\n\n    {:error, reason} ->\n      log_error(signal, reason)\n  end\nend\n```","ref":"routing.html#3-error-handling"},{"type":"extras","title":"Common Patterns - Routing","doc":"","ref":"routing.html#common-patterns"},{"type":"extras","title":"1. Request-Response - Routing","doc":"```elixir\n# Client sends request\nrequest = %Signal{\n  type: \"get.user.profile\",\n  data: %{user_id: \"123\"},\n  jido_dispatch: {:pid, [target: self()]}\n}\n\n{:ok, response} = MyAgent.call(agent, request)\n```","ref":"routing.html#1-request-response"},{"type":"extras","title":"2. Event Broadcasting - Routing","doc":"```elixir\n# Broadcast event to multiple subscribers\nevent = %Signal{\n  type: \"user.registered\",\n  data: %{user_id: \"123\"},\n  jido_dispatch: [\n    {:pubsub, [topic: \"users\"]},\n    {:bus, [stream: \"audit\"]}\n  ]\n}\n\nMyAgent.cast(agent, event)\n```","ref":"routing.html#2-event-broadcasting"},{"type":"extras","title":"3. Chain Processing - Routing","doc":"```elixir\n# Chain multiple agents\nprocess_order = fn order ->\n  with {:ok, validated} <- ValidatorAgent.call(order),\n       {:ok, processed} <- ProcessorAgent.call(validated),\n       {:ok, _stored} <- StorageAgent.call(processed) do\n    {:ok, :completed}\n  end\nend\n```","ref":"routing.html#3-chain-processing"},{"type":"extras","title":"Testing - Routing","doc":"```elixir\ndefmodule AgentRoutingTest do\n  use ExUnit.Case\n\n  test \"routes signals correctly\" do\n    signal = %Signal{type: \"test.event\", data: %{value: 42}}\n\n    # Test synchronous routing\n    assert {:ok, result} = MyAgent.call(agent, signal)\n    assert result.processed == true\n\n    # Test async routing\n    assert {:ok, _id} = MyAgent.cast(agent, signal)\n    assert_receive {:signal, response}, 1000\n  end\n\n  test \"handles routing errors\" do\n    bad_signal = %Signal{type: \"invalid\"}\n    assert {:error, _} = MyAgent.call(agent, bad_signal)\n  end\nend\n```","ref":"routing.html#testing"},{"type":"extras","title":"See Also - Routing","doc":"- [Signal Overview](signals/overview.md)\n- [Signal Routing](signals/routing.md)\n- [Signal Dispatching](signals/dispatching.md)\n- [Signal Bus](signals/bus.md)","ref":"routing.html#see-also"},{"type":"extras","title":"Sensors","doc":"# Agent Sensors in Jido","ref":"sensors.html"},{"type":"extras","title":"Overview - Sensors","doc":"Sensors provide a mechanism for monitoring and responding to external events in Jido's agent system. They act as event producers that dispatch signals back to their parent agent, enabling reactive behavior patterns.\n\nLearn more about [sensors](sensors/overview.md) in the sensors guide. This guide is focused on how Agents utilize Sensors to monitor and respond to external events.","ref":"sensors.html#overview"},{"type":"extras","title":"Core Concepts - Sensors","doc":"- Sensors are initialized during agent server startup\n- Each sensor receives the agent's PID as its target\n- Sensors automatically dispatch signals back to their parent agent\n- Multiple sensors can be configured per agent","ref":"sensors.html#core-concepts"},{"type":"extras","title":"Basic Configuration - Sensors","doc":"The simplest way to add sensors to an agent is through the `:sensors` option when starting the server:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"my_agent\"\n\n\n  def start_link(opts) do\n    # Start agent with sensors\n    {:ok, pid} = Jido.Agent.Server.start_link(\n      child_spec: [\n        {Jido.Sensors.Heartbeat, interval: 5000},\n        {Jido.Sensors.FileWatcher, path: \"/tmp/watch\"}\n      ]\n    )\n  end\nend\n```\n\n```\n\n```","ref":"sensors.html#basic-configuration"},{"type":"extras","title":"Callbacks","doc":"# Agent Callbacks","ref":"callbacks.html"},{"type":"extras","title":"Overview - Callbacks","doc":"Jido Agents provide a rich set of callbacks that allow you to customize behavior at key lifecycle points. These callbacks enable you to implement custom validation logic, manage state transitions, handle errors, and control execution flow.","ref":"callbacks.html#overview"},{"type":"extras","title":"Core Callbacks - Callbacks","doc":"","ref":"callbacks.html#core-callbacks"},{"type":"extras","title":"Lifecycle Management - Callbacks","doc":"#### `mount/2`\n\nCalled when the agent server starts up. Use this callback to perform initialization tasks.\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"my_agent\",\n    schema: [status: [type: :atom]]\n\n  def mount(state, _opts) do\n    # Initialize connections, load configs, etc.\n    {:ok, state}\n  end\nend\n```\n\n#### `shutdown/2`\n\nCalled when the agent server is stopping. Use this for cleanup tasks.\n\n```elixir\ndef shutdown(state, reason) do\n  Logger.info(\"Agent shutting down\", reason: reason)\n  cleanup_resources(state)\n  {:ok, state}\nend\n```","ref":"callbacks.html#lifecycle-management"},{"type":"extras","title":"State Management - Callbacks","doc":"#### `on_before_validate_state/1`\n\nCalled before validating any state changes. Useful for preprocessing state attributes.\n\n```elixir\ndef on_before_validate_state(agent) do\n  # Preprocess state before validation\n  updated_state = Map.update(agent.state, :status, :pending, fn\n    nil -> :pending\n    other -> other\n  end)\n\n  {:ok, %{agent | state: updated_state}}\nend\n```\n\n#### `on_after_validate_state/1`\n\nCalled after state validation but before saving changes.\n\n```elixir\ndef on_after_validate_state(agent) do\n  # Post-process validated state\n  if agent.state.status == :completed do\n    {:ok, clear_temporary_data(agent)}\n  else\n    {:ok, agent}\n  end\nend\n```","ref":"callbacks.html#state-management"},{"type":"extras","title":"Execution Control - Callbacks","doc":"#### `on_before_plan/3`\n\nCalled before planning actions. Allows preprocessing of instructions.\n\n```elixir\ndef on_before_plan(agent, instructions, context) do\n  # Add metadata to context\n  enhanced_context = Map.put(context, :planned_at, DateTime.utc_now())\n\n  case validate_instructions(instructions) do\n    :ok -> {:ok, agent, enhanced_context}\n    {:error, reason} -> {:error, reason}\n  end\nend\n```\n\n#### `on_before_run/1`\n\nCalled before executing planned actions.\n\n```elixir\ndef on_before_run(agent) do\n  case check_preconditions(agent) do\n    :ok -> {:ok, agent}\n    {:error, reason} -> {:error, reason}\n  end\nend\n```\n\n#### `on_after_run/3`\n\nCalled after action execution completes.\n\n```elixir\ndef on_after_run(agent, result, unapplied_directives) do\n  # Process execution results\n  agent = update_execution_stats(agent, result)\n\n  case length(unapplied_directives) do\n    0 -> {:ok, agent}\n    n -> Logger.warning(\"#{n} directives not applied\")\n         {:ok, agent}\n  end\nend\n```","ref":"callbacks.html#execution-control"},{"type":"extras","title":"Error Handling - Callbacks","doc":"#### `on_error/2`\n\nCalled when errors occur during execution.\n\n```elixir\ndef on_error(agent, reason) do\n  Logger.error(\"Agent error\", error: reason)\n\n  updated_agent = %{agent |\n    state: %{agent.state | status: :error},\n    result: %{error: reason}\n  }\n\n  {:ok, updated_agent}\nend\n```","ref":"callbacks.html#error-handling"},{"type":"extras","title":"Signal Processing - Callbacks","doc":"#### `handle_signal/1`\n\nProcesses incoming signals before routing.\n\n```elixir\ndef handle_signal(signal) do\n  case validate_signal_format(signal) do\n    :ok ->\n      enhanced_signal = add_metadata(signal)\n      {:ok, enhanced_signal}\n    {:error, reason} ->\n      {:error, reason}\n  end\nend\n```\n\n#### `transform_result/2`\n\nProcesses results before returning them.\n\n```elixir\ndef transform_result(signal, result) do\n  case result do\n    {:ok, data} ->\n      processed = transform_result(data)\n      {:ok, processed}\n    {:error, _} = error ->\n      error\n  end\nend\n```","ref":"callbacks.html#signal-processing"},{"type":"extras","title":"Common Patterns - Callbacks","doc":"","ref":"callbacks.html#common-patterns"},{"type":"extras","title":"State Preprocessing - Callbacks","doc":"```elixir\ndefmodule PreprocessingAgent do\n  use Jido.Agent,\n    name: \"preprocessing_agent\",\n    schema: [\n      input: [type: :string],\n      processed: [type: :string]\n    ]\n\n  def on_before_validate_state(agent) do\n    # Ensure input is preprocessed before validation\n    case agent.state do\n      %{input: input, processed: nil} when not is_nil(input) ->\n        processed = String.trim(input)\n        {:ok, put_in(agent.state.processed, processed)}\n\n      _ ->\n        {:ok, agent}\n    end\n  end\nend\n```","ref":"callbacks.html#state-preprocessing"},{"type":"extras","title":"Execution Guards - Callbacks","doc":"```elixir\ndefmodule GuardedAgent do\n  use Jido.Agent,\n    name: \"guarded_agent\",\n    schema: [status: [type: :atom]]\n\n  def on_before_run(agent) do\n    case agent.state.status do\n      :ready ->\n        {:ok, agent}\n\n      :locked ->\n        {:error, \"Agent is locked\"}\n\n      other ->\n        {:error, \"Invalid status: #{other}\"}\n    end\n  end\nend\n```","ref":"callbacks.html#execution-guards"},{"type":"extras","title":"Result Transformation - Callbacks","doc":"```elixir\ndefmodule TransformingAgent do\n  use Jido.Agent,\n    name: \"transforming_agent\"\n\n  def transform_result(_signal, {:ok, result}) do\n    transformed = %{\n      data: result,\n      processed_at: DateTime.utc_now(),\n      format_version: \"1.0\"\n    }\n\n    {:ok, transformed}\n  end\n\n  def transform_result(_signal, {:error, _} = error), do: error\nend\n```","ref":"callbacks.html#result-transformation"},{"type":"extras","title":"Comprehensive Error Recovery - Callbacks","doc":"```elixir\ndefmodule RecoveringAgent do\n  use Jido.Agent,\n    name: \"recovering_agent\",\n    schema: [\n      status: [type: :atom],\n      retry_count: [type: :integer, default: 0],\n      last_error: [type: :map]\n    ]\n\n  def on_error(agent, reason) do\n    agent = update_in(agent.state.retry_count, &(&1 + 1))\n\n    if agent.state.retry_count <= 3 do\n      # Attempt recovery\n      {:ok, %{agent |\n        state: %{agent.state |\n          status: :retrying,\n          last_error: %{\n            reason: reason,\n            timestamp: DateTime.utc_now()\n          }\n        }\n      }}\n    else\n      # Give up after 3 retries\n      {:ok, %{agent |\n        state: %{agent.state |\n          status: :failed\n        }\n      }}\n    end\n  end\nend\n```","ref":"callbacks.html#comprehensive-error-recovery"},{"type":"extras","title":"Best Practices - Callbacks","doc":"1. **Keep Callbacks Focused**\n\n   - Each callback should have a single responsibility\n   - Complex logic should be moved to private functions\n   - Return values should be consistent\n\n2. **Handle All Error Cases**\n\n   - Use pattern matching for different error scenarios\n   - Provide meaningful error messages\n   - Consider implementing recovery strategies\n\n3. **State Management**\n\n   - Validate state changes thoroughly\n   - Use schema validations for type safety\n   - Keep state transitions explicit\n\n4. **Performance Considerations**\n\n   - Avoid blocking operations in callbacks\n   - Keep preprocessing lightweight\n   - Consider using Task for heavy operations\n\n5. **Logging and Monitoring**\n   - Log important state transitions\n   - Include relevant context in logs\n   - Use appropriate log levels","ref":"callbacks.html#best-practices"},{"type":"extras","title":"See Also - Callbacks","doc":"- [Agent State Management](state.html)\n- [Agent Configuration](configuration.html)\n- [Error Handling](error-handling.html)\n- [Testing Agents](testing.html)","ref":"callbacks.html#see-also"},{"type":"extras","title":"Child Processes","doc":"# Child Processes in Jido Agents","ref":"child-processes.html"},{"type":"extras","title":"Overview - Child Processes","doc":"Jido agents are built on top of DynamicSupervisor, allowing them to dynamically spawn and manage child processes at runtime. This capability enables agents to coordinate complex distributed workflows by managing a hierarchy of worker processes, including other agents.","ref":"child-processes.html#overview"},{"type":"extras","title":"Core Concepts - Child Processes","doc":"- Each agent has its own DynamicSupervisor\n- Child processes can be any valid OTP process\n- Processes can be spawned directly or via directives\n- Child process lifecycle is tied to the parent agent\n- Automatic cleanup on process termination","ref":"child-processes.html#core-concepts"},{"type":"extras","title":"Basic Child Process Management - Child Processes","doc":"","ref":"child-processes.html#basic-child-process-management"},{"type":"extras","title":"Starting Child Processes Directly - Child Processes","doc":"The most straightforward way to start child processes is through the agent's supervisor:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"process_manager\",\n    description: \"Manages worker processes\"\n\n  def start_worker(agent, worker_module, args) do\n    case DynamicSupervisor.start_child(\n      agent.child_supervisor,\n      {worker_module, args}\n    ) do\n      {:ok, pid} -> {:ok, pid}\n      {:error, reason} -> {:error, reason}\n    end\n  end\nend\n\n# Usage\n{:ok, agent} = MyAgent.new()\n{:ok, worker_pid} = MyAgent.start_worker(agent, MyWorker, [id: 1])\n```","ref":"child-processes.html#starting-child-processes-directly"},{"type":"extras","title":"Using Child Specifications - Child Processes","doc":"For more control, define explicit child specifications:\n\n```elixir\ndefmodule MyAgent do\n  use Jido.Agent,\n    name: \"process_manager\"\n\n  def start_with_spec(agent) do\n    child_spec = %{\n      id: MyWorker,\n      start: {MyWorker, :start_link, [[id: 1]]},\n      restart: :temporary,\n      shutdown: 5000,\n      type: :worker\n    }\n\n    DynamicSupervisor.start_child(agent.child_supervisor, child_spec)\n  end\nend\n```","ref":"child-processes.html#using-child-specifications"},{"type":"extras","title":"Using Directives - Child Processes","doc":"While direct process management works, the recommended approach is using Jido's directive system. This provides better encapsulation and integration with the agent's lifecycle management.","ref":"child-processes.html#using-directives"},{"type":"extras","title":"Spawn Directive - Child Processes","doc":"The `Spawn` directive handles process creation:\n\n```elixir\ndefmodule ProcessManagementAction do\n  use Jido.Action,\n    name: \"manage_processes\",\n    description: \"Manages worker processes\"\n\n  def run(_params, _context) do\n    # Create spawn directive\n    directive = %Jido.Agent.Directive.Spawn{\n      module: MyWorker,\n      args: [id: 1]\n    }\n\n    {:ok, %{spawned: true}, directive}\n  end\nend\n```","ref":"child-processes.html#spawn-directive"},{"type":"extras","title":"Kill Directive - Child Processes","doc":"The `Kill` directive handles process termination:\n\n```elixir\ndefmodule TerminateWorkerAction do\n  use Jido.Action,\n    name: \"terminate_worker\",\n    description: \"Terminates a worker process\"\n\n  def run(%{worker_pid: pid}, _context) do\n    directive = %Jido.Agent.Directive.Kill{\n      pid: pid\n    }\n\n    {:ok, %{terminated: true}, directive}\n  end\nend\n```","ref":"child-processes.html#kill-directive"},{"type":"extras","title":"Managing Child Agents - Child Processes","doc":"Agents can spawn other agents as child processes, creating hierarchical agent networks:\n\n```elixir\ndefmodule ParentAgent do\n  use Jido.Agent,\n    name: \"parent_agent\"\n\n  def spawn_child_agent(agent, child_module, opts \\\\ []) do\n    child_spec = %{\n      id: child_module,\n      start: {child_module, :start_link, [opts]},\n      restart: :temporary\n    }\n\n    DynamicSupervisor.start_child(agent.child_supervisor, child_spec)\n  end\nend\n\n# Usage\n{:ok, parent} = ParentAgent.new()\n{:ok, child_pid} = ParentAgent.spawn_child_agent(parent, ChildAgent, id: \"child_1\")\n```","ref":"child-processes.html#managing-child-agents"},{"type":"extras","title":"Child Agent Directives - Child Processes","doc":"Use directives to manage child agents through the agent system:\n\n```elixir\ndefmodule SpawnChildAgentAction do\n  use Jido.Action,\n    name: \"spawn_child_agent\",\n    schema: [\n      agent_module: [type: :atom, required: true],\n      agent_id: [type: :string, required: true]\n    ]\n\n  def run(%{agent_module: module, agent_id: id}, _context) do\n    directive = %Jido.Agent.Directive.Spawn{\n      module: module,\n      args: [id: id]\n    }\n\n    {:ok, %{child_spawned: true}, directive}\n  end\nend\n```","ref":"child-processes.html#child-agent-directives"},{"type":"extras","title":"Process Monitoring - Child Processes","doc":"Agents automatically monitor their child processes and receive notifications when they terminate:\n\n```elixir\ndefmodule MonitoredAgent do\n  use Jido.Agent,\n    name: \"monitored_agent\"\n\n  def handle_signal(%Signal{type: \"jido.agent.event.process.terminated\"} = signal) do\n    # Handle process termination\n    Logger.info(\"Process terminated: #{inspect(signal.data.pid)}\")\n    {:ok, signal}\n  end\nend\n```","ref":"child-processes.html#process-monitoring"},{"type":"extras","title":"Best Practices - Child Processes","doc":"1. **Use Directives**: Prefer directives over direct process management for better integration\n2. **Handle Termination**: Implement proper cleanup in process termination handlers\n3. **Monitor Health**: Track process status through the agent's monitoring system\n4. **Limit Hierarchy**: Keep agent hierarchies shallow to manage complexity\n5. **Resource Management**: Consider memory and CPU impact when spawning processes","ref":"child-processes.html#best-practices"},{"type":"extras","title":"Error Handling - Child Processes","doc":"Implement comprehensive error handling for process operations:\n\n```elixir\ndefmodule ResilientAgent do\n  use Jido.Agent,\n    name: \"resilient_agent\"\n\n  def handle_signal(%Signal{type: \"jido.agent.event.process.failed\"} = signal) do\n    # Handle process failure\n    %{error: reason, child_spec: spec} = signal.data\n\n    Logger.error(\"Process failed\",\n      error: reason,\n      spec: spec\n    )\n\n    # Attempt recovery\n    case recover_failed_process(spec) do\n      {:ok, _pid} -> {:ok, signal}\n      {:error, _} -> {:error, \"Recovery failed\"}\n    end\n  end\n\n  defp recover_failed_process(spec) do\n    # Implement recovery logic\n  end\nend\n```","ref":"child-processes.html#error-handling"},{"type":"extras","title":"Testing - Child Processes","doc":"Test process management thoroughly:\n\n```elixir\ndefmodule ProcessManagementTest do\n  use ExUnit.Case\n\n  test \"spawns and terminates child process\" do\n    {:ok, agent} = TestAgent.new()\n\n    {:ok, pid} = TestAgent.start_worker(agent, TestWorker, [])\n    assert Process.alive?(pid)\n\n    :ok = TestAgent.terminate_worker(agent, pid)\n    refute Process.alive?(pid)\n  end\n\n  test \"handles process failure\" do\n    {:ok, agent} = TestAgent.new()\n\n    # Test failure handling\n    {:ok, pid} = TestAgent.start_worker(agent, CrashingWorker, [])\n    ref = Process.monitor(pid)\n\n    # Trigger crash\n    send(pid, :crash)\n\n    assert_receive {:DOWN, ^ref, :process, ^pid, _}\n    # Verify agent handled failure\n    assert_receive {:signal, %{type: \"jido.agent.event.process.failed\"}}\n  end\nend\n```","ref":"child-processes.html#testing"},{"type":"extras","title":"See Also - Child Processes","doc":"- [Directives Guide](directives.html) - Detailed information about the directive system\n- [Agent Runtime Guide](runtime.html) - Understanding agent runtime behavior\n- [Testing Guide](testing.html) - Comprehensive testing strategies","ref":"child-processes.html#see-also"},{"type":"extras","title":"Overview","doc":"# Skills Overview","ref":"overview-7.html"},{"type":"extras","title":"Introduction - Overview","doc":"Skills are a module to group a set of Routing rules, Sensors and Actions into a Plugin of functionality for a Jido Agent. As your agents grow and get more sophisticated, the intent is to support just adding a \"Chat Skill\" or \"Database Skill\" to an Agent that accepts a few customization parameters - empowering your agent with a useful set of functionality very easily.\n\nA Skill encapsulates:\n\n- Signal routing and handling patterns\n- State management and isolation\n- Process supervision\n- Configuration management\n- Runtime adaptation","ref":"overview-7.html#introduction"},{"type":"extras","title":"Core Concepts - Overview","doc":"","ref":"overview-7.html#core-concepts"},{"type":"extras","title":"1. Skill Structure - Overview","doc":"A Skill is defined by creating a module that uses the `use Jido.Skill` macro.\n\n```elixir\ndefmodule MyApp.WeatherMonitorSkill do\n  use Jido.Skill,\n    name: \"weather_monitor\",\n    description: \"Monitors weather conditions and generates alerts\",\n    category: \"monitoring\",\n    tags: [\"weather\", \"alerts\"],\n    vsn: \"1.0.0\",\n    # An optional schema key to namespace the skill's state\n    opts_key: :weather,\n    # An optional list of signals the skill will handle\n    signals: [\n      input: [\"weather.data.received\", \"weather.alert.*\"],\n      output: [\"weather.alert.generated\"]\n    ],\n    # An optional configuration schema for the skill\n    config: [\n      weather_api: [\n        type: :map,\n        required: true,\n        doc: \"Weather API configuration\"\n      ]\n    ]\nend\n```\n\nLet's break down each component:\n\n- `name`: Unique identifier for the skill (required)\n- `description`: Human-readable explanation of the skill's purpose\n- `category`: Broad classification for organization\n- `tags`: List of searchable tags\n- `vsn`: Version string for compatibility checking\n- `opts_key`: Atom key for state namespace isolation\n- `signals`: Input/output signal patterns the skill handles\n- `config`: Configuration schema for validation","ref":"overview-7.html#1-skill-structure"},{"type":"extras","title":"2. State Management - Overview","doc":"Skills use `opts_key` for state namespace isolation. This prevents different skills from accidentally interfering with each other's state:\n\n```elixir\ndef initial_state do\n  %{\n    current_conditions: nil,\n    alert_history: [],\n    last_update: nil\n  }\nend\n```\n\nThis state will be stored under the skill's `opts_key` in the agent's state map:\n\n```elixir\n%{\n  weather: %{  # Matches opts_key\n    current_conditions: nil,\n    alert_history: [],\n    last_update: nil\n  }\n}\n```","ref":"overview-7.html#2-state-management"},{"type":"extras","title":"3. Signal Routing - Overview","doc":"Skills define signal routing patterns using a combination of exact matches, wildcards, and pattern matching functions:\n\n```elixir\ndef router do\n  [\n    # High priority alerts\n    %{\n      path: \"weather.alert.**\",\n      instruction: %{\n        action: Actions.GenerateWeatherAlert\n      },\n      priority: 100\n    },\n\n    # Process incoming data\n    %{\n      path: \"weather.data.received\",\n      instruction: %{\n        action: Actions.ProcessWeatherData\n      }\n    },\n\n    # Match severe conditions\n    %{\n      path: \"weather.condition.*\",\n      match: fn signal ->\n        get_in(signal.data, [:severity]) >= 3\n      end,\n      instruction: %{\n        action: Actions.GenerateWeatherAlert\n      },\n      priority: 75\n    }\n  ]\nend\n```","ref":"overview-7.html#3-signal-routing"},{"type":"extras","title":"Building Skills - Overview","doc":"","ref":"overview-7.html#building-skills"},{"type":"extras","title":"Step 1: Define the Skill Module - Overview","doc":"```elixir\ndefmodule MyApp.DataProcessingSkill do\n  use Jido.Skill,\n    name: \"data_processor\",\n    description: \"Processes and transforms data streams\",\n    opts_key: :processor,\n    signals: [\n      input: [\"data.received.*\", \"data.transform.*\"],\n      output: [\"data.processed.*\"]\n    ],\n    config: [\n      batch_size: [\n        type: :pos_integer,\n        default: 100,\n        doc: \"Number of items to process in each batch\"\n      ]\n    ]\nend\n```","ref":"overview-7.html#step-1-define-the-skill-module"},{"type":"extras","title":"Step 2: Implement Required Callbacks - Overview","doc":"```elixir\n# Initial state for the skill's namespace\ndef initial_state do\n  %{\n    processed_count: 0,\n    last_batch: nil,\n    error_count: 0\n  }\nend\n\n# Child processes to supervise, such as custom Sensors\ndef child_spec(config) do\n  [\n    {DataProcessor.BatchWorker,\n     [\n       name: \"batch_worker\",\n       batch_size: config.batch_size\n     ]}\n  ]\nend\n\n# Signal routing rules\ndef router do\n  [\n    %{\n      path: \"data.received.*\",\n      instruction: %{\n        action: Actions.ProcessData\n      }\n    }\n  ]\nend\n```","ref":"overview-7.html#step-2-implement-required-callbacks"},{"type":"extras","title":"Step 3: Define Actions - Overview","doc":"```elixir\ndefmodule MyApp.DataProcessingSkill.Actions do\n  defmodule ProcessData do\n    use Jido.Action,\n      name: \"process_data\",\n      description: \"Processes incoming data batch\",\n      schema: [\n        data: [type: {:list, :map}, required: true]\n      ]\n\n    def run(%{data: data}, context) do\n      # Access skill config from context\n      batch_size = get_in(context, [:config, :batch_size])\n\n      # Process data...\n      {:ok, %{\n        processed: transformed_data,\n        count: length(transformed_data)\n      }}\n    end\n  end\nend\n```","ref":"overview-7.html#step-3-define-actions"},{"type":"extras","title":"Best Practices - Overview","doc":"1. **State Isolation**\n\n   - Use meaningful `opts_key` names\n   - Keep state focused and minimal\n   - Document state structure\n   - Consider persistence needs\n\n2. **Signal Design**\n\n   - Use consistent naming patterns\n   - Document signal formats\n   - Include necessary context\n   - Consider routing efficiency\n\n3. **Configuration**\n\n   - Validate thoroughly\n   - Provide good defaults\n   - Document all options\n   - Consider runtime changes\n\n4. **Process Management**\n   - Supervise child processes\n   - Handle crashes gracefully\n   - Monitor resource usage\n   - Consider distribution","ref":"overview-7.html#best-practices"},{"type":"extras","title":"Sharing and Distribution - Overview","doc":"Skills are designed to be shared and reused across different Jido applications. They act as plugins that can extend agent capabilities:\n\n1. **Package as Library**\n\n   - Create dedicated package\n   - Document dependencies\n   - Version appropriately\n   - Include examples\n\n2. **Distribution**\n   - Publish to Hex.pm\n   - Document installation\n   - Provide configuration guide\n   - Include integration examples","ref":"overview-7.html#sharing-and-distribution"},{"type":"extras","title":"Example Shared Skills - Overview","doc":"Some common types of shared skills:\n\n1. **Integration Skills**\n\n   - Database connectors\n   - API clients\n   - Message queue adapters\n   - File system monitors\n\n2. **Processing Skills**\n\n   - Data transformation\n   - Content analysis\n   - Format conversion\n   - Batch processing\n\n3. **Monitoring Skills**\n   - System metrics\n   - Performance tracking\n   - Error detection\n   - Health checks","ref":"overview-7.html#example-shared-skills"},{"type":"extras","title":"See Also - Overview","doc":"- [Testing Skills](testing.md)\n- [Signal Router](../signals/routing.md)\n- [Agent State](../agents/stateful.md)\n- [Child Processes](../agents/child-processes.md)","ref":"overview-7.html#see-also"},{"type":"extras","title":"Testing Skills","doc":"# Testing Skills in Jido","ref":"testing-8.html"},{"type":"extras","title":"Introduction - Testing Skills","doc":"This guide covers comprehensive testing strategies for Jido Skills. Testing Skills requires a multi-faceted approach since they integrate multiple components:\n\n- Signal routing and handling\n- State management\n- Process supervision\n- Configuration validation\n- Action execution","ref":"testing-8.html#introduction"},{"type":"extras","title":"Test Environment Setup - Testing Skills","doc":"","ref":"testing-8.html#test-environment-setup"},{"type":"extras","title":"Create Test Support Module - Testing Skills","doc":"First, create a test support module with common helpers:\n\n```elixir\ndefmodule MyApp.SkillTestSupport do\n  use ExUnit.Case\n\n  def build_test_signal(opts \\\\ []) do\n    type = Keyword.get(opts, :type, \"test.event\")\n    source = Keyword.get(opts, :source, \"/test\")\n    data = Keyword.get(opts, :data, %{})\n\n    {:ok, signal} = Jido.Signal.new(%{\n      type: type,\n      source: source,\n      data: data\n    })\n\n    signal\n  end\n\n  def assert_skill_state(skill, state_path, expected) do\n    actual = get_in(skill.state, state_path)\n    assert actual == expected,\n           \"Expected state at #{inspect(state_path)} to be #{inspect(expected)}, got: #{inspect(actual)}\"\n  end\nend\n```","ref":"testing-8.html#create-test-support-module"},{"type":"extras","title":"Test Case Template - Testing Skills","doc":"Create a test case template for skill tests:\n\n```elixir\ndefmodule MyApp.SkillCase do\n  use ExUnit.CaseTemplate\n\n  using do\n    quote do\n      use ExUnit.Case\n      import MyApp.SkillTestSupport\n      alias Jido.Signal\n      alias Jido.Skill\n\n      # Setup common test state\n      setup do\n        skill_config = %{\n          name: \"test_skill\",\n          opts_key: :test\n        }\n\n        {:ok, %{config: skill_config}}\n      end\n    end\n  end\nend\n```","ref":"testing-8.html#test-case-template"},{"type":"extras","title":"Unit Testing Skills - Testing Skills","doc":"","ref":"testing-8.html#unit-testing-skills"},{"type":"extras","title":"Testing Configuration - Testing Skills","doc":"Test skill configuration validation:\n\n```elixir\ndefmodule MyApp.WeatherSkill.ConfigTest do\n  use MyApp.SkillCase\n\n  describe \"configuration validation\" do\n    test \"accepts valid config\" do\n      config = %{\n        api_key: \"test_key\",\n        update_interval: 5000\n      }\n\n      assert {:ok, validated} = WeatherSkill.validate_config(config)\n      assert validated.api_key == \"test_key\"\n    end\n\n    test \"rejects invalid config\" do\n      config = %{\n        api_key: nil  # Required field\n      }\n\n      assert {:error, error} = WeatherSkill.validate_config(config)\n      assert error.type == :validation_error\n    end\n  end\nend\n```","ref":"testing-8.html#testing-configuration"},{"type":"extras","title":"Testing State Management - Testing Skills","doc":"Test state initialization and updates:\n\n```elixir\ndefmodule MyApp.WeatherSkill.StateTest do\n  use MyApp.SkillCase\n\n  describe \"state management\" do\n    test \"initializes with correct state\" do\n      initial_state = WeatherSkill.initial_state()\n\n      assert %{\n        current_conditions: nil,\n        alert_history: [],\n        last_update: nil\n      } = initial_state\n    end\n\n    test \"updates state correctly\" do\n      state = WeatherSkill.initial_state()\n\n      # Simulate state update from signal\n      signal = build_test_signal(\n        type: \"weather.data.received\",\n        data: %{temperature: 72}\n      )\n\n      {:ok, new_state} = WeatherSkill.handle_signal(signal, state)\n\n      assert new_state.current_conditions.temperature == 72\n      assert new_state.last_update != nil\n    end\n  end\nend\n```","ref":"testing-8.html#testing-state-management"},{"type":"extras","title":"Testing Signal Routing - Testing Skills","doc":"Test route matching and dispatch:\n\n```elixir\ndefmodule MyApp.WeatherSkill.RoutingTest do\n  use MyApp.SkillCase\n\n  describe \"signal routing\" do\n    test \"matches exact paths\" do\n      routes = WeatherSkill.routes()\n      signal = build_test_signal(type: \"weather.data.received\")\n\n      assert {:ok, [instruction]} =\n        Jido.Signal.Router.match(routes, signal)\n\n      assert instruction.action == WeatherSkill.Actions.ProcessData\n    end\n\n    test \"matches wildcard patterns\" do\n      routes = WeatherSkill.routes()\n      signal = build_test_signal(type: \"weather.alert.severe\")\n\n      assert {:ok, [instruction]} =\n        Jido.Signal.Router.match(routes, signal)\n\n      assert instruction.action == WeatherSkill.Actions.HandleAlert\n    end\n\n    test \"respects priority ordering\" do\n      routes = WeatherSkill.routes()\n      signal = build_test_signal(type: \"weather.alert.emergency\")\n\n      assert {:ok, [first | _]} =\n        Jido.Signal.Router.match(routes, signal)\n\n      # High priority handlers should match first\n      assert first.priority == 100\n    end\n  end\nend\n```","ref":"testing-8.html#testing-signal-routing"},{"type":"extras","title":"Integration Testing - Testing Skills","doc":"","ref":"testing-8.html#integration-testing"},{"type":"extras","title":"Testing with Agent Integration - Testing Skills","doc":"Test skill behavior within an agent:\n\n```elixir\ndefmodule MyApp.WeatherSkill.IntegrationTest do\n  use MyApp.SkillCase\n\n  setup do\n    # Start agent with skill\n    {:ok, agent} = TestAgent.start_link(\n      name: \"test_agent\",\n      skills: [WeatherSkill]\n    )\n\n    {:ok, %{agent: agent}}\n  end\n\n  test \"processes signals through agent\", %{agent: agent} do\n    # Send test signal\n    signal = build_test_signal(\n      type: \"weather.data.received\",\n      data: %{temperature: 72}\n    )\n\n    :ok = TestAgent.process_signal(agent, signal)\n\n    # Verify skill state was updated\n    assert_skill_state(agent, [:weather, :current_conditions],\n      %{temperature: 72})\n  end\n\n  test \"handles multiple skills\", %{agent: agent} do\n    # Add another skill\n    :ok = TestAgent.add_skill(agent, MetricsSkill)\n\n    # Both skills should process appropriate signals\n    weather_signal = build_test_signal(\n      type: \"weather.data.received\"\n    )\n    metrics_signal = build_test_signal(\n      type: \"metrics.collected\"\n    )\n\n    :ok = TestAgent.process_signal(agent, weather_signal)\n    :ok = TestAgent.process_signal(agent, metrics_signal)\n\n    # Verify both skills processed their signals\n    assert_skill_state(agent, [:weather], %{processed: true})\n    assert_skill_state(agent, [:metrics], %{processed: true})\n  end\nend\n```","ref":"testing-8.html#testing-with-agent-integration"},{"type":"extras","title":"Testing Process Supervision - Testing Skills","doc":"Test child process management:\n\n```elixir\ndefmodule MyApp.WeatherSkill.SupervisionTest do\n  use MyApp.SkillCase\n\n  test \"supervises child processes\" do\n    # Start skill with child processes\n    {:ok, skill} = WeatherSkill.start_link()\n\n    # Get child process\n    [{_, worker_pid, _, _}] =\n      Supervisor.which_children(skill.supervisor)\n\n    # Kill worker\n    Process.exit(worker_pid, :kill)\n\n    # Worker should restart\n    :timer.sleep(100)\n    [{_, new_pid, _, _}] =\n      Supervisor.which_children(skill.supervisor)\n\n    assert new_pid != worker_pid\n    assert Process.alive?(new_pid)\n  end\nend\n```","ref":"testing-8.html#testing-process-supervision"},{"type":"extras","title":"Property-Based Testing - Testing Skills","doc":"Use property testing for complex validation:\n\n```elixir\ndefmodule MyApp.WeatherSkill.PropertyTest do\n  use ExUnit.Case\n  use PropCheck\n\n  property \"validates all signal types\" do\n    forall signal_type <- signal_type() do\n      signal = build_test_signal(type: signal_type)\n      {:ok, _} = WeatherSkill.validate_signal(signal)\n    end\n  end\n\n  # Generators\n  def signal_type do\n    let [\n      domain <- elements([\"weather\", \"alert\"]),\n      action <- elements([\"received\", \"processed\", \"error\"]),\n      id <- integer(1, 1000)\n    ] do\n      \"#{domain}.#{action}.#{id}\"\n    end\n  end\nend\n```","ref":"testing-8.html#property-based-testing"},{"type":"extras","title":"Best Practices - Testing Skills","doc":"","ref":"testing-8.html#best-practices"},{"type":"extras","title":"1. Test Organization - Testing Skills","doc":"- Group tests by functionality (config, state, routing)\n- Use descriptive test names\n- Follow arrange-act-assert pattern\n- Keep tests focused and isolated","ref":"testing-8.html#1-test-organization"},{"type":"extras","title":"2. Test Coverage - Testing Skills","doc":"- Test all configuration options\n- Verify signal routing patterns\n- Check state transitions\n- Test error handling\n- Verify process supervision","ref":"testing-8.html#2-test-coverage"},{"type":"extras","title":"3. Test Data - Testing Skills","doc":"- Use factories for complex test data\n- Randomize data when appropriate\n- Test edge cases explicitly\n- Use property testing for validation","ref":"testing-8.html#3-test-data"},{"type":"extras","title":"4. Async Testing - Testing Skills","doc":"- Be careful with async tests\n- Use proper process cleanup\n- Handle timing dependencies\n- Test concurrent operations","ref":"testing-8.html#4-async-testing"},{"type":"extras","title":"Common Testing Patterns - Testing Skills","doc":"","ref":"testing-8.html#common-testing-patterns"},{"type":"extras","title":"1. State Verification - Testing Skills","doc":"```elixir\ntest \"verifies state updates\" do\n  {:ok, skill} = TestSkill.start_link()\n\n  # Initial state\n  assert_skill_state(skill, [:count], 0)\n\n  # Update state\n  signal = build_test_signal(type: \"increment\")\n  :ok = TestSkill.process_signal(skill, signal)\n\n  # Verify update\n  assert_skill_state(skill, [:count], 1)\nend\n```","ref":"testing-8.html#1-state-verification"},{"type":"extras","title":"2. Signal Flow Testing - Testing Skills","doc":"```elixir\ntest \"tracks signal flow\" do\n  {:ok, skill} = TestSkill.start_link()\n\n  # Track signal processing\n  ref = Process.monitor(skill.pid)\n  signal = build_test_signal()\n\n  # Send signal\n  :ok = TestSkill.process_signal(skill, signal)\n\n  # Verify processing\n  assert_receive {:signal_processed, ^signal}, 1000\nend\n```","ref":"testing-8.html#2-signal-flow-testing"},{"type":"extras","title":"3. Error Handling - Testing Skills","doc":"```elixir\ntest \"handles errors gracefully\" do\n  {:ok, skill} = TestSkill.start_link()\n\n  # Invalid signal\n  signal = build_test_signal(type: \"invalid\")\n\n  # Should not crash\n  :ok = TestSkill.process_signal(skill, signal)\n  assert Process.alive?(skill.pid)\n\n  # Should log error\n  assert_receive {:error, \"Invalid signal type\"}\nend\n```","ref":"testing-8.html#3-error-handling"},{"type":"extras","title":"See Also - Testing Skills","doc":"- [Signal Testing](../signals/testing.md)\n- [Agent Testing](../signals/testing.md)\n- [Action Testing](../actions/testing.md)\n- [Child Processes](../agents/child-processes.md)","ref":"testing-8.html#see-also"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}